;//-------- <<< Use Configuration Wizard in Context Menu >>> ------------------


;<h> Stack Configuration
;  <o> Stack Size (in Bytes) <0x0-0xFFFFFFFF:8>
;</h>

                PRESERVE8
                THUMB
                    
Stack_Size      EQU      0x00001000
                AREA     STACK, NOINIT, READWRITE, ALIGN=3
__stack_limit
Stack_Mem       SPACE    Stack_Size
__initial_sp


;<h> Heap Configuration
;  <o> Heap Size (in Bytes) <0x0-0xFFFFFFFF:8>
;</h>

Heap_Size       EQU      0x00001000
                IF       Heap_Size != 0                      ; Heap is provided
                AREA     HEAP, NOINIT, READWRITE, ALIGN=3
__heap_base
Heap_Mem        SPACE    Heap_Size
__heap_limit
                ENDIF


                PRESERVE8
                THUMB


; Vector Table Mapped to Address 0 at Reset

                AREA     RESET, DATA, READONLY
                EXPORT   __Vectors
                EXPORT   __Vectors_End
                EXPORT   __Vectors_Size

__Vectors       DCD     __initial_sp              ; Top of Stack
                DCD     Reset_Handler             ; Reset Handler
                DCD     NMI_Handler               ; NMI Handler
                DCD     HardFault_Handler         ; Hard Fault Handler
                DCD     MemManage_Handler         ; MPU Fault Handler
                DCD     BusFault_Handler          ; Bus Fault Handler
                DCD     UsageFault_Handler        ; Usage Fault Handler
                DCD     0                         ; Reserved
                DCD     0                         ; Reserved
                DCD     0                         ; Reserved
                DCD     0                         ; Reserved
                DCD     SVC_Handler               ; SVCall Handler
                DCD     DebugMon_Handler          ; Debug Monitor Handler
                DCD     0                         ; Reserved
                DCD     PendSV_Handler            ; PendSV Handler
                DCD     SysTick_Handler           ; SysTick Handler

                ; External Interrupts
                DCD      WWDG_IRQHandler                         ; Window Watchdog
                DCD      SVS_IRQHandler                          ; SVS through EXTI line 16
                DCD      RTC_TAMP_CSS_ELS_IRQHandler             ; RTC Timestamp/CSS on ELS through EXTI line 18
                DCD      RTC_WKUP_IRQHandler                     ; RTC wakeup timer through EXTI line 19
                DCD      FLASH_IRQHandler                        ; Flash
                DCD      RCC_IRQHandler                          ; RCC
                DCD      EXTI0_IRQHandler                        ; EXTI line0
                DCD      EXTI1_IRQHandler                        ; EXTI line1
                DCD      EXTI2_IRQHandler                        ; EXTI line2
                DCD      EXTI3_IRQHandler                        ; EXTI line3
                DCD      EXTI4_IRQHandler                        ; EXTI line4
                DCD      0                                       ; Reserved
                DCD      DMA0_Channel0_IRQHandler                ; DMA0 channel0
                DCD      DMA0_Channel1_IRQHandler                ; DMA0 channel1
                DCD      DMA0_Channel2_IRQHandler                ; DMA0 channel2
                DCD      DMA0_Channel3_IRQHandler                ; DMA0 channel3
                DCD      DMA0_Channel4_IRQHandler                ; DMA0 channel4
                DCD      DMA0_Channel5_IRQHandler                ; DMA0 channel5
                DCD      DMA0_Channel6_IRQHandler                ; DMA0 channel6
                DCD      DMA0_Channel7_IRQHandler                ; DMA0 channel7
                DCD      ADC_IRQHandler                          ; ADC
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      CAN_INTR1_IRQHandler                    ; CAN
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      EXTI9_5_IRQHandler                      ; EXTI line[9:5]
                DCD      ADVTMR0_BRK_IRQHandler                  ; ADVTMR0 break
                DCD      ADVTMR0_UPD_IRQHandler                  ; ADVTMR0 update
                DCD      ADVTMR0_TRG_COM_IRQHandler              ; ADVTMR0 trigger and commutation
                DCD      ADVTMR0_CC_IRQHandler                   ; ADVTMR0 capture and compare
                DCD      GPTMR0_BRK_IRQHandler                   ; GPTMR0 break
                DCD      GPTMR0_UPD_IRQHandler                   ; GPTMR0 update
                DCD      GPTMR0_TRG_COM_IRQHandler               ; GPTMR0 trigger and commutation
                DCD      GPTMR0_CC_IRQHandler                    ; GPTMR0 capture and compare 
                DCD      GPTMR1_BRK_IRQHandler                   ; GPTMR1 break
                DCD      GPTMR1_UPD_IRQHandler                   ; GPTMR1 update
                DCD      GPTMR1_TRG_COM_IRQHandler               ; GPTMR1 trigger and commutation
                DCD      GPTMR1_CC_IRQHandler                    ; GPTMR1 capture and compare 
                DCD      GPTMR2_BRK_IRQHandler                   ; GPTMR2 break
                DCD      GPTMR2_UPD_IRQHandler                   ; GPTMR2 update
                DCD      GPTMR2_TRG_COM_IRQHandler               ; GPTMR2 trigger and commutation
                DCD      GPTMR2_CC_IRQHandler                    ; GPTMR2 capture and compare 
                DCD      GPTMR3_BRK_IRQHandler                   ; GPTMR3 break
                DCD      GPTMR3_UPD_IRQHandler                   ; GPTMR3 update
                DCD      GPTMR3_TRG_COM_IRQHandler               ; GPTMR3 trigger and commutation
                DCD      GPTMR3_CC_IRQHandler                    ; GPTMR3 capture and compare 
                DCD      GPTMR4_BRK_IRQHandler                   ; GPTMR4 break
                DCD      GPTMR4_UPD_IRQHandler                   ; GPTMR4 update
                DCD      GPTMR4_TRG_COM_IRQHandler               ; GPTMR4 trigger and commutation
                DCD      GPTMR4_CC_IRQHandler                    ; GPTMR4 capture and compare 
                DCD      GPTMR5_BRK_IRQHandler                   ; GPTMR5 break
                DCD      GPTMR5_UPD_IRQHandler                   ; GPTMR5 update
                DCD      GPTMR5_TRG_COM_IRQHandler               ; GPTMR5 trigger and commutation
                DCD      GPTMR5_CC_IRQHandler                    ; GPTMR5 capture and compare 
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      I2C0_EV_IRQHandler                      ; I2C0 event
                DCD      I2C0_ER_IRQHandler                      ; I2C0 error
                DCD      I2C1_EV_IRQHandler                      ; I2C1 event
                DCD      I2C1_ER_IRQHandler                      ; I2C1 error
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      SPI_I2S0_IRQHandler                     ; SPI_I2S0
                DCD      SPI_I2S1_IRQHandler                     ; SPI_I2S1
                DCD      SPI_I2S2_IRQHandler                     ; SPI_I2S2
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      USART0_IRQHandler                       ; USART0
                DCD      USART1_IRQHandler                       ; USART1
                DCD      USART2_IRQHandler                       ; USART2
                DCD      USART3_IRQHandler                       ; USART3
                DCD      USART4_IRQHandler                       ; USART4
                DCD      USART5_IRQHandler                       ; USART5
                DCD      USART6_IRQHandler                       ; USART6
                DCD      EXTI15_10_IRQHandler                    ; EXTI line[15:10]
                DCD      RTC_Alarm_IRQHandler                    ; RTC alarm
                DCD      ADVTMR1_BRK_IRQHandler                  ; ADVTRM1 break
                DCD      ADVTMR1_UPD_IRQHandler                  ; ADVTRM1 update
                DCD      ADVTMR1_TRG_COM_IRQHandler              ; ADVTRM1 trigger and commutation
                DCD      ADVTMR1_CC_IRQHandler                   ; ADVTRM1 capture and compare
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      DMA1_Channel0_IRQHandler                ; DMA1 channel0
                DCD      DMA1_Channel1_IRQHandler                ; DMA1 channel1
                DCD      DMA1_Channel2_IRQHandler                ; DMA1 channel2
                DCD      DMA1_Channel3_IRQHandler                ; DMA1 channel3
                DCD      DMA1_Channel4_IRQHandler                ; DMA1 channel4
                DCD      DMA1_Channel5_IRQHandler                ; DMA1 channel5
                DCD      DMA1_Channel6_IRQHandler                ; DMA1 channel6
                DCD      DMA1_Channel7_IRQHandler                ; DMA1 channel7
                DCD      0                                       ; Reserved
                DCD      CMP0_IRQHandler                         ; CMP0 through EXTI line 20
                DCD      CMP1_IRQHandler                         ; CMP1 through EXTI line 21
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      ADVTMR2_BRK_IRQHandler                  ; ADVTMR2 break
                DCD      ADVTMR2_UPD_IRQHandler                  ; ADVTMR2 update
                DCD      ADVTMR2_TRG_COM_IRQHandler              ; ADVTMR2 trigger and commutation
                DCD      ADVTMR2_CC_IRQHandler                   ; ADVTMR2 capture and compare
                DCD      0                                       ; Reserved
                DCD      FPU_IRQHandler                          ; FPU
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      AES_IRQHandler                          ; AES 
                DCD      TRNG_IRQHandler                         ; TRNG
                DCD      0                                       ; Reserved
                DCD      HASH_IRQHandler                         ; SHA
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      0                                       ; Reserved
                DCD      TPSENSOR_IRQHandler                     ; TPSENSOR
                DCD      DAC_IRQHandler                          ; DAC                

__Vectors_End
__Vectors_Size  EQU      __Vectors_End - __Vectors

                AREA     |.text|, CODE, READONLY

; Reset Handler

Reset_Handler   PROC
                EXPORT   Reset_Handler             [WEAK]
                IMPORT   SystemInit
                IMPORT   __main

                LDR      R0, =__stack_limit
                MSR      MSPLIM, R0                          ; Non-secure version of MSPLIM is RAZ/WI

                LDR      R0, =SystemInit
                BLX      R0
                LDR      R0, =__main
                BX       R0

                ; Should never get here
                B       .

                ENDP


; Dummy Exception Handlers (infinite loops which can be modified)

NMI_Handler\
                PROC
                EXPORT  NMI_Handler               [WEAK]
                B       .
                ENDP

tp_sysLib_faultHandler PROC
                    EXPORT  tp_sysLib_faultHandler   [WEAK]
                    B       .
                    ENDP
HardFault_Wrapper\
                    PROC
                    EXPORT HardFault_Wrapper         [WEAK]
                    movs r0, #4
                    mov r1, LR
                    tst r0, r1
                    beq L_MSP
                    mrs r0, PSP
                    bl L_API_call
L_MSP
                    mrs r0, MSP
L_API_call
                    bl tp_sysLib_faultHandler
                    ENDP
HardFault_Handler\
                PROC
                EXPORT  HardFault_Handler         [WEAK]
                B       HardFault_Wrapper
                ENDP
MemManage_Handler\
                PROC
                EXPORT  MemManage_Handler         [WEAK]
                B       HardFault_Wrapper
                ENDP
BusFault_Handler\
                PROC
                EXPORT  BusFault_Handler          [WEAK]
                B       HardFault_Wrapper
                ENDP
UsageFault_Handler\
                PROC
                EXPORT  UsageFault_Handler        [WEAK]
                B       HardFault_Wrapper
                ENDP
SVC_Handler\
                PROC
                EXPORT  SVC_Handler               [WEAK]
                B       .
                ENDP
DebugMon_Handler\
                PROC
                EXPORT  DebugMon_Handler          [WEAK]
                B       .
                ENDP
PendSV_Handler\
                PROC
                EXPORT  PendSV_Handler            [WEAK]
                B       .
                ENDP
SysTick_Handler\
                PROC
                EXPORT  SysTick_Handler           [WEAK]
                B       .
                ENDP

Default_Handler PROC

                EXPORT      WWDG_IRQHandler                         [WEAK]
                EXPORT      SVS_IRQHandler                          [WEAK] 
                EXPORT      RTC_TAMP_CSS_ELS_IRQHandler             [WEAK] 
                EXPORT      RTC_WKUP_IRQHandler                     [WEAK] 
                EXPORT      FLASH_IRQHandler                        [WEAK] 
                EXPORT      RCC_IRQHandler                          [WEAK] 
                EXPORT      EXTI0_IRQHandler                        [WEAK]
                EXPORT      EXTI1_IRQHandler                        [WEAK] 
                EXPORT      EXTI2_IRQHandler                        [WEAK] 
                EXPORT      EXTI3_IRQHandler                        [WEAK] 
                EXPORT      EXTI4_IRQHandler                        [WEAK] 
                EXPORT      DMA0_Channel0_IRQHandler                [WEAK] 
                EXPORT      DMA0_Channel1_IRQHandler                [WEAK] 
                EXPORT      DMA0_Channel2_IRQHandler                [WEAK] 
                EXPORT      DMA0_Channel3_IRQHandler                [WEAK] 
                EXPORT      DMA0_Channel4_IRQHandler                [WEAK] 
                EXPORT      DMA0_Channel5_IRQHandler                [WEAK] 
                EXPORT      DMA0_Channel6_IRQHandler                [WEAK] 
                EXPORT      DMA0_Channel7_IRQHandler                [WEAK] 
                EXPORT      ADC_IRQHandler                          [WEAK] 
                EXPORT      CAN_INTR1_IRQHandler                    [WEAK] 
                EXPORT      EXTI9_5_IRQHandler                      [WEAK] 
                EXPORT      ADVTMR0_BRK_IRQHandler                  [WEAK] 
                EXPORT      ADVTMR0_UPD_IRQHandler                  [WEAK] 
                EXPORT      ADVTMR0_TRG_COM_IRQHandler              [WEAK] 
                EXPORT      ADVTMR0_CC_IRQHandler                   [WEAK] 
                EXPORT      GPTMR0_BRK_IRQHandler                   [WEAK] 
                EXPORT      GPTMR0_UPD_IRQHandler                   [WEAK] 
                EXPORT      GPTMR0_TRG_COM_IRQHandler               [WEAK] 
                EXPORT      GPTMR0_CC_IRQHandler                    [WEAK] 
                EXPORT      GPTMR1_BRK_IRQHandler                   [WEAK] 
                EXPORT      GPTMR1_UPD_IRQHandler                   [WEAK] 
                EXPORT      GPTMR1_TRG_COM_IRQHandler               [WEAK] 
                EXPORT      GPTMR1_CC_IRQHandler                    [WEAK] 
                EXPORT      GPTMR2_BRK_IRQHandler                   [WEAK] 
                EXPORT      GPTMR2_UPD_IRQHandler                   [WEAK] 
                EXPORT      GPTMR2_TRG_COM_IRQHandler               [WEAK] 
                EXPORT      GPTMR2_CC_IRQHandler                    [WEAK] 
                EXPORT      GPTMR3_BRK_IRQHandler                   [WEAK] 
                EXPORT      GPTMR3_UPD_IRQHandler                   [WEAK] 
                EXPORT      GPTMR3_TRG_COM_IRQHandler               [WEAK] 
                EXPORT      GPTMR3_CC_IRQHandler                    [WEAK] 
                EXPORT      GPTMR4_BRK_IRQHandler                   [WEAK] 
                EXPORT      GPTMR4_UPD_IRQHandler                   [WEAK] 
                EXPORT      GPTMR4_TRG_COM_IRQHandler               [WEAK] 
                EXPORT      GPTMR4_CC_IRQHandler                    [WEAK] 
                EXPORT      GPTMR5_BRK_IRQHandler                   [WEAK] 
                EXPORT      GPTMR5_UPD_IRQHandler                   [WEAK] 
                EXPORT      GPTMR5_TRG_COM_IRQHandler               [WEAK] 
                EXPORT      GPTMR5_CC_IRQHandler                    [WEAK] 
                EXPORT      I2C0_EV_IRQHandler                      [WEAK] 
                EXPORT      I2C0_ER_IRQHandler                      [WEAK] 
                EXPORT      I2C1_EV_IRQHandler                      [WEAK] 
                EXPORT      I2C1_ER_IRQHandler                      [WEAK] 
                EXPORT      SPI_I2S0_IRQHandler                     [WEAK] 
                EXPORT      SPI_I2S1_IRQHandler                     [WEAK] 
                EXPORT      SPI_I2S2_IRQHandler                     [WEAK] 
                EXPORT      USART0_IRQHandler                       [WEAK] 
                EXPORT      USART1_IRQHandler                       [WEAK] 
                EXPORT      USART2_IRQHandler                       [WEAK] 
                EXPORT      USART3_IRQHandler                       [WEAK] 
                EXPORT      USART4_IRQHandler                       [WEAK] 
                EXPORT      USART5_IRQHandler                       [WEAK] 
                EXPORT      USART6_IRQHandler                       [WEAK] 
                EXPORT      EXTI15_10_IRQHandler                    [WEAK] 
                EXPORT      RTC_Alarm_IRQHandler                    [WEAK] 
                EXPORT      ADVTMR1_BRK_IRQHandler                  [WEAK] 
                EXPORT      ADVTMR1_UPD_IRQHandler                  [WEAK] 
                EXPORT      ADVTMR1_TRG_COM_IRQHandler              [WEAK] 
                EXPORT      ADVTMR1_CC_IRQHandler                   [WEAK] 
                EXPORT      DMA1_Channel0_IRQHandler                [WEAK] 
                EXPORT      DMA1_Channel1_IRQHandler                [WEAK] 
                EXPORT      DMA1_Channel2_IRQHandler                [WEAK] 
                EXPORT      DMA1_Channel3_IRQHandler                [WEAK] 
                EXPORT      DMA1_Channel4_IRQHandler                [WEAK] 
                EXPORT      DMA1_Channel5_IRQHandler                [WEAK] 
                EXPORT      DMA1_Channel6_IRQHandler                [WEAK] 
                EXPORT      DMA1_Channel7_IRQHandler                [WEAK] 
                EXPORT      CMP0_IRQHandler                         [WEAK] 
                EXPORT      CMP1_IRQHandler                         [WEAK] 
                EXPORT      ADVTMR2_BRK_IRQHandler                  [WEAK] 
                EXPORT      ADVTMR2_UPD_IRQHandler                  [WEAK] 
                EXPORT      ADVTMR2_TRG_COM_IRQHandler              [WEAK] 
                EXPORT      ADVTMR2_CC_IRQHandler                   [WEAK] 
                EXPORT      FPU_IRQHandler                          [WEAK] 
                EXPORT      AES_IRQHandler                          [WEAK] 
                EXPORT      TRNG_IRQHandler                         [WEAK] 
                EXPORT      HASH_IRQHandler                         [WEAK] 
                EXPORT      TPSENSOR_IRQHandler                     [WEAK] 
                EXPORT      DAC_IRQHandler                          [WEAK]

WWDG_IRQHandler                       
SVS_IRQHandler                          
RTC_TAMP_CSS_ELS_IRQHandler             
RTC_WKUP_IRQHandler                     
FLASH_IRQHandler                        
RCC_IRQHandler                          
EXTI0_IRQHandler                       
EXTI1_IRQHandler                        
EXTI2_IRQHandler                        
EXTI3_IRQHandler                        
EXTI4_IRQHandler                        
DMA0_Channel0_IRQHandler                
DMA0_Channel1_IRQHandler                
DMA0_Channel2_IRQHandler                
DMA0_Channel3_IRQHandler                
DMA0_Channel4_IRQHandler                
DMA0_Channel5_IRQHandler                
DMA0_Channel6_IRQHandler                
DMA0_Channel7_IRQHandler                
ADC_IRQHandler                          
CAN_INTR1_IRQHandler                    
EXTI9_5_IRQHandler                      
ADVTMR0_BRK_IRQHandler                  
ADVTMR0_UPD_IRQHandler                  
ADVTMR0_TRG_COM_IRQHandler              
ADVTMR0_CC_IRQHandler                   
GPTMR0_BRK_IRQHandler                   
GPTMR0_UPD_IRQHandler                   
GPTMR0_TRG_COM_IRQHandler               
GPTMR0_CC_IRQHandler                    
GPTMR1_BRK_IRQHandler                   
GPTMR1_UPD_IRQHandler                   
GPTMR1_TRG_COM_IRQHandler               
GPTMR1_CC_IRQHandler                    
GPTMR2_BRK_IRQHandler                   
GPTMR2_UPD_IRQHandler                   
GPTMR2_TRG_COM_IRQHandler               
GPTMR2_CC_IRQHandler                    
GPTMR3_BRK_IRQHandler                   
GPTMR3_UPD_IRQHandler                   
GPTMR3_TRG_COM_IRQHandler               
GPTMR3_CC_IRQHandler                    
GPTMR4_BRK_IRQHandler                   
GPTMR4_UPD_IRQHandler                   
GPTMR4_TRG_COM_IRQHandler               
GPTMR4_CC_IRQHandler                    
GPTMR5_BRK_IRQHandler                   
GPTMR5_UPD_IRQHandler                   
GPTMR5_TRG_COM_IRQHandler               
GPTMR5_CC_IRQHandler                    
I2C0_EV_IRQHandler                      
I2C0_ER_IRQHandler                      
I2C1_EV_IRQHandler                      
I2C1_ER_IRQHandler                      
SPI_I2S0_IRQHandler                     
SPI_I2S1_IRQHandler                     
SPI_I2S2_IRQHandler                      
USART0_IRQHandler                       
USART1_IRQHandler                       
USART2_IRQHandler                       
USART3_IRQHandler                       
USART4_IRQHandler                        
USART5_IRQHandler                        
USART6_IRQHandler                        
EXTI15_10_IRQHandler                    
RTC_Alarm_IRQHandler                    
ADVTMR1_BRK_IRQHandler                  
ADVTMR1_UPD_IRQHandler                  
ADVTMR1_TRG_COM_IRQHandler              
ADVTMR1_CC_IRQHandler                  
DMA1_Channel0_IRQHandler                
DMA1_Channel1_IRQHandler                
DMA1_Channel2_IRQHandler                
DMA1_Channel3_IRQHandler                
DMA1_Channel4_IRQHandler                
DMA1_Channel5_IRQHandler                
DMA1_Channel6_IRQHandler                
DMA1_Channel7_IRQHandler               
CMP0_IRQHandler                         
CMP1_IRQHandler                         
ADVTMR2_BRK_IRQHandler                  
ADVTMR2_UPD_IRQHandler                 
ADVTMR2_TRG_COM_IRQHandler             
ADVTMR2_CC_IRQHandler                  
FPU_IRQHandler                         
AES_IRQHandler                        
TRNG_IRQHandler                        
HASH_IRQHandler                         
TPSENSOR_IRQHandler                  
DAC_IRQHandler                   

                B       .

                ENDP

                ALIGN


;*******************************************************************************
; User Stack and Heap initialization
;*******************************************************************************

                IF      :DEF:__MICROLIB

                EXPORT  __initial_sp
                EXPORT  __heap_base
                EXPORT  __heap_limit

                ELSE

                IMPORT  __use_two_region_memory
                EXPORT  __user_setup_stackheap

__user_setup_stackheap PROC
                LDR     R0, =  Heap_Mem
                LDR     R1, =(Stack_Mem + Stack_Size)
                LDR     R2, = (Heap_Mem +  Heap_Size)
                LDR     R3, = Stack_Mem
                BX      LR
                ENDP

                ALIGN

                ENDIF

                END
