/*
 * Copyright (c) 2022 3Peak Microelectronics. All rights reserved.
 *
 * @attention
 *
 * SPDX-License-Identifier: BSD-3-Clause.
 *
 * @file     TPS325M0x.h
 * @brief    CMSIS HeaderFile
 * @version  1.0
 * @date     17. November 2023
 * @note     Generated by SVDConv V3.3.27 on Friday, 17.11.2023 16:29:58
 *           from File 'TPS325M.svd',
 *           last modified on Friday, 17.11.2023 08:29:47
 */

/** @addtogroup
 * @{
 */

/** @addtogroup TPS325M0x
 * @{
 */

#ifndef TPS325M0x_H
#define TPS325M0x_H

#ifdef __cplusplus
extern "C"
{
#endif

  /** @addtogroup Configuration_of_CMSIS
   * @{
   */

  /* =========================================================================================================================== */
  /* ================                                Interrupt Number Definition                                ================ */
  /* =========================================================================================================================== */

typedef enum {
/* =======================================  ARM Cortex-M33 Specific Interrupt Numbers  ======================================= */
  Reset_IRQn                = -15,              /*!< -15  Reset Vector, invoked on Power up and warm reset                     */
  NonMaskableInt_IRQn       = -14,              /*!< -14  Non maskable Interrupt, cannot be stopped or preempted               */
  HardFault_IRQn            = -13,              /*!< -13  Hard Fault, all classes of Fault                                     */
  MemoryManagement_IRQn     = -12,              /*!< -12  Memory Management, MPU mismatch, including Access Violation
                                                     and No Match                                                              */
  BusFault_IRQn             = -11,              /*!< -11  Bus Fault, Pre-Fetch-, Memory Access Fault, other address/memory
                                                     related Fault                                                             */
  UsageFault_IRQn           = -10,              /*!< -10  Usage Fault, i.e. Undef Instruction, Illegal State Transition        */
  SecureFault_IRQn          =  -9,              /*!< -9 Secure Fault Handler                                                   */
  SVCall_IRQn               =  -5,              /*!< -5 System Service Call via SVC instruction                                */
  DebugMonitor_IRQn         =  -4,              /*!< -4 Debug Monitor                                                          */
  PendSV_IRQn               =  -2,              /*!< -2 Pendable request for system service                                    */
  SysTick_IRQn              =  -1,              /*!< -1 System Tick Timer                                                      */
/* ==========================================  TPS325M Specific Interrupt Numbers  =========================================== */
  WWDG_IRQn                 =   0,              /*!< 0  Window Watchdog interrupt                                              */
  SVS_IRQn                  =   1,              /*!< 1  SVS through EXTI line 16                                               */
  RTC_TAMP_CSS_ELS_IRQn     =   2,              /*!< 2  RTC/TAMP/CSS on ELS through EXTI line 18                               */
  RTC_WKUP_IRQn             =   3,              /*!< 3  RTC Wakeup timer through EXTI line 19                                  */
  FLASH_IRQn                =   4,              /*!< 4  Flash global interrupt                                                 */
  RCC_IRQn                  =   5,              /*!< 5  RCC global interrupt                                                   */
  EXTI0_IRQn                =   6,              /*!< 6  EXTI Line0 interrupt                                                   */
  EXTI1_IRQn                =   7,              /*!< 7  EXTI Line1 interrupt                                                   */
  EXTI2_IRQn                =   8,              /*!< 8  EXTI Line2 interrupt                                                   */
  EXTI3_IRQn                =   9,              /*!< 9  EXTI Line3 interrupt                                                   */
  EXTI4_IRQn                =  10,              /*!< 10 EXTI Line4 interrupt                                                   */
  DMA0_CH0_IRQn             =  12,              /*!< 12 DMA0 channel 0 interrupt                                               */
  DMA0_CH1_IRQn             =  13,              /*!< 13 DMA0 channel 1 interrupt                                               */
  DMA0_CH2_IRQn             =  14,              /*!< 14 DMA0 channel 2 interrupt                                               */
  DMA0_CH3_IRQn             =  15,              /*!< 15 DMA0 channel 3 interrupt                                               */
  DMA0_CH4_IRQn             =  16,              /*!< 16 DMA0 channel 4 interrupt                                               */
  DMA0_CH5_IRQn             =  17,              /*!< 17 DMA0 channel 5 interrupt                                               */
  DMA0_CH6_IRQn             =  18,              /*!< 18 DMA0 channel 6 interrupt                                               */
  DMA0_CH7_IRQn             =  19,              /*!< 19 DMA0 channel 7 interrupt                                               */
  ADC_IRQn                  =  20,              /*!< 20 ADC global interrupt                                                   */
  CAN_INTR1_IRQn            =  23,              /*!< 23 CAN interrupt                                                          */
  EXTI9_5_IRQn              =  27,              /*!< 27 EXTI Line[9:5] interrupts                                              */
  ADVTMR0_BRK_IRQn          =  28,              /*!< 28 ADVTMR0 Break                                                          */
  ADVTMR0_UPD_IRQn          =  29,              /*!< 29 ADVTMR0 Update                                                         */
  ADVTMR0_TRG_COM_IRQn      =  30,              /*!< 30 ADVTMR0 trigger and commutation/ADVTMR0 Direction Change
                                                     interrupt/ADVTMR0 Index                                                   */
  ADVTMR0_CC_IRQn           =  31,              /*!< 31 ADVTMR0 capture compare interrupt                                      */
  GPTMR0_BRK_IRQn           =  32,              /*!< 32 GPTMR0 Break                                                           */
  GPTMR0_UPD_IRQn           =  33,              /*!< 33 GPTMR0 Update                                                          */
  GPTMR0_TRG_COM_IRQn       =  34,              /*!< 34 GPTMR0 trigger and commutation/GPTMR0 Direction Change interrupt/GPTMR0
                                                     Index                                                                     */
  GPTMR0_CC_IRQn            =  35,              /*!< 35 GPTMR0 capture compare interrupt                                       */
  GPTMR1_BRK_IRQn           =  36,              /*!< 36 GPTMR1 Break                                                           */
  GPTMR1_UPD_IRQn           =  37,              /*!< 37 GPTMR1 Update                                                          */
  GPTMR1_TRG_COM_IRQn       =  38,              /*!< 38 GPTMR1 trigger and commutation/GPTMR1 Direction Change interrupt/GPTMR1
                                                     Index                                                                     */
  GPTMR1_CC_IRQn            =  39,              /*!< 39 GPTMR1 capture compare interrupt                                       */
  GPTMR2_BRK_IRQn           =  40,              /*!< 40 GPTMR2 Break                                                           */
  GPTMR2_UPD_IRQn           =  41,              /*!< 41 GPTMR2 Update                                                          */
  GPTMR2_TRG_COM_IRQn       =  42,              /*!< 42 GPTMR2 trigger and commutation/GPTMR2 Direction Change interrupt/GPTMR2
                                                     Index                                                                     */
  GPTMR2_CC_IRQn            =  43,              /*!< 43 GPTMR2 capture compare interrupt                                       */
  GPTMR3_BRK_IRQn           =  44,              /*!< 44 GPTMR3 Break                                                           */
  GPTMR3_UPD_IRQn           =  45,              /*!< 45 GPTMR3 Update                                                          */
  GPTMR3_TRG_COM_IRQn       =  46,              /*!< 46 GPTMR3 trigger and commutation/GPTMR3 Direction Change interrupt/GPTMR3
                                                     Index                                                                     */
  GPTMR3_CC_IRQn            =  47,              /*!< 47 GPTMR3 capture compare interrupt                                       */
  GPTMR4_BRK_IRQn           =  48,              /*!< 48 GPTMR4_DACUNDER Break                                                  */
  GPTMR4_UPD_IRQn           =  49,              /*!< 49 GPTMR4_DACUNDER Update and DAC1/3 underrun global interrupts           */
  GPTMR4_TRG_COM_IRQn       =  50,              /*!< 50 GPTMR4_DACUNDER trigger and commutation/GPTMR4_DACUNDER Direction
                                                     Change interrupt/GPTMR4_DACUNDER Index                                    */
  GPTMR4_CC_IRQn            =  51,              /*!< 51 GPTMR4_DACUNDER capture compare interrupt                              */
  GPTMR5_BRK_IRQn           =  52,              /*!< 52 GPTMR5_DACUNDER Break                                                  */
  GPTMR5_UPD_IRQn           =  53,              /*!< 53 GPTMR5_DACUNDER Update and DAC1/3 underrun global interrupts           */
  GPTMR5_TRG_COM_IRQn       =  54,              /*!< 54 GPTMR5_DACUNDER trigger and commutation/GPTMR5_DACUNDER Direction
                                                     Change interrupt/GPTMR5_DACUNDER Index                                    */
  GPTMR5_CC_IRQn            =  55,              /*!< 55 GPTMR5_DACUNDER capture compare interrupt                              */
  I2C0_EV_IRQn              =  59,              /*!< 59 I2C0 event interrupt                                                   */
  I2C0_ER_IRQn              =  60,              /*!< 60 I2C0 error interrupt                                                   */
  I2C1_EV_IRQn              =  61,              /*!< 61 I2C1 event interrupt                                                   */
  I2C1_ER_IRQn              =  62,              /*!< 62 I2C1 error interrupt                                                   */
  SPI_I2S0_IRQn             =  65,              /*!< 65 SPI_I2S0 global interrupt                                              */
  SPI_I2S1_IRQn             =  66,              /*!< 66 SPI_I2S1 global interrupt                                              */
  SPI_I2S2_IRQn             =  67,              /*!< 67 SPI_I2S2 global interrupt                                              */
  USART0_IRQn               =  70,              /*!< 70 USART0 global interrupt and EXTI line 26                               */
  USART1_IRQn               =  71,              /*!< 71 USART1 global interrupt and EXTI line 27                               */
  USART2_IRQn               =  72,              /*!< 72 USART2 global interrupt and EXTI line 28                               */
  USART3_IRQn               =  73,              /*!< 73 USART3 global interrupt and EXTI line 29                               */
  USART4_IRQn               =  74,              /*!< 74 USART4 global interrupt and EXTI line 24                               */
  USART5_IRQn               =  75,              /*!< 75 USART5 global interrupt and EXTI line 25                               */
  USART6_IRQn               =  76,              /*!< 76 USART6 global interrupt and EXTI line 30                               */
  EXTI15_10_IRQn            =  77,              /*!< 77 EXTI Line[15:10] interrupts                                            */
  RTC_ALARM_IRQn            =  78,              /*!< 78 RTC alarms interrupts                                                  */
  ADVTMR1_BRK_IRQn          =  79,              /*!< 79 ADVTMR1 Break                                                          */
  ADVTMR1_UPD_IRQn          =  80,              /*!< 80 ADVTMR1 Update                                                         */
  ADVTMR1_TRG_COM_IRQn      =  81,              /*!< 81 ADVTMR1 trigger and commutation/Direction Change interrupt/
                                                     Index                                                                     */
  ADVTMR1_CC_IRQn           =  82,              /*!< 82 ADVTMR1 capture compare interrupt                                      */
  DMA1_CH0_IRQn             =  86,              /*!< 86 DMA1 channel 0 interrupt                                               */
  DMA1_CH1_IRQn             =  87,              /*!< 87 DMA1 channel 1 interrupt                                               */
  DMA1_CH2_IRQn             =  88,              /*!< 88 DMA1 channel 2 interrupt                                               */
  DMA1_CH3_IRQn             =  89,              /*!< 89 DMA1 channel 3 interrupt                                               */
  DMA1_CH4_IRQn             =  90,              /*!< 90 DMA1 channel 4 interrupt                                               */
  DMA1_CH5_IRQn             =  91,              /*!< 91 DMA1 channel 5 interrupt                                               */
  DMA1_CH6_IRQn             =  92,              /*!< 92 DMA1 channel 6 interrupt                                               */
  DMA1_CH7_IRQn             =  93,              /*!< 93 DMA1 channel 7 interrupt                                               */
  CMP0_IRQn                 =  95,              /*!< 95 CMP0 through EXTI lines 20                                             */
  CMP1_IRQn                 =  96,              /*!< 96 CMP1 through EXTI lines 21                                             */
  ADVTMR2_BRK_IRQn          =  99,              /*!< 99 ADVTMR2 Break                                                          */
  ADVTMR2_UPD_IRQn          = 100,              /*!< 100  ADVTMR2 Update                                                       */
  ADVTMR2_TRG_COM_IRQn      = 101,              /*!< 101  ADVTMR2 trigger and commutation/Direction Change interrupt/
                                                     Index                                                                     */
  ADVTMR2_CC_IRQn           = 102,              /*!< 102  ADVTMR2 capture compare interrupt                                    */
  FPU_IRQn                  = 104,              /*!< 104  fpu interrupt                                                        */
  AES_IRQn                  = 107,              /*!< 107  AES global interrupt                                                 */
  TRNG_IRQn                 = 108,              /*!< 108  TRNG global interrupt                                                */
  HASH_IRQn                 = 110,              /*!< 110  HASH global interrupt                                                */
  DAC_IRQn                  = 115               /*!< 115  DAC global interrupt                                                 */
} IRQn_Type;



/* =========================================================================================================================== */
/* ================                           Processor and Core Peripheral Section                           ================ */
/* =========================================================================================================================== */

/* ==========================  Configuration of the ARM Cortex-M33 Processor and Core Peripherals  =========================== */
#define __CM33_REV                 0x0001U      /*!< CM33 Core Revision                                                        */
#define __NVIC_PRIO_BITS               4        /*!< Number of Bits used for Priority Levels                                   */
#define __Vendor_SysTickConfig         0        /*!< Set to 1 if different SysTick Config is used                              */
#define __VTOR_PRESENT                 1        /*!< Set to 1 if CPU supports Vector Table Offset Register                     */
#define __MPU_PRESENT                  1        /*!< MPU present                                                               */
#define __FPU_PRESENT                  1        /*!< FPU present                                                               */
#define __FPU_DP                       0        /*!< Double Precision FPU                                                      */
#define __DSP_PRESENT                  1        /*!< DSP extension present                                                     */
#define __SAUREGION_PRESENT            0        /*!< SAU region present                                                        */
#define __ICACHE_PRESENT 1       /*!< Set to 1 if I-Cache is present                                            */
#define __DCACHE_PRESENT 1       /*!< Set to 1 if D-Cache is present                                            */

/* =======  NVIC priority group define  ======= */
#define NVIC_PRIORITY_GROUP_3 0x00000004U // 3 bits for pre-emption priority, 0 bit for subpriority
#define NVIC_PRIORITY_GROUP_2 0x00000005U // 2 bits for pre-emption priority, 1 bit for subpriority
#define NVIC_PRIORITY_GROUP_1 0x00000006U // 1 bits for pre-emption priority, 2 bit for subpriority
#define NVIC_PRIORITY_GROUP_0 0x00000007U // 0 bits for pre-emption priority, 3 bit for subpriority

  /** @} */ /* End of group Configuration_of_CMSIS */

#include "core_star.h"          /*!< ARM Cortex-M33 processor and core peripherals                             */
#include "system_tps325mx.h"   /*!< TPS325M5x System                                                       */
#include "tps325mx_features.h" /*!< TPS325Mx instance implemenation list*/

#ifndef __IM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __IM   __I
#endif
#ifndef __OM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __OM   __O
#endif
#ifndef __IOM                                   /*!< Fallback for older CMSIS versions                                         */
  #define __IOM  __IO
#endif


/* =========================================================================================================================== */
/* ================                            Device Specific Peripheral Section                             ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                          DBG_MCU                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Reigsters for dbg mcu (DBG_MCU)
  */

typedef struct {                                /*!< (@ 0xE0045000) DBG_MCU Structure                                          */
  __IOM uint32_t  CR;                           /*!< (@ 0x00000000) CR                                                         */
  __IOM uint32_t  APBFZR;                       /*!< (@ 0x00000004) APBFZR                                                     */
} DBG_MCU_Type;                                 /*!< Size = 8 (0x8)                                                            */



/* =========================================================================================================================== */
/* ================                                          USART                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Univeral synchronous/asynchronous reveiver transmitter (USART)
  */

typedef struct {                                /*!< (@ 0x40010000) USART Structure                                           */
  __IOM uint32_t  CR1;                          /*!< (@ 0x00000000) CR1                                                        */
  __IOM uint32_t  CR2;                          /*!< (@ 0x00000004) CR2                                                        */
  __IOM uint32_t  CR3;                          /*!< (@ 0x00000008) CR3                                                        */
  __IOM uint32_t  BRR;                          /*!< (@ 0x0000000C) BRR                                                        */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  RTOR;                         /*!< (@ 0x00000014) RTOR                                                       */
  __IOM uint32_t  RQR;                          /*!< (@ 0x00000018) RQR                                                        */
  __IOM uint32_t  ISR;                          /*!< (@ 0x0000001C) ISR                                                        */
  __IOM uint32_t  ICR;                          /*!< (@ 0x00000020) ICR                                                        */
  __IOM uint32_t  RDR;                          /*!< (@ 0x00000024) RDR                                                        */
  __IOM uint32_t  TDR;                          /*!< (@ 0x00000028) TDR                                                        */
  __IOM uint32_t  PRESC;                        /*!< (@ 0x0000002C) PRESC                                                      */
  } USART_Type;           /*!< Size = 48 (0x30)                                                          */



/* =========================================================================================================================== */
/* ================                                         SPI_IIS                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial peripheral interface/inter-IC sound (SPI_IIS)
  */

typedef struct {                                /*!< (@ 0x40009400) SPI_IIS Structure                                         */
  __IOM uint32_t  CTL0;                         /*!< (@ 0x00000000) CTL0                                                       */
  __IOM uint32_t  CTL1;                         /*!< (@ 0x00000004) CTL1                                                       */
  __IOM uint32_t  STAT;                         /*!< (@ 0x00000008) STAT                                                       */
  __IOM uint32_t  DATA;                         /*!< (@ 0x0000000C) DATA                                                       */
  __IOM uint32_t  CRCPOLY;                      /*!< (@ 0x00000010) CRCPOLY                                                    */
  __IOM uint32_t  RXCRC;                        /*!< (@ 0x00000014) RXCRC                                                      */
  __IOM uint32_t  TXCRC;                        /*!< (@ 0x00000018) TXCRC                                                      */
  __IOM uint32_t  IISCFG0;                      /*!< (@ 0x0000001C) IISCFG0                                                    */
  __IOM uint32_t  IISCFG1;                      /*!< (@ 0x00000020) IISCFG1                                                    */
  __IOM uint32_t  EXTCFG0;                      /*!< (@ 0x00000024) EXTCFG0                                                    */
  __IOM uint32_t  FIFOCFG;                      /*!< (@ 0x00000028) FIFOCFG                                                    */
  __IOM uint32_t  CRCCFG;                       /*!< (@ 0x0000002C) CRCCFG                                                     */
  __IOM uint32_t  EXTCFG1;                      /*!< (@ 0x00000030) EXTCFG1                                                    */
  __IOM uint32_t  EXTCFG2;                      /*!< (@ 0x00000034) EXTCFG2                                                    */
  __IOM uint32_t  EXTCFG3;                      /*!< (@ 0x00000038) EXTCFG3                                                    */
  } SPI_IIS_Type;           /*!< Size = 60 (0x3c)                                                          */



/* =========================================================================================================================== */
/* ================                                          GPTMR                                            ================ */
/* =========================================================================================================================== */

  /**
   * @brief General-purpose timer (GPTMR)
   */

typedef struct {                                /*!< (@ 0x40000000) GPTMR Structure                                           */
  __IOM uint32_t  CTRL1;                        /*!< (@ 0x00000000) CTRL1                                                      */
  __IOM uint32_t  CTRL2;                        /*!< (@ 0x00000004) CTRL2                                                      */
  __IOM uint32_t  SMCFG;                        /*!< (@ 0x00000008) SMCFG                                                      */
  __IOM uint32_t  DMAINTEN;                     /*!< (@ 0x0000000C) DMAINTEN                                                   */
  __IOM uint32_t  INTSTS;                       /*!< (@ 0x00000010) INTSTS                                                     */
  __IOM uint32_t  SWEVTGEN;                     /*!< (@ 0x00000014) SWEVTGEN                                                   */
  __IOM uint32_t  CHXMODECTRL1;                 /*!< (@ 0x00000018) CHXMODECTRL1                                               */
  __IOM uint32_t  CHXMODECTRL2;                 /*!< (@ 0x0000001C) CHXMODECTRL2                                               */
  __IOM uint32_t  CCER;                         /*!< (@ 0x00000020) CCER                                                       */
  __IOM uint32_t  TCNT;                         /*!< (@ 0x00000024) TCNT                                                       */
  __IOM uint32_t  PSC;                          /*!< (@ 0x00000028) PSC                                                        */
  __IOM uint32_t  ARR;                          /*!< (@ 0x0000002C) ARR                                                        */
  __IOM uint32_t  RCR;                          /*!< (@ 0x00000030) RCR                                                        */
  __IOM uint32_t  CCR0;                         /*!< (@ 0x00000034) CCR0                                                       */
  __IOM uint32_t  CCR1;                         /*!< (@ 0x00000038) CCR1                                                       */
  __IOM uint32_t  CCR2;                         /*!< (@ 0x0000003C) CCR2                                                       */
  __IOM uint32_t  CCR3;                         /*!< (@ 0x00000040) CCR3                                                       */
  __IOM uint32_t  BDTR;                         /*!< (@ 0x00000044) BDTR                                                       */
  __IOM uint32_t  CHXSEL;                       /*!< (@ 0x00000048) CHxSEL                                                     */
  __IOM uint32_t  AF1;                          /*!< (@ 0x0000004C) AF1                                                        */
  __IOM uint32_t  AF2;                          /*!< (@ 0x00000050) AF2                                                        */
  __IOM uint32_t  DMACFG;                       /*!< (@ 0x00000054) DMACFG                                                     */
  __IOM uint32_t  DMAR;                         /*!< (@ 0x00000058) DMAR                                                       */
  } GPTMR_Type;                  /*!< Size = 92 (0x5c)                                                          */



/* =========================================================================================================================== */
/* ================                                          ADVTMR                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Advanced-control timer (ADVTMR)
  */

typedef struct {                                /*!< (@ 0x40013400) ADVTMR Structure                                          */
  __IOM uint32_t  CTRL1;                        /*!< (@ 0x00000000) CTRL1                                                      */
  __IOM uint32_t  CTRL2;                        /*!< (@ 0x00000004) CTRL2                                                      */
  __IOM uint32_t  SMCFG;                        /*!< (@ 0x00000008) SMCFG                                                      */
  __IOM uint32_t  DMAINTEN;                     /*!< (@ 0x0000000C) DMAINTEN                                                   */
  __IOM uint32_t  INTSTS;                       /*!< (@ 0x00000010) INTSTS                                                     */
  __IOM uint32_t  SWEVTGEN;                     /*!< (@ 0x00000014) SWEVTGEN                                                   */
  __IOM uint32_t  CHXMODECTRL1;                 /*!< (@ 0x00000018) CHXMODECTRL1                                               */
  __IOM uint32_t  CHXMODECTRL2;                 /*!< (@ 0x0000001C) CHXMODECTRL2                                               */
  __IOM uint32_t  CCER;                         /*!< (@ 0x00000020) CCER                                                       */
  __IOM uint32_t  TCNT;                         /*!< (@ 0x00000024) TCNT                                                       */
  __IOM uint32_t  PSC;                          /*!< (@ 0x00000028) PSC                                                        */
  __IOM uint32_t  ARR;                          /*!< (@ 0x0000002C) ARR                                                        */
  __IOM uint32_t  RCR;                          /*!< (@ 0x00000030) RCR                                                        */
  __IOM uint32_t  CCR0;                         /*!< (@ 0x00000034) CCR0                                                       */
  __IOM uint32_t  CCR1;                         /*!< (@ 0x00000038) CCR1                                                       */
  __IOM uint32_t  CCR2;                         /*!< (@ 0x0000003C) CCR2                                                       */
  __IOM uint32_t  CCR3;                         /*!< (@ 0x00000040) CCR3                                                       */
  __IOM uint32_t  BDTR;                         /*!< (@ 0x00000044) BDTR                                                       */
  __IOM uint32_t  CCR4;                         /*!< (@ 0x00000048) CCR4                                                       */
  __IOM uint32_t  CCR5;                         /*!< (@ 0x0000004C) CCR5                                                       */
  __IOM uint32_t  CHXMODECTRL3;                 /*!< (@ 0x00000050) CHXMODECTRL3                                               */
  __IOM uint32_t  CHXSEL;                       /*!< (@ 0x00000054) CHXSEL                                                     */
  __IOM uint32_t  AF1;                          /*!< (@ 0x00000058) AF1                                                        */
  __IOM uint32_t  AF2;                          /*!< (@ 0x0000005C) AF2                                                        */
  __IOM uint32_t  DMACFG;                       /*!< (@ 0x00000060) DMACFG                                                     */
  __IOM uint32_t  DMAR;                         /*!< (@ 0x00000064) DMAR                                                       */
  } ADVTMR_Type;                 /*!< Size = 104 (0x68)                                                         */



/* =========================================================================================================================== */
/* ================                                            RTC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Real-time clock (RTC)
  */

typedef struct {                                /*!< (@ 0x40004800) RTC Structure                                              */
  __IOM uint32_t  TR;                           /*!< (@ 0x00000000) TR                                                         */
  __IOM uint32_t  DR;                           /*!< (@ 0x00000004) DR                                                         */
  __IOM uint32_t  SSR;                          /*!< (@ 0x00000008) SSR                                                        */
  __IOM uint32_t  ICSR;                         /*!< (@ 0x0000000C) ICSR                                                       */
  __IOM uint32_t  PSCR;                         /*!< (@ 0x00000010) PSCR                                                       */
  __IOM uint32_t  WUTR;                         /*!< (@ 0x00000014) WUTR                                                       */
  __IOM uint32_t  CR;                           /*!< (@ 0x00000018) CR                                                         */
  __IOM uint32_t  WPR;                          /*!< (@ 0x0000001C) WPR                                                        */
  __IOM uint32_t  CALR;                         /*!< (@ 0x00000020) CALR                                                       */
  __IOM uint32_t  SHIFTR;                       /*!< (@ 0x00000024) SHIFTR                                                     */
  __IOM uint32_t  TSTR;                         /*!< (@ 0x00000028) TSTR                                                       */
  __IOM uint32_t  TSDR;                         /*!< (@ 0x0000002C) TSDR                                                       */
  __IOM uint32_t  TSSSR;                        /*!< (@ 0x00000030) TSSSR                                                      */
  __IOM uint32_t  ALRMAR;                       /*!< (@ 0x00000034) ALRMAR                                                     */
  __IOM uint32_t  ALRMASSR;                     /*!< (@ 0x00000038) ALRMASSR                                                   */
  __IOM uint32_t  ALRMBR;                       /*!< (@ 0x0000003C) ALRMBR                                                     */
  __IOM uint32_t  ALRMBSSR;                     /*!< (@ 0x00000040) ALRMBSSR                                                   */
  __IOM uint32_t  SR;                           /*!< (@ 0x00000044) SR                                                         */
  __IOM uint32_t  INTSR;                        /*!< (@ 0x00000048) INTSR                                                      */
  __IOM uint32_t  SCR;                          /*!< (@ 0x0000004C) SCR                                                        */
} RTC_Type;                                     /*!< Size = 80 (0x50)                                                          */



/* =========================================================================================================================== */
/* ================                                          RTC_BKR                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Real-time clock (RTC_BKR)
  */

typedef struct {                                /*!< (@ 0x40004400) RTC_BKR Structure                                          */
  __IOM uint32_t  BKP1R;                        /*!< (@ 0x00000000) BKP1R                                                      */
  __IOM uint32_t  BKP2R;                        /*!< (@ 0x00000004) BKP2R                                                      */
  __IOM uint32_t  BKP3R;                        /*!< (@ 0x00000008) BKP3R                                                      */
  __IOM uint32_t  BKP4R;                        /*!< (@ 0x0000000C) BKP4R                                                      */
  __IOM uint32_t  BKP5R;                        /*!< (@ 0x00000010) BKP5R                                                      */
  __IOM uint32_t  BKP6R;                        /*!< (@ 0x00000014) BKP6R                                                      */
  __IOM uint32_t  BKP7R;                        /*!< (@ 0x00000018) BKP7R                                                      */
  __IOM uint32_t  BKP8R;                        /*!< (@ 0x0000001C) BKP8R                                                      */
  __IOM uint32_t  BKP9R;                        /*!< (@ 0x00000020) BKP9R                                                      */
  __IOM uint32_t  BKP10R;                       /*!< (@ 0x00000024) BKP10R                                                     */
  __IOM uint32_t  BKP11R;                       /*!< (@ 0x00000028) BKP11R                                                     */
  __IOM uint32_t  BKP12R;                       /*!< (@ 0x0000002C) BKP12R                                                     */
  __IOM uint32_t  BKP13R;                       /*!< (@ 0x00000030) BKP13R                                                     */
  __IOM uint32_t  BKP14R;                       /*!< (@ 0x00000034) BKP14R                                                     */
  __IOM uint32_t  BKP15R;                       /*!< (@ 0x00000038) BKP15R                                                     */
  __IOM uint32_t  BKP16R;                       /*!< (@ 0x0000003C) BKP16R                                                     */
  } RTC_BKR_Type;          /*!< Size = 64 (0x40)                                                          */

  /* =========================================================================================================================== */
  /* ================                                            I2C                                            ================ */
  /* =========================================================================================================================== */


/**
  * @brief Inter-integrated circuit (I2C)
  */

typedef struct {                                /*!< (@ 0x40004C00) I2C Structure                                             */
  __IOM uint32_t  CR1;                          /*!< (@ 0x00000000) CR1                                                        */
  __IOM uint32_t  CR2;                          /*!< (@ 0x00000004) CR2                                                        */
  __IOM uint32_t  OAR1;                         /*!< (@ 0x00000008) OAR1                                                       */
  __IOM uint32_t  OAR2;                         /*!< (@ 0x0000000C) OAR2                                                       */
  __IOM uint32_t  TIMINGR;                      /*!< (@ 0x00000010) TIMINGR                                                    */
  __IOM uint32_t  TIMEOUTR;                     /*!< (@ 0x00000014) TIMEOUTR                                                   */
  __IOM uint32_t  ISR;                          /*!< (@ 0x00000018) ISR                                                        */
  __IOM uint32_t  ICR;                          /*!< (@ 0x0000001C) ICR                                                        */
  __IOM uint32_t  PECR;                         /*!< (@ 0x00000020) PECR                                                       */
  __IOM uint32_t  RXDR;                         /*!< (@ 0x00000024) RXDR                                                       */
  __IOM uint32_t  TXDR;                         /*!< (@ 0x00000028) TXDR                                                       */
  } I2C_Type;                /*!< Size = 44 (0x2c)                                                          */



/* =========================================================================================================================== */
/* ================                                            PMU                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Power Management Unit (PMU)
  */

typedef struct {                                /*!< (@ 0x40005800) PMU Structure                                              */
  __IOM uint32_t  CR00;                         /*!< (@ 0x00000000) CR00                                                       */
  __IOM uint32_t  CR01;                         /*!< (@ 0x00000004) CR01                                                       */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  CR03;                         /*!< (@ 0x0000000C) CR03                                                       */
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  CR05;                         /*!< (@ 0x00000014) CR05                                                       */
  __IM  uint32_t  RESERVED2[11];
  __IOM uint32_t  CR11;                         /*!< (@ 0x00000044) CR11                                                       */
  __IM  uint32_t  RESERVED3[24];
  __IOM uint32_t  CR2A;                         /*!< (@ 0x000000A8) CR2A                                                       */
  __IOM uint32_t  CR2B;                         /*!< (@ 0x000000AC) CR2B                                                       */
  __IOM uint32_t  SR1;                          /*!< (@ 0x000000B0) SR1                                                        */
  __IOM uint32_t  CSR1;                         /*!< (@ 0x000000B4) CSR1                                                       */
  __IOM uint32_t  SR2;                          /*!< (@ 0x000000B8) SR2                                                        */
  __IM  uint32_t  RESERVED4[3];
  __IOM uint32_t  CSR4;                         /*!< (@ 0x000000C8) CSR4                                                       */
} PMU_Type;                                     /*!< Size = 204 (0xcc)                                                         */


  /* =========================================================================================================================== */
  /* ================                                           IWDG                                            ================ */
  /* =========================================================================================================================== */


/**
  * @brief Independent watchdog (IWDG)
  */

typedef struct {                                /*!< (@ 0x40005C00) IWDG Structure                                             */
  __IOM uint32_t  CMD;                          /*!< (@ 0x00000000) CMD                                                        */
  __IOM uint32_t  PSC;                          /*!< (@ 0x00000004) PSC                                                        */
  __IOM uint32_t  RLD;                          /*!< (@ 0x00000008) RLD                                                        */
  __IOM uint32_t  STS;                          /*!< (@ 0x0000000C) STS                                                        */
  __IOM uint32_t  WIN;                          /*!< (@ 0x00000010) WIN                                                        */
  __IOM uint32_t  CLKSEL;                       /*!< (@ 0x00000014) CLKSEL                                                     */
} IWDG_Type;                                    /*!< Size = 24 (0x18)                                                          */



/* =========================================================================================================================== */
/* ================                                           WWDG                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief System window watchdog (WWDG)
  */

typedef struct {                                /*!< (@ 0x40006000) WWDG Structure                                             */
  __IOM uint32_t  CTRL;                         /*!< (@ 0x00000000) CTRL                                                       */
  __IOM uint32_t  CFG;                          /*!< (@ 0x00000004) CFG                                                        */
  __IOM uint32_t  STS;                          /*!< (@ 0x00000008) STS                                                        */
} WWDG_Type;                                    /*!< Size = 12 (0xc)                                                           */



/* =========================================================================================================================== */
/* ================                                            DAC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Digital-toanalog converter (DAC)
  */

typedef struct {                                /*!< (@ 0x40006400) DAC Structure                                              */
  __IOM uint32_t  CR;                           /*!< (@ 0x00000000) CR                                                         */
  __IOM uint32_t  SWTRGR;                       /*!< (@ 0x00000004) SWTRGR                                                     */
  __IOM uint32_t  DHR12R;                       /*!< (@ 0x00000008) DHR12R                                                     */
  __IOM uint32_t  DHR12L;                       /*!< (@ 0x0000000C) DHR12L                                                     */
  __IOM uint32_t  DHR8R;                        /*!< (@ 0x00000010) DHR8R                                                      */
  __IOM uint32_t  DOR;                          /*!< (@ 0x00000014) DOR                                                        */
  __IOM uint32_t  SR;                           /*!< (@ 0x00000018) SR                                                         */
  __IOM uint32_t  MCR;                          /*!< (@ 0x0000001C) MCR                                                        */
  __IOM uint32_t  CCR;                          /*!< (@ 0x00000020) CCR                                                        */
} DAC_Type;                                     /*!< Size = 36 (0x24)                                                          */



/* =========================================================================================================================== */
/* ================                                          VREFBUF                                          ================ */
/* =========================================================================================================================== */


/**
  * @brief Voltage reference buffer (VREFBUF)
  */

typedef struct {                                /*!< (@ 0x40011400) VREFBUF Structure                                          */
  __IOM uint32_t  CSR;                          /*!< (@ 0x00000000) CSR                                                        */
  __IOM uint32_t  CCR;                          /*!< (@ 0x00000004) CCR                                                        */
} VREFBUF_Type;                                 /*!< Size = 8 (0x8)                                                            */



/* =========================================================================================================================== */
/* ================                                          SYSCFG                                           ================ */
/* =========================================================================================================================== */

  /**
   * @brief System config (SYSCFG)
   */

typedef struct {                                /*!< (@ 0x40013000) SYSCFG Structure                                           */
  __IOM uint32_t  MEMRMP;                       /*!< (@ 0x00000000) MEMRMP                                                     */
  __IOM uint32_t  CFGR1;                        /*!< (@ 0x00000004) CFGR1                                                      */
  __IOM uint32_t  EXTICR1;                      /*!< (@ 0x00000008) EXTICR1                                                    */
  __IOM uint32_t  EXTICR2;                      /*!< (@ 0x0000000C) EXTICR2                                                    */
  __IOM uint32_t  EXTICR3;                      /*!< (@ 0x00000010) EXTICR3                                                    */
  __IOM uint32_t  EXTICR4;                      /*!< (@ 0x00000014) EXTICR4                                                    */
  __IM  uint32_t  RESERVED[3];
  __IOM uint32_t  INSTCTRL;                     /*!< (@ 0x00000024) INSTCTRL                                                   */
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  TRACECTRL;                    /*!< (@ 0x0000002C) TRACECTRL                                                  */
  __IM  uint32_t  RESERVED2[2];
  __IOM uint32_t  PINOVERTURNINGCTRL0;          /*!< (@ 0x00000038) PINOVERTURNINGCTRL0                                        */
  __IOM uint32_t  PINOVERTURNINGCTRL1;          /*!< (@ 0x0000003C) PINOVERTURNINGCTRL1                                        */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  TCMEB;                        /*!< (@ 0x00000044) TCMEB                                                      */
  __IM  uint32_t  RESERVED4[2];
  __IOM uint32_t  CANCNTCTRL;                   /*!< (@ 0x00000050) CANCNTCTRL                                                 */
  __IM  uint32_t  RESERVED5[43];
  __IOM uint32_t  OPENINFO0;                    /*!< (@ 0x00000100) OPENINFO0                                                  */
  __IOM uint32_t  OPENINFO1;                    /*!< (@ 0x00000104) OPENINFO1                                                  */
  __IOM uint32_t  OPENINFO2;                    /*!< (@ 0x00000108) OPENINFO2                                                  */
  __IOM uint32_t  OPENINFO3;                    /*!< (@ 0x0000010C) OPENINFO3                                                  */
} SYSCFG_Type;                                  /*!< Size = 272 (0x110)                                                        */



/* =========================================================================================================================== */
/* ================                                           CMP                                             ================ */
/* =========================================================================================================================== */


/**
  * @brief Comparator (CMP)
  */

typedef struct {                                /*!< (@ 0x40018C00) CMP Structure                                             */
  __IOM uint32_t  CSR;                          /*!< (@ 0x00000000) CSR                                                        */
} CMP_Type;                                    /*!< Size = 4 (0x4)                                                            */



/* =========================================================================================================================== */
/* ================                                            OA                                             ================ */
/* =========================================================================================================================== */


/**
  * @brief Operational amplifiers (OA)
  */

typedef struct {                                /*!< (@ 0x40019C00) OA Structure                                              */
  __IOM uint32_t  CSR;                          /*!< (@ 0x00000000) CSR                                                        */
} OA_Type;                                     /*!< Size = 4 (0x4)                                                            */

  /* =========================================================================================================================== */
  /* ================                                           EXTI                                            ================ */
  /* =========================================================================================================================== */


/**
  * @brief Entended interrupts and events controller (EXTI)
  */

typedef struct {                                /*!< (@ 0x4001CC00) EXTI Structure                                             */
  __IOM uint32_t  IMR1;                         /*!< (@ 0x00000000) IMR1                                                       */
  __IOM uint32_t  EMR1;                         /*!< (@ 0x00000004) EMR1                                                       */
  __IOM uint32_t  RTSR1;                        /*!< (@ 0x00000008) RTSR1                                                      */
  __IOM uint32_t  FTSR1;                        /*!< (@ 0x0000000C) FTSR1                                                      */
  __IOM uint32_t  SWIER1;                       /*!< (@ 0x00000010) SWIER1                                                     */
  __IOM uint32_t  PR1;                          /*!< (@ 0x00000014) PR1                                                        */
} EXTI_Type;                                    /*!< Size = 24 (0x18)                                                          */


  /* =========================================================================================================================== */
  /* ================                                           GPIO                                           ================ */
  /* =========================================================================================================================== */


/**
  * @brief General-purpose I/Os (GPIO)
  */

typedef struct {                                /*!< (@ 0x40020000) GPIO Structure                                            */
  __IOM uint32_t  MODER;                        /*!< (@ 0x00000000) MODER                                                      */
  __IOM uint32_t  OTYPER;                       /*!< (@ 0x00000004) OTYPER                                                     */
  __IOM uint32_t  OSPEEDR;                      /*!< (@ 0x00000008) OSPEEDR                                                    */
  __IOM uint32_t  PUPDR;                        /*!< (@ 0x0000000C) PUPDR                                                      */
  __IOM uint32_t  DRR;                          /*!< (@ 0x00000010) DRR                                                        */
  __IOM uint32_t  IDR;                          /*!< (@ 0x00000014) IDR                                                        */
  __IOM uint32_t  ODR;                          /*!< (@ 0x00000018) ODR                                                        */
  __IOM uint32_t  BSRR;                         /*!< (@ 0x0000001C) BSRR                                                       */
  __IOM uint32_t  LCKR;                         /*!< (@ 0x00000020) LCKR                                                       */
  __IOM uint32_t  AFRL;                         /*!< (@ 0x00000024) AFRL                                                       */
  __IOM uint32_t  AFRH;                         /*!< (@ 0x00000028) AFRH                                                       */
  __IOM uint32_t  BRR;                          /*!< (@ 0x0000002C) BRR                                                        */
  __IOM uint32_t  DFR;                          /*!< (@ 0x00000030) DFR                                                        */
  __IOM uint32_t  ASR;                          /*!< (@ 0x00000034) ASR                                                        */
  __IOM uint32_t  CSR;                          /*!< (@ 0x00000038) CSR                                                        */
  } GPIO_Type;              /*!< Size = 60 (0x3c)                                                          */



/* =========================================================================================================================== */
/* ================                                            AES                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief AES encrypt module (AES)
  */

typedef struct {                                /*!< (@ 0x48000400) AES Structure                                              */
  __IOM uint32_t  CR;                           /*!< (@ 0x00000000) CR                                                         */
  __IOM uint32_t  SR;                           /*!< (@ 0x00000004) SR                                                         */
  __IOM uint32_t  DINR;                         /*!< (@ 0x00000008) DINR                                                       */
  __IOM uint32_t  DOUT;                         /*!< (@ 0x0000000C) DOUT                                                       */
  __IOM uint32_t  KEY0;                         /*!< (@ 0x00000010) KEY0                                                       */
  __IOM uint32_t  KEY1;                         /*!< (@ 0x00000014) KEY1                                                       */
  __IOM uint32_t  KEY2;                         /*!< (@ 0x00000018) KEY2                                                       */
  __IOM uint32_t  KEY3;                         /*!< (@ 0x0000001C) KEY3                                                       */
  __IOM uint32_t  IVR0;                         /*!< (@ 0x00000020) IVR0                                                       */
  __IOM uint32_t  IVR1;                         /*!< (@ 0x00000024) IVR1                                                       */
  __IOM uint32_t  IVR2;                         /*!< (@ 0x00000028) IVR2                                                       */
  __IOM uint32_t  IVR3;                         /*!< (@ 0x0000002C) IVR3                                                       */
  __IOM uint32_t  KEY4;                         /*!< (@ 0x00000030) KEY4                                                       */
  __IOM uint32_t  KEY5;                         /*!< (@ 0x00000034) KEY5                                                       */
  __IOM uint32_t  KEY6;                         /*!< (@ 0x00000038) KEY6                                                       */
  __IOM uint32_t  KEY7;                         /*!< (@ 0x0000003C) KEY7                                                       */
} AES_Type;                                     /*!< Size = 64 (0x40)                                                          */



/* =========================================================================================================================== */
/* ================                                           HASH                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief HASH encrypt module (HASH)
  */

typedef struct {                                /*!< (@ 0x48000800) HASH Structure                                             */
  __IOM uint32_t  CR0;                          /*!< (@ 0x00000000) CR0                                                        */
  __IOM uint32_t  DIN;                          /*!< (@ 0x00000004) DIN                                                        */
  __IOM uint32_t  STR;                          /*!< (@ 0x00000008) STR                                                        */
  __IOM uint32_t  H0;                           /*!< (@ 0x0000000C) H0                                                         */
  __IOM uint32_t  H1;                           /*!< (@ 0x00000010) H1                                                         */
  __IOM uint32_t  H2;                           /*!< (@ 0x00000014) H2                                                         */
  __IOM uint32_t  H3;                           /*!< (@ 0x00000018) H3                                                         */
  __IOM uint32_t  H4;                           /*!< (@ 0x0000001C) H4                                                         */
  __IOM uint32_t  H5;                           /*!< (@ 0x00000020) H5                                                         */
  __IOM uint32_t  H6;                           /*!< (@ 0x00000024) H6                                                         */
  __IOM uint32_t  H7;                           /*!< (@ 0x00000028) H7                                                         */
  __IOM uint32_t  IMR;                          /*!< (@ 0x0000002C) IMR                                                        */
  __IOM uint32_t  SR;                           /*!< (@ 0x00000030) SR                                                         */
  __IOM uint32_t  CR1;                          /*!< (@ 0x00000034) CR1                                                        */
} HASH_Type;                                    /*!< Size = 56 (0x38)                                                          */



/* =========================================================================================================================== */
/* ================                                            ADC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Analog-to-digital converters (ADC)
  */

typedef struct {                                /*!< (@ 0x48000C00) ADC Structure                                              */
  __IOM uint32_t  ISR;                          /*!< (@ 0x00000000) ISR                                                        */
  __IOM uint32_t  IER;                          /*!< (@ 0x00000004) IER                                                        */
  __IOM uint32_t  CR;                           /*!< (@ 0x00000008) CR                                                         */
  __IOM uint32_t  CFGR;                         /*!< (@ 0x0000000C) CFGR                                                       */
  __IOM uint32_t  CFGR2;                        /*!< (@ 0x00000010) CFGR2                                                      */
  __IOM uint32_t  SMPR1;                        /*!< (@ 0x00000014) SMPR1                                                      */
  __IOM uint32_t  SMPR2;                        /*!< (@ 0x00000018) SMPR2                                                      */
  __IOM uint32_t  AWDCR;                        /*!< (@ 0x0000001C) AWDCR                                                      */
  __IOM uint32_t  AWDTR;                        /*!< (@ 0x00000020) AWDTR                                                      */
  __IOM uint32_t  SQR1;                         /*!< (@ 0x00000024) SQR1                                                       */
  __IOM uint32_t  SQR2;                         /*!< (@ 0x00000028) SQR2                                                       */
  __IOM uint32_t  SQR3;                         /*!< (@ 0x0000002C) SQR3                                                       */
  __IOM uint32_t  SQR4;                         /*!< (@ 0x00000030) SQR4                                                       */
  __IOM uint32_t  DR;                           /*!< (@ 0x00000034) DR                                                         */
  __IOM uint32_t  DR0;                          /*!< (@ 0x00000038) DR0                                                        */
  __IOM uint32_t  DR1;                          /*!< (@ 0x0000003C) DR1                                                        */
  __IOM uint32_t  DR2;                          /*!< (@ 0x00000040) DR2                                                        */
  __IOM uint32_t  DR3;                          /*!< (@ 0x00000044) DR3                                                        */
  __IOM uint32_t  DR4;                          /*!< (@ 0x00000048) DR4                                                        */
  __IOM uint32_t  DR5;                          /*!< (@ 0x0000004C) DR5                                                        */
  __IOM uint32_t  DR6;                          /*!< (@ 0x00000050) DR6                                                        */
  __IOM uint32_t  DR7;                          /*!< (@ 0x00000054) DR7                                                        */
  __IOM uint32_t  DR8;                          /*!< (@ 0x00000058) DR8                                                        */
  __IOM uint32_t  DR9;                          /*!< (@ 0x0000005C) DR9                                                        */
  __IOM uint32_t  DR10;                         /*!< (@ 0x00000060) DR10                                                       */
  __IOM uint32_t  DR11;                         /*!< (@ 0x00000064) DR11                                                       */
  __IOM uint32_t  DR12;                         /*!< (@ 0x00000068) DR12                                                       */
  __IOM uint32_t  DR13;                         /*!< (@ 0x0000006C) DR13                                                       */
  __IOM uint32_t  DR14;                         /*!< (@ 0x00000070) DR14                                                       */
  __IOM uint32_t  DR15;                         /*!< (@ 0x00000074) DR15                                                       */
  __IOM uint32_t  DR16;                         /*!< (@ 0x00000078) DR16                                                       */
  __IOM uint32_t  DR17;                         /*!< (@ 0x0000007C) DR17                                                       */
  __IOM uint32_t  DR18;                         /*!< (@ 0x00000080) DR18                                                       */
  __IOM uint32_t  DR19;                         /*!< (@ 0x00000084) DR19                                                       */
  __IOM uint32_t  OFR1;                         /*!< (@ 0x00000088) OFR1                                                       */
  __IOM uint32_t  OFR2;                         /*!< (@ 0x0000008C) OFR2                                                       */
  __IOM uint32_t  OFR3;                         /*!< (@ 0x00000090) OFR3                                                       */
  __IOM uint32_t  OFR4;                         /*!< (@ 0x00000094) OFR4                                                       */
  __IOM uint32_t  DIFSEL;                       /*!< (@ 0x00000098) DIFSEL                                                     */
  __IOM uint32_t  CALFACT;                      /*!< (@ 0x0000009C) CALFACT                                                    */
  __IOM uint32_t  GCOMP;                        /*!< (@ 0x000000A0) GCOMP                                                      */
  __IOM uint32_t  CCR;                          /*!< (@ 0x000000A4) CCR                                                        */
  __IOM uint32_t  TSR;                          /*!< (@ 0x000000A8) TSR                                                        */
} ADC_Type;                                     /*!< Size = 172 (0xac)                                                         */



/* =========================================================================================================================== */
/* ================                                            RCC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Reset and clock control (RCC)
  */

typedef struct {                                /*!< (@ 0x48001000) RCC Structure                                              */
  __IOM uint32_t  CR;                           /*!< (@ 0x00000000) CR                                                         */
  __IOM uint32_t  CR1;                          /*!< (@ 0x00000004) CR1                                                        */
  __IOM uint32_t  CFGR;                         /*!< (@ 0x00000008) CFGR                                                       */
  __IOM uint32_t  PLLCFGR1;                     /*!< (@ 0x0000000C) PLLCFGR1                                                   */
  __IOM uint32_t  PLLCFGR2;                     /*!< (@ 0x00000010) PLLCFGR2                                                   */
  __IOM uint32_t  CR2;                          /*!< (@ 0x00000014) CR2                                                        */
  __IOM uint32_t  CIER;                         /*!< (@ 0x00000018) CIER                                                       */
  __IOM uint32_t  CIFR;                         /*!< (@ 0x0000001C) CIFR                                                       */
  __IOM uint32_t  CICR;                         /*!< (@ 0x00000020) CICR                                                       */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  AHB1RSTR;                     /*!< (@ 0x00000028) AHB1RSTR                                                   */
  __IOM uint32_t  AHB2RSTR;                     /*!< (@ 0x0000002C) AHB2RSTR                                                   */
  __IOM uint32_t  AHB2RSTR1;                    /*!< (@ 0x00000030) AHB2RSTR1                                                  */
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  APB1RSTR;                     /*!< (@ 0x00000038) APB1RSTR                                                   */
  __IM  uint32_t  RESERVED2;
  __IOM uint32_t  APB2RSTR;                     /*!< (@ 0x00000040) APB2RSTR                                                   */
  __IM  uint32_t  RESERVED3;
  __IOM uint32_t  AHB1ENR;                      /*!< (@ 0x00000048) AHB1ENR                                                    */
  __IOM uint32_t  AHB2ENR;                      /*!< (@ 0x0000004C) AHB2ENR                                                    */
  __IOM uint32_t  AHB2ENR1;                     /*!< (@ 0x00000050) AHB2ENR1                                                   */
  __IM  uint32_t  RESERVED4;
  __IOM uint32_t  APB1ENR;                      /*!< (@ 0x00000058) APB1ENR                                                    */
  __IM  uint32_t  RESERVED5;
  __IOM uint32_t  APB2ENR;                      /*!< (@ 0x00000060) APB2ENR                                                    */
  __IM  uint32_t  RESERVED6[3];
  __IOM uint32_t  PLLCFGR3;                     /*!< (@ 0x00000070) PLLCFGR3                                                   */
  __IOM uint32_t  PLLCFGR4;                     /*!< (@ 0x00000074) PLLCFGR4                                                   */
  __IM  uint32_t  RESERVED7[4];
  __IOM uint32_t  CCIPR;                        /*!< (@ 0x00000088) CCIPR                                                      */
  __IM  uint32_t  RESERVED8[2];
  __IOM uint32_t  CSR;                          /*!< (@ 0x00000094) CSR                                                        */
  __IOM uint32_t  CFG2R;                        /*!< (@ 0x00000098) CFG2R                                                      */
  __IOM uint32_t  CFG3R;                        /*!< (@ 0x0000009C) CFG3R                                                      */
  __IOM uint32_t  BDCR;                         /*!< (@ 0x000000A0) BDCR                                                       */
  __IOM uint32_t  BDCR2;                        /*!< (@ 0x000000A4) BDCR2                                                      */
  __IOM uint32_t  BDCR3;                        /*!< (@ 0x000000A8) BDCR3                                                      */
  __IOM uint32_t  BDCR4;                        /*!< (@ 0x000000AC) BDCR4                                                      */
  __IM  uint32_t  RESERVED9[2];
  __IOM uint32_t  BDCR5;                        /*!< (@ 0x000000B8) BDCR5                                                      */
  __IOM uint32_t  BDCR6;                        /*!< (@ 0x000000BC) BDCR6                                                      */
  __IOM uint32_t  BDCR7;                        /*!< (@ 0x000000C0) BDCR7                                                      */
} RCC_Type;                                     /*!< Size = 196 (0xc4)                                                         */



/* =========================================================================================================================== */
/* ================                                           DMA                                             ================ */
/* =========================================================================================================================== */


/**
  * @brief Direct Memory access controller (DMA0)
  */

typedef struct {                                /*!< (@ 0x48001400) DMA0 Structure                                             */
  __IOM uint32_t  INTSTS0;                      /*!< (@ 0x00000000) INTSTS0                                                    */
  __IOM uint32_t  INTSTS1;                      /*!< (@ 0x00000004) INTSTS1                                                    */
  __IOM uint32_t  INTCLR0;                      /*!< (@ 0x00000008) INTCLR0                                                    */
  __IOM uint32_t  INTCLR1;                     /*!< (@ 0x0000000C) INTCLR1                                                 */
} DMA_Type;                                    /*!< Size = 16 (0x10)                                                          */


  /* =========================================================================================================================== */
  /* ================                                          DMA_CH                                           ================ */
  /* =========================================================================================================================== */

  /**
   * @brief Direct Memory access controller channel (DMA_CH)
   */

typedef struct {                                /*!< (@ 0x48001410) DMA0_CH0 Structure                                         */
  __IOM uint32_t  CFG;                          /*!< (@ 0x00000000) CFG                                                        */
  __IOM uint32_t  DATANUM;                      /*!< (@ 0x00000004) DATANUM                                                    */
  __IOM uint32_t  PERIADDR;                     /*!< (@ 0x00000008) PERIADDR                                                   */
  __IOM uint32_t  MEM0ADDR;                     /*!< (@ 0x0000000C) MEM0ADDR                                                   */
  __IOM uint32_t  MEM1ADDR;                     /*!< (@ 0x00000010) MEM1ADDR                                                   */
  __IOM uint32_t  FIFOCTRL;                     /*!< (@ 0x00000014) FIFOCTRL                                                   */
  } DMA_CH_Type;             /*!< Size = 24 (0x18)                                                          */



/* =========================================================================================================================== */
/* ================                                            CRC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Cyclic redundancy check calculation unit (CRC)
  */

typedef struct {                                /*!< (@ 0x48001C00) CRC Structure                                              */
  __IOM uint32_t  DR;                           /*!< (@ 0x00000000) DR                                                         */
  __IOM uint32_t  IDR;                          /*!< (@ 0x00000004) IDR                                                        */
  __IOM uint32_t  CR;                           /*!< (@ 0x00000008) CR                                                         */
  __IOM uint32_t  INIT;                         /*!< (@ 0x0000000C) INIT                                                       */
  __IOM uint32_t  POLY;                         /*!< (@ 0x00000010) POLY                                                       */
} CRC_Type;                                     /*!< Size = 20 (0x14)                                                          */



/* =========================================================================================================================== */
/* ================                                            FMC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Flash Memory Controller (FMC)
  */

typedef struct {                                /*!< (@ 0x48002000) FMC Structure                                              */
  __IOM uint32_t  ACR;                          /*!< (@ 0x00000000) ACR                                                        */
  __IOM uint32_t  PDKEYR;                       /*!< (@ 0x00000004) PDKEYR                                                     */
  __IOM uint32_t  KEYR;                         /*!< (@ 0x00000008) KEYR                                                       */
  __IOM uint32_t  OPTKEYR;                      /*!< (@ 0x0000000C) OPTKEYR                                                    */
  __IOM uint32_t  SR;                           /*!< (@ 0x00000010) SR                                                         */
  __IOM uint32_t  CR;                           /*!< (@ 0x00000014) CR                                                         */
  __IOM uint32_t  PESR;                         /*!< (@ 0x00000018) PESR                                                       */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  OPTR;                         /*!< (@ 0x00000020) OPTR                                                       */
  __IOM uint32_t  PCROP1SR;                     /*!< (@ 0x00000024) PCROP1SR                                                   */
  __IOM uint32_t  PCROP1ER;                     /*!< (@ 0x00000028) PCROP1ER                                                   */
  __IOM uint32_t  WRP1AR;                       /*!< (@ 0x0000002C) WRP1AR                                                     */
  __IOM uint32_t  WRP1BR;                       /*!< (@ 0x00000030) WRP1BR                                                     */
  __IM  uint32_t  RESERVED1[4];
  __IOM uint32_t  PCROP2SR;                     /*!< (@ 0x00000044) PCROP2SR                                                   */
  __IOM uint32_t  PCROP2ER;                     /*!< (@ 0x00000048) PCROP2ER                                                   */
  __IOM uint32_t  WRP2AR;                       /*!< (@ 0x0000004C) WRP2AR                                                     */
  __IOM uint32_t  WRP2BR;                       /*!< (@ 0x00000050) WRP2BR                                                     */
  __IM  uint32_t  RESERVED2[7];
  __IOM uint32_t  BOOTR;                        /*!< (@ 0x00000070) BOOTR                                                      */
} FMC_Type;                                     /*!< Size = 116 (0x74)                                                         */





/* =========================================================================================================================== */
/* ================                                            CAN                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief can controller (CAN)
  */

typedef struct {                                /*!< (@ 0x40014000) CAN Structure                                              */
  __IOM uint32_t  CFG;                          /*!< (@ 0x00000000) CFG                                                        */
  __IOM uint32_t  BITTIME;                      /*!< (@ 0x00000004) BITTIME                                                    */
  __IM  uint32_t  RESERVED[2];
  __IOM uint32_t  CLKCTRL;                      /*!< (@ 0x00000010) CLKCTRL                                                    */
  __IOM uint32_t  INTF;                         /*!< (@ 0x00000014) INTF                                                       */
  __IOM uint32_t  INTE;                         /*!< (@ 0x00000018) INTE                                                       */
  __IOM uint32_t  TSTAT;                        /*!< (@ 0x0000001C) TSTAT                                                      */
  __IOM uint32_t  TSCSR;                        /*!< (@ 0x00000020) TSCSR                                                      */
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  CMD;                          /*!< (@ 0x00000028) CMD                                                        */
  __IOM uint32_t  ERRSTATS;                     /*!< (@ 0x0000002C) ERRSTATS                                                   */
  __IM  uint32_t  RESERVED2[5];
  __IOM uint32_t  ACF;                          /*!< (@ 0x00000044) ACF                                                        */
  __IOM uint32_t  ACFIDENTREG;                  /*!< (@ 0x00000048) ACFIDENTREG                                                */
  __IOM uint32_t  ACFFORMAT;                    /*!< (@ 0x0000004C) ACFFORMAT                                                  */
  __IM  uint32_t  RESERVED3[2];
  __IOM uint32_t  ACMIDENTREG;                  /*!< (@ 0x00000058) ACMIDENTREG                                                */
  __IOM uint32_t  ACMFORMAT;                    /*!< (@ 0x0000005C) ACMFORMAT                                                  */
  __IM  uint32_t  RESERVED4[4];
  __IOM uint32_t  RBID;                         /*!< (@ 0x00000070) RBID                                                       */
  __IOM uint32_t  RBFORMAT;                     /*!< (@ 0x00000074) RBFORMAT                                                   */
  __IM  uint32_t  RESERVED5[2];
  __IOM uint32_t  RBTSREG;                      /*!< (@ 0x00000080) RBTSREG                                                    */
  __IM  uint32_t  RESERVED6[2];
  __IOM uint32_t  RBDATAREG0;                   /*!< (@ 0x0000008C) RBDATAREG0                                                 */
  __IOM uint32_t  RBDATAREG1;                   /*!< (@ 0x00000090) RBDATAREG1                                                 */
  __IM  uint32_t  RESERVED7[511];
  __IOM uint32_t  TBID;                         /*!< (@ 0x00000890) TBID                                                       */
  __IOM uint32_t  TBFORMAT;                     /*!< (@ 0x00000894) TBFORMAT                                                   */
  __IM  uint32_t  RESERVED8[5];
  __IOM uint32_t  TBDATAREG0;                   /*!< (@ 0x000008AC) TBDATAREG0                                                 */
  __IOM uint32_t  TBDATAREG1;                   /*!< (@ 0x000008B0) TBDATAREG1                                                 */
} CAN_Type;                                     /*!< Size = 2228 (0x8b4)                                                       */



/* =========================================================================================================================== */
/* ================                                           QSPI                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Quard spi (QSPI)
  */

typedef struct {                                /*!< (@ 0xE0044000) QSPI Structure                                             */
  __IOM uint32_t  CR;                           /*!< (@ 0x00000000) CR                                                         */
  __IOM uint32_t  SR;                           /*!< (@ 0x00000004) SR                                                         */
  __IOM uint32_t  RMCR;                         /*!< (@ 0x00000008) RMCR                                                       */
  __IOM uint32_t  OMCR;                         /*!< (@ 0x0000000C) OMCR                                                       */
  __IOM uint32_t  RABR;                         /*!< (@ 0x00000010) RABR                                                       */
  __IOM uint32_t  OABR;                         /*!< (@ 0x00000014) OABR                                                       */
  __IOM uint32_t  IMAR;                         /*!< (@ 0x00000018) IMAR                                                       */
  __IOM uint32_t  FDR;                          /*!< (@ 0x0000001C) FDR                                                        */
  __IOM uint32_t  DLR;                          /*!< (@ 0x00000020) DLR                                                        */
  __IOM uint32_t  WCNT;                         /*!< (@ 0x00000024) WCNT                                                       */
} QSPI_Type;                                    /*!< Size = 40 (0x28)                                                          */



/* =========================================================================================================================== */
/* ================                                           TRNG                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief true random number generator (TRNG)
  */

typedef struct {                                /*!< (@ 0x40016000) TRNG Structure                                             */
  __IM  uint32_t  RESERVED[64];
  __IOM uint32_t  RNGIMR;                       /*!< (@ 0x00000100) RNGIMR                                                     */
  __IOM uint32_t  RNGISR;                       /*!< (@ 0x00000104) RNGISR                                                     */
  __IOM uint32_t  RNGICR;                       /*!< (@ 0x00000108) RNGICR                                                     */
  __IOM uint32_t  TRNGCONFIG;                   /*!< (@ 0x0000010C) TRNGCONFIG                                                 */
  __IOM uint32_t  TRNGVALID;                    /*!< (@ 0x00000110) TRNGVALID                                                  */
  __IOM uint32_t  EHRDATA0;                     /*!< (@ 0x00000114) EHRDATA0                                                   */
  __IOM uint32_t  EHRDATA1;                     /*!< (@ 0x00000118) EHRDATA1                                                   */
  __IOM uint32_t  EHRDATA2;                     /*!< (@ 0x0000011C) EHRDATA2                                                   */
  __IOM uint32_t  EHRDATA3;                     /*!< (@ 0x00000120) EHRDATA3                                                   */
  __IOM uint32_t  EHRDATA4;                     /*!< (@ 0x00000124) EHRDATA4                                                   */
  __IOM uint32_t  EHRDATA5;                     /*!< (@ 0x00000128) EHRDATA5                                                   */
  __IOM uint32_t  RNDSOURCEENABLE;              /*!< (@ 0x0000012C) RNDSOURCEENABLE                                            */
  __IOM uint32_t  SAMPLECNT1;                   /*!< (@ 0x00000130) SAMPLECNT1                                                 */
  __IOM uint32_t  AUTOCORRSTATISTIC;            /*!< (@ 0x00000134) AUTOCORRSTATISTIC                                          */
  __IOM uint32_t  TRNGDEBUGCONTROL;             /*!< (@ 0x00000138) TRNGDEBUGCONTROL                                           */
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  TRNGSWRESET;                  /*!< (@ 0x00000140) TRNGSWRESET                                                */
  __IM  uint32_t  RESERVED2[28];
  __IOM uint32_t  RNGDEBUGENINPUT;              /*!< (@ 0x000001B4) RNGDEBUGENINPUT                                            */
  __IOM uint32_t  RNGBUSY;                      /*!< (@ 0x000001B8) RNGBUSY                                                    */
  __IOM uint32_t  RSTBITSCOUNTER;               /*!< (@ 0x000001BC) RSTBITSCOUNTER                                             */
  __IOM uint32_t  RNGVERSION;                   /*!< (@ 0x000001C0) RNGVERSION                                                 */
  __IM  uint32_t  RESERVED3[7];
  __IOM uint32_t  RNGBISTCNTR0;                 /*!< (@ 0x000001E0) RNGBISTCNTR0                                               */
  __IOM uint32_t  RNGBISTCNTR1;                 /*!< (@ 0x000001E4) RNGBISTCNTR1                                               */
  __IOM uint32_t  RNGBISTCNTR2;                 /*!< (@ 0x000001E8) RNGBISTCNTR2                                               */
} TRNG_Type;                                    /*!< Size = 492 (0x1ec)                                                        */


/** @} */ /* End of group Device_Peripheral_peripherals */


/* =========================================================================================================================== */
/* ================                          Device Specific Peripheral Address Map                           ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripheralAddr
  * @{
  */

#define DBG_MCU_BASE                0xE0045000UL
#define USART0_BASE                 0x40010000UL
#define USART1_BASE                 0x40010400UL
#define USART2_BASE                 0x40010800UL
#define USART3_BASE                 0x40010C00UL
#define USART4_BASE                 0x40008000UL
#define USART5_BASE                 0x40008400UL
#define USART6_BASE                 0x40008800UL
#define SPI_IIS0_BASE               0x40009400UL
#define SPI_IIS1_BASE               0x40009800UL
#define SPI_IIS2_BASE               0x40017400UL
#define GPTMR0_BASE                 0x40000000UL
#define GPTMR1_BASE                 0x40000400UL
#define GPTMR2_BASE                 0x40000800UL
#define GPTMR3_BASE                 0x40000C00UL
#define GPTMR4_BASE                 0x40001000UL
#define GPTMR5_BASE                 0x40001400UL
#define ADVTMR0_BASE                0x40013400UL
#define ADVTMR1_BASE                0x40013800UL
#define ADVTMR2_BASE                0x40013C00UL
#define RTC_BASE                    0x40004800UL
#define RTC_BKR_BASE                0x40004400UL
#define I2C0_BASE                   0x40004C00UL
#define I2C1_BASE                   0x40005000UL
#define PMU_BASE                    0x40005800UL
#define IWDG_BASE                   0x40005C00UL
#define WWDG_BASE                   0x40006000UL
#define DAC_BASE                    0x40006400UL
#define VREFBUF_BASE                0x40011400UL
#define SYSCFG_BASE                 0x40013000UL
#define CMP0_BASE                   0x40018C00UL
#define CMP1_BASE                   0x40019000UL
#define OA0_BASE                    0x40019C00UL
#define OA1_BASE                    0x4001A000UL
#define EXTI_BASE                   0x4001CC00UL
#define GPIOA_BASE                  0x40020000UL
#define GPIOB_BASE                  0x40020400UL
#define GPIOC_BASE                  0x40020800UL
#define GPIOD_BASE                  0x40020C00UL
#define GPIOE_BASE                  0x40021000UL
#define GPIOF_BASE                  0x40021400UL
#define AES_BASE                    0x48000400UL
#define HASH_BASE                   0x48000800UL
#define ADC_BASE                    0x48000C00UL
#define RCC_BASE                    0x48001000UL
#define DMA0_BASE                   0x48001400UL
#define DMA0_CH0_BASE               0x48001410UL
#define DMA0_CH1_BASE               0x48001428UL
#define DMA0_CH2_BASE               0x48001440UL
#define DMA0_CH3_BASE               0x48001458UL
#define DMA0_CH4_BASE               0x48001470UL
#define DMA0_CH5_BASE               0x48001488UL
#define DMA0_CH6_BASE               0x480014A0UL
#define DMA0_CH7_BASE               0x480014B8UL
#define DMA1_BASE                   0x48001800UL
#define DMA1_CH0_BASE               0x48001810UL
#define DMA1_CH1_BASE               0x48001828UL
#define DMA1_CH2_BASE               0x48001840UL
#define DMA1_CH3_BASE               0x48001858UL
#define DMA1_CH4_BASE               0x48001870UL
#define DMA1_CH5_BASE               0x48001888UL
#define DMA1_CH6_BASE               0x480018A0UL
#define DMA1_CH7_BASE               0x480018B8UL
#define CRC_BASE                    0x48001C00UL
#define FMC_BASE                    0x48002000UL
#define CAN_BASE                    0x40014000UL
#define QSPI_BASE                   0xE0044000UL
#define TRNG_BASE                   0x40016000UL

/** @} */ /* End of group Device_Peripheral_peripheralAddr */

/* =========================================================================================================================== */
/* ================                                  System level memory map                                  ================ */
/* =========================================================================================================================== */
#define FLASH_BASE (0x08000000UL)       /*!< (FLASH     ) Base Address */
#define FLASH_BANK0_BASE (0x08000000UL) /*!< (FLASH     ) Bank0 Base Address  */
#define FLASH_BANK1_BASE (0x08100000UL) /*!< (FLASH     ) Bank1 Base Address   */

#define FLASH_BOOTLOADER_BASE (0x0FFE0000UL) /*!< (FLASH     ) System Memory Base Address   */

#define FLASH_OTP_BASE (0x0FFE9000UL)     /*!< (FLASH     ) One Time Programming Area Base Address    */
#define FLASH_OTPLOCK_BASE (0x0FFE9400UL) /*!< (FLASH     ) One Time Programming Lock Area     */

#define SRAM0_BASE (0x20000000UL) /*!< (SRAM      ) SRAM1 Base Address */
#define SRAM1_BASE (0x20030000UL) /*!< (SRAM      ) SRAM2 Base Address */
#define SRAM2_BASE (0x20050000UL) /*!< (SRAM      ) SRAM3 Base Address */
#define SRAM_END (0x20053FFFUL)   /*!< (SRAM      ) End  Address */

#define PERIPH_BASE (0x40000000UL) /*!< (Peripheral) Base Address */

#define FLASH_SYSCFG_BASE (0x0FFEA000UL)   /* */
#define FLASH_NVR_TRIM_BASE (0x0FFEA400UL) /* */
#define FLASH_OPENINFO_BASE (0x0FFEA800UL) /* */
#define FLASH_BURNDONE_BASE (0x0FFEAFF8UL) /* */
#define FLASH_B1_USER_BASE (0x0FFF0000UL)  /* */

#define RAM_BASE (0x20000000UL)
#define APB1_BASE (0x40000000UL)
#define APB2_BASE (0x40010000UL)
#define AHB1_BASE (0x40020000UL)
#define AHB2_BASE (0x48000000UL)

  /* =========================================================================================================================== */
  /* ================                                  Peripheral declaration                                   ================ */
  /* =========================================================================================================================== */

  /** @addtogroup Device_Peripheral_declaration
   * @{
   */

#define DBG_MCU ((DBG_MCU_Type *)DBG_MCU_BASE)
#define USART0 ((USART_Type *)USART0_BASE)
#define USART1 ((USART_Type *)USART1_BASE)
#define USART2 ((USART_Type *)USART2_BASE)
#define USART3 ((USART_Type *)USART3_BASE)
#define USART4 ((USART_Type *)USART4_BASE)
#define USART5 ((USART_Type *)USART5_BASE)
#define USART6 ((USART_Type *)USART6_BASE)
#define SPI_IIS0 ((SPI_IIS_Type *)SPI_IIS0_BASE)
#define SPI_IIS1 ((SPI_IIS_Type *)SPI_IIS1_BASE)
#define SPI_IIS2 ((SPI_IIS_Type *)SPI_IIS2_BASE)
#define GPTMR0 ((GPTMR_Type *)GPTMR0_BASE)
#define GPTMR1 ((GPTMR_Type *)GPTMR1_BASE)
#define GPTMR2 ((GPTMR_Type *)GPTMR2_BASE)
#define GPTMR3 ((GPTMR_Type *)GPTMR3_BASE)
#define GPTMR4 ((GPTMR_Type *)GPTMR4_BASE)
#define GPTMR5 ((GPTMR_Type *)GPTMR5_BASE)
#define ADVTMR0 ((ADVTMR_Type *)ADVTMR0_BASE)
#define ADVTMR1 ((ADVTMR_Type *)ADVTMR1_BASE)
#define ADVTMR2 ((ADVTMR_Type *)ADVTMR2_BASE)
#define RTC ((RTC_Type *)RTC_BASE)
#define RTC_BKR ((RTC_BKR_Type *)RTC_BKR_BASE)
#define I2C0 ((I2C_Type *)I2C0_BASE)
#define I2C1 ((I2C_Type *)I2C1_BASE)
#define PMU                         ((PMU_Type*)               PMU_BASE)
#define IWDG                        ((IWDG_Type*)              IWDG_BASE)
#define WWDG                        ((WWDG_Type*)              WWDG_BASE)
#define DAC                         ((DAC_Type*)               DAC_BASE)
#define VREFBUF                     ((VREFBUF_Type*)           VREFBUF_BASE)
#define SYSCFG ((SYSCFG_Type *)SYSCFG_BASE)
#define CMP0 ((CMP_Type *)CMP0_BASE)
#define CMP1 ((CMP_Type *)CMP1_BASE)
#define OA0 ((OA_Type *)OA0_BASE)
#define OA1 ((OA_Type *)OA1_BASE)
#define EXTI ((EXTI_Type *)EXTI_BASE)
#define GPIOA ((GPIO_Type *)GPIOA_BASE)
#define GPIOB ((GPIO_Type *)GPIOB_BASE)
#define GPIOC ((GPIO_Type *)GPIOC_BASE)
#define GPIOD ((GPIO_Type *)GPIOD_BASE)
#define GPIOE ((GPIO_Type *)GPIOE_BASE)
#define GPIOF ((GPIO_Type *)GPIOF_BASE)
#define AES                         ((AES_Type*)               AES_BASE)
#define HASH                        ((HASH_Type*)              HASH_BASE)
#define ADC                         ((ADC_Type*)               ADC_BASE)
#define RCC                         ((RCC_Type*)               RCC_BASE)
#define DMA0 ((DMA_Type *)DMA0_BASE)
#define DMA0_CH0 ((DMA_CH_Type *)DMA0_CH0_BASE)
#define DMA0_CH1 ((DMA_CH_Type *)DMA0_CH1_BASE)
#define DMA0_CH2 ((DMA_CH_Type *)DMA0_CH2_BASE)
#define DMA0_CH3 ((DMA_CH_Type *)DMA0_CH3_BASE)
#define DMA0_CH4 ((DMA_CH_Type *)DMA0_CH4_BASE)
#define DMA0_CH5 ((DMA_CH_Type *)DMA0_CH5_BASE)
#define DMA0_CH6 ((DMA_CH_Type *)DMA0_CH6_BASE)
#define DMA0_CH7 ((DMA_CH_Type *)DMA0_CH7_BASE)
#define DMA1 ((DMA_Type *)DMA1_BASE)
#define DMA1_CH0 ((DMA_CH_Type *)DMA1_CH0_BASE)
#define DMA1_CH1 ((DMA_CH_Type *)DMA1_CH1_BASE)
#define DMA1_CH2 ((DMA_CH_Type *)DMA1_CH2_BASE)
#define DMA1_CH3 ((DMA_CH_Type *)DMA1_CH3_BASE)
#define DMA1_CH4 ((DMA_CH_Type *)DMA1_CH4_BASE)
#define DMA1_CH5 ((DMA_CH_Type *)DMA1_CH5_BASE)
#define DMA1_CH6 ((DMA_CH_Type *)DMA1_CH6_BASE)
#define DMA1_CH7 ((DMA_CH_Type *)DMA1_CH7_BASE)
#define CRC                         ((CRC_Type*)               CRC_BASE)
#define FMC                         ((FMC_Type*)               FMC_BASE)
#define CAN                         ((CAN_Type*)               CAN_BASE)
#define QSPI                        ((QSPI_Type*)              QSPI_BASE)
#define TRNG                        ((TRNG_Type*)              TRNG_BASE)

/** @} */ /* End of group Device_Peripheral_declaration */


/* =========================================================================================================================== */
/* ================                                Pos/Mask Peripheral Section                                ================ */
/* =========================================================================================================================== */


/** @addtogroup PosMask_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                          DBG_MCU                                          ================ */
/* =========================================================================================================================== */

/* ==========================================================  CR  =========================================================== */
#define DBG_MCU_CR_DBGSTOP_Pos            (3UL)                     /*!< DBGSTOP (Bit 3)                                       */
#define DBG_MCU_CR_DBGSTOP_Msk            (0x8UL)                   /*!< DBGSTOP (Bitfield-Mask: 0x01)                         */
#define DBG_MCU_CR_DBGSHUTDOWN_Pos        (2UL)                     /*!< DBGSHUTDOWN (Bit 2)                                   */
#define DBG_MCU_CR_DBGSHUTDOWN_Msk        (0x4UL)                   /*!< DBGSHUTDOWN (Bitfield-Mask: 0x01)                     */
#define DBG_MCU_CR_DBGSTANDBY_Pos         (1UL)                     /*!< DBGSTANDBY (Bit 1)                                    */
#define DBG_MCU_CR_DBGSTANDBY_Msk         (0x2UL)                   /*!< DBGSTANDBY (Bitfield-Mask: 0x01)                      */
#define DBG_MCU_CR_DBGSLEEP_Pos           (0UL)                     /*!< DBGSLEEP (Bit 0)                                      */
#define DBG_MCU_CR_DBGSLEEP_Msk           (0x1UL)                   /*!< DBGSLEEP (Bitfield-Mask: 0x01)                        */
/* ========================================================  APBFZR  ========================================================= */
#define DBG_MCU_APBFZR_DBGI2C1STOP_Pos    (22UL)                    /*!< DBGI2C1STOP (Bit 22)                                  */
#define DBG_MCU_APBFZR_DBGI2C1STOP_Msk    (0x400000UL)              /*!< DBGI2C1STOP (Bitfield-Mask: 0x01)                     */
#define DBG_MCU_APBFZR_DBGI2C0STOP_Pos    (21UL)                    /*!< DBGI2C0STOP (Bit 21)                                  */
#define DBG_MCU_APBFZR_DBGI2C0STOP_Msk    (0x200000UL)              /*!< DBGI2C0STOP (Bitfield-Mask: 0x01)                     */
#define DBG_MCU_APBFZR_DBGIWDGSTOP_Pos    (12UL)                    /*!< DBGIWDGSTOP (Bit 12)                                  */
#define DBG_MCU_APBFZR_DBGIWDGSTOP_Msk    (0x1000UL)                /*!< DBGIWDGSTOP (Bitfield-Mask: 0x01)                     */
#define DBG_MCU_APBFZR_DBGWWDGSTOP_Pos    (11UL)                    /*!< DBGWWDGSTOP (Bit 11)                                  */
#define DBG_MCU_APBFZR_DBGWWDGSTOP_Msk    (0x800UL)                 /*!< DBGWWDGSTOP (Bitfield-Mask: 0x01)                     */
#define DBG_MCU_APBFZR_DBGRTCSTOP_Pos     (10UL)                    /*!< DBGRTCSTOP (Bit 10)                                   */
#define DBG_MCU_APBFZR_DBGRTCSTOP_Msk     (0x400UL)                 /*!< DBGRTCSTOP (Bitfield-Mask: 0x01)                      */
#define DBG_MCU_APBFZR_DBGADVTMR2STOP_Pos (8UL)                     /*!< DBGADVTMR2STOP (Bit 8)                                */
#define DBG_MCU_APBFZR_DBGADVTMR2STOP_Msk (0x100UL)                 /*!< DBGADVTMR2STOP (Bitfield-Mask: 0x01)                  */
#define DBG_MCU_APBFZR_DBGADVTMR1STOP_Pos (7UL)                     /*!< DBGADVTMR1STOP (Bit 7)                                */
#define DBG_MCU_APBFZR_DBGADVTMR1STOP_Msk (0x80UL)                  /*!< DBGADVTMR1STOP (Bitfield-Mask: 0x01)                  */
#define DBG_MCU_APBFZR_DBGADVTMR0STOP_Pos (6UL)                     /*!< DBGADVTMR0STOP (Bit 6)                                */
#define DBG_MCU_APBFZR_DBGADVTMR0STOP_Msk (0x40UL)                  /*!< DBGADVTMR0STOP (Bitfield-Mask: 0x01)                  */
#define DBG_MCU_APBFZR_DBGGPTMR5STOP_Pos  (5UL)                     /*!< DBGGPTMR5STOP (Bit 5)                                 */
#define DBG_MCU_APBFZR_DBGGPTMR5STOP_Msk  (0x20UL)                  /*!< DBGGPTMR5STOP (Bitfield-Mask: 0x01)                   */
#define DBG_MCU_APBFZR_DBGGPTMR4STOP_Pos  (4UL)                     /*!< DBGGPTMR4STOP (Bit 4)                                 */
#define DBG_MCU_APBFZR_DBGGPTMR4STOP_Msk  (0x10UL)                  /*!< DBGGPTMR4STOP (Bitfield-Mask: 0x01)                   */
#define DBG_MCU_APBFZR_DBGGPTMR3STOP_Pos  (3UL)                     /*!< DBGGPTMR3STOP (Bit 3)                                 */
#define DBG_MCU_APBFZR_DBGGPTMR3STOP_Msk  (0x8UL)                   /*!< DBGGPTMR3STOP (Bitfield-Mask: 0x01)                   */
#define DBG_MCU_APBFZR_DBGGPTMR2STOP_Pos  (2UL)                     /*!< DBGGPTMR2STOP (Bit 2)                                 */
#define DBG_MCU_APBFZR_DBGGPTMR2STOP_Msk  (0x4UL)                   /*!< DBGGPTMR2STOP (Bitfield-Mask: 0x01)                   */
#define DBG_MCU_APBFZR_DBGGPTMR1STOP_Pos  (1UL)                     /*!< DBGGPTMR1STOP (Bit 1)                                 */
#define DBG_MCU_APBFZR_DBGGPTMR1STOP_Msk  (0x2UL)                   /*!< DBGGPTMR1STOP (Bitfield-Mask: 0x01)                   */
#define DBG_MCU_APBFZR_DBGGPTMR0STOP_Pos  (0UL)                     /*!< DBGGPTMR0STOP (Bit 0)                                 */
#define DBG_MCU_APBFZR_DBGGPTMR0STOP_Msk  (0x1UL)                   /*!< DBGGPTMR0STOP (Bitfield-Mask: 0x01)                   */


/* =========================================================================================================================== */
/* ================                                           USART                                           ================ */
/* =========================================================================================================================== */

/* ==========================================================  CR1  ========================================================== */
#define USART_CR1_RXFFIE_Pos             (31UL)                    /*!< RXFFIE (Bit 31)                                       */
#define USART_CR1_RXFFIE_Msk             (0x80000000UL)            /*!< RXFFIE (Bitfield-Mask: 0x01)                          */
#define USART_CR1_TXFEIE_Pos             (30UL)                    /*!< TXFEIE (Bit 30)                                       */
#define USART_CR1_TXFEIE_Msk             (0x40000000UL)            /*!< TXFEIE (Bitfield-Mask: 0x01)                          */
#define USART_CR1_FIFOEN_Pos             (29UL)                    /*!< FIFOEN (Bit 29)                                       */
#define USART_CR1_FIFOEN_Msk             (0x20000000UL)            /*!< FIFOEN (Bitfield-Mask: 0x01)                          */
#define USART_CR1_M1_Pos                 (28UL)                    /*!< M1 (Bit 28)                                           */
#define USART_CR1_M1_Msk                 (0x10000000UL)            /*!< M1 (Bitfield-Mask: 0x01)                              */
#define USART_CR1_RTOIE_Pos              (26UL)                    /*!< RTOIE (Bit 26)                                        */
#define USART_CR1_RTOIE_Msk              (0x4000000UL)             /*!< RTOIE (Bitfield-Mask: 0x01)                           */
#define USART_CR1_DEAT_Pos               (21UL)                    /*!< DEAT (Bit 21)                                         */
#define USART_CR1_DEAT_Msk               (0x3e00000UL)             /*!< DEAT (Bitfield-Mask: 0x1f)                            */
#define USART_CR1_DEDT_Pos               (16UL)                    /*!< DEDT (Bit 16)                                         */
#define USART_CR1_DEDT_Msk               (0x1f0000UL)              /*!< DEDT (Bitfield-Mask: 0x1f)                            */
#define USART_CR1_OVER8_Pos              (15UL)                    /*!< OVER8 (Bit 15)                                        */
#define USART_CR1_OVER8_Msk              (0x8000UL)                /*!< OVER8 (Bitfield-Mask: 0x01)                           */
#define USART_CR1_CMIE_Pos               (14UL)                    /*!< CMIE (Bit 14)                                         */
#define USART_CR1_CMIE_Msk               (0x4000UL)                /*!< CMIE (Bitfield-Mask: 0x01)                            */
#define USART_CR1_MME_Pos                (13UL)                    /*!< MME (Bit 13)                                          */
#define USART_CR1_MME_Msk                (0x2000UL)                /*!< MME (Bitfield-Mask: 0x01)                             */
#define USART_CR1_M0_Pos                 (12UL)                    /*!< M0 (Bit 12)                                           */
#define USART_CR1_M0_Msk                 (0x1000UL)                /*!< M0 (Bitfield-Mask: 0x01)                              */
#define USART_CR1_WAKE_Pos               (11UL)                    /*!< WAKE (Bit 11)                                         */
#define USART_CR1_WAKE_Msk               (0x800UL)                 /*!< WAKE (Bitfield-Mask: 0x01)                            */
#define USART_CR1_PCE_Pos                (10UL)                    /*!< PCE (Bit 10)                                          */
#define USART_CR1_PCE_Msk                (0x400UL)                 /*!< PCE (Bitfield-Mask: 0x01)                             */
#define USART_CR1_PS_Pos                 (9UL)                     /*!< PS (Bit 9)                                            */
#define USART_CR1_PS_Msk                 (0x200UL)                 /*!< PS (Bitfield-Mask: 0x01)                              */
#define USART_CR1_PEIE_Pos               (8UL)                     /*!< PEIE (Bit 8)                                          */
#define USART_CR1_PEIE_Msk               (0x100UL)                 /*!< PEIE (Bitfield-Mask: 0x01)                            */
#define USART_CR1_TXETXFNFIE_Pos         (7UL)                     /*!< TXETXFNFIE (Bit 7)                                    */
#define USART_CR1_TXETXFNFIE_Msk         (0x80UL)                  /*!< TXETXFNFIE (Bitfield-Mask: 0x01)                      */
#define USART_CR1_TCIE_Pos               (6UL)                     /*!< TCIE (Bit 6)                                          */
#define USART_CR1_TCIE_Msk               (0x40UL)                  /*!< TCIE (Bitfield-Mask: 0x01)                            */
#define USART_CR1_RXNERXFNEIE_Pos        (5UL)                     /*!< RXNERXFNEIE (Bit 5)                                   */
#define USART_CR1_RXNERXFNEIE_Msk        (0x20UL)                  /*!< RXNERXFNEIE (Bitfield-Mask: 0x01)                     */
#define USART_CR1_IDLEIE_Pos             (4UL)                     /*!< IDLEIE (Bit 4)                                        */
#define USART_CR1_IDLEIE_Msk             (0x10UL)                  /*!< IDLEIE (Bitfield-Mask: 0x01)                          */
#define USART_CR1_TE_Pos                 (3UL)                     /*!< TE (Bit 3)                                            */
#define USART_CR1_TE_Msk                 (0x8UL)                   /*!< TE (Bitfield-Mask: 0x01)                              */
#define USART_CR1_RE_Pos                 (2UL)                     /*!< RE (Bit 2)                                            */
#define USART_CR1_RE_Msk                 (0x4UL)                   /*!< RE (Bitfield-Mask: 0x01)                              */
#define USART_CR1_UE_Pos                 (0UL)                     /*!< UE (Bit 0)                                            */
#define USART_CR1_UE_Msk                 (0x1UL)                   /*!< UE (Bitfield-Mask: 0x01)                              */
/* ==========================================================  CR2  ========================================================== */
#define USART_CR2_ADDR_Pos               (24UL)                    /*!< ADDR (Bit 24)                                         */
#define USART_CR2_ADDR_Msk               (0xff000000UL)            /*!< ADDR (Bitfield-Mask: 0xff)                            */
#define USART_CR2_RTOEN_Pos              (23UL)                    /*!< RTOEN (Bit 23)                                        */
#define USART_CR2_RTOEN_Msk              (0x800000UL)              /*!< RTOEN (Bitfield-Mask: 0x01)                           */
#define USART_CR2_ABRMOD_Pos             (21UL)                    /*!< ABRMOD (Bit 21)                                       */
#define USART_CR2_ABRMOD_Msk             (0x600000UL)              /*!< ABRMOD (Bitfield-Mask: 0x03)                          */
#define USART_CR2_ABREN_Pos              (20UL)                    /*!< ABREN (Bit 20)                                        */
#define USART_CR2_ABREN_Msk              (0x100000UL)              /*!< ABREN (Bitfield-Mask: 0x01)                           */
#define USART_CR2_MSBFIRST_Pos           (19UL)                    /*!< MSBFIRST (Bit 19)                                     */
#define USART_CR2_MSBFIRST_Msk           (0x80000UL)               /*!< MSBFIRST (Bitfield-Mask: 0x01)                        */
#define USART_CR2_DATAINV_Pos            (18UL)                    /*!< DATAINV (Bit 18)                                      */
#define USART_CR2_DATAINV_Msk            (0x40000UL)               /*!< DATAINV (Bitfield-Mask: 0x01)                         */
#define USART_CR2_TXINV_Pos              (17UL)                    /*!< TXINV (Bit 17)                                        */
#define USART_CR2_TXINV_Msk              (0x20000UL)               /*!< TXINV (Bitfield-Mask: 0x01)                           */
#define USART_CR2_RXINV_Pos              (16UL)                    /*!< RXINV (Bit 16)                                        */
#define USART_CR2_RXINV_Msk              (0x10000UL)               /*!< RXINV (Bitfield-Mask: 0x01)                           */
#define USART_CR2_SWAP_Pos               (15UL)                    /*!< SWAP (Bit 15)                                         */
#define USART_CR2_SWAP_Msk               (0x8000UL)                /*!< SWAP (Bitfield-Mask: 0x01)                            */
#define USART_CR2_LINEN_Pos              (14UL)                    /*!< LINEN (Bit 14)                                        */
#define USART_CR2_LINEN_Msk              (0x4000UL)                /*!< LINEN (Bitfield-Mask: 0x01)                           */
#define USART_CR2_STOP_Pos               (12UL)                    /*!< STOP (Bit 12)                                         */
#define USART_CR2_STOP_Msk               (0x3000UL)                /*!< STOP (Bitfield-Mask: 0x03)                            */
#define USART_CR2_CLKEN_Pos              (11UL)                    /*!< CLKEN (Bit 11)                                        */
#define USART_CR2_CLKEN_Msk              (0x800UL)                 /*!< CLKEN (Bitfield-Mask: 0x01)                           */
#define USART_CR2_CPOL_Pos               (10UL)                    /*!< CPOL (Bit 10)                                         */
#define USART_CR2_CPOL_Msk               (0x400UL)                 /*!< CPOL (Bitfield-Mask: 0x01)                            */
#define USART_CR2_CPHA_Pos               (9UL)                     /*!< CPHA (Bit 9)                                          */
#define USART_CR2_CPHA_Msk               (0x200UL)                 /*!< CPHA (Bitfield-Mask: 0x01)                            */
#define USART_CR2_LBCL_Pos               (8UL)                     /*!< LBCL (Bit 8)                                          */
#define USART_CR2_LBCL_Msk               (0x100UL)                 /*!< LBCL (Bitfield-Mask: 0x01)                            */
#define USART_CR2_PM_Pos                 (7UL)                     /*!< PM (Bit 7)                                            */
#define USART_CR2_PM_Msk                 (0x80UL)                  /*!< PM (Bitfield-Mask: 0x01)                              */
#define USART_CR2_LBDIE_Pos              (6UL)                     /*!< LBDIE (Bit 6)                                         */
#define USART_CR2_LBDIE_Msk              (0x40UL)                  /*!< LBDIE (Bitfield-Mask: 0x01)                           */
#define USART_CR2_LBDL_Pos               (5UL)                     /*!< LBDL (Bit 5)                                          */
#define USART_CR2_LBDL_Msk               (0x20UL)                  /*!< LBDL (Bitfield-Mask: 0x01)                            */
#define USART_CR2_ADDM7_Pos              (4UL)                     /*!< ADDM7 (Bit 4)                                         */
#define USART_CR2_ADDM7_Msk              (0x10UL)                  /*!< ADDM7 (Bitfield-Mask: 0x01)                           */
#define USART_CR2_M2_Pos                 (2UL)                     /*!< M2 (Bit 2)                                            */
#define USART_CR2_M2_Msk                 (0x4UL)                   /*!< M2 (Bitfield-Mask: 0x01)                              */
#define USART_CR2_LBE_Pos                (1UL)                     /*!< LBE (Bit 1)                                           */
#define USART_CR2_LBE_Msk                (0x2UL)                   /*!< LBE (Bitfield-Mask: 0x01)                             */
/* ==========================================================  CR3  ========================================================== */
#define USART_CR3_TXFTCFG_Pos            (29UL)                    /*!< TXFTCFG (Bit 29)                                      */
#define USART_CR3_TXFTCFG_Msk            (0xe0000000UL)            /*!< TXFTCFG (Bitfield-Mask: 0x07)                         */
#define USART_CR3_RXFTIE_Pos             (28UL)                    /*!< RXFTIE (Bit 28)                                       */
#define USART_CR3_RXFTIE_Msk             (0x10000000UL)            /*!< RXFTIE (Bitfield-Mask: 0x01)                          */
#define USART_CR3_RXFTCFG_Pos            (25UL)                    /*!< RXFTCFG (Bit 25)                                      */
#define USART_CR3_RXFTCFG_Msk            (0xe000000UL)             /*!< RXFTCFG (Bitfield-Mask: 0x07)                         */
#define USART_CR3_TXFTIE_Pos             (23UL)                    /*!< TXFTIE (Bit 23)                                       */
#define USART_CR3_TXFTIE_Msk             (0x800000UL)              /*!< TXFTIE (Bitfield-Mask: 0x01)                          */
#define USART_CR3_DEP_Pos                (15UL)                    /*!< DEP (Bit 15)                                          */
#define USART_CR3_DEP_Msk                (0x8000UL)                /*!< DEP (Bitfield-Mask: 0x01)                             */
#define USART_CR3_DEM_Pos                (14UL)                    /*!< DEM (Bit 14)                                          */
#define USART_CR3_DEM_Msk                (0x4000UL)                /*!< DEM (Bitfield-Mask: 0x01)                             */
#define USART_CR3_DDRE_Pos               (13UL)                    /*!< DDRE (Bit 13)                                         */
#define USART_CR3_DDRE_Msk               (0x2000UL)                /*!< DDRE (Bitfield-Mask: 0x01)                            */
#define USART_CR3_OVRDIS_Pos             (12UL)                    /*!< OVRDIS (Bit 12)                                       */
#define USART_CR3_OVRDIS_Msk             (0x1000UL)                /*!< OVRDIS (Bitfield-Mask: 0x01)                          */
#define USART_CR3_ONEBIT_Pos             (11UL)                    /*!< ONEBIT (Bit 11)                                       */
#define USART_CR3_ONEBIT_Msk             (0x800UL)                 /*!< ONEBIT (Bitfield-Mask: 0x01)                          */
#define USART_CR3_CTSIE_Pos              (10UL)                    /*!< CTSIE (Bit 10)                                        */
#define USART_CR3_CTSIE_Msk              (0x400UL)                 /*!< CTSIE (Bitfield-Mask: 0x01)                           */
#define USART_CR3_CTSE_Pos               (9UL)                     /*!< CTSE (Bit 9)                                          */
#define USART_CR3_CTSE_Msk               (0x200UL)                 /*!< CTSE (Bitfield-Mask: 0x01)                            */
#define USART_CR3_RTSE_Pos               (8UL)                     /*!< RTSE (Bit 8)                                          */
#define USART_CR3_RTSE_Msk               (0x100UL)                 /*!< RTSE (Bitfield-Mask: 0x01)                            */
#define USART_CR3_DMAT_Pos               (7UL)                     /*!< DMAT (Bit 7)                                          */
#define USART_CR3_DMAT_Msk               (0x80UL)                  /*!< DMAT (Bitfield-Mask: 0x01)                            */
#define USART_CR3_DMAR_Pos               (6UL)                     /*!< DMAR (Bit 6)                                          */
#define USART_CR3_DMAR_Msk               (0x40UL)                  /*!< DMAR (Bitfield-Mask: 0x01)                            */
#define USART_CR3_HDSEL_Pos              (3UL)                     /*!< HDSEL (Bit 3)                                         */
#define USART_CR3_HDSEL_Msk              (0x8UL)                   /*!< HDSEL (Bitfield-Mask: 0x01)                           */
#define USART_CR3_EIE_Pos                (0UL)                     /*!< EIE (Bit 0)                                           */
#define USART_CR3_EIE_Msk                (0x1UL)                   /*!< EIE (Bitfield-Mask: 0x01)                             */
/* ==========================================================  BRR  ========================================================== */
#define USART_BRR_BRR_Pos                (0UL)                     /*!< BRR (Bit 0)                                           */
#define USART_BRR_BRR_Msk                (0xffffUL)                /*!< BRR (Bitfield-Mask: 0xffff)                           */
/* =========================================================  RTOR  ========================================================== */
#define USART_RTOR_RTO_Pos               (0UL)                     /*!< RTO (Bit 0)                                           */
#define USART_RTOR_RTO_Msk               (0xffffffUL)              /*!< RTO (Bitfield-Mask: 0xffffff)                         */
/* ==========================================================  RQR  ========================================================== */
#define USART_RQR_TXFRQ_Pos              (4UL)                     /*!< TXFRQ (Bit 4)                                         */
#define USART_RQR_TXFRQ_Msk              (0x10UL)                  /*!< TXFRQ (Bitfield-Mask: 0x01)                           */
#define USART_RQR_RXFRQ_Pos              (3UL)                     /*!< RXFRQ (Bit 3)                                         */
#define USART_RQR_RXFRQ_Msk              (0x8UL)                   /*!< RXFRQ (Bitfield-Mask: 0x01)                           */
#define USART_RQR_MMRQ_Pos               (2UL)                     /*!< MMRQ (Bit 2)                                          */
#define USART_RQR_MMRQ_Msk               (0x4UL)                   /*!< MMRQ (Bitfield-Mask: 0x01)                            */
#define USART_RQR_SBKRQ_Pos              (1UL)                     /*!< SBKRQ (Bit 1)                                         */
#define USART_RQR_SBKRQ_Msk              (0x2UL)                   /*!< SBKRQ (Bitfield-Mask: 0x01)                           */
#define USART_RQR_ABRRQ_Pos              (0UL)                     /*!< ABRRQ (Bit 0)                                         */
#define USART_RQR_ABRRQ_Msk              (0x1UL)                   /*!< ABRRQ (Bitfield-Mask: 0x01)                           */
/* ==========================================================  ISR  ========================================================== */
#define USART_ISR_TXFT_Pos               (27UL)                    /*!< TXFT (Bit 27)                                         */
#define USART_ISR_TXFT_Msk               (0x8000000UL)             /*!< TXFT (Bitfield-Mask: 0x01)                            */
#define USART_ISR_RXFT_Pos               (26UL)                    /*!< RXFT (Bit 26)                                         */
#define USART_ISR_RXFT_Msk               (0x4000000UL)             /*!< RXFT (Bitfield-Mask: 0x01)                            */
#define USART_ISR_RXFF_Pos               (24UL)                    /*!< RXFF (Bit 24)                                         */
#define USART_ISR_RXFF_Msk               (0x1000000UL)             /*!< RXFF (Bitfield-Mask: 0x01)                            */
#define USART_ISR_TXFE_Pos               (23UL)                    /*!< TXFE (Bit 23)                                         */
#define USART_ISR_TXFE_Msk               (0x800000UL)              /*!< TXFE (Bitfield-Mask: 0x01)                            */
#define USART_ISR_TEACK_Pos              (21UL)                    /*!< TEACK (Bit 21)                                        */
#define USART_ISR_TEACK_Msk              (0x200000UL)              /*!< TEACK (Bitfield-Mask: 0x01)                           */
#define USART_ISR_RWU_Pos                (19UL)                    /*!< RWU (Bit 19)                                          */
#define USART_ISR_RWU_Msk                (0x80000UL)               /*!< RWU (Bitfield-Mask: 0x01)                             */
#define USART_ISR_SBKF_Pos               (18UL)                    /*!< SBKF (Bit 18)                                         */
#define USART_ISR_SBKF_Msk               (0x40000UL)               /*!< SBKF (Bitfield-Mask: 0x01)                            */
#define USART_ISR_CMF_Pos                (17UL)                    /*!< CMF (Bit 17)                                          */
#define USART_ISR_CMF_Msk                (0x20000UL)               /*!< CMF (Bitfield-Mask: 0x01)                             */
#define USART_ISR_BUSY_Pos               (16UL)                    /*!< BUSY (Bit 16)                                         */
#define USART_ISR_BUSY_Msk               (0x10000UL)               /*!< BUSY (Bitfield-Mask: 0x01)                            */
#define USART_ISR_ABRF_Pos               (15UL)                    /*!< ABRF (Bit 15)                                         */
#define USART_ISR_ABRF_Msk               (0x8000UL)                /*!< ABRF (Bitfield-Mask: 0x01)                            */
#define USART_ISR_ABRE_Pos               (14UL)                    /*!< ABRE (Bit 14)                                         */
#define USART_ISR_ABRE_Msk               (0x4000UL)                /*!< ABRE (Bitfield-Mask: 0x01)                            */
#define USART_ISR_RTOF_Pos               (11UL)                    /*!< RTOF (Bit 11)                                         */
#define USART_ISR_RTOF_Msk               (0x800UL)                 /*!< RTOF (Bitfield-Mask: 0x01)                            */
#define USART_ISR_CTS_Pos                (10UL)                    /*!< CTS (Bit 10)                                          */
#define USART_ISR_CTS_Msk                (0x400UL)                 /*!< CTS (Bitfield-Mask: 0x01)                             */
#define USART_ISR_CTSIF_Pos              (9UL)                     /*!< CTSIF (Bit 9)                                         */
#define USART_ISR_CTSIF_Msk              (0x200UL)                 /*!< CTSIF (Bitfield-Mask: 0x01)                           */
#define USART_ISR_LBDF_Pos               (8UL)                     /*!< LBDF (Bit 8)                                          */
#define USART_ISR_LBDF_Msk               (0x100UL)                 /*!< LBDF (Bitfield-Mask: 0x01)                            */
#define USART_ISR_TXETXFNF_Pos           (7UL)                     /*!< TXETXFNF (Bit 7)                                      */
#define USART_ISR_TXETXFNF_Msk           (0x80UL)                  /*!< TXETXFNF (Bitfield-Mask: 0x01)                        */
#define USART_ISR_TC_Pos                 (6UL)                     /*!< TC (Bit 6)                                            */
#define USART_ISR_TC_Msk                 (0x40UL)                  /*!< TC (Bitfield-Mask: 0x01)                              */
#define USART_ISR_RXNERXFNE_Pos          (5UL)                     /*!< RXNERXFNE (Bit 5)                                     */
#define USART_ISR_RXNERXFNE_Msk          (0x20UL)                  /*!< RXNERXFNE (Bitfield-Mask: 0x01)                       */
#define USART_ISR_IDLE_Pos               (4UL)                     /*!< IDLE (Bit 4)                                          */
#define USART_ISR_IDLE_Msk               (0x10UL)                  /*!< IDLE (Bitfield-Mask: 0x01)                            */
#define USART_ISR_ORE_Pos                (3UL)                     /*!< ORE (Bit 3)                                           */
#define USART_ISR_ORE_Msk                (0x8UL)                   /*!< ORE (Bitfield-Mask: 0x01)                             */
#define USART_ISR_NE_Pos                 (2UL)                     /*!< NE (Bit 2)                                            */
#define USART_ISR_NE_Msk                 (0x4UL)                   /*!< NE (Bitfield-Mask: 0x01)                              */
#define USART_ISR_FE_Pos                 (1UL)                     /*!< FE (Bit 1)                                            */
#define USART_ISR_FE_Msk                 (0x2UL)                   /*!< FE (Bitfield-Mask: 0x01)                              */
#define USART_ISR_PE_Pos                 (0UL)                     /*!< PE (Bit 0)                                            */
#define USART_ISR_PE_Msk                 (0x1UL)                   /*!< PE (Bitfield-Mask: 0x01)                              */
/* ==========================================================  ICR  ========================================================== */
#define USART_ICR_CMCF_Pos               (17UL)                    /*!< CMCF (Bit 17)                                         */
#define USART_ICR_CMCF_Msk               (0x20000UL)               /*!< CMCF (Bitfield-Mask: 0x01)                            */
#define USART_ICR_RTOCF_Pos              (11UL)                    /*!< RTOCF (Bit 11)                                        */
#define USART_ICR_RTOCF_Msk              (0x800UL)                 /*!< RTOCF (Bitfield-Mask: 0x01)                           */
#define USART_ICR_CTSCF_Pos              (9UL)                     /*!< CTSCF (Bit 9)                                         */
#define USART_ICR_CTSCF_Msk              (0x200UL)                 /*!< CTSCF (Bitfield-Mask: 0x01)                           */
#define USART_ICR_LBDCF_Pos              (8UL)                     /*!< LBDCF (Bit 8)                                         */
#define USART_ICR_LBDCF_Msk              (0x100UL)                 /*!< LBDCF (Bitfield-Mask: 0x01)                           */
#define USART_ICR_TCCF_Pos               (6UL)                     /*!< TCCF (Bit 6)                                          */
#define USART_ICR_TCCF_Msk               (0x40UL)                  /*!< TCCF (Bitfield-Mask: 0x01)                            */
#define USART_ICR_TXFECF_Pos             (5UL)                     /*!< TXFECF (Bit 5)                                        */
#define USART_ICR_TXFECF_Msk             (0x20UL)                  /*!< TXFECF (Bitfield-Mask: 0x01)                          */
#define USART_ICR_IDLECF_Pos             (4UL)                     /*!< IDLECF (Bit 4)                                        */
#define USART_ICR_IDLECF_Msk             (0x10UL)                  /*!< IDLECF (Bitfield-Mask: 0x01)                          */
#define USART_ICR_ORECF_Pos              (3UL)                     /*!< ORECF (Bit 3)                                         */
#define USART_ICR_ORECF_Msk              (0x8UL)                   /*!< ORECF (Bitfield-Mask: 0x01)                           */
#define USART_ICR_NECF_Pos               (2UL)                     /*!< NECF (Bit 2)                                          */
#define USART_ICR_NECF_Msk               (0x4UL)                   /*!< NECF (Bitfield-Mask: 0x01)                            */
#define USART_ICR_FECF_Pos               (1UL)                     /*!< FECF (Bit 1)                                          */
#define USART_ICR_FECF_Msk               (0x2UL)                   /*!< FECF (Bitfield-Mask: 0x01)                            */
#define USART_ICR_PECF_Pos               (0UL)                     /*!< PECF (Bit 0)                                          */
#define USART_ICR_PECF_Msk               (0x1UL)                   /*!< PECF (Bitfield-Mask: 0x01)                            */
/* ==========================================================  RDR  ========================================================== */
#define USART_RDR_RDR_Pos                (0UL)                     /*!< RDR (Bit 0)                                           */
#define USART_RDR_RDR_Msk                (0x1ffUL)                 /*!< RDR (Bitfield-Mask: 0x1ff)                            */
/* ==========================================================  TDR  ========================================================== */
#define USART_TDR_TDR_Pos                (0UL)                     /*!< TDR (Bit 0)                                           */
#define USART_TDR_TDR_Msk                (0x1ffUL)                 /*!< TDR (Bitfield-Mask: 0x1ff)                            */
/* =========================================================  PRESC  ========================================================= */
#define USART_PRESC_PRESCALER_Pos        (0UL)                     /*!< PRESCALER (Bit 0)                                     */
#define USART_PRESC_PRESCALER_Msk        (0xfUL)                   /*!< PRESCALER (Bitfield-Mask: 0x0f)                       */


/* =========================================================================================================================== */
/* ================                                          SPI_IIS                                          ================ */
/* =========================================================================================================================== */

/* =========================================================  CTL0  ========================================================== */
#define SPI_IIS_CTL0_BIDEN_Pos           (15UL)                    /*!< BIDEN (Bit 15)                                        */
#define SPI_IIS_CTL0_BIDEN_Msk           (0x8000UL)                /*!< BIDEN (Bitfield-Mask: 0x01)                           */
#define SPI_IIS_CTL0_BIDOEN_Pos          (14UL)                    /*!< BIDOEN (Bit 14)                                       */
#define SPI_IIS_CTL0_BIDOEN_Msk          (0x4000UL)                /*!< BIDOEN (Bitfield-Mask: 0x01)                          */
#define SPI_IIS_CTL0_CRCEN_Pos           (13UL)                    /*!< CRCEN (Bit 13)                                        */
#define SPI_IIS_CTL0_CRCEN_Msk           (0x2000UL)                /*!< CRCEN (Bitfield-Mask: 0x01)                           */
#define SPI_IIS_CTL0_CRCNEXT_Pos         (12UL)                    /*!< CRCNEXT (Bit 12)                                      */
#define SPI_IIS_CTL0_CRCNEXT_Msk         (0x1000UL)                /*!< CRCNEXT (Bitfield-Mask: 0x01)                         */
#define SPI_IIS_CTL0_FRMFORMAT_Pos       (11UL)                    /*!< FRMFORMAT (Bit 11)                                    */
#define SPI_IIS_CTL0_FRMFORMAT_Msk       (0x800UL)                 /*!< FRMFORMAT (Bitfield-Mask: 0x01)                       */
#define SPI_IIS_CTL0_RXONLY_Pos          (10UL)                    /*!< RXONLY (Bit 10)                                       */
#define SPI_IIS_CTL0_RXONLY_Msk          (0x400UL)                 /*!< RXONLY (Bitfield-Mask: 0x01)                          */
#define SPI_IIS_CTL0_SWNSSEN_Pos         (9UL)                     /*!< SWNSSEN (Bit 9)                                       */
#define SPI_IIS_CTL0_SWNSSEN_Msk         (0x200UL)                 /*!< SWNSSEN (Bitfield-Mask: 0x01)                         */
#define SPI_IIS_CTL0_SWNSS_Pos           (8UL)                     /*!< SWNSS (Bit 8)                                         */
#define SPI_IIS_CTL0_SWNSS_Msk           (0x100UL)                 /*!< SWNSS (Bitfield-Mask: 0x01)                           */
#define SPI_IIS_CTL0_LSBF_Pos            (7UL)                     /*!< LSBF (Bit 7)                                          */
#define SPI_IIS_CTL0_LSBF_Msk            (0x80UL)                  /*!< LSBF (Bitfield-Mask: 0x01)                            */
#define SPI_IIS_CTL0_EN_Pos              (6UL)                     /*!< EN (Bit 6)                                            */
#define SPI_IIS_CTL0_EN_Msk              (0x40UL)                  /*!< EN (Bitfield-Mask: 0x01)                              */
#define SPI_IIS_CTL0_PRESCALER_Pos       (3UL)                     /*!< PRESCALER (Bit 3)                                     */
#define SPI_IIS_CTL0_PRESCALER_Msk       (0x38UL)                  /*!< PRESCALER (Bitfield-Mask: 0x07)                       */
#define SPI_IIS_CTL0_MSTR_Pos            (2UL)                     /*!< MSTR (Bit 2)                                          */
#define SPI_IIS_CTL0_MSTR_Msk            (0x4UL)                   /*!< MSTR (Bitfield-Mask: 0x01)                            */
#define SPI_IIS_CTL0_CKPL_Pos            (1UL)                     /*!< CKPL (Bit 1)                                          */
#define SPI_IIS_CTL0_CKPL_Msk            (0x2UL)                   /*!< CKPL (Bitfield-Mask: 0x01)                            */
#define SPI_IIS_CTL0_CKPH_Pos            (0UL)                     /*!< CKPH (Bit 0)                                          */
#define SPI_IIS_CTL0_CKPH_Msk            (0x1UL)                   /*!< CKPH (Bitfield-Mask: 0x01)                            */
/* =========================================================  CTL1  ========================================================== */
#define SPI_IIS_CTL1_RXMASK_Pos          (15UL)                    /*!< RXMASK (Bit 15)                                       */
#define SPI_IIS_CTL1_RXMASK_Msk          (0x8000UL)                /*!< RXMASK (Bitfield-Mask: 0x01)                          */
#define SPI_IIS_CTL1_RXFFIE_Pos          (14UL)                    /*!< RXFFIE (Bit 14)                                       */
#define SPI_IIS_CTL1_RXFFIE_Msk          (0x4000UL)                /*!< RXFFIE (Bitfield-Mask: 0x01)                          */
#define SPI_IIS_CTL1_TXFAEIE_Pos         (13UL)                    /*!< TXFAEIE (Bit 13)                                      */
#define SPI_IIS_CTL1_TXFAEIE_Msk         (0x2000UL)                /*!< TXFAEIE (Bitfield-Mask: 0x01)                         */
#define SPI_IIS_CTL1_TXFEIE_Pos          (7UL)                     /*!< TXFEIE (Bit 7)                                        */
#define SPI_IIS_CTL1_TXFEIE_Msk          (0x80UL)                  /*!< TXFEIE (Bitfield-Mask: 0x01)                          */
#define SPI_IIS_CTL1_RXFNEIE_Pos         (6UL)                     /*!< RXFNEIE (Bit 6)                                       */
#define SPI_IIS_CTL1_RXFNEIE_Msk         (0x40UL)                  /*!< RXFNEIE (Bitfield-Mask: 0x01)                         */
#define SPI_IIS_CTL1_ERRIE_Pos           (5UL)                     /*!< ERRIE (Bit 5)                                         */
#define SPI_IIS_CTL1_ERRIE_Msk           (0x20UL)                  /*!< ERRIE (Bitfield-Mask: 0x01)                           */
#define SPI_IIS_CTL1_TIMODE_Pos          (4UL)                     /*!< TIMODE (Bit 4)                                        */
#define SPI_IIS_CTL1_TIMODE_Msk          (0x10UL)                  /*!< TIMODE (Bitfield-Mask: 0x01)                          */
#define SPI_IIS_CTL1_NSSMODE_Pos         (3UL)                     /*!< NSSMODE (Bit 3)                                       */
#define SPI_IIS_CTL1_NSSMODE_Msk         (0x8UL)                   /*!< NSSMODE (Bitfield-Mask: 0x01)                         */
#define SPI_IIS_CTL1_NSSOESEL_Pos        (2UL)                     /*!< NSSOESEL (Bit 2)                                      */
#define SPI_IIS_CTL1_NSSOESEL_Msk        (0x4UL)                   /*!< NSSOESEL (Bitfield-Mask: 0x01)                        */
#define SPI_IIS_CTL1_DMATXEN_Pos         (1UL)                     /*!< DMATXEN (Bit 1)                                       */
#define SPI_IIS_CTL1_DMATXEN_Msk         (0x2UL)                   /*!< DMATXEN (Bitfield-Mask: 0x01)                         */
#define SPI_IIS_CTL1_DMARXEN_Pos         (0UL)                     /*!< DMARXEN (Bit 0)                                       */
#define SPI_IIS_CTL1_DMARXEN_Msk         (0x1UL)                   /*!< DMARXEN (Bitfield-Mask: 0x01)                         */
/* =========================================================  STAT  ========================================================== */
#define SPI_IIS_STAT_RXFEMPTYFLAG_Pos    (15UL)                    /*!< RXFEMPTYFLAG (Bit 15)                                 */
#define SPI_IIS_STAT_RXFEMPTYFLAG_Msk    (0x8000UL)                /*!< RXFEMPTYFLAG (Bitfield-Mask: 0x01)                    */
#define SPI_IIS_STAT_RXFFULLFLAG_Pos     (14UL)                    /*!< RXFFULLFLAG (Bit 14)                                  */
#define SPI_IIS_STAT_RXFFULLFLAG_Msk     (0x4000UL)                /*!< RXFFULLFLAG (Bitfield-Mask: 0x01)                     */
#define SPI_IIS_STAT_TXFAEMPTYFLAG_Pos   (13UL)                    /*!< TXFAEMPTYFLAG (Bit 13)                                */
#define SPI_IIS_STAT_TXFAEMPTYFLAG_Msk   (0x2000UL)                /*!< TXFAEMPTYFLAG (Bitfield-Mask: 0x01)                   */
#define SPI_IIS_STAT_TXFFULLFLAG_Pos     (12UL)                    /*!< TXFFULLFLAG (Bit 12)                                  */
#define SPI_IIS_STAT_TXFFULLFLAG_Msk     (0x1000UL)                /*!< TXFFULLFLAG (Bitfield-Mask: 0x01)                     */
#define SPI_IIS_STAT_DATATRANS_Pos       (9UL)                     /*!< DATATRANS (Bit 9)                                     */
#define SPI_IIS_STAT_DATATRANS_Msk       (0x200UL)                 /*!< DATATRANS (Bitfield-Mask: 0x01)                       */
#define SPI_IIS_STAT_FRMERR_Pos          (8UL)                     /*!< FRMERR (Bit 8)                                        */
#define SPI_IIS_STAT_FRMERR_Msk          (0x100UL)                 /*!< FRMERR (Bitfield-Mask: 0x01)                          */
#define SPI_IIS_STAT_BUSY_Pos            (7UL)                     /*!< BUSY (Bit 7)                                          */
#define SPI_IIS_STAT_BUSY_Msk            (0x80UL)                  /*!< BUSY (Bitfield-Mask: 0x01)                            */
#define SPI_IIS_STAT_RXFOVERFLOW_Pos     (6UL)                     /*!< RXFOVERFLOW (Bit 6)                                   */
#define SPI_IIS_STAT_RXFOVERFLOW_Msk     (0x40UL)                  /*!< RXFOVERFLOW (Bitfield-Mask: 0x01)                     */
#define SPI_IIS_STAT_MODEFAULT_Pos       (5UL)                     /*!< MODEFAULT (Bit 5)                                     */
#define SPI_IIS_STAT_MODEFAULT_Msk       (0x20UL)                  /*!< MODEFAULT (Bitfield-Mask: 0x01)                       */
#define SPI_IIS_STAT_CRCERR_Pos          (4UL)                     /*!< CRCERR (Bit 4)                                        */
#define SPI_IIS_STAT_CRCERR_Msk          (0x10UL)                  /*!< CRCERR (Bitfield-Mask: 0x01)                          */
#define SPI_IIS_STAT_TXFUNDERFLOW_Pos    (3UL)                     /*!< TXFUNDERFLOW (Bit 3)                                  */
#define SPI_IIS_STAT_TXFUNDERFLOW_Msk    (0x8UL)                   /*!< TXFUNDERFLOW (Bitfield-Mask: 0x01)                    */
#define SPI_IIS_STAT_IISCH_Pos           (2UL)                     /*!< IISCH (Bit 2)                                         */
#define SPI_IIS_STAT_IISCH_Msk           (0x4UL)                   /*!< IISCH (Bitfield-Mask: 0x01)                           */
#define SPI_IIS_STAT_TXEFLAG_Pos         (1UL)                     /*!< TXEFLAG (Bit 1)                                       */
#define SPI_IIS_STAT_TXEFLAG_Msk         (0x2UL)                   /*!< TXEFLAG (Bitfield-Mask: 0x01)                         */
#define SPI_IIS_STAT_RXNEFLAG_Pos        (0UL)                     /*!< RXNEFLAG (Bit 0)                                      */
#define SPI_IIS_STAT_RXNEFLAG_Msk        (0x1UL)                   /*!< RXNEFLAG (Bitfield-Mask: 0x01)                        */
/* =========================================================  DATA  ========================================================== */
#define SPI_IIS_DATA_DAT_Pos             (0UL)                     /*!< DAT (Bit 0)                                           */
#define SPI_IIS_DATA_DAT_Msk             (0xffffffffUL)            /*!< DAT (Bitfield-Mask: 0xffffffff)                       */
/* ========================================================  CRCPOLY  ======================================================== */
#define SPI_IIS_CRCPOLY_CRCPOLY_Pos      (0UL)                     /*!< CRCPOLY (Bit 0)                                       */
#define SPI_IIS_CRCPOLY_CRCPOLY_Msk      (0xffffUL)                /*!< CRCPOLY (Bitfield-Mask: 0xffff)                       */
/* =========================================================  RXCRC  ========================================================= */
#define SPI_IIS_RXCRC_CRCRXRSLT_Pos      (0UL)                     /*!< CRCRXRSLT (Bit 0)                                     */
#define SPI_IIS_RXCRC_CRCRXRSLT_Msk      (0xffffUL)                /*!< CRCRXRSLT (Bitfield-Mask: 0xffff)                     */
/* =========================================================  TXCRC  ========================================================= */
#define SPI_IIS_TXCRC_CRCTXRSLT_Pos      (0UL)                     /*!< CRCTXRSLT (Bit 0)                                     */
#define SPI_IIS_TXCRC_CRCTXRSLT_Msk      (0xffffUL)                /*!< CRCTXRSLT (Bitfield-Mask: 0xffff)                     */
/* ========================================================  IISCFG0  ======================================================== */
#define SPI_IIS_IISCFG0_IISSEL_Pos       (11UL)                    /*!< IISSEL (Bit 11)                                       */
#define SPI_IIS_IISCFG0_IISSEL_Msk       (0x800UL)                 /*!< IISSEL (Bitfield-Mask: 0x01)                          */
#define SPI_IIS_IISCFG0_IISEN_Pos        (10UL)                    /*!< IISEN (Bit 10)                                        */
#define SPI_IIS_IISCFG0_IISEN_Msk        (0x400UL)                 /*!< IISEN (Bitfield-Mask: 0x01)                           */
#define SPI_IIS_IISCFG0_IISMODE_Pos      (8UL)                     /*!< IISMODE (Bit 8)                                       */
#define SPI_IIS_IISCFG0_IISMODE_Msk      (0x300UL)                 /*!< IISMODE (Bitfield-Mask: 0x03)                         */
#define SPI_IIS_IISCFG0_IISPCMSYNCSEL_Pos (7UL)                    /*!< IISPCMSYNCSEL (Bit 7)                                 */
#define SPI_IIS_IISCFG0_IISPCMSYNCSEL_Msk (0x80UL)                 /*!< IISPCMSYNCSEL (Bitfield-Mask: 0x01)                   */
#define SPI_IIS_IISCFG0_IISSTD_Pos       (4UL)                     /*!< IISSTD (Bit 4)                                        */
#define SPI_IIS_IISCFG0_IISSTD_Msk       (0x30UL)                  /*!< IISSTD (Bitfield-Mask: 0x03)                          */
#define SPI_IIS_IISCFG0_IISCKPL_Pos      (3UL)                     /*!< IISCKPL (Bit 3)                                       */
#define SPI_IIS_IISCFG0_IISCKPL_Msk      (0x8UL)                   /*!< IISCKPL (Bitfield-Mask: 0x01)                         */
#define SPI_IIS_IISCFG0_IISDATLEN_Pos    (1UL)                     /*!< IISDATLEN (Bit 1)                                     */
#define SPI_IIS_IISCFG0_IISDATLEN_Msk    (0x6UL)                   /*!< IISDATLEN (Bitfield-Mask: 0x03)                       */
#define SPI_IIS_IISCFG0_IISCHNLEN_Pos    (0UL)                     /*!< IISCHNLEN (Bit 0)                                     */
#define SPI_IIS_IISCFG0_IISCHNLEN_Msk    (0x1UL)                   /*!< IISCHNLEN (Bitfield-Mask: 0x01)                       */
/* ========================================================  IISCFG1  ======================================================== */
#define SPI_IIS_IISCFG1_IISMCKOEN_Pos    (9UL)                     /*!< IISMCKOEN (Bit 9)                                     */
#define SPI_IIS_IISCFG1_IISMCKOEN_Msk    (0x200UL)                 /*!< IISMCKOEN (Bitfield-Mask: 0x01)                       */
#define SPI_IIS_IISCFG1_IISODDSCALER_Pos (8UL)                     /*!< IISODDSCALER (Bit 8)                                  */
#define SPI_IIS_IISCFG1_IISODDSCALER_Msk (0x100UL)                 /*!< IISODDSCALER (Bitfield-Mask: 0x01)                    */
#define SPI_IIS_IISCFG1_IISEVENSCALER_Pos (0UL)                    /*!< IISEVENSCALER (Bit 0)                                 */
#define SPI_IIS_IISCFG1_IISEVENSCALER_Msk (0xffUL)                 /*!< IISEVENSCALER (Bitfield-Mask: 0xff)                   */
/* ========================================================  EXTCFG0  ======================================================== */
#define SPI_IIS_EXTCFG0_FIFOBUFSEL_Pos   (15UL)                    /*!< FIFOBUFSEL (Bit 15)                                   */
#define SPI_IIS_EXTCFG0_FIFOBUFSEL_Msk   (0x8000UL)                /*!< FIFOBUFSEL (Bitfield-Mask: 0x01)                      */
#define SPI_IIS_EXTCFG0_IISLRCKPOLAR_Pos (13UL)                    /*!< IISLRCKPOLAR (Bit 13)                                 */
#define SPI_IIS_EXTCFG0_IISLRCKPOLAR_Msk (0x2000UL)                /*!< IISLRCKPOLAR (Bitfield-Mask: 0x01)                    */
#define SPI_IIS_EXTCFG0_IISFDEN_Pos      (12UL)                    /*!< IISFDEN (Bit 12)                                      */
#define SPI_IIS_EXTCFG0_IISFDEN_Msk      (0x1000UL)                /*!< IISFDEN (Bitfield-Mask: 0x01)                         */
#define SPI_IIS_EXTCFG0_IISHDEN_Pos      (11UL)                    /*!< IISHDEN (Bit 11)                                      */
#define SPI_IIS_EXTCFG0_IISHDEN_Msk      (0x800UL)                 /*!< IISHDEN (Bitfield-Mask: 0x01)                         */
#define SPI_IIS_EXTCFG0_IISDAT20BIT_Pos  (6UL)                     /*!< IISDAT20BIT (Bit 6)                                   */
#define SPI_IIS_EXTCFG0_IISDAT20BIT_Msk  (0x40UL)                  /*!< IISDAT20BIT (Bitfield-Mask: 0x01)                     */
#define SPI_IIS_EXTCFG0_RXCLKREVTS_Pos   (5UL)                     /*!< RXCLKREVTS (Bit 5)                                    */
#define SPI_IIS_EXTCFG0_RXCLKREVTS_Msk   (0x20UL)                  /*!< RXCLKREVTS (Bitfield-Mask: 0x01)                      */
#define SPI_IIS_EXTCFG0_IISCLKREVTM_Pos  (4UL)                     /*!< IISCLKREVTM (Bit 4)                                   */
#define SPI_IIS_EXTCFG0_IISCLKREVTM_Msk  (0x10UL)                  /*!< IISCLKREVTM (Bitfield-Mask: 0x01)                     */
#define SPI_IIS_EXTCFG0_IISLRCKRFIRST_Pos (3UL)                    /*!< IISLRCKRFIRST (Bit 3)                                 */
#define SPI_IIS_EXTCFG0_IISLRCKRFIRST_Msk (0x8UL)                  /*!< IISLRCKRFIRST (Bitfield-Mask: 0x01)                   */
#define SPI_IIS_EXTCFG0_IISLRCKSELEN_Pos (2UL)                     /*!< IISLRCKSELEN (Bit 2)                                  */
#define SPI_IIS_EXTCFG0_IISLRCKSELEN_Msk (0x4UL)                   /*!< IISLRCKSELEN (Bitfield-Mask: 0x01)                    */
#define SPI_IIS_EXTCFG0_ENDIANSEL_Pos    (1UL)                     /*!< ENDIANSEL (Bit 1)                                     */
#define SPI_IIS_EXTCFG0_ENDIANSEL_Msk    (0x2UL)                   /*!< ENDIANSEL (Bitfield-Mask: 0x01)                       */
/* ========================================================  FIFOCFG  ======================================================== */
#define SPI_IIS_FIFOCFG_RXFAFLVL_Pos     (8UL)                     /*!< RXFAFLVL (Bit 8)                                      */
#define SPI_IIS_FIFOCFG_RXFAFLVL_Msk     (0x700UL)                 /*!< RXFAFLVL (Bitfield-Mask: 0x07)                        */
#define SPI_IIS_FIFOCFG_TXFAELVL_Pos     (4UL)                     /*!< TXFAELVL (Bit 4)                                      */
#define SPI_IIS_FIFOCFG_TXFAELVL_Msk     (0x70UL)                  /*!< TXFAELVL (Bitfield-Mask: 0x07)                        */
/* ========================================================  CRCCFG  ========================================================= */
#define SPI_IIS_CRCCFG_CRCINIT_Pos       (0UL)                     /*!< CRCINIT (Bit 0)                                       */
#define SPI_IIS_CRCCFG_CRCINIT_Msk       (0xffffUL)                /*!< CRCINIT (Bitfield-Mask: 0xffff)                       */
/* ========================================================  EXTCFG1  ======================================================== */
#define SPI_IIS_EXTCFG1_CRCXOROUT_Pos    (13UL)                    /*!< CRCXOROUT (Bit 13)                                    */
#define SPI_IIS_EXTCFG1_CRCXOROUT_Msk    (0x2000UL)                /*!< CRCXOROUT (Bitfield-Mask: 0x01)                       */
#define SPI_IIS_EXTCFG1_LENCFGEN_Pos     (12UL)                    /*!< LENCFGEN (Bit 12)                                     */
#define SPI_IIS_EXTCFG1_LENCFGEN_Msk     (0x1000UL)                /*!< LENCFGEN (Bitfield-Mask: 0x01)                        */
#define SPI_IIS_EXTCFG1_LENCFG_Pos       (8UL)                     /*!< LENCFG (Bit 8)                                        */
#define SPI_IIS_EXTCFG1_LENCFG_Msk       (0xf00UL)                 /*!< LENCFG (Bitfield-Mask: 0x0f)                          */
#define SPI_IIS_EXTCFG1_DUMMYEN_Pos      (7UL)                     /*!< DUMMYEN (Bit 7)                                       */
#define SPI_IIS_EXTCFG1_DUMMYEN_Msk      (0x80UL)                  /*!< DUMMYEN (Bitfield-Mask: 0x01)                         */
#define SPI_IIS_EXTCFG1_DUMMYLEN_Pos     (4UL)                     /*!< DUMMYLEN (Bit 4)                                      */
#define SPI_IIS_EXTCFG1_DUMMYLEN_Msk     (0x70UL)                  /*!< DUMMYLEN (Bitfield-Mask: 0x07)                        */
/* ========================================================  EXTCFG2  ======================================================== */
#define SPI_IIS_EXTCFG2_NSSSEL_Pos       (13UL)                    /*!< NSSSEL (Bit 13)                                       */
#define SPI_IIS_EXTCFG2_NSSSEL_Msk       (0xe000UL)                /*!< NSSSEL (Bitfield-Mask: 0x07)                          */
#define SPI_IIS_EXTCFG2_SCKDLYEN_Pos     (7UL)                     /*!< SCKDLYEN (Bit 7)                                      */
#define SPI_IIS_EXTCFG2_SCKDLYEN_Msk     (0x80UL)                  /*!< SCKDLYEN (Bitfield-Mask: 0x01)                        */
#define SPI_IIS_EXTCFG2_SCKDLYLEN_Pos    (0UL)                     /*!< SCKDLYLEN (Bit 0)                                     */
#define SPI_IIS_EXTCFG2_SCKDLYLEN_Msk    (0x7fUL)                  /*!< SCKDLYLEN (Bitfield-Mask: 0x7f)                       */
/* ========================================================  EXTCFG3  ======================================================== */
#define SPI_IIS_EXTCFG3_DATDLYEN_Pos     (15UL)                    /*!< DATDLYEN (Bit 15)                                     */
#define SPI_IIS_EXTCFG3_DATDLYEN_Msk     (0x8000UL)                /*!< DATDLYEN (Bitfield-Mask: 0x01)                        */
#define SPI_IIS_EXTCFG3_DATDLYLEN_Pos    (8UL)                     /*!< DATDLYLEN (Bit 8)                                     */
#define SPI_IIS_EXTCFG3_DATDLYLEN_Msk    (0x7f00UL)                /*!< DATDLYLEN (Bitfield-Mask: 0x7f)                       */
#define SPI_IIS_EXTCFG3_NSSDLYEN_Pos     (7UL)                     /*!< NSSDLYEN (Bit 7)                                      */
#define SPI_IIS_EXTCFG3_NSSDLYEN_Msk     (0x80UL)                  /*!< NSSDLYEN (Bitfield-Mask: 0x01)                        */
#define SPI_IIS_EXTCFG3_NSSDLYLEN_Pos    (0UL)                     /*!< NSSDLYLEN (Bit 0)                                     */
#define SPI_IIS_EXTCFG3_NSSDLYLEN_Msk    (0x7fUL)                  /*!< NSSDLYLEN (Bitfield-Mask: 0x7f)                       */


/* =========================================================================================================================== */
/* ================                                          GPTMR0                                           ================ */
/* =========================================================================================================================== */

/* =========================================================  CTRL1  ========================================================= */
#define GPTMR_CTRL1_UPDIFREMAP_Pos       (11UL)                    /*!< UPDIFREMAP (Bit 11)                                   */
#define GPTMR_CTRL1_UPDIFREMAP_Msk       (0x800UL)                 /*!< UPDIFREMAP (Bitfield-Mask: 0x01)                      */
#define GPTMR_CTRL1_CLKDTFDIV_Pos        (8UL)                     /*!< CLKDTFDIV (Bit 8)                                     */
#define GPTMR_CTRL1_CLKDTFDIV_Msk        (0x300UL)                 /*!< CLKDTFDIV (Bitfield-Mask: 0x03)                       */
#define GPTMR_CTRL1_ARRSHDWEN_Pos        (7UL)                     /*!< ARRSHDWEN (Bit 7)                                     */
#define GPTMR_CTRL1_ARRSHDWEN_Msk        (0x80UL)                  /*!< ARRSHDWEN (Bitfield-Mask: 0x01)                       */
#define GPTMR_CTRL1_TCNTALIGNMODE_Pos    (5UL)                     /*!< TCNTALIGNMODE (Bit 5)                                 */
#define GPTMR_CTRL1_TCNTALIGNMODE_Msk    (0x60UL)                  /*!< TCNTALIGNMODE (Bitfield-Mask: 0x03)                   */
#define GPTMR_CTRL1_DIR_Pos              (4UL)                     /*!< DIR (Bit 4)                                           */
#define GPTMR_CTRL1_DIR_Msk              (0x10UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define GPTMR_CTRL1_SINGLEPLSMODE_Pos    (3UL)                     /*!< SINGLEPLSMODE (Bit 3)                                 */
#define GPTMR_CTRL1_SINGLEPLSMODE_Msk    (0x8UL)                   /*!< SINGLEPLSMODE (Bitfield-Mask: 0x01)                   */
#define GPTMR_CTRL1_UPDREQSRC_Pos        (2UL)                     /*!< UPDREQSRC (Bit 2)                                     */
#define GPTMR_CTRL1_UPDREQSRC_Msk        (0x4UL)                   /*!< UPDREQSRC (Bitfield-Mask: 0x01)                       */
#define GPTMR_CTRL1_UPDDIS_Pos           (1UL)                     /*!< UPDDIS (Bit 1)                                        */
#define GPTMR_CTRL1_UPDDIS_Msk           (0x2UL)                   /*!< UPDDIS (Bitfield-Mask: 0x01)                          */
#define GPTMR_CTRL1_TCNTEN_Pos           (0UL)                     /*!< TCNTEN (Bit 0)                                        */
#define GPTMR_CTRL1_TCNTEN_Msk           (0x1UL)                   /*!< TCNTEN (Bitfield-Mask: 0x01)                          */
/* =========================================================  CTRL2  ========================================================= */
#define GPTMR_CTRL2_MSTMODECTRLBIT3_Pos  (24UL)                    /*!< MSTMODECTRLBIT3 (Bit 24)                              */
#define GPTMR_CTRL2_MSTMODECTRLBIT3_Msk  (0x1000000UL)             /*!< MSTMODECTRLBIT3 (Bitfield-Mask: 0x01)                 */
#define GPTMR_CTRL2_CH3NOIS_Pos          (15UL)                    /*!< CH3NOIS (Bit 15)                                      */
#define GPTMR_CTRL2_CH3NOIS_Msk          (0x8000UL)                /*!< CH3NOIS (Bitfield-Mask: 0x01)                         */
#define GPTMR_CTRL2_CH3OIS_Pos           (14UL)                    /*!< CH3OIS (Bit 14)                                       */
#define GPTMR_CTRL2_CH3OIS_Msk           (0x4000UL)                /*!< CH3OIS (Bitfield-Mask: 0x01)                          */
#define GPTMR_CTRL2_CH2NOIS_Pos          (13UL)                    /*!< CH2NOIS (Bit 13)                                      */
#define GPTMR_CTRL2_CH2NOIS_Msk          (0x2000UL)                /*!< CH2NOIS (Bitfield-Mask: 0x01)                         */
#define GPTMR_CTRL2_CH2OIS_Pos           (12UL)                    /*!< CH2OIS (Bit 12)                                       */
#define GPTMR_CTRL2_CH2OIS_Msk           (0x1000UL)                /*!< CH2OIS (Bitfield-Mask: 0x01)                          */
#define GPTMR_CTRL2_CH1NOIS_Pos          (11UL)                    /*!< CH1NOIS (Bit 11)                                      */
#define GPTMR_CTRL2_CH1NOIS_Msk          (0x800UL)                 /*!< CH1NOIS (Bitfield-Mask: 0x01)                         */
#define GPTMR_CTRL2_CH1OIS_Pos           (10UL)                    /*!< CH1OIS (Bit 10)                                       */
#define GPTMR_CTRL2_CH1OIS_Msk           (0x400UL)                 /*!< CH1OIS (Bitfield-Mask: 0x01)                          */
#define GPTMR_CTRL2_CH0NOIS_Pos          (9UL)                     /*!< CH0NOIS (Bit 9)                                       */
#define GPTMR_CTRL2_CH0NOIS_Msk          (0x200UL)                 /*!< CH0NOIS (Bitfield-Mask: 0x01)                         */
#define GPTMR_CTRL2_CH0OIS_Pos           (8UL)                     /*!< CH0OIS (Bit 8)                                        */
#define GPTMR_CTRL2_CH0OIS_Msk           (0x100UL)                 /*!< CH0OIS (Bitfield-Mask: 0x01)                          */
#define GPTMR_CTRL2_TI0SEL_Pos           (7UL)                     /*!< TI0SEL (Bit 7)                                        */
#define GPTMR_CTRL2_TI0SEL_Msk           (0x80UL)                  /*!< TI0SEL (Bitfield-Mask: 0x01)                          */
#define GPTMR_CTRL2_MSTMODECTRL_Pos      (4UL)                     /*!< MSTMODECTRL (Bit 4)                                   */
#define GPTMR_CTRL2_MSTMODECTRL_Msk      (0x70UL)                  /*!< MSTMODECTRL (Bitfield-Mask: 0x07)                     */
#define GPTMR_CTRL2_CCDMAREQSRC_Pos      (3UL)                     /*!< CCDMAREQSRC (Bit 3)                                   */
#define GPTMR_CTRL2_CCDMAREQSRC_Msk      (0x8UL)                   /*!< CCDMAREQSRC (Bitfield-Mask: 0x01)                     */
#define GPTMR_CTRL2_CCUPDSRC_Pos         (2UL)                     /*!< CCUPDSRC (Bit 2)                                      */
#define GPTMR_CTRL2_CCUPDSRC_Msk         (0x4UL)                   /*!< CCUPDSRC (Bitfield-Mask: 0x01)                        */
#define GPTMR_CTRL2_CCSHWDEN_Pos         (0UL)                     /*!< CCSHWDEN (Bit 0)                                      */
#define GPTMR_CTRL2_CCSHWDEN_Msk         (0x1UL)                   /*!< CCSHWDEN (Bitfield-Mask: 0x01)                        */
/* =========================================================  SMCFG  ========================================================= */
#define GPTMR_SMCFG_ITRGSELBIT4_Pos      (21UL)                    /*!< ITRGSELBIT4 (Bit 21)                                  */
#define GPTMR_SMCFG_ITRGSELBIT4_Msk      (0x200000UL)              /*!< ITRGSELBIT4 (Bitfield-Mask: 0x01)                     */
#define GPTMR_SMCFG_ITRGSELBIT3_Pos      (20UL)                    /*!< ITRGSELBIT3 (Bit 20)                                  */
#define GPTMR_SMCFG_ITRGSELBIT3_Msk      (0x100000UL)              /*!< ITRGSELBIT3 (Bitfield-Mask: 0x01)                     */
#define GPTMR_SMCFG_OCREFCLRSEL_Pos      (16UL)                    /*!< OCREFCLRSEL (Bit 16)                                  */
#define GPTMR_SMCFG_OCREFCLRSEL_Msk      (0x10000UL)               /*!< OCREFCLRSEL (Bitfield-Mask: 0x01)                     */
#define GPTMR_SMCFG_ETRGP_Pos            (15UL)                    /*!< ETRGP (Bit 15)                                        */
#define GPTMR_SMCFG_ETRGP_Msk            (0x8000UL)                /*!< ETRGP (Bitfield-Mask: 0x01)                           */
#define GPTMR_SMCFG_EXTCLKMODE1EN_Pos    (14UL)                    /*!< EXTCLKMODE1EN (Bit 14)                                */
#define GPTMR_SMCFG_EXTCLKMODE1EN_Msk    (0x4000UL)                /*!< EXTCLKMODE1EN (Bitfield-Mask: 0x01)                   */
#define GPTMR_SMCFG_ETRGFDIVCFG_Pos      (12UL)                    /*!< ETRGFDIVCFG (Bit 12)                                  */
#define GPTMR_SMCFG_ETRGFDIVCFG_Msk      (0x3000UL)                /*!< ETRGFDIVCFG (Bitfield-Mask: 0x03)                     */
#define GPTMR_SMCFG_ETRGFILTCFG_Pos      (8UL)                     /*!< ETRGFILTCFG (Bit 8)                                   */
#define GPTMR_SMCFG_ETRGFILTCFG_Msk      (0xf00UL)                 /*!< ETRGFILTCFG (Bitfield-Mask: 0x0f)                     */
#define GPTMR_SMCFG_MSM_Pos              (7UL)                     /*!< MSM (Bit 7)                                           */
#define GPTMR_SMCFG_MSM_Msk              (0x80UL)                  /*!< MSM (Bitfield-Mask: 0x01)                             */
#define GPTMR_SMCFG_ITRGSEL_Pos          (4UL)                     /*!< ITRGSEL (Bit 4)                                       */
#define GPTMR_SMCFG_ITRGSEL_Msk          (0x70UL)                  /*!< ITRGSEL (Bitfield-Mask: 0x07)                         */
#define GPTMR_SMCFG_SLVMODECTRL_Pos      (0UL)                     /*!< SLVMODECTRL (Bit 0)                                   */
#define GPTMR_SMCFG_SLVMODECTRL_Msk      (0xfUL)                   /*!< SLVMODECTRL (Bitfield-Mask: 0x0f)                     */
/* =======================================================  DMAINTEN  ======================================================== */
#define GPTMR_DMAINTEN_DIRIE_Pos         (21UL)                    /*!< DIRIE (Bit 21)                                        */
#define GPTMR_DMAINTEN_DIRIE_Msk         (0x200000UL)              /*!< DIRIE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_TRGDE_Pos         (14UL)                    /*!< TRGDE (Bit 14)                                        */
#define GPTMR_DMAINTEN_TRGDE_Msk         (0x4000UL)                /*!< TRGDE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_COMDE_Pos         (13UL)                    /*!< COMDE (Bit 13)                                        */
#define GPTMR_DMAINTEN_COMDE_Msk         (0x2000UL)                /*!< COMDE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_CH3DE_Pos         (12UL)                    /*!< CH3DE (Bit 12)                                        */
#define GPTMR_DMAINTEN_CH3DE_Msk         (0x1000UL)                /*!< CH3DE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_CH2DE_Pos         (11UL)                    /*!< CH2DE (Bit 11)                                        */
#define GPTMR_DMAINTEN_CH2DE_Msk         (0x800UL)                 /*!< CH2DE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_CH1DE_Pos         (10UL)                    /*!< CH1DE (Bit 10)                                        */
#define GPTMR_DMAINTEN_CH1DE_Msk         (0x400UL)                 /*!< CH1DE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_CH0DE_Pos         (9UL)                     /*!< CH0DE (Bit 9)                                         */
#define GPTMR_DMAINTEN_CH0DE_Msk         (0x200UL)                 /*!< CH0DE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_UPDDE_Pos         (8UL)                     /*!< UPDDE (Bit 8)                                         */
#define GPTMR_DMAINTEN_UPDDE_Msk         (0x100UL)                 /*!< UPDDE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_BRKIE_Pos         (7UL)                     /*!< BRKIE (Bit 7)                                         */
#define GPTMR_DMAINTEN_BRKIE_Msk         (0x80UL)                  /*!< BRKIE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_TRGIE_Pos         (6UL)                     /*!< TRGIE (Bit 6)                                         */
#define GPTMR_DMAINTEN_TRGIE_Msk         (0x40UL)                  /*!< TRGIE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_COMIE_Pos         (5UL)                     /*!< COMIE (Bit 5)                                         */
#define GPTMR_DMAINTEN_COMIE_Msk         (0x20UL)                  /*!< COMIE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_CH3IE_Pos         (4UL)                     /*!< CH3IE (Bit 4)                                         */
#define GPTMR_DMAINTEN_CH3IE_Msk         (0x10UL)                  /*!< CH3IE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_CH2IE_Pos         (3UL)                     /*!< CH2IE (Bit 3)                                         */
#define GPTMR_DMAINTEN_CH2IE_Msk         (0x8UL)                   /*!< CH2IE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_CH1IE_Pos         (2UL)                     /*!< CH1IE (Bit 2)                                         */
#define GPTMR_DMAINTEN_CH1IE_Msk         (0x4UL)                   /*!< CH1IE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_CH0IE_Pos         (1UL)                     /*!< CH0IE (Bit 1)                                         */
#define GPTMR_DMAINTEN_CH0IE_Msk         (0x2UL)                   /*!< CH0IE (Bitfield-Mask: 0x01)                           */
#define GPTMR_DMAINTEN_UPDIE_Pos         (0UL)                     /*!< UPDIE (Bit 0)                                         */
#define GPTMR_DMAINTEN_UPDIE_Msk         (0x1UL)                   /*!< UPDIE (Bitfield-Mask: 0x01)                           */
/* ========================================================  INTSTS  ========================================================= */
#define GPTMR_INTSTS_DIRF_Pos            (21UL)                    /*!< DIRF (Bit 21)                                         */
#define GPTMR_INTSTS_DIRF_Msk            (0x200000UL)              /*!< DIRF (Bitfield-Mask: 0x01)                            */
#define GPTMR_INTSTS_SYSBRKIF_Pos        (13UL)                    /*!< SYSBRKIF (Bit 13)                                     */
#define GPTMR_INTSTS_SYSBRKIF_Msk        (0x2000UL)                /*!< SYSBRKIF (Bitfield-Mask: 0x01)                        */
#define GPTMR_INTSTS_CH3OF_Pos           (12UL)                    /*!< CH3OF (Bit 12)                                        */
#define GPTMR_INTSTS_CH3OF_Msk           (0x1000UL)                /*!< CH3OF (Bitfield-Mask: 0x01)                           */
#define GPTMR_INTSTS_CH2OF_Pos           (11UL)                    /*!< CH2OF (Bit 11)                                        */
#define GPTMR_INTSTS_CH2OF_Msk           (0x800UL)                 /*!< CH2OF (Bitfield-Mask: 0x01)                           */
#define GPTMR_INTSTS_CH1OF_Pos           (10UL)                    /*!< CH1OF (Bit 10)                                        */
#define GPTMR_INTSTS_CH1OF_Msk           (0x400UL)                 /*!< CH1OF (Bitfield-Mask: 0x01)                           */
#define GPTMR_INTSTS_CH0OF_Pos           (9UL)                     /*!< CH0OF (Bit 9)                                         */
#define GPTMR_INTSTS_CH0OF_Msk           (0x200UL)                 /*!< CH0OF (Bitfield-Mask: 0x01)                           */
#define GPTMR_INTSTS_BRKIF_Pos           (7UL)                     /*!< BRKIF (Bit 7)                                         */
#define GPTMR_INTSTS_BRKIF_Msk           (0x80UL)                  /*!< BRKIF (Bitfield-Mask: 0x01)                           */
#define GPTMR_INTSTS_TRGIF_Pos           (6UL)                     /*!< TRGIF (Bit 6)                                         */
#define GPTMR_INTSTS_TRGIF_Msk           (0x40UL)                  /*!< TRGIF (Bitfield-Mask: 0x01)                           */
#define GPTMR_INTSTS_COMIF_Pos           (5UL)                     /*!< COMIF (Bit 5)                                         */
#define GPTMR_INTSTS_COMIF_Msk           (0x20UL)                  /*!< COMIF (Bitfield-Mask: 0x01)                           */
#define GPTMR_INTSTS_CH3IF_Pos           (4UL)                     /*!< CH3IF (Bit 4)                                         */
#define GPTMR_INTSTS_CH3IF_Msk           (0x10UL)                  /*!< CH3IF (Bitfield-Mask: 0x01)                           */
#define GPTMR_INTSTS_CH2IF_Pos           (3UL)                     /*!< CH2IF (Bit 3)                                         */
#define GPTMR_INTSTS_CH2IF_Msk           (0x8UL)                   /*!< CH2IF (Bitfield-Mask: 0x01)                           */
#define GPTMR_INTSTS_CH1IF_Pos           (2UL)                     /*!< CH1IF (Bit 2)                                         */
#define GPTMR_INTSTS_CH1IF_Msk           (0x4UL)                   /*!< CH1IF (Bitfield-Mask: 0x01)                           */
#define GPTMR_INTSTS_CH0IF_Pos           (1UL)                     /*!< CH0IF (Bit 1)                                         */
#define GPTMR_INTSTS_CH0IF_Msk           (0x2UL)                   /*!< CH0IF (Bitfield-Mask: 0x01)                           */
#define GPTMR_INTSTS_UPDIF_Pos           (0UL)                     /*!< UPDIF (Bit 0)                                         */
#define GPTMR_INTSTS_UPDIF_Msk           (0x1UL)                   /*!< UPDIF (Bitfield-Mask: 0x01)                           */
/* =======================================================  SWEVTGEN  ======================================================== */
#define GPTMR_SWEVTGEN_SWBRKGEN_Pos      (7UL)                     /*!< SWBRKGEN (Bit 7)                                      */
#define GPTMR_SWEVTGEN_SWBRKGEN_Msk      (0x80UL)                  /*!< SWBRKGEN (Bitfield-Mask: 0x01)                        */
#define GPTMR_SWEVTGEN_SWTRGGEN_Pos      (6UL)                     /*!< SWTRGGEN (Bit 6)                                      */
#define GPTMR_SWEVTGEN_SWTRGGEN_Msk      (0x40UL)                  /*!< SWTRGGEN (Bitfield-Mask: 0x01)                        */
#define GPTMR_SWEVTGEN_SWCOMGEN_Pos      (5UL)                     /*!< SWCOMGEN (Bit 5)                                      */
#define GPTMR_SWEVTGEN_SWCOMGEN_Msk      (0x20UL)                  /*!< SWCOMGEN (Bitfield-Mask: 0x01)                        */
#define GPTMR_SWEVTGEN_SWCH3CCGEN_Pos    (4UL)                     /*!< SWCH3CCGEN (Bit 4)                                    */
#define GPTMR_SWEVTGEN_SWCH3CCGEN_Msk    (0x10UL)                  /*!< SWCH3CCGEN (Bitfield-Mask: 0x01)                      */
#define GPTMR_SWEVTGEN_SWCH2CCGEN_Pos    (3UL)                     /*!< SWCH2CCGEN (Bit 3)                                    */
#define GPTMR_SWEVTGEN_SWCH2CCGEN_Msk    (0x8UL)                   /*!< SWCH2CCGEN (Bitfield-Mask: 0x01)                      */
#define GPTMR_SWEVTGEN_SWCH1CCGEN_Pos    (2UL)                     /*!< SWCH1CCGEN (Bit 2)                                    */
#define GPTMR_SWEVTGEN_SWCH1CCGEN_Msk    (0x4UL)                   /*!< SWCH1CCGEN (Bitfield-Mask: 0x01)                      */
#define GPTMR_SWEVTGEN_SWCH0CCGEN_Pos    (1UL)                     /*!< SWCH0CCGEN (Bit 1)                                    */
#define GPTMR_SWEVTGEN_SWCH0CCGEN_Msk    (0x2UL)                   /*!< SWCH0CCGEN (Bitfield-Mask: 0x01)                      */
#define GPTMR_SWEVTGEN_SWUPDGEN_Pos      (0UL)                     /*!< SWUPDGEN (Bit 0)                                      */
#define GPTMR_SWEVTGEN_SWUPDGEN_Msk      (0x1UL)                   /*!< SWUPDGEN (Bitfield-Mask: 0x01)                        */
/* =====================================================  CHXMODECTRL1  ====================================================== */
#define GPTMR_CHXMODECTRL1_CCMR1_Pos     (0UL)                     /*!< CCMR1 (Bit 0)                                         */
#define GPTMR_CHXMODECTRL1_CCMR1_Msk     (0x1ffffffUL)             /*!< CCMR1 (Bitfield-Mask: 0x1ffffff)                      */
/* =====================================================  CHXMODECTRL2  ====================================================== */
#define GPTMR_CHXMODECTRL2_CCMR2_Pos     (0UL)                     /*!< CCMR2 (Bit 0)                                         */
#define GPTMR_CHXMODECTRL2_CCMR2_Msk     (0x1ffffffUL)             /*!< CCMR2 (Bitfield-Mask: 0x1ffffff)                      */
/* =========================================================  CCER  ========================================================== */
#define GPTMR_CCER_CH3NP_Pos             (15UL)                    /*!< CH3NP (Bit 15)                                        */
#define GPTMR_CCER_CH3NP_Msk             (0x8000UL)                /*!< CH3NP (Bitfield-Mask: 0x01)                           */
#define GPTMR_CCER_CH3NEN_Pos            (14UL)                    /*!< CH3NEN (Bit 14)                                       */
#define GPTMR_CCER_CH3NEN_Msk            (0x4000UL)                /*!< CH3NEN (Bitfield-Mask: 0x01)                          */
#define GPTMR_CCER_CH3P_Pos              (13UL)                    /*!< CH3P (Bit 13)                                         */
#define GPTMR_CCER_CH3P_Msk              (0x2000UL)                /*!< CH3P (Bitfield-Mask: 0x01)                            */
#define GPTMR_CCER_CH3EN_Pos             (12UL)                    /*!< CH3EN (Bit 12)                                        */
#define GPTMR_CCER_CH3EN_Msk             (0x1000UL)                /*!< CH3EN (Bitfield-Mask: 0x01)                           */
#define GPTMR_CCER_CH2NP_Pos             (11UL)                    /*!< CH2NP (Bit 11)                                        */
#define GPTMR_CCER_CH2NP_Msk             (0x800UL)                 /*!< CH2NP (Bitfield-Mask: 0x01)                           */
#define GPTMR_CCER_CH2NEN_Pos            (10UL)                    /*!< CH2NEN (Bit 10)                                       */
#define GPTMR_CCER_CH2NEN_Msk            (0x400UL)                 /*!< CH2NEN (Bitfield-Mask: 0x01)                          */
#define GPTMR_CCER_CH2P_Pos              (9UL)                     /*!< CH2P (Bit 9)                                          */
#define GPTMR_CCER_CH2P_Msk              (0x200UL)                 /*!< CH2P (Bitfield-Mask: 0x01)                            */
#define GPTMR_CCER_CH2EN_Pos             (8UL)                     /*!< CH2EN (Bit 8)                                         */
#define GPTMR_CCER_CH2EN_Msk             (0x100UL)                 /*!< CH2EN (Bitfield-Mask: 0x01)                           */
#define GPTMR_CCER_CH1NP_Pos             (7UL)                     /*!< CH1NP (Bit 7)                                         */
#define GPTMR_CCER_CH1NP_Msk             (0x80UL)                  /*!< CH1NP (Bitfield-Mask: 0x01)                           */
#define GPTMR_CCER_CH1NEN_Pos            (6UL)                     /*!< CH1NEN (Bit 6)                                        */
#define GPTMR_CCER_CH1NEN_Msk            (0x40UL)                  /*!< CH1NEN (Bitfield-Mask: 0x01)                          */
#define GPTMR_CCER_CH1P_Pos              (5UL)                     /*!< CH1P (Bit 5)                                          */
#define GPTMR_CCER_CH1P_Msk              (0x20UL)                  /*!< CH1P (Bitfield-Mask: 0x01)                            */
#define GPTMR_CCER_CH1EN_Pos             (4UL)                     /*!< CH1EN (Bit 4)                                         */
#define GPTMR_CCER_CH1EN_Msk             (0x10UL)                  /*!< CH1EN (Bitfield-Mask: 0x01)                           */
#define GPTMR_CCER_CH0NP_Pos             (3UL)                     /*!< CH0NP (Bit 3)                                         */
#define GPTMR_CCER_CH0NP_Msk             (0x8UL)                   /*!< CH0NP (Bitfield-Mask: 0x01)                           */
#define GPTMR_CCER_CH0NEN_Pos            (2UL)                     /*!< CH0NEN (Bit 2)                                        */
#define GPTMR_CCER_CH0NEN_Msk            (0x4UL)                   /*!< CH0NEN (Bitfield-Mask: 0x01)                          */
#define GPTMR_CCER_CH0P_Pos              (1UL)                     /*!< CH0P (Bit 1)                                          */
#define GPTMR_CCER_CH0P_Msk              (0x2UL)                   /*!< CH0P (Bitfield-Mask: 0x01)                            */
#define GPTMR_CCER_CH0EN_Pos             (0UL)                     /*!< CH0EN (Bit 0)                                         */
#define GPTMR_CCER_CH0EN_Msk             (0x1UL)                   /*!< CH0EN (Bitfield-Mask: 0x01)                           */
/* =========================================================  TCNT  ========================================================== */
#define GPTMR_TCNT_UPDIFCPY_Pos          (31UL)                    /*!< UPDIFCPY (Bit 31)                                     */
#define GPTMR_TCNT_UPDIFCPY_Msk          (0x80000000UL)            /*!< UPDIFCPY (Bitfield-Mask: 0x01)                        */
#define GPTMR_TCNT_TCNTH_Pos             (16UL)                    /*!< TCNTH (Bit 16)                                        */
#define GPTMR_TCNT_TCNTH_Msk             (0x7fff0000UL)            /*!< TCNTH (Bitfield-Mask: 0x7fff)                         */
#define GPTMR_TCNT_TCNTL_Pos             (0UL)                     /*!< TCNTL (Bit 0)                                         */
#define GPTMR_TCNT_TCNTL_Msk             (0xffffUL)                /*!< TCNTL (Bitfield-Mask: 0xffff)                         */
/* ==========================================================  PSC  ========================================================== */
#define GPTMR_PSC_PSC_Pos                (0UL)                     /*!< PSC (Bit 0)                                           */
#define GPTMR_PSC_PSC_Msk                (0xffffUL)                /*!< PSC (Bitfield-Mask: 0xffff)                           */
/* ==========================================================  ARR  ========================================================== */
#define GPTMR_ARR_ARRH_Pos               (16UL)                    /*!< ARRH (Bit 16)                                         */
#define GPTMR_ARR_ARRH_Msk               (0xffff0000UL)            /*!< ARRH (Bitfield-Mask: 0xffff)                          */
#define GPTMR_ARR_ARRL_Pos               (0UL)                     /*!< ARRL (Bit 0)                                          */
#define GPTMR_ARR_ARRL_Msk               (0xffffUL)                /*!< ARRL (Bitfield-Mask: 0xffff)                          */
/* ==========================================================  RCR  ========================================================== */
#define GPTMR_RCR_REPCNT_Pos             (16UL)                    /*!< REPCNT (Bit 16)                                       */
#define GPTMR_RCR_REPCNT_Msk             (0xffff0000UL)            /*!< REPCNT (Bitfield-Mask: 0xffff)                        */
#define GPTMR_RCR_REPVAL_Pos             (0UL)                     /*!< REPVAL (Bit 0)                                        */
#define GPTMR_RCR_REPVAL_Msk             (0xffffUL)                /*!< REPVAL (Bitfield-Mask: 0xffff)                        */
/* =========================================================  CCR0  ========================================================== */
#define GPTMR_CCR0_CH0CCRVALH_Pos        (16UL)                    /*!< CH0CCRVALH (Bit 16)                                   */
#define GPTMR_CCR0_CH0CCRVALH_Msk        (0xffff0000UL)            /*!< CH0CCRVALH (Bitfield-Mask: 0xffff)                    */
#define GPTMR_CCR0_CH0CCRVALL_Pos        (0UL)                     /*!< CH0CCRVALL (Bit 0)                                    */
#define GPTMR_CCR0_CH0CCRVALL_Msk        (0xffffUL)                /*!< CH0CCRVALL (Bitfield-Mask: 0xffff)                    */
/* =========================================================  CCR1  ========================================================== */
#define GPTMR_CCR1_CH1CCRVALH_Pos        (16UL)                    /*!< CH1CCRVALH (Bit 16)                                   */
#define GPTMR_CCR1_CH1CCRVALH_Msk        (0xffff0000UL)            /*!< CH1CCRVALH (Bitfield-Mask: 0xffff)                    */
#define GPTMR_CCR1_CH1CCRVALL_Pos        (0UL)                     /*!< CH1CCRVALL (Bit 0)                                    */
#define GPTMR_CCR1_CH1CCRVALL_Msk        (0xffffUL)                /*!< CH1CCRVALL (Bitfield-Mask: 0xffff)                    */
/* =========================================================  CCR2  ========================================================== */
#define GPTMR_CCR2_CH2CCRVALH_Pos        (16UL)                    /*!< CH2CCRVALH (Bit 16)                                   */
#define GPTMR_CCR2_CH2CCRVALH_Msk        (0xffff0000UL)            /*!< CH2CCRVALH (Bitfield-Mask: 0xffff)                    */
#define GPTMR_CCR2_CH2CCRVALL_Pos        (0UL)                     /*!< CH2CCRVALL (Bit 0)                                    */
#define GPTMR_CCR2_CH2CCRVALL_Msk        (0xffffUL)                /*!< CH2CCRVALL (Bitfield-Mask: 0xffff)                    */
/* =========================================================  CCR3  ========================================================== */
#define GPTMR_CCR3_CH3CCRVALH_Pos        (16UL)                    /*!< CH3CCRVALH (Bit 16)                                   */
#define GPTMR_CCR3_CH3CCRVALH_Msk        (0xffff0000UL)            /*!< CH3CCRVALH (Bitfield-Mask: 0xffff)                    */
#define GPTMR_CCR3_CH3CCRVALL_Pos        (0UL)                     /*!< CH3CCRVALL (Bit 0)                                    */
#define GPTMR_CCR3_CH3CCRVALL_Msk        (0xffffUL)                /*!< CH3CCRVALL (Bitfield-Mask: 0xffff)                    */
/* =========================================================  BDTR  ========================================================== */
#define GPTMR_BDTR_BRKFILTCFG_Pos        (16UL)                    /*!< BRKFILTCFG (Bit 16)                                   */
#define GPTMR_BDTR_BRKFILTCFG_Msk        (0xf0000UL)               /*!< BRKFILTCFG (Bitfield-Mask: 0x0f)                      */
#define GPTMR_BDTR_MOE_Pos               (15UL)                    /*!< MOE (Bit 15)                                          */
#define GPTMR_BDTR_MOE_Msk               (0x8000UL)                /*!< MOE (Bitfield-Mask: 0x01)                             */
#define GPTMR_BDTR_AOE_Pos               (14UL)                    /*!< AOE (Bit 14)                                          */
#define GPTMR_BDTR_AOE_Msk               (0x4000UL)                /*!< AOE (Bitfield-Mask: 0x01)                             */
#define GPTMR_BDTR_BRKP_Pos              (13UL)                    /*!< BRKP (Bit 13)                                         */
#define GPTMR_BDTR_BRKP_Msk              (0x2000UL)                /*!< BRKP (Bitfield-Mask: 0x01)                            */
#define GPTMR_BDTR_BRKEN_Pos             (12UL)                    /*!< BRKEN (Bit 12)                                        */
#define GPTMR_BDTR_BRKEN_Msk             (0x1000UL)                /*!< BRKEN (Bitfield-Mask: 0x01)                           */
#define GPTMR_BDTR_OSSR_Pos              (11UL)                    /*!< OSSR (Bit 11)                                         */
#define GPTMR_BDTR_OSSR_Msk              (0x800UL)                 /*!< OSSR (Bitfield-Mask: 0x01)                            */
#define GPTMR_BDTR_OSSI_Pos              (10UL)                    /*!< OSSI (Bit 10)                                         */
#define GPTMR_BDTR_OSSI_Msk              (0x400UL)                 /*!< OSSI (Bitfield-Mask: 0x01)                            */
#define GPTMR_BDTR_LOCK_Pos              (8UL)                     /*!< LOCK (Bit 8)                                          */
#define GPTMR_BDTR_LOCK_Msk              (0x300UL)                 /*!< LOCK (Bitfield-Mask: 0x03)                            */
#define GPTMR_BDTR_DTG_Pos               (0UL)                     /*!< DTG (Bit 0)                                           */
#define GPTMR_BDTR_DTG_Msk               (0xffUL)                  /*!< DTG (Bitfield-Mask: 0xff)                             */
/* ========================================================  CHXSEL  ========================================================= */
#define GPTMR_CHXSEL_CH3SRCSEL_Pos       (24UL)                    /*!< CH3SRCSEL (Bit 24)                                    */
#define GPTMR_CHXSEL_CH3SRCSEL_Msk       (0x7000000UL)             /*!< CH3SRCSEL (Bitfield-Mask: 0x07)                       */
#define GPTMR_CHXSEL_CH2SRCSEL_Pos       (16UL)                    /*!< CH2SRCSEL (Bit 16)                                    */
#define GPTMR_CHXSEL_CH2SRCSEL_Msk       (0x70000UL)               /*!< CH2SRCSEL (Bitfield-Mask: 0x07)                       */
#define GPTMR_CHXSEL_CH1SRCSEL_Pos       (8UL)                     /*!< CH1SRCSEL (Bit 8)                                     */
#define GPTMR_CHXSEL_CH1SRCSEL_Msk       (0x700UL)                 /*!< CH1SRCSEL (Bitfield-Mask: 0x07)                       */
#define GPTMR_CHXSEL_CH0SRCSEL_Pos       (0UL)                     /*!< CH0SRCSEL (Bit 0)                                     */
#define GPTMR_CHXSEL_CH0SRCSEL_Msk       (0x7UL)                   /*!< CH0SRCSEL (Bitfield-Mask: 0x07)                       */
/* ==========================================================  AF1  ========================================================== */
#define GPTMR_AF1_SYSBRKEN_Pos           (20UL)                    /*!< SYSBRKEN (Bit 20)                                     */
#define GPTMR_AF1_SYSBRKEN_Msk           (0xf00000UL)              /*!< SYSBRKEN (Bitfield-Mask: 0x0f)                        */
#define GPTMR_AF1_ETRGSEL_Pos            (16UL)                    /*!< ETRGSEL (Bit 16)                                      */
#define GPTMR_AF1_ETRGSEL_Msk            (0x70000UL)               /*!< ETRGSEL (Bitfield-Mask: 0x07)                         */
#define GPTMR_AF1_BRKCOMP3P_Pos          (11UL)                    /*!< BRKCOMP3P (Bit 11)                                    */
#define GPTMR_AF1_BRKCOMP3P_Msk          (0x800UL)                 /*!< BRKCOMP3P (Bitfield-Mask: 0x01)                       */
#define GPTMR_AF1_BRKCOMP2P_Pos          (10UL)                    /*!< BRKCOMP2P (Bit 10)                                    */
#define GPTMR_AF1_BRKCOMP2P_Msk          (0x400UL)                 /*!< BRKCOMP2P (Bitfield-Mask: 0x01)                       */
#define GPTMR_AF1_BRKCOMP1P_Pos          (9UL)                     /*!< BRKCOMP1P (Bit 9)                                     */
#define GPTMR_AF1_BRKCOMP1P_Msk          (0x200UL)                 /*!< BRKCOMP1P (Bitfield-Mask: 0x01)                       */
#define GPTMR_AF1_BRKINP_Pos             (8UL)                     /*!< BRKINP (Bit 8)                                        */
#define GPTMR_AF1_BRKINP_Msk             (0x100UL)                 /*!< BRKINP (Bitfield-Mask: 0x01)                          */
#define GPTMR_AF1_BRKCOMP3EN_Pos         (3UL)                     /*!< BRKCOMP3EN (Bit 3)                                    */
#define GPTMR_AF1_BRKCOMP3EN_Msk         (0x8UL)                   /*!< BRKCOMP3EN (Bitfield-Mask: 0x01)                      */
#define GPTMR_AF1_BRKCOMP2EN_Pos         (2UL)                     /*!< BRKCOMP2EN (Bit 2)                                    */
#define GPTMR_AF1_BRKCOMP2EN_Msk         (0x4UL)                   /*!< BRKCOMP2EN (Bitfield-Mask: 0x01)                      */
#define GPTMR_AF1_BRKCOMP1EN_Pos         (1UL)                     /*!< BRKCOMP1EN (Bit 1)                                    */
#define GPTMR_AF1_BRKCOMP1EN_Msk         (0x2UL)                   /*!< BRKCOMP1EN (Bitfield-Mask: 0x01)                      */
#define GPTMR_AF1_BRKINEN_Pos            (0UL)                     /*!< BRKINEN (Bit 0)                                       */
#define GPTMR_AF1_BRKINEN_Msk            (0x1UL)                   /*!< BRKINEN (Bitfield-Mask: 0x01)                         */
/* ==========================================================  AF2  ========================================================== */
#define GPTMR_AF2_OCREFCLRSRCSEL_Pos     (16UL)                    /*!< OCREFCLRSRCSEL (Bit 16)                               */
#define GPTMR_AF2_OCREFCLRSRCSEL_Msk     (0x30000UL)               /*!< OCREFCLRSRCSEL (Bitfield-Mask: 0x03)                  */
/* ========================================================  DMACFG  ========================================================= */
#define GPTMR_DMACFG_DBL_Pos             (8UL)                     /*!< DBL (Bit 8)                                           */
#define GPTMR_DMACFG_DBL_Msk             (0x3f00UL)                /*!< DBL (Bitfield-Mask: 0x3f)                             */
#define GPTMR_DMACFG_DBA_Pos             (0UL)                     /*!< DBA (Bit 0)                                           */
#define GPTMR_DMACFG_DBA_Msk             (0x3fUL)                  /*!< DBA (Bitfield-Mask: 0x3f)                             */
/* =========================================================  DMAR  ========================================================== */
#define GPTMR_DMAR_DMAB_Pos              (0UL)                     /*!< DMAB (Bit 0)                                          */
#define GPTMR_DMAR_DMAB_Msk              (0xffffffffUL)            /*!< DMAB (Bitfield-Mask: 0xffffffff)                      */


/* =========================================================================================================================== */
/* ================                                          ADVTMR0                                          ================ */
/* =========================================================================================================================== */

/* =========================================================  CTRL1  ========================================================= */
#define ADVTMR_CTRL1_UPDIFREMAP_Pos      (11UL)                    /*!< UPDIFREMAP (Bit 11)                                   */
#define ADVTMR_CTRL1_UPDIFREMAP_Msk      (0x800UL)                 /*!< UPDIFREMAP (Bitfield-Mask: 0x01)                      */
#define ADVTMR_CTRL1_CLKDTFDIV_Pos       (8UL)                     /*!< CLKDTFDIV (Bit 8)                                     */
#define ADVTMR_CTRL1_CLKDTFDIV_Msk       (0x300UL)                 /*!< CLKDTFDIV (Bitfield-Mask: 0x03)                       */
#define ADVTMR_CTRL1_ARRSHDWEN_Pos       (7UL)                     /*!< ARRSHDWEN (Bit 7)                                     */
#define ADVTMR_CTRL1_ARRSHDWEN_Msk       (0x80UL)                  /*!< ARRSHDWEN (Bitfield-Mask: 0x01)                       */
#define ADVTMR_CTRL1_TCNTALIGNMODE_Pos   (5UL)                     /*!< TCNTALIGNMODE (Bit 5)                                 */
#define ADVTMR_CTRL1_TCNTALIGNMODE_Msk   (0x60UL)                  /*!< TCNTALIGNMODE (Bitfield-Mask: 0x03)                   */
#define ADVTMR_CTRL1_DIR_Pos             (4UL)                     /*!< DIR (Bit 4)                                           */
#define ADVTMR_CTRL1_DIR_Msk             (0x10UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define ADVTMR_CTRL1_SINGLEPLSMODE_Pos   (3UL)                     /*!< SINGLEPLSMODE (Bit 3)                                 */
#define ADVTMR_CTRL1_SINGLEPLSMODE_Msk   (0x8UL)                   /*!< SINGLEPLSMODE (Bitfield-Mask: 0x01)                   */
#define ADVTMR_CTRL1_UPDREQSRC_Pos       (2UL)                     /*!< UPDREQSRC (Bit 2)                                     */
#define ADVTMR_CTRL1_UPDREQSRC_Msk       (0x4UL)                   /*!< UPDREQSRC (Bitfield-Mask: 0x01)                       */
#define ADVTMR_CTRL1_UPDDIS_Pos          (1UL)                     /*!< UPDDIS (Bit 1)                                        */
#define ADVTMR_CTRL1_UPDDIS_Msk          (0x2UL)                   /*!< UPDDIS (Bitfield-Mask: 0x01)                          */
#define ADVTMR_CTRL1_TCNTEN_Pos          (0UL)                     /*!< TCNTEN (Bit 0)                                        */
#define ADVTMR_CTRL1_TCNTEN_Msk          (0x1UL)                   /*!< TCNTEN (Bitfield-Mask: 0x01)                          */
/* =========================================================  CTRL2  ========================================================= */
#define ADVTMR_CTRL2_MSTMODECTRL1BIT3_Pos (24UL)                   /*!< MSTMODECTRL1BIT3 (Bit 24)                             */
#define ADVTMR_CTRL2_MSTMODECTRL1BIT3_Msk (0x1000000UL)            /*!< MSTMODECTRL1BIT3 (Bitfield-Mask: 0x01)                */
#define ADVTMR_CTRL2_MSTMODECTRL2_Pos    (20UL)                    /*!< MSTMODECTRL2 (Bit 20)                                 */
#define ADVTMR_CTRL2_MSTMODECTRL2_Msk    (0xf00000UL)              /*!< MSTMODECTRL2 (Bitfield-Mask: 0x0f)                    */
#define ADVTMR_CTRL2_CH5OIS_Pos          (18UL)                    /*!< CH5OIS (Bit 18)                                       */
#define ADVTMR_CTRL2_CH5OIS_Msk          (0x40000UL)               /*!< CH5OIS (Bitfield-Mask: 0x01)                          */
#define ADVTMR_CTRL2_CH4OIS_Pos          (16UL)                    /*!< CH4OIS (Bit 16)                                       */
#define ADVTMR_CTRL2_CH4OIS_Msk          (0x10000UL)               /*!< CH4OIS (Bitfield-Mask: 0x01)                          */
#define ADVTMR_CTRL2_CH3NOIS_Pos         (15UL)                    /*!< CH3NOIS (Bit 15)                                      */
#define ADVTMR_CTRL2_CH3NOIS_Msk         (0x8000UL)                /*!< CH3NOIS (Bitfield-Mask: 0x01)                         */
#define ADVTMR_CTRL2_CH3OIS_Pos          (14UL)                    /*!< CH3OIS (Bit 14)                                       */
#define ADVTMR_CTRL2_CH3OIS_Msk          (0x4000UL)                /*!< CH3OIS (Bitfield-Mask: 0x01)                          */
#define ADVTMR_CTRL2_CH2NOIS_Pos         (13UL)                    /*!< CH2NOIS (Bit 13)                                      */
#define ADVTMR_CTRL2_CH2NOIS_Msk         (0x2000UL)                /*!< CH2NOIS (Bitfield-Mask: 0x01)                         */
#define ADVTMR_CTRL2_CH2OIS_Pos          (12UL)                    /*!< CH2OIS (Bit 12)                                       */
#define ADVTMR_CTRL2_CH2OIS_Msk          (0x1000UL)                /*!< CH2OIS (Bitfield-Mask: 0x01)                          */
#define ADVTMR_CTRL2_CH1NOIS_Pos         (11UL)                    /*!< CH1NOIS (Bit 11)                                      */
#define ADVTMR_CTRL2_CH1NOIS_Msk         (0x800UL)                 /*!< CH1NOIS (Bitfield-Mask: 0x01)                         */
#define ADVTMR_CTRL2_CH1OIS_Pos          (10UL)                    /*!< CH1OIS (Bit 10)                                       */
#define ADVTMR_CTRL2_CH1OIS_Msk          (0x400UL)                 /*!< CH1OIS (Bitfield-Mask: 0x01)                          */
#define ADVTMR_CTRL2_CH0NOIS_Pos         (9UL)                     /*!< CH0NOIS (Bit 9)                                       */
#define ADVTMR_CTRL2_CH0NOIS_Msk         (0x200UL)                 /*!< CH0NOIS (Bitfield-Mask: 0x01)                         */
#define ADVTMR_CTRL2_CH0OIS_Pos          (8UL)                     /*!< CH0OIS (Bit 8)                                        */
#define ADVTMR_CTRL2_CH0OIS_Msk          (0x100UL)                 /*!< CH0OIS (Bitfield-Mask: 0x01)                          */
#define ADVTMR_CTRL2_TI0SEL_Pos          (7UL)                     /*!< TI0SEL (Bit 7)                                        */
#define ADVTMR_CTRL2_TI0SEL_Msk          (0x80UL)                  /*!< TI0SEL (Bitfield-Mask: 0x01)                          */
#define ADVTMR_CTRL2_MSTMODECTRL1_Pos    (4UL)                     /*!< MSTMODECTRL1 (Bit 4)                                  */
#define ADVTMR_CTRL2_MSTMODECTRL1_Msk    (0x70UL)                  /*!< MSTMODECTRL1 (Bitfield-Mask: 0x07)                    */
#define ADVTMR_CTRL2_CCDMAREQSRC_Pos     (3UL)                     /*!< CCDMAREQSRC (Bit 3)                                   */
#define ADVTMR_CTRL2_CCDMAREQSRC_Msk     (0x8UL)                   /*!< CCDMAREQSRC (Bitfield-Mask: 0x01)                     */
#define ADVTMR_CTRL2_CCUPDSRC_Pos        (2UL)                     /*!< CCUPDSRC (Bit 2)                                      */
#define ADVTMR_CTRL2_CCUPDSRC_Msk        (0x4UL)                   /*!< CCUPDSRC (Bitfield-Mask: 0x01)                        */
#define ADVTMR_CTRL2_CCSHWDEN_Pos        (0UL)                     /*!< CCSHWDEN (Bit 0)                                      */
#define ADVTMR_CTRL2_CCSHWDEN_Msk        (0x1UL)                   /*!< CCSHWDEN (Bitfield-Mask: 0x01)                        */
/* =========================================================  SMCFG  ========================================================= */
#define ADVTMR_SMCFG_ITRGSELBIT4_Pos     (21UL)                    /*!< ITRGSELBIT4 (Bit 21)                                  */
#define ADVTMR_SMCFG_ITRGSELBIT4_Msk     (0x200000UL)              /*!< ITRGSELBIT4 (Bitfield-Mask: 0x01)                     */
#define ADVTMR_SMCFG_ITRGSELBIT3_Pos     (20UL)                    /*!< ITRGSELBIT3 (Bit 20)                                  */
#define ADVTMR_SMCFG_ITRGSELBIT3_Msk     (0x100000UL)              /*!< ITRGSELBIT3 (Bitfield-Mask: 0x01)                     */
#define ADVTMR_SMCFG_OCREFCLRSEL_Pos     (16UL)                    /*!< OCREFCLRSEL (Bit 16)                                  */
#define ADVTMR_SMCFG_OCREFCLRSEL_Msk     (0x10000UL)               /*!< OCREFCLRSEL (Bitfield-Mask: 0x01)                     */
#define ADVTMR_SMCFG_ETRGP_Pos           (15UL)                    /*!< ETRGP (Bit 15)                                        */
#define ADVTMR_SMCFG_ETRGP_Msk           (0x8000UL)                /*!< ETRGP (Bitfield-Mask: 0x01)                           */
#define ADVTMR_SMCFG_EXTCLKMODE1EN_Pos   (14UL)                    /*!< EXTCLKMODE1EN (Bit 14)                                */
#define ADVTMR_SMCFG_EXTCLKMODE1EN_Msk   (0x4000UL)                /*!< EXTCLKMODE1EN (Bitfield-Mask: 0x01)                   */
#define ADVTMR_SMCFG_ETRGFDIVCFG_Pos     (12UL)                    /*!< ETRGFDIVCFG (Bit 12)                                  */
#define ADVTMR_SMCFG_ETRGFDIVCFG_Msk     (0x3000UL)                /*!< ETRGFDIVCFG (Bitfield-Mask: 0x03)                     */
#define ADVTMR_SMCFG_ETRGFILTCFG_Pos     (8UL)                     /*!< ETRGFILTCFG (Bit 8)                                   */
#define ADVTMR_SMCFG_ETRGFILTCFG_Msk     (0xf00UL)                 /*!< ETRGFILTCFG (Bitfield-Mask: 0x0f)                     */
#define ADVTMR_SMCFG_MSM_Pos             (7UL)                     /*!< MSM (Bit 7)                                           */
#define ADVTMR_SMCFG_MSM_Msk             (0x80UL)                  /*!< MSM (Bitfield-Mask: 0x01)                             */
#define ADVTMR_SMCFG_ITRGSEL_Pos         (4UL)                     /*!< ITRGSEL (Bit 4)                                       */
#define ADVTMR_SMCFG_ITRGSEL_Msk         (0x70UL)                  /*!< ITRGSEL (Bitfield-Mask: 0x07)                         */
#define ADVTMR_SMCFG_SLVMODECTRL_Pos     (0UL)                     /*!< SLVMODECTRL (Bit 0)                                   */
#define ADVTMR_SMCFG_SLVMODECTRL_Msk     (0xfUL)                   /*!< SLVMODECTRL (Bitfield-Mask: 0x0f)                     */
/* =======================================================  DMAINTEN  ======================================================== */
#define ADVTMR_DMAINTEN_DIRIE_Pos        (21UL)                    /*!< DIRIE (Bit 21)                                        */
#define ADVTMR_DMAINTEN_DIRIE_Msk        (0x200000UL)              /*!< DIRIE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_TRGDE_Pos        (14UL)                    /*!< TRGDE (Bit 14)                                        */
#define ADVTMR_DMAINTEN_TRGDE_Msk        (0x4000UL)                /*!< TRGDE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_COMDE_Pos        (13UL)                    /*!< COMDE (Bit 13)                                        */
#define ADVTMR_DMAINTEN_COMDE_Msk        (0x2000UL)                /*!< COMDE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_CH3DE_Pos        (12UL)                    /*!< CH3DE (Bit 12)                                        */
#define ADVTMR_DMAINTEN_CH3DE_Msk        (0x1000UL)                /*!< CH3DE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_CH2DE_Pos        (11UL)                    /*!< CH2DE (Bit 11)                                        */
#define ADVTMR_DMAINTEN_CH2DE_Msk        (0x800UL)                 /*!< CH2DE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_CH1DE_Pos        (10UL)                    /*!< CH1DE (Bit 10)                                        */
#define ADVTMR_DMAINTEN_CH1DE_Msk        (0x400UL)                 /*!< CH1DE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_CH0DE_Pos        (9UL)                     /*!< CH0DE (Bit 9)                                         */
#define ADVTMR_DMAINTEN_CH0DE_Msk        (0x200UL)                 /*!< CH0DE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_UPDDE_Pos        (8UL)                     /*!< UPDDE (Bit 8)                                         */
#define ADVTMR_DMAINTEN_UPDDE_Msk        (0x100UL)                 /*!< UPDDE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_BRKIE_Pos        (7UL)                     /*!< BRKIE (Bit 7)                                         */
#define ADVTMR_DMAINTEN_BRKIE_Msk        (0x80UL)                  /*!< BRKIE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_TRGIE_Pos        (6UL)                     /*!< TRGIE (Bit 6)                                         */
#define ADVTMR_DMAINTEN_TRGIE_Msk        (0x40UL)                  /*!< TRGIE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_COMIE_Pos        (5UL)                     /*!< COMIE (Bit 5)                                         */
#define ADVTMR_DMAINTEN_COMIE_Msk        (0x20UL)                  /*!< COMIE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_CH3IE_Pos        (4UL)                     /*!< CH3IE (Bit 4)                                         */
#define ADVTMR_DMAINTEN_CH3IE_Msk        (0x10UL)                  /*!< CH3IE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_CH2IE_Pos        (3UL)                     /*!< CH2IE (Bit 3)                                         */
#define ADVTMR_DMAINTEN_CH2IE_Msk        (0x8UL)                   /*!< CH2IE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_CH1IE_Pos        (2UL)                     /*!< CH1IE (Bit 2)                                         */
#define ADVTMR_DMAINTEN_CH1IE_Msk        (0x4UL)                   /*!< CH1IE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_CH0IE_Pos        (1UL)                     /*!< CH0IE (Bit 1)                                         */
#define ADVTMR_DMAINTEN_CH0IE_Msk        (0x2UL)                   /*!< CH0IE (Bitfield-Mask: 0x01)                           */
#define ADVTMR_DMAINTEN_UPDIE_Pos        (0UL)                     /*!< UPDIE (Bit 0)                                         */
#define ADVTMR_DMAINTEN_UPDIE_Msk        (0x1UL)                   /*!< UPDIE (Bitfield-Mask: 0x01)                           */
/* ========================================================  INTSTS  ========================================================= */
#define ADVTMR_INTSTS_DIRF_Pos           (21UL)                    /*!< DIRF (Bit 21)                                         */
#define ADVTMR_INTSTS_DIRF_Msk           (0x200000UL)              /*!< DIRF (Bitfield-Mask: 0x01)                            */
#define ADVTMR_INTSTS_CH5IF_Pos          (17UL)                    /*!< CH5IF (Bit 17)                                        */
#define ADVTMR_INTSTS_CH5IF_Msk          (0x20000UL)               /*!< CH5IF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_CH4IF_Pos          (16UL)                    /*!< CH4IF (Bit 16)                                        */
#define ADVTMR_INTSTS_CH4IF_Msk          (0x10000UL)               /*!< CH4IF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_SYSBRKIF_Pos       (13UL)                    /*!< SYSBRKIF (Bit 13)                                     */
#define ADVTMR_INTSTS_SYSBRKIF_Msk       (0x2000UL)                /*!< SYSBRKIF (Bitfield-Mask: 0x01)                        */
#define ADVTMR_INTSTS_CH3OF_Pos          (12UL)                    /*!< CH3OF (Bit 12)                                        */
#define ADVTMR_INTSTS_CH3OF_Msk          (0x1000UL)                /*!< CH3OF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_CH2OF_Pos          (11UL)                    /*!< CH2OF (Bit 11)                                        */
#define ADVTMR_INTSTS_CH2OF_Msk          (0x800UL)                 /*!< CH2OF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_CH1OF_Pos          (10UL)                    /*!< CH1OF (Bit 10)                                        */
#define ADVTMR_INTSTS_CH1OF_Msk          (0x400UL)                 /*!< CH1OF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_CH0OF_Pos          (9UL)                     /*!< CH0OF (Bit 9)                                         */
#define ADVTMR_INTSTS_CH0OF_Msk          (0x200UL)                 /*!< CH0OF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_BRK2IF_Pos         (8UL)                     /*!< BRK2IF (Bit 8)                                        */
#define ADVTMR_INTSTS_BRK2IF_Msk         (0x100UL)                 /*!< BRK2IF (Bitfield-Mask: 0x01)                          */
#define ADVTMR_INTSTS_BRKIF_Pos          (7UL)                     /*!< BRKIF (Bit 7)                                         */
#define ADVTMR_INTSTS_BRKIF_Msk          (0x80UL)                  /*!< BRKIF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_TRGIF_Pos          (6UL)                     /*!< TRGIF (Bit 6)                                         */
#define ADVTMR_INTSTS_TRGIF_Msk          (0x40UL)                  /*!< TRGIF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_COMIF_Pos          (5UL)                     /*!< COMIF (Bit 5)                                         */
#define ADVTMR_INTSTS_COMIF_Msk          (0x20UL)                  /*!< COMIF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_CH3IF_Pos          (4UL)                     /*!< CH3IF (Bit 4)                                         */
#define ADVTMR_INTSTS_CH3IF_Msk          (0x10UL)                  /*!< CH3IF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_CH2IF_Pos          (3UL)                     /*!< CH2IF (Bit 3)                                         */
#define ADVTMR_INTSTS_CH2IF_Msk          (0x8UL)                   /*!< CH2IF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_CH1IF_Pos          (2UL)                     /*!< CH1IF (Bit 2)                                         */
#define ADVTMR_INTSTS_CH1IF_Msk          (0x4UL)                   /*!< CH1IF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_CH0IF_Pos          (1UL)                     /*!< CH0IF (Bit 1)                                         */
#define ADVTMR_INTSTS_CH0IF_Msk          (0x2UL)                   /*!< CH0IF (Bitfield-Mask: 0x01)                           */
#define ADVTMR_INTSTS_UPDIF_Pos          (0UL)                     /*!< UPDIF (Bit 0)                                         */
#define ADVTMR_INTSTS_UPDIF_Msk          (0x1UL)                   /*!< UPDIF (Bitfield-Mask: 0x01)                           */
/* =======================================================  SWEVTGEN  ======================================================== */
#define ADVTMR_SWEVTGEN_SWBRK2GEN_Pos    (8UL)                     /*!< SWBRK2GEN (Bit 8)                                     */
#define ADVTMR_SWEVTGEN_SWBRK2GEN_Msk    (0x100UL)                 /*!< SWBRK2GEN (Bitfield-Mask: 0x01)                       */
#define ADVTMR_SWEVTGEN_SWBRKGEN_Pos     (7UL)                     /*!< SWBRKGEN (Bit 7)                                      */
#define ADVTMR_SWEVTGEN_SWBRKGEN_Msk     (0x80UL)                  /*!< SWBRKGEN (Bitfield-Mask: 0x01)                        */
#define ADVTMR_SWEVTGEN_SWTRGGEN_Pos     (6UL)                     /*!< SWTRGGEN (Bit 6)                                      */
#define ADVTMR_SWEVTGEN_SWTRGGEN_Msk     (0x40UL)                  /*!< SWTRGGEN (Bitfield-Mask: 0x01)                        */
#define ADVTMR_SWEVTGEN_SWCOMGEN_Pos     (5UL)                     /*!< SWCOMGEN (Bit 5)                                      */
#define ADVTMR_SWEVTGEN_SWCOMGEN_Msk     (0x20UL)                  /*!< SWCOMGEN (Bitfield-Mask: 0x01)                        */
#define ADVTMR_SWEVTGEN_SWCH3CCGEN_Pos   (4UL)                     /*!< SWCH3CCGEN (Bit 4)                                    */
#define ADVTMR_SWEVTGEN_SWCH3CCGEN_Msk   (0x10UL)                  /*!< SWCH3CCGEN (Bitfield-Mask: 0x01)                      */
#define ADVTMR_SWEVTGEN_SWCH2CCGEN_Pos   (3UL)                     /*!< SWCH2CCGEN (Bit 3)                                    */
#define ADVTMR_SWEVTGEN_SWCH2CCGEN_Msk   (0x8UL)                   /*!< SWCH2CCGEN (Bitfield-Mask: 0x01)                      */
#define ADVTMR_SWEVTGEN_SWCH1CCGEN_Pos   (2UL)                     /*!< SWCH1CCGEN (Bit 2)                                    */
#define ADVTMR_SWEVTGEN_SWCH1CCGEN_Msk   (0x4UL)                   /*!< SWCH1CCGEN (Bitfield-Mask: 0x01)                      */
#define ADVTMR_SWEVTGEN_SWCH0CCGEN_Pos   (1UL)                     /*!< SWCH0CCGEN (Bit 1)                                    */
#define ADVTMR_SWEVTGEN_SWCH0CCGEN_Msk   (0x2UL)                   /*!< SWCH0CCGEN (Bitfield-Mask: 0x01)                      */
#define ADVTMR_SWEVTGEN_SWUPDGEN_Pos     (0UL)                     /*!< SWUPDGEN (Bit 0)                                      */
#define ADVTMR_SWEVTGEN_SWUPDGEN_Msk     (0x1UL)                   /*!< SWUPDGEN (Bitfield-Mask: 0x01)                        */
/* =====================================================  CHXMODECTRL1  ====================================================== */
#define ADVTMR_CHXMODECTRL1_CCMR1_Pos    (0UL)                     /*!< CCMR1 (Bit 0)                                         */
#define ADVTMR_CHXMODECTRL1_CCMR1_Msk    (0x1ffffffUL)             /*!< CCMR1 (Bitfield-Mask: 0x1ffffff)                      */
/* =====================================================  CHXMODECTRL2  ====================================================== */
#define ADVTMR_CHXMODECTRL2_CCMR2_Pos    (0UL)                     /*!< CCMR2 (Bit 0)                                         */
#define ADVTMR_CHXMODECTRL2_CCMR2_Msk    (0x1ffffffUL)             /*!< CCMR2 (Bitfield-Mask: 0x1ffffff)                      */
/* =========================================================  CCER  ========================================================== */
#define ADVTMR_CCER_CH5P_Pos             (21UL)                    /*!< CH5P (Bit 21)                                         */
#define ADVTMR_CCER_CH5P_Msk             (0x200000UL)              /*!< CH5P (Bitfield-Mask: 0x01)                            */
#define ADVTMR_CCER_CH5EN_Pos            (20UL)                    /*!< CH5EN (Bit 20)                                        */
#define ADVTMR_CCER_CH5EN_Msk            (0x100000UL)              /*!< CH5EN (Bitfield-Mask: 0x01)                           */
#define ADVTMR_CCER_CH4P_Pos             (17UL)                    /*!< CH4P (Bit 17)                                         */
#define ADVTMR_CCER_CH4P_Msk             (0x20000UL)               /*!< CH4P (Bitfield-Mask: 0x01)                            */
#define ADVTMR_CCER_CH4EN_Pos            (16UL)                    /*!< CH4EN (Bit 16)                                        */
#define ADVTMR_CCER_CH4EN_Msk            (0x10000UL)               /*!< CH4EN (Bitfield-Mask: 0x01)                           */
#define ADVTMR_CCER_CH3NP_Pos            (15UL)                    /*!< CH3NP (Bit 15)                                        */
#define ADVTMR_CCER_CH3NP_Msk            (0x8000UL)                /*!< CH3NP (Bitfield-Mask: 0x01)                           */
#define ADVTMR_CCER_CH3NEN_Pos           (14UL)                    /*!< CH3NEN (Bit 14)                                       */
#define ADVTMR_CCER_CH3NEN_Msk           (0x4000UL)                /*!< CH3NEN (Bitfield-Mask: 0x01)                          */
#define ADVTMR_CCER_CH3P_Pos             (13UL)                    /*!< CH3P (Bit 13)                                         */
#define ADVTMR_CCER_CH3P_Msk             (0x2000UL)                /*!< CH3P (Bitfield-Mask: 0x01)                            */
#define ADVTMR_CCER_CH3EN_Pos            (12UL)                    /*!< CH3EN (Bit 12)                                        */
#define ADVTMR_CCER_CH3EN_Msk            (0x1000UL)                /*!< CH3EN (Bitfield-Mask: 0x01)                           */
#define ADVTMR_CCER_CH2NP_Pos            (11UL)                    /*!< CH2NP (Bit 11)                                        */
#define ADVTMR_CCER_CH2NP_Msk            (0x800UL)                 /*!< CH2NP (Bitfield-Mask: 0x01)                           */
#define ADVTMR_CCER_CH2NEN_Pos           (10UL)                    /*!< CH2NEN (Bit 10)                                       */
#define ADVTMR_CCER_CH2NEN_Msk           (0x400UL)                 /*!< CH2NEN (Bitfield-Mask: 0x01)                          */
#define ADVTMR_CCER_CH2P_Pos             (9UL)                     /*!< CH2P (Bit 9)                                          */
#define ADVTMR_CCER_CH2P_Msk             (0x200UL)                 /*!< CH2P (Bitfield-Mask: 0x01)                            */
#define ADVTMR_CCER_CH2EN_Pos            (8UL)                     /*!< CH2EN (Bit 8)                                         */
#define ADVTMR_CCER_CH2EN_Msk            (0x100UL)                 /*!< CH2EN (Bitfield-Mask: 0x01)                           */
#define ADVTMR_CCER_CH1NP_Pos            (7UL)                     /*!< CH1NP (Bit 7)                                         */
#define ADVTMR_CCER_CH1NP_Msk            (0x80UL)                  /*!< CH1NP (Bitfield-Mask: 0x01)                           */
#define ADVTMR_CCER_CH1NEN_Pos           (6UL)                     /*!< CH1NEN (Bit 6)                                        */
#define ADVTMR_CCER_CH1NEN_Msk           (0x40UL)                  /*!< CH1NEN (Bitfield-Mask: 0x01)                          */
#define ADVTMR_CCER_CH1P_Pos             (5UL)                     /*!< CH1P (Bit 5)                                          */
#define ADVTMR_CCER_CH1P_Msk             (0x20UL)                  /*!< CH1P (Bitfield-Mask: 0x01)                            */
#define ADVTMR_CCER_CH1EN_Pos            (4UL)                     /*!< CH1EN (Bit 4)                                         */
#define ADVTMR_CCER_CH1EN_Msk            (0x10UL)                  /*!< CH1EN (Bitfield-Mask: 0x01)                           */
#define ADVTMR_CCER_CH0NP_Pos            (3UL)                     /*!< CH0NP (Bit 3)                                         */
#define ADVTMR_CCER_CH0NP_Msk            (0x8UL)                   /*!< CH0NP (Bitfield-Mask: 0x01)                           */
#define ADVTMR_CCER_CH0NEN_Pos           (2UL)                     /*!< CH0NEN (Bit 2)                                        */
#define ADVTMR_CCER_CH0NEN_Msk           (0x4UL)                   /*!< CH0NEN (Bitfield-Mask: 0x01)                          */
#define ADVTMR_CCER_CH0P_Pos             (1UL)                     /*!< CH0P (Bit 1)                                          */
#define ADVTMR_CCER_CH0P_Msk             (0x2UL)                   /*!< CH0P (Bitfield-Mask: 0x01)                            */
#define ADVTMR_CCER_CH0EN_Pos            (0UL)                     /*!< CH0EN (Bit 0)                                         */
#define ADVTMR_CCER_CH0EN_Msk            (0x1UL)                   /*!< CH0EN (Bitfield-Mask: 0x01)                           */
/* =========================================================  TCNT  ========================================================== */
#define ADVTMR_TCNT_UPDIFCPY_Pos         (31UL)                    /*!< UPDIFCPY (Bit 31)                                     */
#define ADVTMR_TCNT_UPDIFCPY_Msk         (0x80000000UL)            /*!< UPDIFCPY (Bitfield-Mask: 0x01)                        */
#define ADVTMR_TCNT_TCNT_Pos             (0UL)                     /*!< TCNT (Bit 0)                                          */
#define ADVTMR_TCNT_TCNT_Msk             (0xffffUL)                /*!< TCNT (Bitfield-Mask: 0xffff)                          */
/* ==========================================================  PSC  ========================================================== */
#define ADVTMR_PSC_PSC_Pos               (0UL)                     /*!< PSC (Bit 0)                                           */
#define ADVTMR_PSC_PSC_Msk               (0xffffUL)                /*!< PSC (Bitfield-Mask: 0xffff)                           */
/* ==========================================================  ARR  ========================================================== */
#define ADVTMR_ARR_ARR_Pos               (0UL)                     /*!< ARR (Bit 0)                                           */
#define ADVTMR_ARR_ARR_Msk               (0xffffUL)                /*!< ARR (Bitfield-Mask: 0xffff)                           */
/* ==========================================================  RCR  ========================================================== */
#define ADVTMR_RCR_REPCNT_Pos            (16UL)                    /*!< REPCNT (Bit 16)                                       */
#define ADVTMR_RCR_REPCNT_Msk            (0xffff0000UL)            /*!< REPCNT (Bitfield-Mask: 0xffff)                        */
#define ADVTMR_RCR_REPVAL_Pos            (0UL)                     /*!< REPVAL (Bit 0)                                        */
#define ADVTMR_RCR_REPVAL_Msk            (0xffffUL)                /*!< REPVAL (Bitfield-Mask: 0xffff)                        */
/* =========================================================  CCR0  ========================================================== */
#define ADVTMR_CCR0_CH0CCRVAL_Pos        (0UL)                     /*!< CH0CCRVAL (Bit 0)                                     */
#define ADVTMR_CCR0_CH0CCRVAL_Msk        (0xffffUL)                /*!< CH0CCRVAL (Bitfield-Mask: 0xffff)                     */
/* =========================================================  CCR1  ========================================================== */
#define ADVTMR_CCR1_CH1CCRVAL_Pos        (0UL)                     /*!< CH1CCRVAL (Bit 0)                                     */
#define ADVTMR_CCR1_CH1CCRVAL_Msk        (0xffffUL)                /*!< CH1CCRVAL (Bitfield-Mask: 0xffff)                     */
/* =========================================================  CCR2  ========================================================== */
#define ADVTMR_CCR2_CH2CCRVAL_Pos        (0UL)                     /*!< CH2CCRVAL (Bit 0)                                     */
#define ADVTMR_CCR2_CH2CCRVAL_Msk        (0xffffUL)                /*!< CH2CCRVAL (Bitfield-Mask: 0xffff)                     */
/* =========================================================  CCR3  ========================================================== */
#define ADVTMR_CCR3_CH3CCRVAL_Pos        (0UL)                     /*!< CH3CCRVAL (Bit 0)                                     */
#define ADVTMR_CCR3_CH3CCRVAL_Msk        (0xffffUL)                /*!< CH3CCRVAL (Bitfield-Mask: 0xffff)                     */
/* =========================================================  BDTR  ========================================================== */
#define ADVTMR_BDTR_BRK2P_Pos            (25UL)                    /*!< BRK2P (Bit 25)                                        */
#define ADVTMR_BDTR_BRK2P_Msk            (0x2000000UL)             /*!< BRK2P (Bitfield-Mask: 0x01)                           */
#define ADVTMR_BDTR_BRK2EN_Pos           (24UL)                    /*!< BRK2EN (Bit 24)                                       */
#define ADVTMR_BDTR_BRK2EN_Msk           (0x1000000UL)             /*!< BRK2EN (Bitfield-Mask: 0x01)                          */
#define ADVTMR_BDTR_BRK2FILTCFG_Pos      (20UL)                    /*!< BRK2FILTCFG (Bit 20)                                  */
#define ADVTMR_BDTR_BRK2FILTCFG_Msk      (0xf00000UL)              /*!< BRK2FILTCFG (Bitfield-Mask: 0x0f)                     */
#define ADVTMR_BDTR_BRKFILTCFG_Pos       (16UL)                    /*!< BRKFILTCFG (Bit 16)                                   */
#define ADVTMR_BDTR_BRKFILTCFG_Msk       (0xf0000UL)               /*!< BRKFILTCFG (Bitfield-Mask: 0x0f)                      */
#define ADVTMR_BDTR_MOE_Pos              (15UL)                    /*!< MOE (Bit 15)                                          */
#define ADVTMR_BDTR_MOE_Msk              (0x8000UL)                /*!< MOE (Bitfield-Mask: 0x01)                             */
#define ADVTMR_BDTR_AOE_Pos              (14UL)                    /*!< AOE (Bit 14)                                          */
#define ADVTMR_BDTR_AOE_Msk              (0x4000UL)                /*!< AOE (Bitfield-Mask: 0x01)                             */
#define ADVTMR_BDTR_BRKP_Pos             (13UL)                    /*!< BRKP (Bit 13)                                         */
#define ADVTMR_BDTR_BRKP_Msk             (0x2000UL)                /*!< BRKP (Bitfield-Mask: 0x01)                            */
#define ADVTMR_BDTR_BRKEN_Pos            (12UL)                    /*!< BRKEN (Bit 12)                                        */
#define ADVTMR_BDTR_BRKEN_Msk            (0x1000UL)                /*!< BRKEN (Bitfield-Mask: 0x01)                           */
#define ADVTMR_BDTR_OSSR_Pos             (11UL)                    /*!< OSSR (Bit 11)                                         */
#define ADVTMR_BDTR_OSSR_Msk             (0x800UL)                 /*!< OSSR (Bitfield-Mask: 0x01)                            */
#define ADVTMR_BDTR_OSSI_Pos             (10UL)                    /*!< OSSI (Bit 10)                                         */
#define ADVTMR_BDTR_OSSI_Msk             (0x400UL)                 /*!< OSSI (Bitfield-Mask: 0x01)                            */
#define ADVTMR_BDTR_LOCK_Pos             (8UL)                     /*!< LOCK (Bit 8)                                          */
#define ADVTMR_BDTR_LOCK_Msk             (0x300UL)                 /*!< LOCK (Bitfield-Mask: 0x03)                            */
#define ADVTMR_BDTR_DTG_Pos              (0UL)                     /*!< DTG (Bit 0)                                           */
#define ADVTMR_BDTR_DTG_Msk              (0xffUL)                  /*!< DTG (Bitfield-Mask: 0xff)                             */
/* =========================================================  CCR4  ========================================================== */
#define ADVTMR_CCR4_GC4C2_Pos            (31UL)                    /*!< GC4C2 (Bit 31)                                        */
#define ADVTMR_CCR4_GC4C2_Msk            (0x80000000UL)            /*!< GC4C2 (Bitfield-Mask: 0x01)                           */
#define ADVTMR_CCR4_GC4C1_Pos            (30UL)                    /*!< GC4C1 (Bit 30)                                        */
#define ADVTMR_CCR4_GC4C1_Msk            (0x40000000UL)            /*!< GC4C1 (Bitfield-Mask: 0x01)                           */
#define ADVTMR_CCR4_GC4C0_Pos            (29UL)                    /*!< GC4C0 (Bit 29)                                        */
#define ADVTMR_CCR4_GC4C0_Msk            (0x20000000UL)            /*!< GC4C0 (Bitfield-Mask: 0x01)                           */
#define ADVTMR_CCR4_CH4CCRVAL_Pos        (0UL)                     /*!< CH4CCRVAL (Bit 0)                                     */
#define ADVTMR_CCR4_CH4CCRVAL_Msk        (0xffffUL)                /*!< CH4CCRVAL (Bitfield-Mask: 0xffff)                     */
/* =========================================================  CCR5  ========================================================== */
#define ADVTMR_CCR5_CH5CCRVAL_Pos        (0UL)                     /*!< CH5CCRVAL (Bit 0)                                     */
#define ADVTMR_CCR5_CH5CCRVAL_Msk        (0xffffUL)                /*!< CH5CCRVAL (Bitfield-Mask: 0xffff)                     */
/* =====================================================  CHXMODECTRL3  ====================================================== */
#define ADVTMR_CHXMODECTRL3_CH5OCMODEBIT3_Pos (24UL)               /*!< CH5OCMODEBIT3 (Bit 24)                                */
#define ADVTMR_CHXMODECTRL3_CH5OCMODEBIT3_Msk (0x1000000UL)        /*!< CH5OCMODEBIT3 (Bitfield-Mask: 0x01)                   */
#define ADVTMR_CHXMODECTRL3_CH4OCMODEBIT3_Pos (16UL)               /*!< CH4OCMODEBIT3 (Bit 16)                                */
#define ADVTMR_CHXMODECTRL3_CH4OCMODEBIT3_Msk (0x10000UL)          /*!< CH4OCMODEBIT3 (Bitfield-Mask: 0x01)                   */
#define ADVTMR_CHXMODECTRL3_CH5OCREFCLREN_Pos (15UL)               /*!< CH5OCREFCLREN (Bit 15)                                */
#define ADVTMR_CHXMODECTRL3_CH5OCREFCLREN_Msk (0x8000UL)           /*!< CH5OCREFCLREN (Bitfield-Mask: 0x01)                   */
#define ADVTMR_CHXMODECTRL3_CH5OCMODE_Pos (12UL)                   /*!< CH5OCMODE (Bit 12)                                    */
#define ADVTMR_CHXMODECTRL3_CH5OCMODE_Msk (0x7000UL)               /*!< CH5OCMODE (Bitfield-Mask: 0x07)                       */
#define ADVTMR_CHXMODECTRL3_CH5CCRSHDWEN_Pos (11UL)                /*!< CH5CCRSHDWEN (Bit 11)                                 */
#define ADVTMR_CHXMODECTRL3_CH5CCRSHDWEN_Msk (0x800UL)             /*!< CH5CCRSHDWEN (Bitfield-Mask: 0x01)                    */
#define ADVTMR_CHXMODECTRL3_CH5OCFASTEN_Pos (10UL)                 /*!< CH5OCFASTEN (Bit 10)                                  */
#define ADVTMR_CHXMODECTRL3_CH5OCFASTEN_Msk (0x400UL)              /*!< CH5OCFASTEN (Bitfield-Mask: 0x01)                     */
#define ADVTMR_CHXMODECTRL3_CH4OCREFCLREN_Pos (7UL)                /*!< CH4OCREFCLREN (Bit 7)                                 */
#define ADVTMR_CHXMODECTRL3_CH4OCREFCLREN_Msk (0x80UL)             /*!< CH4OCREFCLREN (Bitfield-Mask: 0x01)                   */
#define ADVTMR_CHXMODECTRL3_CH4OCMODE_Pos (4UL)                    /*!< CH4OCMODE (Bit 4)                                     */
#define ADVTMR_CHXMODECTRL3_CH4OCMODE_Msk (0x70UL)                 /*!< CH4OCMODE (Bitfield-Mask: 0x07)                       */
#define ADVTMR_CHXMODECTRL3_CH4CCRSHDWEN_Pos (3UL)                 /*!< CH4CCRSHDWEN (Bit 3)                                  */
#define ADVTMR_CHXMODECTRL3_CH4CCRSHDWEN_Msk (0x8UL)               /*!< CH4CCRSHDWEN (Bitfield-Mask: 0x01)                    */
#define ADVTMR_CHXMODECTRL3_CH4OCFASTEN_Pos (2UL)                  /*!< CH4OCFASTEN (Bit 2)                                   */
#define ADVTMR_CHXMODECTRL3_CH4OCFASTEN_Msk (0x4UL)                /*!< CH4OCFASTEN (Bitfield-Mask: 0x01)                     */
/* ========================================================  CHXSEL  ========================================================= */
#define ADVTMR_CHXSEL_CH3SRCSEL_Pos      (24UL)                    /*!< CH3SRCSEL (Bit 24)                                    */
#define ADVTMR_CHXSEL_CH3SRCSEL_Msk      (0x7000000UL)             /*!< CH3SRCSEL (Bitfield-Mask: 0x07)                       */
#define ADVTMR_CHXSEL_CH2SRCSEL_Pos      (16UL)                    /*!< CH2SRCSEL (Bit 16)                                    */
#define ADVTMR_CHXSEL_CH2SRCSEL_Msk      (0x70000UL)               /*!< CH2SRCSEL (Bitfield-Mask: 0x07)                       */
#define ADVTMR_CHXSEL_CH1SRCSEL_Pos      (8UL)                     /*!< CH1SRCSEL (Bit 8)                                     */
#define ADVTMR_CHXSEL_CH1SRCSEL_Msk      (0x700UL)                 /*!< CH1SRCSEL (Bitfield-Mask: 0x07)                       */
#define ADVTMR_CHXSEL_CH0SRCSEL_Pos      (0UL)                     /*!< CH0SRCSEL (Bit 0)                                     */
#define ADVTMR_CHXSEL_CH0SRCSEL_Msk      (0x7UL)                   /*!< CH0SRCSEL (Bitfield-Mask: 0x07)                       */
/* ==========================================================  AF1  ========================================================== */
#define ADVTMR_AF1_SYSBRKEN_Pos          (20UL)                    /*!< SYSBRKEN (Bit 20)                                     */
#define ADVTMR_AF1_SYSBRKEN_Msk          (0xf00000UL)              /*!< SYSBRKEN (Bitfield-Mask: 0x0f)                        */
#define ADVTMR_AF1_ETRGSEL_Pos           (16UL)                    /*!< ETRGSEL (Bit 16)                                      */
#define ADVTMR_AF1_ETRGSEL_Msk           (0x70000UL)               /*!< ETRGSEL (Bitfield-Mask: 0x07)                         */
#define ADVTMR_AF1_BRKCOMP3P_Pos         (11UL)                    /*!< BRKCOMP3P (Bit 11)                                    */
#define ADVTMR_AF1_BRKCOMP3P_Msk         (0x800UL)                 /*!< BRKCOMP3P (Bitfield-Mask: 0x01)                       */
#define ADVTMR_AF1_BRKCOMP2P_Pos         (10UL)                    /*!< BRKCOMP2P (Bit 10)                                    */
#define ADVTMR_AF1_BRKCOMP2P_Msk         (0x400UL)                 /*!< BRKCOMP2P (Bitfield-Mask: 0x01)                       */
#define ADVTMR_AF1_BRKCOMP1P_Pos         (9UL)                     /*!< BRKCOMP1P (Bit 9)                                     */
#define ADVTMR_AF1_BRKCOMP1P_Msk         (0x200UL)                 /*!< BRKCOMP1P (Bitfield-Mask: 0x01)                       */
#define ADVTMR_AF1_BRKINP_Pos            (8UL)                     /*!< BRKINP (Bit 8)                                        */
#define ADVTMR_AF1_BRKINP_Msk            (0x100UL)                 /*!< BRKINP (Bitfield-Mask: 0x01)                          */
#define ADVTMR_AF1_BRKCOMP3EN_Pos        (3UL)                     /*!< BRKCOMP3EN (Bit 3)                                    */
#define ADVTMR_AF1_BRKCOMP3EN_Msk        (0x8UL)                   /*!< BRKCOMP3EN (Bitfield-Mask: 0x01)                      */
#define ADVTMR_AF1_BRKCOMP2EN_Pos        (2UL)                     /*!< BRKCOMP2EN (Bit 2)                                    */
#define ADVTMR_AF1_BRKCOMP2EN_Msk        (0x4UL)                   /*!< BRKCOMP2EN (Bitfield-Mask: 0x01)                      */
#define ADVTMR_AF1_BRKCOMP1EN_Pos        (1UL)                     /*!< BRKCOMP1EN (Bit 1)                                    */
#define ADVTMR_AF1_BRKCOMP1EN_Msk        (0x2UL)                   /*!< BRKCOMP1EN (Bitfield-Mask: 0x01)                      */
#define ADVTMR_AF1_BRKINEN_Pos           (0UL)                     /*!< BRKINEN (Bit 0)                                       */
#define ADVTMR_AF1_BRKINEN_Msk           (0x1UL)                   /*!< BRKINEN (Bitfield-Mask: 0x01)                         */
/* ==========================================================  AF2  ========================================================== */
#define ADVTMR_AF2_OCREFCLRSRCSEL_Pos    (16UL)                    /*!< OCREFCLRSRCSEL (Bit 16)                               */
#define ADVTMR_AF2_OCREFCLRSRCSEL_Msk    (0x30000UL)               /*!< OCREFCLRSRCSEL (Bitfield-Mask: 0x03)                  */
#define ADVTMR_AF2_BRK2COMP3P_Pos        (11UL)                    /*!< BRK2COMP3P (Bit 11)                                   */
#define ADVTMR_AF2_BRK2COMP3P_Msk        (0x800UL)                 /*!< BRK2COMP3P (Bitfield-Mask: 0x01)                      */
#define ADVTMR_AF2_BRK2COMP2P_Pos        (10UL)                    /*!< BRK2COMP2P (Bit 10)                                   */
#define ADVTMR_AF2_BRK2COMP2P_Msk        (0x400UL)                 /*!< BRK2COMP2P (Bitfield-Mask: 0x01)                      */
#define ADVTMR_AF2_BRK2COMP1P_Pos        (9UL)                     /*!< BRK2COMP1P (Bit 9)                                    */
#define ADVTMR_AF2_BRK2COMP1P_Msk        (0x200UL)                 /*!< BRK2COMP1P (Bitfield-Mask: 0x01)                      */
#define ADVTMR_AF2_BRK2INP_Pos           (8UL)                     /*!< BRK2INP (Bit 8)                                       */
#define ADVTMR_AF2_BRK2INP_Msk           (0x100UL)                 /*!< BRK2INP (Bitfield-Mask: 0x01)                         */
#define ADVTMR_AF2_BRK2COMP3EN_Pos       (3UL)                     /*!< BRK2COMP3EN (Bit 3)                                   */
#define ADVTMR_AF2_BRK2COMP3EN_Msk       (0x8UL)                   /*!< BRK2COMP3EN (Bitfield-Mask: 0x01)                     */
#define ADVTMR_AF2_BRK2COMP2EN_Pos       (2UL)                     /*!< BRK2COMP2EN (Bit 2)                                   */
#define ADVTMR_AF2_BRK2COMP2EN_Msk       (0x4UL)                   /*!< BRK2COMP2EN (Bitfield-Mask: 0x01)                     */
#define ADVTMR_AF2_BRK2COMP1EN_Pos       (1UL)                     /*!< BRK2COMP1EN (Bit 1)                                   */
#define ADVTMR_AF2_BRK2COMP1EN_Msk       (0x2UL)                   /*!< BRK2COMP1EN (Bitfield-Mask: 0x01)                     */
#define ADVTMR_AF2_BRK2INEN_Pos          (0UL)                     /*!< BRK2INEN (Bit 0)                                      */
#define ADVTMR_AF2_BRK2INEN_Msk          (0x1UL)                   /*!< BRK2INEN (Bitfield-Mask: 0x01)                        */
/* ========================================================  DMACFG  ========================================================= */
#define ADVTMR_DMACFG_DBL_Pos            (8UL)                     /*!< DBL (Bit 8)                                           */
#define ADVTMR_DMACFG_DBL_Msk            (0x3f00UL)                /*!< DBL (Bitfield-Mask: 0x3f)                             */
#define ADVTMR_DMACFG_DBA_Pos            (0UL)                     /*!< DBA (Bit 0)                                           */
#define ADVTMR_DMACFG_DBA_Msk            (0x3fUL)                  /*!< DBA (Bitfield-Mask: 0x3f)                             */
/* =========================================================  DMAR  ========================================================== */
#define ADVTMR_DMAR_DMAB_Pos             (0UL)                     /*!< DMAB (Bit 0)                                          */
#define ADVTMR_DMAR_DMAB_Msk             (0xffffffffUL)            /*!< DMAB (Bitfield-Mask: 0xffffffff)                      */


/* =========================================================================================================================== */
/* ================                                            RTC                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  TR  =========================================================== */
#define RTC_TR_PM_Pos                     (22UL)                    /*!< PM (Bit 22)                                           */
#define RTC_TR_PM_Msk                     (0x400000UL)              /*!< PM (Bitfield-Mask: 0x01)                              */
#define RTC_TR_HOURT_Pos                  (20UL)                    /*!< HOURT (Bit 20)                                        */
#define RTC_TR_HOURT_Msk                  (0x300000UL)              /*!< HOURT (Bitfield-Mask: 0x03)                           */
#define RTC_TR_HOURU_Pos                  (16UL)                    /*!< HOURU (Bit 16)                                        */
#define RTC_TR_HOURU_Msk                  (0xf0000UL)               /*!< HOURU (Bitfield-Mask: 0x0f)                           */
#define RTC_TR_MINT_Pos                   (12UL)                    /*!< MINT (Bit 12)                                         */
#define RTC_TR_MINT_Msk                   (0x7000UL)                /*!< MINT (Bitfield-Mask: 0x07)                            */
#define RTC_TR_MINU_Pos                   (8UL)                     /*!< MINU (Bit 8)                                          */
#define RTC_TR_MINU_Msk                   (0xf00UL)                 /*!< MINU (Bitfield-Mask: 0x0f)                            */
#define RTC_TR_SECT_Pos                   (4UL)                     /*!< SECT (Bit 4)                                          */
#define RTC_TR_SECT_Msk                   (0x70UL)                  /*!< SECT (Bitfield-Mask: 0x07)                            */
#define RTC_TR_SECU_Pos                   (0UL)                     /*!< SECU (Bit 0)                                          */
#define RTC_TR_SECU_Msk                   (0xfUL)                   /*!< SECU (Bitfield-Mask: 0x0f)                            */
/* ==========================================================  DR  =========================================================== */
#define RTC_DR_YEART_Pos                  (20UL)                    /*!< YEART (Bit 20)                                        */
#define RTC_DR_YEART_Msk                  (0xf00000UL)              /*!< YEART (Bitfield-Mask: 0x0f)                           */
#define RTC_DR_YEARU_Pos                  (16UL)                    /*!< YEARU (Bit 16)                                        */
#define RTC_DR_YEARU_Msk                  (0xf0000UL)               /*!< YEARU (Bitfield-Mask: 0x0f)                           */
#define RTC_DR_WEEKU_Pos                  (13UL)                    /*!< WEEKU (Bit 13)                                        */
#define RTC_DR_WEEKU_Msk                  (0xe000UL)                /*!< WEEKU (Bitfield-Mask: 0x07)                           */
#define RTC_DR_MONTHT_Pos                 (12UL)                    /*!< MONTHT (Bit 12)                                       */
#define RTC_DR_MONTHT_Msk                 (0x1000UL)                /*!< MONTHT (Bitfield-Mask: 0x01)                          */
#define RTC_DR_MONTHU_Pos                 (8UL)                     /*!< MONTHU (Bit 8)                                        */
#define RTC_DR_MONTHU_Msk                 (0xf00UL)                 /*!< MONTHU (Bitfield-Mask: 0x0f)                          */
#define RTC_DR_DATET_Pos                  (4UL)                     /*!< DATET (Bit 4)                                         */
#define RTC_DR_DATET_Msk                  (0x30UL)                  /*!< DATET (Bitfield-Mask: 0x03)                           */
#define RTC_DR_DATEU_Pos                  (0UL)                     /*!< DATEU (Bit 0)                                         */
#define RTC_DR_DATEU_Msk                  (0xfUL)                   /*!< DATEU (Bitfield-Mask: 0x0f)                           */
/* ==========================================================  SSR  ========================================================== */
#define RTC_SSR_SS_Pos                    (0UL)                     /*!< SS (Bit 0)                                            */
#define RTC_SSR_SS_Msk                    (0xffffUL)                /*!< SS (Bitfield-Mask: 0xffff)                            */
/* =========================================================  ICSR  ========================================================== */
#define RTC_ICSR_RECALBF_Pos              (16UL)                    /*!< RECALBF (Bit 16)                                      */
#define RTC_ICSR_RECALBF_Msk              (0x10000UL)               /*!< RECALBF (Bitfield-Mask: 0x01)                         */
#define RTC_ICSR_INIT_Pos                 (7UL)                     /*!< INIT (Bit 7)                                          */
#define RTC_ICSR_INIT_Msk                 (0x80UL)                  /*!< INIT (Bitfield-Mask: 0x01)                            */
#define RTC_ICSR_INITF_Pos                (6UL)                     /*!< INITF (Bit 6)                                         */
#define RTC_ICSR_INITF_Msk                (0x40UL)                  /*!< INITF (Bitfield-Mask: 0x01)                           */
#define RTC_ICSR_RSF_Pos                  (5UL)                     /*!< RSF (Bit 5)                                           */
#define RTC_ICSR_RSF_Msk                  (0x20UL)                  /*!< RSF (Bitfield-Mask: 0x01)                             */
#define RTC_ICSR_INITSTS_Pos              (4UL)                     /*!< INITSTS (Bit 4)                                       */
#define RTC_ICSR_INITSTS_Msk              (0x10UL)                  /*!< INITSTS (Bitfield-Mask: 0x01)                         */
#define RTC_ICSR_SHIFTF_Pos               (3UL)                     /*!< SHIFTF (Bit 3)                                        */
#define RTC_ICSR_SHIFTF_Msk               (0x8UL)                   /*!< SHIFTF (Bitfield-Mask: 0x01)                          */
#define RTC_ICSR_WUTWF_Pos                (2UL)                     /*!< WUTWF (Bit 2)                                         */
#define RTC_ICSR_WUTWF_Msk                (0x4UL)                   /*!< WUTWF (Bitfield-Mask: 0x01)                           */
#define RTC_ICSR_ALRMBWF_Pos              (1UL)                     /*!< ALRMBWF (Bit 1)                                       */
#define RTC_ICSR_ALRMBWF_Msk              (0x2UL)                   /*!< ALRMBWF (Bitfield-Mask: 0x01)                         */
#define RTC_ICSR_ALRMAWF_Pos              (0UL)                     /*!< ALRMAWF (Bit 0)                                       */
#define RTC_ICSR_ALRMAWF_Msk              (0x1UL)                   /*!< ALRMAWF (Bitfield-Mask: 0x01)                         */
/* =========================================================  PSCR  ========================================================== */
#define RTC_PSCR_PSCDIVA_Pos              (16UL)                    /*!< PSCDIVA (Bit 16)                                      */
#define RTC_PSCR_PSCDIVA_Msk              (0x7f0000UL)              /*!< PSCDIVA (Bitfield-Mask: 0x7f)                         */
#define RTC_PSCR_PSCDIVS_Pos              (0UL)                     /*!< PSCDIVS (Bit 0)                                       */
#define RTC_PSCR_PSCDIVS_Msk              (0x7fffUL)                /*!< PSCDIVS (Bitfield-Mask: 0x7fff)                       */
/* =========================================================  WUTR  ========================================================== */
#define RTC_WUTR_WUTRLDVAL_Pos            (0UL)                     /*!< WUTRLDVAL (Bit 0)                                     */
#define RTC_WUTR_WUTRLDVAL_Msk            (0xffffUL)                /*!< WUTRLDVAL (Bitfield-Mask: 0xffff)                     */
/* ==========================================================  CR  =========================================================== */
#define RTC_CR_OUT2EN_Pos                 (31UL)                    /*!< OUT2EN (Bit 31)                                       */
#define RTC_CR_OUT2EN_Msk                 (0x80000000UL)            /*!< OUT2EN (Bitfield-Mask: 0x01)                          */
#define RTC_CR_ALRMTYPE_Pos               (30UL)                    /*!< ALRMTYPE (Bit 30)                                     */
#define RTC_CR_ALRMTYPE_Msk               (0x40000000UL)            /*!< ALRMTYPE (Bitfield-Mask: 0x01)                        */
#define RTC_CR_ALRMPU_Pos                 (29UL)                    /*!< ALRMPU (Bit 29)                                       */
#define RTC_CR_ALRMPU_Msk                 (0x20000000UL)            /*!< ALRMPU (Bitfield-Mask: 0x01)                          */
#define RTC_CR_ITSEN_Pos                  (24UL)                    /*!< ITSEN (Bit 24)                                        */
#define RTC_CR_ITSEN_Msk                  (0x1000000UL)             /*!< ITSEN (Bitfield-Mask: 0x01)                           */
#define RTC_CR_CALBOE_Pos                 (23UL)                    /*!< CALBOE (Bit 23)                                       */
#define RTC_CR_CALBOE_Msk                 (0x800000UL)              /*!< CALBOE (Bitfield-Mask: 0x01)                          */
#define RTC_CR_OSEL_Pos                   (21UL)                    /*!< OSEL (Bit 21)                                         */
#define RTC_CR_OSEL_Msk                   (0x600000UL)              /*!< OSEL (Bitfield-Mask: 0x03)                            */
#define RTC_CR_POL_Pos                    (20UL)                    /*!< POL (Bit 20)                                          */
#define RTC_CR_POL_Msk                    (0x100000UL)              /*!< POL (Bitfield-Mask: 0x01)                             */
#define RTC_CR_CALBOSEL_Pos               (19UL)                    /*!< CALBOSEL (Bit 19)                                     */
#define RTC_CR_CALBOSEL_Msk               (0x80000UL)               /*!< CALBOSEL (Bitfield-Mask: 0x01)                        */
#define RTC_CR_BKP_Pos                    (18UL)                    /*!< BKP (Bit 18)                                          */
#define RTC_CR_BKP_Msk                    (0x40000UL)               /*!< BKP (Bitfield-Mask: 0x01)                             */
#define RTC_CR_SUB1H_Pos                  (17UL)                    /*!< SUB1H (Bit 17)                                        */
#define RTC_CR_SUB1H_Msk                  (0x20000UL)               /*!< SUB1H (Bitfield-Mask: 0x01)                           */
#define RTC_CR_ADD1H_Pos                  (16UL)                    /*!< ADD1H (Bit 16)                                        */
#define RTC_CR_ADD1H_Msk                  (0x10000UL)               /*!< ADD1H (Bitfield-Mask: 0x01)                           */
#define RTC_CR_TSIEN_Pos                  (15UL)                    /*!< TSIEN (Bit 15)                                        */
#define RTC_CR_TSIEN_Msk                  (0x8000UL)                /*!< TSIEN (Bitfield-Mask: 0x01)                           */
#define RTC_CR_WUTIEN_Pos                 (14UL)                    /*!< WUTIEN (Bit 14)                                       */
#define RTC_CR_WUTIEN_Msk                 (0x4000UL)                /*!< WUTIEN (Bitfield-Mask: 0x01)                          */
#define RTC_CR_ALRMBIEN_Pos               (13UL)                    /*!< ALRMBIEN (Bit 13)                                     */
#define RTC_CR_ALRMBIEN_Msk               (0x2000UL)                /*!< ALRMBIEN (Bitfield-Mask: 0x01)                        */
#define RTC_CR_ALRMAIEN_Pos               (12UL)                    /*!< ALRMAIEN (Bit 12)                                     */
#define RTC_CR_ALRMAIEN_Msk               (0x1000UL)                /*!< ALRMAIEN (Bitfield-Mask: 0x01)                        */
#define RTC_CR_TSEN_Pos                   (11UL)                    /*!< TSEN (Bit 11)                                         */
#define RTC_CR_TSEN_Msk                   (0x800UL)                 /*!< TSEN (Bitfield-Mask: 0x01)                            */
#define RTC_CR_WUTEN_Pos                  (10UL)                    /*!< WUTEN (Bit 10)                                        */
#define RTC_CR_WUTEN_Msk                  (0x400UL)                 /*!< WUTEN (Bitfield-Mask: 0x01)                           */
#define RTC_CR_ALRMBEN_Pos                (9UL)                     /*!< ALRMBEN (Bit 9)                                       */
#define RTC_CR_ALRMBEN_Msk                (0x200UL)                 /*!< ALRMBEN (Bitfield-Mask: 0x01)                         */
#define RTC_CR_ALRMAEN_Pos                (8UL)                     /*!< ALRMAEN (Bit 8)                                       */
#define RTC_CR_ALRMAEN_Msk                (0x100UL)                 /*!< ALRMAEN (Bitfield-Mask: 0x01)                         */
#define RTC_CR_FMT_Pos                    (6UL)                     /*!< FMT (Bit 6)                                           */
#define RTC_CR_FMT_Msk                    (0x40UL)                  /*!< FMT (Bitfield-Mask: 0x01)                             */
#define RTC_CR_BYPSSHDW_Pos               (5UL)                     /*!< BYPSSHDW (Bit 5)                                      */
#define RTC_CR_BYPSSHDW_Msk               (0x20UL)                  /*!< BYPSSHDW (Bitfield-Mask: 0x01)                        */
#define RTC_CR_REFCKON_Pos                (4UL)                     /*!< REFCKON (Bit 4)                                       */
#define RTC_CR_REFCKON_Msk                (0x10UL)                  /*!< REFCKON (Bitfield-Mask: 0x01)                         */
#define RTC_CR_TSEDGE_Pos                 (3UL)                     /*!< TSEDGE (Bit 3)                                        */
#define RTC_CR_TSEDGE_Msk                 (0x8UL)                   /*!< TSEDGE (Bitfield-Mask: 0x01)                          */
#define RTC_CR_WUTCKSEL_Pos               (0UL)                     /*!< WUTCKSEL (Bit 0)                                      */
#define RTC_CR_WUTCKSEL_Msk               (0x7UL)                   /*!< WUTCKSEL (Bitfield-Mask: 0x07)                        */
/* ==========================================================  WPR  ========================================================== */
#define RTC_WPR_KEY_Pos                   (0UL)                     /*!< KEY (Bit 0)                                           */
#define RTC_WPR_KEY_Msk                   (0xffUL)                  /*!< KEY (Bitfield-Mask: 0xff)                             */
/* =========================================================  CALR  ========================================================== */
#define RTC_CALR_CALP_Pos                 (15UL)                    /*!< CALP (Bit 15)                                         */
#define RTC_CALR_CALP_Msk                 (0x8000UL)                /*!< CALP (Bitfield-Mask: 0x01)                            */
#define RTC_CALR_CALW8_Pos                (14UL)                    /*!< CALW8 (Bit 14)                                        */
#define RTC_CALR_CALW8_Msk                (0x4000UL)                /*!< CALW8 (Bitfield-Mask: 0x01)                           */
#define RTC_CALR_CALW16_Pos               (13UL)                    /*!< CALW16 (Bit 13)                                       */
#define RTC_CALR_CALW16_Msk               (0x2000UL)                /*!< CALW16 (Bitfield-Mask: 0x01)                          */
#define RTC_CALR_CALM_Pos                 (0UL)                     /*!< CALM (Bit 0)                                          */
#define RTC_CALR_CALM_Msk                 (0x1ffUL)                 /*!< CALM (Bitfield-Mask: 0x1ff)                           */
/* ========================================================  SHIFTR  ========================================================= */
#define RTC_SHIFTR_ADD1S_Pos              (31UL)                    /*!< ADD1S (Bit 31)                                        */
#define RTC_SHIFTR_ADD1S_Msk              (0x80000000UL)            /*!< ADD1S (Bitfield-Mask: 0x01)                           */
#define RTC_SHIFTR_SUBFS_Pos              (0UL)                     /*!< SUBFS (Bit 0)                                         */
#define RTC_SHIFTR_SUBFS_Msk              (0x7fffUL)                /*!< SUBFS (Bitfield-Mask: 0x7fff)                         */
/* =========================================================  TSTR  ========================================================== */
#define RTC_TSTR_PM_Pos                   (22UL)                    /*!< PM (Bit 22)                                           */
#define RTC_TSTR_PM_Msk                   (0x400000UL)              /*!< PM (Bitfield-Mask: 0x01)                              */
#define RTC_TSTR_HOURT_Pos                (20UL)                    /*!< HOURT (Bit 20)                                        */
#define RTC_TSTR_HOURT_Msk                (0x300000UL)              /*!< HOURT (Bitfield-Mask: 0x03)                           */
#define RTC_TSTR_HOURU_Pos                (16UL)                    /*!< HOURU (Bit 16)                                        */
#define RTC_TSTR_HOURU_Msk                (0xf0000UL)               /*!< HOURU (Bitfield-Mask: 0x0f)                           */
#define RTC_TSTR_MINT_Pos                 (12UL)                    /*!< MINT (Bit 12)                                         */
#define RTC_TSTR_MINT_Msk                 (0x7000UL)                /*!< MINT (Bitfield-Mask: 0x07)                            */
#define RTC_TSTR_MINU_Pos                 (8UL)                     /*!< MINU (Bit 8)                                          */
#define RTC_TSTR_MINU_Msk                 (0xf00UL)                 /*!< MINU (Bitfield-Mask: 0x0f)                            */
#define RTC_TSTR_SECT_Pos                 (4UL)                     /*!< SECT (Bit 4)                                          */
#define RTC_TSTR_SECT_Msk                 (0x70UL)                  /*!< SECT (Bitfield-Mask: 0x07)                            */
#define RTC_TSTR_SECU_Pos                 (0UL)                     /*!< SECU (Bit 0)                                          */
#define RTC_TSTR_SECU_Msk                 (0xfUL)                   /*!< SECU (Bitfield-Mask: 0x0f)                            */
/* =========================================================  TSDR  ========================================================== */
#define RTC_TSDR_WEEKU_Pos                (13UL)                    /*!< WEEKU (Bit 13)                                        */
#define RTC_TSDR_WEEKU_Msk                (0xe000UL)                /*!< WEEKU (Bitfield-Mask: 0x07)                           */
#define RTC_TSDR_MONTHT_Pos               (12UL)                    /*!< MONTHT (Bit 12)                                       */
#define RTC_TSDR_MONTHT_Msk               (0x1000UL)                /*!< MONTHT (Bitfield-Mask: 0x01)                          */
#define RTC_TSDR_MONTHU_Pos               (8UL)                     /*!< MONTHU (Bit 8)                                        */
#define RTC_TSDR_MONTHU_Msk               (0xf00UL)                 /*!< MONTHU (Bitfield-Mask: 0x0f)                          */
#define RTC_TSDR_DATET_Pos                (4UL)                     /*!< DATET (Bit 4)                                         */
#define RTC_TSDR_DATET_Msk                (0x30UL)                  /*!< DATET (Bitfield-Mask: 0x03)                           */
#define RTC_TSDR_DATEU_Pos                (0UL)                     /*!< DATEU (Bit 0)                                         */
#define RTC_TSDR_DATEU_Msk                (0xfUL)                   /*!< DATEU (Bitfield-Mask: 0x0f)                           */
/* =========================================================  TSSSR  ========================================================= */
#define RTC_TSSSR_SS_Pos                  (0UL)                     /*!< SS (Bit 0)                                            */
#define RTC_TSSSR_SS_Msk                  (0xffffUL)                /*!< SS (Bitfield-Mask: 0xffff)                            */
/* ========================================================  ALRMAR  ========================================================= */
#define RTC_ALRMAR_DATEMASK_Pos           (31UL)                    /*!< DATEMASK (Bit 31)                                     */
#define RTC_ALRMAR_DATEMASK_Msk           (0x80000000UL)            /*!< DATEMASK (Bitfield-Mask: 0x01)                        */
#define RTC_ALRMAR_WEEKSEL_Pos            (30UL)                    /*!< WEEKSEL (Bit 30)                                      */
#define RTC_ALRMAR_WEEKSEL_Msk            (0x40000000UL)            /*!< WEEKSEL (Bitfield-Mask: 0x01)                         */
#define RTC_ALRMAR_DATET_Pos              (28UL)                    /*!< DATET (Bit 28)                                        */
#define RTC_ALRMAR_DATET_Msk              (0x30000000UL)            /*!< DATET (Bitfield-Mask: 0x03)                           */
#define RTC_ALRMAR_DATEU_Pos              (24UL)                    /*!< DATEU (Bit 24)                                        */
#define RTC_ALRMAR_DATEU_Msk              (0xf000000UL)             /*!< DATEU (Bitfield-Mask: 0x0f)                           */
#define RTC_ALRMAR_HOURMASK_Pos           (23UL)                    /*!< HOURMASK (Bit 23)                                     */
#define RTC_ALRMAR_HOURMASK_Msk           (0x800000UL)              /*!< HOURMASK (Bitfield-Mask: 0x01)                        */
#define RTC_ALRMAR_PM_Pos                 (22UL)                    /*!< PM (Bit 22)                                           */
#define RTC_ALRMAR_PM_Msk                 (0x400000UL)              /*!< PM (Bitfield-Mask: 0x01)                              */
#define RTC_ALRMAR_HOURT_Pos              (20UL)                    /*!< HOURT (Bit 20)                                        */
#define RTC_ALRMAR_HOURT_Msk              (0x300000UL)              /*!< HOURT (Bitfield-Mask: 0x03)                           */
#define RTC_ALRMAR_HOURU_Pos              (16UL)                    /*!< HOURU (Bit 16)                                        */
#define RTC_ALRMAR_HOURU_Msk              (0xf0000UL)               /*!< HOURU (Bitfield-Mask: 0x0f)                           */
#define RTC_ALRMAR_MINMASK_Pos            (15UL)                    /*!< MINMASK (Bit 15)                                      */
#define RTC_ALRMAR_MINMASK_Msk            (0x8000UL)                /*!< MINMASK (Bitfield-Mask: 0x01)                         */
#define RTC_ALRMAR_MINT_Pos               (12UL)                    /*!< MINT (Bit 12)                                         */
#define RTC_ALRMAR_MINT_Msk               (0x7000UL)                /*!< MINT (Bitfield-Mask: 0x07)                            */
#define RTC_ALRMAR_MINU_Pos               (8UL)                     /*!< MINU (Bit 8)                                          */
#define RTC_ALRMAR_MINU_Msk               (0xf00UL)                 /*!< MINU (Bitfield-Mask: 0x0f)                            */
#define RTC_ALRMAR_SECMASK_Pos            (7UL)                     /*!< SECMASK (Bit 7)                                       */
#define RTC_ALRMAR_SECMASK_Msk            (0x80UL)                  /*!< SECMASK (Bitfield-Mask: 0x01)                         */
#define RTC_ALRMAR_SECT_Pos               (4UL)                     /*!< SECT (Bit 4)                                          */
#define RTC_ALRMAR_SECT_Msk               (0x70UL)                  /*!< SECT (Bitfield-Mask: 0x07)                            */
#define RTC_ALRMAR_SECU_Pos               (0UL)                     /*!< SECU (Bit 0)                                          */
#define RTC_ALRMAR_SECU_Msk               (0xfUL)                   /*!< SECU (Bitfield-Mask: 0x0f)                            */
/* =======================================================  ALRMASSR  ======================================================== */
#define RTC_ALRMASSR_MASKSS_Pos           (24UL)                    /*!< MASKSS (Bit 24)                                       */
#define RTC_ALRMASSR_MASKSS_Msk           (0xf000000UL)             /*!< MASKSS (Bitfield-Mask: 0x0f)                          */
#define RTC_ALRMASSR_SS_Pos               (0UL)                     /*!< SS (Bit 0)                                            */
#define RTC_ALRMASSR_SS_Msk               (0x7fffUL)                /*!< SS (Bitfield-Mask: 0x7fff)                            */
/* ========================================================  ALRMBR  ========================================================= */
#define RTC_ALRMBR_DATEMASK_Pos           (31UL)                    /*!< DATEMASK (Bit 31)                                     */
#define RTC_ALRMBR_DATEMASK_Msk           (0x80000000UL)            /*!< DATEMASK (Bitfield-Mask: 0x01)                        */
#define RTC_ALRMBR_WEEKSEL_Pos            (30UL)                    /*!< WEEKSEL (Bit 30)                                      */
#define RTC_ALRMBR_WEEKSEL_Msk            (0x40000000UL)            /*!< WEEKSEL (Bitfield-Mask: 0x01)                         */
#define RTC_ALRMBR_DATET_Pos              (28UL)                    /*!< DATET (Bit 28)                                        */
#define RTC_ALRMBR_DATET_Msk              (0x30000000UL)            /*!< DATET (Bitfield-Mask: 0x03)                           */
#define RTC_ALRMBR_DATEU_Pos              (24UL)                    /*!< DATEU (Bit 24)                                        */
#define RTC_ALRMBR_DATEU_Msk              (0xf000000UL)             /*!< DATEU (Bitfield-Mask: 0x0f)                           */
#define RTC_ALRMBR_HOURMASK_Pos           (23UL)                    /*!< HOURMASK (Bit 23)                                     */
#define RTC_ALRMBR_HOURMASK_Msk           (0x800000UL)              /*!< HOURMASK (Bitfield-Mask: 0x01)                        */
#define RTC_ALRMBR_PM_Pos                 (22UL)                    /*!< PM (Bit 22)                                           */
#define RTC_ALRMBR_PM_Msk                 (0x400000UL)              /*!< PM (Bitfield-Mask: 0x01)                              */
#define RTC_ALRMBR_HOURT_Pos              (20UL)                    /*!< HOURT (Bit 20)                                        */
#define RTC_ALRMBR_HOURT_Msk              (0x300000UL)              /*!< HOURT (Bitfield-Mask: 0x03)                           */
#define RTC_ALRMBR_HOURU_Pos              (16UL)                    /*!< HOURU (Bit 16)                                        */
#define RTC_ALRMBR_HOURU_Msk              (0xf0000UL)               /*!< HOURU (Bitfield-Mask: 0x0f)                           */
#define RTC_ALRMBR_MINMASK_Pos            (15UL)                    /*!< MINMASK (Bit 15)                                      */
#define RTC_ALRMBR_MINMASK_Msk            (0x8000UL)                /*!< MINMASK (Bitfield-Mask: 0x01)                         */
#define RTC_ALRMBR_MINT_Pos               (12UL)                    /*!< MINT (Bit 12)                                         */
#define RTC_ALRMBR_MINT_Msk               (0x7000UL)                /*!< MINT (Bitfield-Mask: 0x07)                            */
#define RTC_ALRMBR_MINU_Pos               (8UL)                     /*!< MINU (Bit 8)                                          */
#define RTC_ALRMBR_MINU_Msk               (0xf00UL)                 /*!< MINU (Bitfield-Mask: 0x0f)                            */
#define RTC_ALRMBR_SECMASK_Pos            (7UL)                     /*!< SECMASK (Bit 7)                                       */
#define RTC_ALRMBR_SECMASK_Msk            (0x80UL)                  /*!< SECMASK (Bitfield-Mask: 0x01)                         */
#define RTC_ALRMBR_SECT_Pos               (4UL)                     /*!< SECT (Bit 4)                                          */
#define RTC_ALRMBR_SECT_Msk               (0x70UL)                  /*!< SECT (Bitfield-Mask: 0x07)                            */
#define RTC_ALRMBR_SECU_Pos               (0UL)                     /*!< SECU (Bit 0)                                          */
#define RTC_ALRMBR_SECU_Msk               (0xfUL)                   /*!< SECU (Bitfield-Mask: 0x0f)                            */
/* =======================================================  ALRMBSSR  ======================================================== */
#define RTC_ALRMBSSR_MASKSS_Pos           (24UL)                    /*!< MASKSS (Bit 24)                                       */
#define RTC_ALRMBSSR_MASKSS_Msk           (0xf000000UL)             /*!< MASKSS (Bitfield-Mask: 0x0f)                          */
#define RTC_ALRMBSSR_SS_Pos               (0UL)                     /*!< SS (Bit 0)                                            */
#define RTC_ALRMBSSR_SS_Msk               (0x7fffUL)                /*!< SS (Bitfield-Mask: 0x7fff)                            */
/* ==========================================================  SR  =========================================================== */
#define RTC_SR_ITSF_Pos                   (5UL)                     /*!< ITSF (Bit 5)                                          */
#define RTC_SR_ITSF_Msk                   (0x20UL)                  /*!< ITSF (Bitfield-Mask: 0x01)                            */
#define RTC_SR_TSOVF_Pos                  (4UL)                     /*!< TSOVF (Bit 4)                                         */
#define RTC_SR_TSOVF_Msk                  (0x10UL)                  /*!< TSOVF (Bitfield-Mask: 0x01)                           */
#define RTC_SR_TSF_Pos                    (3UL)                     /*!< TSF (Bit 3)                                           */
#define RTC_SR_TSF_Msk                    (0x8UL)                   /*!< TSF (Bitfield-Mask: 0x01)                             */
#define RTC_SR_WUTF_Pos                   (2UL)                     /*!< WUTF (Bit 2)                                          */
#define RTC_SR_WUTF_Msk                   (0x4UL)                   /*!< WUTF (Bitfield-Mask: 0x01)                            */
#define RTC_SR_ALRMBF_Pos                 (1UL)                     /*!< ALRMBF (Bit 1)                                        */
#define RTC_SR_ALRMBF_Msk                 (0x2UL)                   /*!< ALRMBF (Bitfield-Mask: 0x01)                          */
#define RTC_SR_ALRMAF_Pos                 (0UL)                     /*!< ALRMAF (Bit 0)                                        */
#define RTC_SR_ALRMAF_Msk                 (0x1UL)                   /*!< ALRMAF (Bitfield-Mask: 0x01)                          */
/* =========================================================  INTSR  ========================================================= */
#define RTC_INTSR_ITSIF_Pos               (5UL)                     /*!< ITSIF (Bit 5)                                         */
#define RTC_INTSR_ITSIF_Msk               (0x20UL)                  /*!< ITSIF (Bitfield-Mask: 0x01)                           */
#define RTC_INTSR_TSOVF_Pos               (4UL)                     /*!< TSOVF (Bit 4)                                         */
#define RTC_INTSR_TSOVF_Msk               (0x10UL)                  /*!< TSOVF (Bitfield-Mask: 0x01)                           */
#define RTC_INTSR_TSIF_Pos                (3UL)                     /*!< TSIF (Bit 3)                                          */
#define RTC_INTSR_TSIF_Msk                (0x8UL)                   /*!< TSIF (Bitfield-Mask: 0x01)                            */
#define RTC_INTSR_WUTIF_Pos               (2UL)                     /*!< WUTIF (Bit 2)                                         */
#define RTC_INTSR_WUTIF_Msk               (0x4UL)                   /*!< WUTIF (Bitfield-Mask: 0x01)                           */
#define RTC_INTSR_ALRMBIF_Pos             (1UL)                     /*!< ALRMBIF (Bit 1)                                       */
#define RTC_INTSR_ALRMBIF_Msk             (0x2UL)                   /*!< ALRMBIF (Bitfield-Mask: 0x01)                         */
#define RTC_INTSR_ALRMAIF_Pos             (0UL)                     /*!< ALRMAIF (Bit 0)                                       */
#define RTC_INTSR_ALRMAIF_Msk             (0x1UL)                   /*!< ALRMAIF (Bitfield-Mask: 0x01)                         */
/* ==========================================================  SCR  ========================================================== */
#define RTC_SCR_ITSFCLR_Pos               (5UL)                     /*!< ITSFCLR (Bit 5)                                       */
#define RTC_SCR_ITSFCLR_Msk               (0x20UL)                  /*!< ITSFCLR (Bitfield-Mask: 0x01)                         */
#define RTC_SCR_TSOVFCLR_Pos              (4UL)                     /*!< TSOVFCLR (Bit 4)                                      */
#define RTC_SCR_TSOVFCLR_Msk              (0x10UL)                  /*!< TSOVFCLR (Bitfield-Mask: 0x01)                        */
#define RTC_SCR_TSFCLR_Pos                (3UL)                     /*!< TSFCLR (Bit 3)                                        */
#define RTC_SCR_TSFCLR_Msk                (0x8UL)                   /*!< TSFCLR (Bitfield-Mask: 0x01)                          */
#define RTC_SCR_WUTFCLR_Pos               (2UL)                     /*!< WUTFCLR (Bit 2)                                       */
#define RTC_SCR_WUTFCLR_Msk               (0x4UL)                   /*!< WUTFCLR (Bitfield-Mask: 0x01)                         */
#define RTC_SCR_ALRMBFCLR_Pos             (1UL)                     /*!< ALRMBFCLR (Bit 1)                                     */
#define RTC_SCR_ALRMBFCLR_Msk             (0x2UL)                   /*!< ALRMBFCLR (Bitfield-Mask: 0x01)                       */
#define RTC_SCR_ALRMAFCLR_Pos             (0UL)                     /*!< ALRMAFCLR (Bit 0)                                     */
#define RTC_SCR_ALRMAFCLR_Msk             (0x1UL)                   /*!< ALRMAFCLR (Bitfield-Mask: 0x01)                       */


/* =========================================================================================================================== */
/* ================                                          RTC_BKR                                          ================ */
/* =========================================================================================================================== */

/* =========================================================  BKP1R  ========================================================= */
#define RTC_BKR_BKP1R_BKP_Pos             (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP1R_BKP_Msk             (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  BKP2R  ========================================================= */
#define RTC_BKR_BKP2R_BKP_Pos             (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP2R_BKP_Msk             (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  BKP3R  ========================================================= */
#define RTC_BKR_BKP3R_BKP_Pos             (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP3R_BKP_Msk             (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  BKP4R  ========================================================= */
#define RTC_BKR_BKP4R_BKP_Pos             (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP4R_BKP_Msk             (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  BKP5R  ========================================================= */
#define RTC_BKR_BKP5R_BKP_Pos             (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP5R_BKP_Msk             (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  BKP6R  ========================================================= */
#define RTC_BKR_BKP6R_BKP_Pos             (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP6R_BKP_Msk             (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  BKP7R  ========================================================= */
#define RTC_BKR_BKP7R_BKP_Pos             (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP7R_BKP_Msk             (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  BKP8R  ========================================================= */
#define RTC_BKR_BKP8R_BKP_Pos             (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP8R_BKP_Msk             (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  BKP9R  ========================================================= */
#define RTC_BKR_BKP9R_BKP_Pos             (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP9R_BKP_Msk             (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* ========================================================  BKP10R  ========================================================= */
#define RTC_BKR_BKP10R_BKP_Pos            (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP10R_BKP_Msk            (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* ========================================================  BKP11R  ========================================================= */
#define RTC_BKR_BKP11R_BKP_Pos            (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP11R_BKP_Msk            (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* ========================================================  BKP12R  ========================================================= */
#define RTC_BKR_BKP12R_BKP_Pos            (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP12R_BKP_Msk            (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* ========================================================  BKP13R  ========================================================= */
#define RTC_BKR_BKP13R_BKP_Pos            (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP13R_BKP_Msk            (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* ========================================================  BKP14R  ========================================================= */
#define RTC_BKR_BKP14R_BKP_Pos            (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP14R_BKP_Msk            (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* ========================================================  BKP15R  ========================================================= */
#define RTC_BKR_BKP15R_BKP_Pos            (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP15R_BKP_Msk            (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */
/* ========================================================  BKP16R  ========================================================= */
#define RTC_BKR_BKP16R_BKP_Pos            (0UL)                     /*!< BKP (Bit 0)                                           */
#define RTC_BKR_BKP16R_BKP_Msk            (0xffffffffUL)            /*!< BKP (Bitfield-Mask: 0xffffffff)                       */


/* =========================================================================================================================== */
/* ================                                           I2C                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  CR1  ========================================================== */
#define I2C_CR1_PECEN_Pos                (23UL)                    /*!< PECEN (Bit 23)                                        */
#define I2C_CR1_PECEN_Msk                (0x800000UL)              /*!< PECEN (Bitfield-Mask: 0x01)                           */
#define I2C_CR1_ALERTEN_Pos              (22UL)                    /*!< ALERTEN (Bit 22)                                      */
#define I2C_CR1_ALERTEN_Msk              (0x400000UL)              /*!< ALERTEN (Bitfield-Mask: 0x01)                         */
#define I2C_CR1_SMBDEN_Pos               (21UL)                    /*!< SMBDEN (Bit 21)                                       */
#define I2C_CR1_SMBDEN_Msk               (0x200000UL)              /*!< SMBDEN (Bitfield-Mask: 0x01)                          */
#define I2C_CR1_SMBHEN_Pos               (20UL)                    /*!< SMBHEN (Bit 20)                                       */
#define I2C_CR1_SMBHEN_Msk               (0x100000UL)              /*!< SMBHEN (Bitfield-Mask: 0x01)                          */
#define I2C_CR1_GCEN_Pos                 (19UL)                    /*!< GCEN (Bit 19)                                         */
#define I2C_CR1_GCEN_Msk                 (0x80000UL)               /*!< GCEN (Bitfield-Mask: 0x01)                            */
#define I2C_CR1_WUPEN_Pos                (18UL)                    /*!< WUPEN (Bit 18)                                        */
#define I2C_CR1_WUPEN_Msk                (0x40000UL)               /*!< WUPEN (Bitfield-Mask: 0x01)                           */
#define I2C_CR1_NOEXT_Pos                (17UL)                    /*!< NOEXT (Bit 17)                                        */
#define I2C_CR1_NOEXT_Msk                (0x20000UL)               /*!< NOEXT (Bitfield-Mask: 0x01)                           */
#define I2C_CR1_SBCEN_Pos                (16UL)                    /*!< SBCEN (Bit 16)                                        */
#define I2C_CR1_SBCEN_Msk                (0x10000UL)               /*!< SBCEN (Bitfield-Mask: 0x01)                           */
#define I2C_CR1_RXDMAEN_Pos              (15UL)                    /*!< RXDMAEN (Bit 15)                                      */
#define I2C_CR1_RXDMAEN_Msk              (0x8000UL)                /*!< RXDMAEN (Bitfield-Mask: 0x01)                         */
#define I2C_CR1_TXDMAEN_Pos              (14UL)                    /*!< TXDMAEN (Bit 14)                                      */
#define I2C_CR1_TXDMAEN_Msk              (0x4000UL)                /*!< TXDMAEN (Bitfield-Mask: 0x01)                         */
#define I2C_CR1_ANFOFF_Pos               (12UL)                    /*!< ANFOFF (Bit 12)                                       */
#define I2C_CR1_ANFOFF_Msk               (0x1000UL)                /*!< ANFOFF (Bitfield-Mask: 0x01)                          */
#define I2C_CR1_DNF_Pos                  (8UL)                     /*!< DNF (Bit 8)                                           */
#define I2C_CR1_DNF_Msk                  (0xf00UL)                 /*!< DNF (Bitfield-Mask: 0x0f)                             */
#define I2C_CR1_ERRIEN_Pos               (7UL)                     /*!< ERRIEN (Bit 7)                                        */
#define I2C_CR1_ERRIEN_Msk               (0x80UL)                  /*!< ERRIEN (Bitfield-Mask: 0x01)                          */
#define I2C_CR1_TCIEN_Pos                (6UL)                     /*!< TCIEN (Bit 6)                                         */
#define I2C_CR1_TCIEN_Msk                (0x40UL)                  /*!< TCIEN (Bitfield-Mask: 0x01)                           */
#define I2C_CR1_STOPIEN_Pos              (5UL)                     /*!< STOPIEN (Bit 5)                                       */
#define I2C_CR1_STOPIEN_Msk              (0x20UL)                  /*!< STOPIEN (Bitfield-Mask: 0x01)                         */
#define I2C_CR1_NACKIEN_Pos              (4UL)                     /*!< NACKIEN (Bit 4)                                       */
#define I2C_CR1_NACKIEN_Msk              (0x10UL)                  /*!< NACKIEN (Bitfield-Mask: 0x01)                         */
#define I2C_CR1_ADDRIEN_Pos              (3UL)                     /*!< ADDRIEN (Bit 3)                                       */
#define I2C_CR1_ADDRIEN_Msk              (0x8UL)                   /*!< ADDRIEN (Bitfield-Mask: 0x01)                         */
#define I2C_CR1_RXIEN_Pos                (2UL)                     /*!< RXIEN (Bit 2)                                         */
#define I2C_CR1_RXIEN_Msk                (0x4UL)                   /*!< RXIEN (Bitfield-Mask: 0x01)                           */
#define I2C_CR1_TXIEN_Pos                (1UL)                     /*!< TXIEN (Bit 1)                                         */
#define I2C_CR1_TXIEN_Msk                (0x2UL)                   /*!< TXIEN (Bitfield-Mask: 0x01)                           */
#define I2C_CR1_I2CEN_Pos                (0UL)                     /*!< I2CEN (Bit 0)                                         */
#define I2C_CR1_I2CEN_Msk                (0x1UL)                   /*!< I2CEN (Bitfield-Mask: 0x01)                           */
/* ==========================================================  CR2  ========================================================== */
#define I2C_CR2_PECBYTE_Pos              (26UL)                    /*!< PECBYTE (Bit 26)                                      */
#define I2C_CR2_PECBYTE_Msk              (0x4000000UL)             /*!< PECBYTE (Bitfield-Mask: 0x01)                         */
#define I2C_CR2_AUTOEND_Pos              (25UL)                    /*!< AUTOEND (Bit 25)                                      */
#define I2C_CR2_AUTOEND_Msk              (0x2000000UL)             /*!< AUTOEND (Bitfield-Mask: 0x01)                         */
#define I2C_CR2_RELOAD_Pos               (24UL)                    /*!< RELOAD (Bit 24)                                       */
#define I2C_CR2_RELOAD_Msk               (0x1000000UL)             /*!< RELOAD (Bitfield-Mask: 0x01)                          */
#define I2C_CR2_NBYTE_Pos                (16UL)                    /*!< NBYTE (Bit 16)                                        */
#define I2C_CR2_NBYTE_Msk                (0xff0000UL)              /*!< NBYTE (Bitfield-Mask: 0xff)                           */
#define I2C_CR2_NACK_Pos                 (15UL)                    /*!< NACK (Bit 15)                                         */
#define I2C_CR2_NACK_Msk                 (0x8000UL)                /*!< NACK (Bitfield-Mask: 0x01)                            */
#define I2C_CR2_STOP_Pos                 (14UL)                    /*!< STOP (Bit 14)                                         */
#define I2C_CR2_STOP_Msk                 (0x4000UL)                /*!< STOP (Bitfield-Mask: 0x01)                            */
#define I2C_CR2_START_Pos                (13UL)                    /*!< START (Bit 13)                                        */
#define I2C_CR2_START_Msk                (0x2000UL)                /*!< START (Bitfield-Mask: 0x01)                           */
#define I2C_CR2_ADD10_Pos                (11UL)                    /*!< ADD10 (Bit 11)                                        */
#define I2C_CR2_ADD10_Msk                (0x800UL)                 /*!< ADD10 (Bitfield-Mask: 0x01)                           */
#define I2C_CR2_RDWRN_Pos                (10UL)                    /*!< RDWRN (Bit 10)                                        */
#define I2C_CR2_RDWRN_Msk                (0x400UL)                 /*!< RDWRN (Bitfield-Mask: 0x01)                           */
#define I2C_CR2_SADD_Pos                 (0UL)                     /*!< SADD (Bit 0)                                          */
#define I2C_CR2_SADD_Msk                 (0x3ffUL)                 /*!< SADD (Bitfield-Mask: 0x3ff)                           */
/* =========================================================  OAR1  ========================================================== */
#define I2C_OAR1_OA1EN_Pos               (15UL)                    /*!< OA1EN (Bit 15)                                        */
#define I2C_OAR1_OA1EN_Msk               (0x8000UL)                /*!< OA1EN (Bitfield-Mask: 0x01)                           */
#define I2C_OAR1_OA1MODE_Pos             (10UL)                    /*!< OA1MODE (Bit 10)                                      */
#define I2C_OAR1_OA1MODE_Msk             (0x400UL)                 /*!< OA1MODE (Bitfield-Mask: 0x01)                         */
#define I2C_OAR1_OA198_Pos               (8UL)                     /*!< OA198 (Bit 8)                                         */
#define I2C_OAR1_OA198_Msk               (0x300UL)                 /*!< OA198 (Bitfield-Mask: 0x03)                           */
#define I2C_OAR1_OA171_Pos               (1UL)                     /*!< OA171 (Bit 1)                                         */
#define I2C_OAR1_OA171_Msk               (0xfeUL)                  /*!< OA171 (Bitfield-Mask: 0x7f)                           */
#define I2C_OAR1_OA10_Pos                (0UL)                     /*!< OA10 (Bit 0)                                          */
#define I2C_OAR1_OA10_Msk                (0x1UL)                   /*!< OA10 (Bitfield-Mask: 0x01)                            */
/* =========================================================  OAR2  ========================================================== */
#define I2C_OAR2_OA2EN_Pos               (15UL)                    /*!< OA2EN (Bit 15)                                        */
#define I2C_OAR2_OA2EN_Msk               (0x8000UL)                /*!< OA2EN (Bitfield-Mask: 0x01)                           */
#define I2C_OAR2_OA2MSK_Pos              (8UL)                     /*!< OA2MSK (Bit 8)                                        */
#define I2C_OAR2_OA2MSK_Msk              (0x700UL)                 /*!< OA2MSK (Bitfield-Mask: 0x07)                          */
#define I2C_OAR2_OA271_Pos               (1UL)                     /*!< OA271 (Bit 1)                                         */
#define I2C_OAR2_OA271_Msk               (0xfeUL)                  /*!< OA271 (Bitfield-Mask: 0x7f)                           */
/* ========================================================  TIMINGR  ======================================================== */
#define I2C_TIMINGR_PREDIV_Pos           (28UL)                    /*!< PREDIV (Bit 28)                                       */
#define I2C_TIMINGR_PREDIV_Msk           (0xf0000000UL)            /*!< PREDIV (Bitfield-Mask: 0x0f)                          */
#define I2C_TIMINGR_SCLDEL_Pos           (20UL)                    /*!< SCLDEL (Bit 20)                                       */
#define I2C_TIMINGR_SCLDEL_Msk           (0xf00000UL)              /*!< SCLDEL (Bitfield-Mask: 0x0f)                          */
#define I2C_TIMINGR_SDADEL_Pos           (16UL)                    /*!< SDADEL (Bit 16)                                       */
#define I2C_TIMINGR_SDADEL_Msk           (0xf0000UL)               /*!< SDADEL (Bitfield-Mask: 0x0f)                          */
#define I2C_TIMINGR_SCLHI_Pos            (8UL)                     /*!< SCLHI (Bit 8)                                         */
#define I2C_TIMINGR_SCLHI_Msk            (0xff00UL)                /*!< SCLHI (Bitfield-Mask: 0xff)                           */
#define I2C_TIMINGR_SCLLOW_Pos           (0UL)                     /*!< SCLLOW (Bit 0)                                        */
#define I2C_TIMINGR_SCLLOW_Msk           (0xffUL)                  /*!< SCLLOW (Bitfield-Mask: 0xff)                          */
/* =======================================================  TIMEOUTR  ======================================================== */
#define I2C_TIMEOUTR_EXTTOEN_Pos         (31UL)                    /*!< EXTTOEN (Bit 31)                                      */
#define I2C_TIMEOUTR_EXTTOEN_Msk         (0x80000000UL)            /*!< EXTTOEN (Bitfield-Mask: 0x01)                         */
#define I2C_TIMEOUTR_TOB_Pos             (16UL)                    /*!< TOB (Bit 16)                                          */
#define I2C_TIMEOUTR_TOB_Msk             (0xfff0000UL)             /*!< TOB (Bitfield-Mask: 0xfff)                            */
#define I2C_TIMEOUTR_TOEN_Pos            (15UL)                    /*!< TOEN (Bit 15)                                         */
#define I2C_TIMEOUTR_TOEN_Msk            (0x8000UL)                /*!< TOEN (Bitfield-Mask: 0x01)                            */
#define I2C_TIMEOUTR_TOIDLE_Pos          (12UL)                    /*!< TOIDLE (Bit 12)                                       */
#define I2C_TIMEOUTR_TOIDLE_Msk          (0x1000UL)                /*!< TOIDLE (Bitfield-Mask: 0x01)                          */
#define I2C_TIMEOUTR_TOA_Pos             (0UL)                     /*!< TOA (Bit 0)                                           */
#define I2C_TIMEOUTR_TOA_Msk             (0xfffUL)                 /*!< TOA (Bitfield-Mask: 0xfff)                            */
/* ==========================================================  ISR  ========================================================== */
#define I2C_ISR_ADDCODE_Pos              (17UL)                    /*!< ADDCODE (Bit 17)                                      */
#define I2C_ISR_ADDCODE_Msk              (0xfe0000UL)              /*!< ADDCODE (Bitfield-Mask: 0x7f)                         */
#define I2C_ISR_DIR_Pos                  (16UL)                    /*!< DIR (Bit 16)                                          */
#define I2C_ISR_DIR_Msk                  (0x10000UL)               /*!< DIR (Bitfield-Mask: 0x01)                             */
#define I2C_ISR_BUSY_Pos                 (15UL)                    /*!< BUSY (Bit 15)                                         */
#define I2C_ISR_BUSY_Msk                 (0x8000UL)                /*!< BUSY (Bitfield-Mask: 0x01)                            */
#define I2C_ISR_ALERT_Pos                (13UL)                    /*!< ALERT (Bit 13)                                        */
#define I2C_ISR_ALERT_Msk                (0x2000UL)                /*!< ALERT (Bitfield-Mask: 0x01)                           */
#define I2C_ISR_TIMEOUT_Pos              (12UL)                    /*!< TIMEOUT (Bit 12)                                      */
#define I2C_ISR_TIMEOUT_Msk              (0x1000UL)                /*!< TIMEOUT (Bitfield-Mask: 0x01)                         */
#define I2C_ISR_PECERR_Pos               (11UL)                    /*!< PECERR (Bit 11)                                       */
#define I2C_ISR_PECERR_Msk               (0x800UL)                 /*!< PECERR (Bitfield-Mask: 0x01)                          */
#define I2C_ISR_OVF_Pos                  (10UL)                    /*!< OVF (Bit 10)                                          */
#define I2C_ISR_OVF_Msk                  (0x400UL)                 /*!< OVF (Bitfield-Mask: 0x01)                             */
#define I2C_ISR_ARLO_Pos                 (9UL)                     /*!< ARLO (Bit 9)                                          */
#define I2C_ISR_ARLO_Msk                 (0x200UL)                 /*!< ARLO (Bitfield-Mask: 0x01)                            */
#define I2C_ISR_BERR_Pos                 (8UL)                     /*!< BERR (Bit 8)                                          */
#define I2C_ISR_BERR_Msk                 (0x100UL)                 /*!< BERR (Bitfield-Mask: 0x01)                            */
#define I2C_ISR_TCR_Pos                  (7UL)                     /*!< TCR (Bit 7)                                           */
#define I2C_ISR_TCR_Msk                  (0x80UL)                  /*!< TCR (Bitfield-Mask: 0x01)                             */
#define I2C_ISR_TC_Pos                   (6UL)                     /*!< TC (Bit 6)                                            */
#define I2C_ISR_TC_Msk                   (0x40UL)                  /*!< TC (Bitfield-Mask: 0x01)                              */
#define I2C_ISR_STOPF_Pos                (5UL)                     /*!< STOPF (Bit 5)                                         */
#define I2C_ISR_STOPF_Msk                (0x20UL)                  /*!< STOPF (Bitfield-Mask: 0x01)                           */
#define I2C_ISR_NACKF_Pos                (4UL)                     /*!< NACKF (Bit 4)                                         */
#define I2C_ISR_NACKF_Msk                (0x10UL)                  /*!< NACKF (Bitfield-Mask: 0x01)                           */
#define I2C_ISR_ADDR_Pos                 (3UL)                     /*!< ADDR (Bit 3)                                          */
#define I2C_ISR_ADDR_Msk                 (0x8UL)                   /*!< ADDR (Bitfield-Mask: 0x01)                            */
#define I2C_ISR_RXNE_Pos                 (2UL)                     /*!< RXNE (Bit 2)                                          */
#define I2C_ISR_RXNE_Msk                 (0x4UL)                   /*!< RXNE (Bitfield-Mask: 0x01)                            */
#define I2C_ISR_TXIS_Pos                 (1UL)                     /*!< TXIS (Bit 1)                                          */
#define I2C_ISR_TXIS_Msk                 (0x2UL)                   /*!< TXIS (Bitfield-Mask: 0x01)                            */
#define I2C_ISR_TXE_Pos                  (0UL)                     /*!< TXE (Bit 0)                                           */
#define I2C_ISR_TXE_Msk                  (0x1UL)                   /*!< TXE (Bitfield-Mask: 0x01)                             */
/* ==========================================================  ICR  ========================================================== */
#define I2C_ICR_ALERTCF_Pos              (13UL)                    /*!< ALERTCF (Bit 13)                                      */
#define I2C_ICR_ALERTCF_Msk              (0x2000UL)                /*!< ALERTCF (Bitfield-Mask: 0x01)                         */
#define I2C_ICR_TIMEOUTCF_Pos            (12UL)                    /*!< TIMEOUTCF (Bit 12)                                    */
#define I2C_ICR_TIMEOUTCF_Msk            (0x1000UL)                /*!< TIMEOUTCF (Bitfield-Mask: 0x01)                       */
#define I2C_ICR_PECCF_Pos                (11UL)                    /*!< PECCF (Bit 11)                                        */
#define I2C_ICR_PECCF_Msk                (0x800UL)                 /*!< PECCF (Bitfield-Mask: 0x01)                           */
#define I2C_ICR_OVFCF_Pos                (10UL)                    /*!< OVFCF (Bit 10)                                        */
#define I2C_ICR_OVFCF_Msk                (0x400UL)                 /*!< OVFCF (Bitfield-Mask: 0x01)                           */
#define I2C_ICR_ARLOCF_Pos               (9UL)                     /*!< ARLOCF (Bit 9)                                        */
#define I2C_ICR_ARLOCF_Msk               (0x200UL)                 /*!< ARLOCF (Bitfield-Mask: 0x01)                          */
#define I2C_ICR_BERRCF_Pos               (8UL)                     /*!< BERRCF (Bit 8)                                        */
#define I2C_ICR_BERRCF_Msk               (0x100UL)                 /*!< BERRCF (Bitfield-Mask: 0x01)                          */
#define I2C_ICR_STOPCF_Pos               (5UL)                     /*!< STOPCF (Bit 5)                                        */
#define I2C_ICR_STOPCF_Msk               (0x20UL)                  /*!< STOPCF (Bitfield-Mask: 0x01)                          */
#define I2C_ICR_NACKCF_Pos               (4UL)                     /*!< NACKCF (Bit 4)                                        */
#define I2C_ICR_NACKCF_Msk               (0x10UL)                  /*!< NACKCF (Bitfield-Mask: 0x01)                          */
#define I2C_ICR_ADDRCR_Pos               (3UL)                     /*!< ADDRCR (Bit 3)                                        */
#define I2C_ICR_ADDRCR_Msk               (0x8UL)                   /*!< ADDRCR (Bitfield-Mask: 0x01)                          */
/* =========================================================  PECR  ========================================================== */
#define I2C_PECR_PEC_Pos                 (0UL)                     /*!< PEC (Bit 0)                                           */
#define I2C_PECR_PEC_Msk                 (0xffUL)                  /*!< PEC (Bitfield-Mask: 0xff)                             */
/* =========================================================  RXDR  ========================================================== */
#define I2C_RXDR_RXDATA_Pos              (0UL)                     /*!< RXDATA (Bit 0)                                        */
#define I2C_RXDR_RXDATA_Msk              (0xffUL)                  /*!< RXDATA (Bitfield-Mask: 0xff)                          */
/* =========================================================  TXDR  ========================================================== */
#define I2C_TXDR_TXDR_Pos                (0UL)                     /*!< TXDR (Bit 0)                                          */
#define I2C_TXDR_TXDR_Msk                (0xffUL)                  /*!< TXDR (Bitfield-Mask: 0xff)                            */


/* =========================================================================================================================== */
/* ================                                            PMU                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  CR00  ========================================================== */
#define PMU_CR00_DBP_Pos                  (8UL)                     /*!< DBP (Bit 8)                                           */
#define PMU_CR00_DBP_Msk                  (0x100UL)                 /*!< DBP (Bitfield-Mask: 0x01)                             */
#define PMU_CR00_LPR_Pos                  (4UL)                     /*!< LPR (Bit 4)                                           */
#define PMU_CR00_LPR_Msk                  (0x10UL)                  /*!< LPR (Bitfield-Mask: 0x01)                             */
#define PMU_CR00_STOPFRC_Pos              (0UL)                     /*!< STOPFRC (Bit 0)                                       */
#define PMU_CR00_STOPFRC_Msk              (0x1UL)                   /*!< STOPFRC (Bitfield-Mask: 0x01)                         */
/* =========================================================  CR01  ========================================================== */
#define PMU_CR01_SRAMSYNCEN_Pos           (10UL)                    /*!< SRAMSYNCEN (Bit 10)                                   */
#define PMU_CR01_SRAMSYNCEN_Msk           (0x400UL)                 /*!< SRAMSYNCEN (Bitfield-Mask: 0x01)                      */
#define PMU_CR01_STOPSRAM2RET_Pos         (9UL)                     /*!< STOPSRAM2RET (Bit 9)                                  */
#define PMU_CR01_STOPSRAM2RET_Msk         (0x200UL)                 /*!< STOPSRAM2RET (Bitfield-Mask: 0x01)                    */
#define PMU_CR01_STOPSRAM1RET1_Pos        (8UL)                     /*!< STOPSRAM1RET1 (Bit 8)                                 */
#define PMU_CR01_STOPSRAM1RET1_Msk        (0x100UL)                 /*!< STOPSRAM1RET1 (Bitfield-Mask: 0x01)                   */
#define PMU_CR01_STOPSRAM1RET0_Pos        (7UL)                     /*!< STOPSRAM1RET0 (Bit 7)                                 */
#define PMU_CR01_STOPSRAM1RET0_Msk        (0x80UL)                  /*!< STOPSRAM1RET0 (Bitfield-Mask: 0x01)                   */
#define PMU_CR01_STOPSRAM0RET2_Pos        (6UL)                     /*!< STOPSRAM0RET2 (Bit 6)                                 */
#define PMU_CR01_STOPSRAM0RET2_Msk        (0x40UL)                  /*!< STOPSRAM0RET2 (Bitfield-Mask: 0x01)                   */
#define PMU_CR01_STOPSRAM0RET1_Pos        (5UL)                     /*!< STOPSRAM0RET1 (Bit 5)                                 */
#define PMU_CR01_STOPSRAM0RET1_Msk        (0x20UL)                  /*!< STOPSRAM0RET1 (Bitfield-Mask: 0x01)                   */
#define PMU_CR01_STOPSRAM0RET0_Pos        (4UL)                     /*!< STOPSRAM0RET0 (Bit 4)                                 */
#define PMU_CR01_STOPSRAM0RET0_Msk        (0x10UL)                  /*!< STOPSRAM0RET0 (Bitfield-Mask: 0x01)                   */
#define PMU_CR01_LPMS_Pos                 (0UL)                     /*!< LPMS (Bit 0)                                          */
#define PMU_CR01_LPMS_Msk                 (0xfUL)                   /*!< LPMS (Bitfield-Mask: 0x0f)                            */
/* =========================================================  CR03  ========================================================== */
#define PMU_CR03_SVSEN_Pos                (0UL)                     /*!< SVSEN (Bit 0)                                         */
#define PMU_CR03_SVSEN_Msk                (0x1UL)                   /*!< SVSEN (Bitfield-Mask: 0x01)                           */
/* =========================================================  CR05  ========================================================== */
#define PMU_CR05_IHSCALUPDENFRC_Pos       (14UL)                    /*!< IHSCALUPDENFRC (Bit 14)                               */
#define PMU_CR05_IHSCALUPDENFRC_Msk       (0x4000UL)                /*!< IHSCALUPDENFRC (Bitfield-Mask: 0x01)                  */
#define PMU_CR05_IHSTRIM_Pos              (0UL)                     /*!< IHSTRIM (Bit 0)                                       */
#define PMU_CR05_IHSTRIM_Msk              (0x3fffUL)                /*!< IHSTRIM (Bitfield-Mask: 0x3fff)                       */
/* =========================================================  CR11  ========================================================== */
#define PMU_CR11_SWLDORAMRA_Pos           (8UL)                     /*!< SWLDORAMRA (Bit 8)                                    */
#define PMU_CR11_SWLDORAMRA_Msk           (0x300UL)                 /*!< SWLDORAMRA (Bitfield-Mask: 0x03)                      */
#define PMU_CR11_SWLDORAMWA_Pos           (4UL)                     /*!< SWLDORAMWA (Bit 4)                                    */
#define PMU_CR11_SWLDORAMWA_Msk           (0x70UL)                  /*!< SWLDORAMWA (Bitfield-Mask: 0x07)                      */
#define PMU_CR11_SWLDORAMRM_Pos           (0UL)                     /*!< SWLDORAMRM (Bit 0)                                    */
#define PMU_CR11_SWLDORAMRM_Msk           (0xfUL)                   /*!< SWLDORAMRM (Bitfield-Mask: 0x0f)                      */
/* =========================================================  CR2A  ========================================================== */
#define PMU_CR2A_EIWUL_Pos                (15UL)                    /*!< EIWUL (Bit 15)                                        */
#define PMU_CR2A_EIWUL_Msk                (0x8000UL)                /*!< EIWUL (Bitfield-Mask: 0x01)                           */
#define PMU_CR2A_EWUP5_Pos                (4UL)                     /*!< EWUP5 (Bit 4)                                         */
#define PMU_CR2A_EWUP5_Msk                (0x10UL)                  /*!< EWUP5 (Bitfield-Mask: 0x01)                           */
#define PMU_CR2A_EWUP4_Pos                (3UL)                     /*!< EWUP4 (Bit 3)                                         */
#define PMU_CR2A_EWUP4_Msk                (0x8UL)                   /*!< EWUP4 (Bitfield-Mask: 0x01)                           */
#define PMU_CR2A_EWUP3_Pos                (2UL)                     /*!< EWUP3 (Bit 2)                                         */
#define PMU_CR2A_EWUP3_Msk                (0x4UL)                   /*!< EWUP3 (Bitfield-Mask: 0x01)                           */
#define PMU_CR2A_EWUP2_Pos                (1UL)                     /*!< EWUP2 (Bit 1)                                         */
#define PMU_CR2A_EWUP2_Msk                (0x2UL)                   /*!< EWUP2 (Bitfield-Mask: 0x01)                           */
#define PMU_CR2A_EWUP1_Pos                (0UL)                     /*!< EWUP1 (Bit 0)                                         */
#define PMU_CR2A_EWUP1_Msk                (0x1UL)                   /*!< EWUP1 (Bitfield-Mask: 0x01)                           */
/* =========================================================  CR2B  ========================================================== */
#define PMU_CR2B_WP5_Pos                  (4UL)                     /*!< WP5 (Bit 4)                                           */
#define PMU_CR2B_WP5_Msk                  (0x10UL)                  /*!< WP5 (Bitfield-Mask: 0x01)                             */
#define PMU_CR2B_WP4_Pos                  (3UL)                     /*!< WP4 (Bit 3)                                           */
#define PMU_CR2B_WP4_Msk                  (0x8UL)                   /*!< WP4 (Bitfield-Mask: 0x01)                             */
#define PMU_CR2B_WP3_Pos                  (2UL)                     /*!< WP3 (Bit 2)                                           */
#define PMU_CR2B_WP3_Msk                  (0x4UL)                   /*!< WP3 (Bitfield-Mask: 0x01)                             */
#define PMU_CR2B_WP2_Pos                  (1UL)                     /*!< WP2 (Bit 1)                                           */
#define PMU_CR2B_WP2_Msk                  (0x2UL)                   /*!< WP2 (Bitfield-Mask: 0x01)                             */
#define PMU_CR2B_WP1_Pos                  (0UL)                     /*!< WP1 (Bit 0)                                           */
#define PMU_CR2B_WP1_Msk                  (0x1UL)                   /*!< WP1 (Bitfield-Mask: 0x01)                             */
/* ==========================================================  SR1  ========================================================== */
#define PMU_SR1_WUFI_Pos                  (15UL)                    /*!< WUFI (Bit 15)                                         */
#define PMU_SR1_WUFI_Msk                  (0x8000UL)                /*!< WUFI (Bitfield-Mask: 0x01)                            */
#define PMU_SR1_SDF_Pos                   (10UL)                    /*!< SDF (Bit 10)                                          */
#define PMU_SR1_SDF_Msk                   (0x400UL)                 /*!< SDF (Bitfield-Mask: 0x01)                             */
#define PMU_SR1_SB2F_Pos                  (9UL)                     /*!< SB2F (Bit 9)                                          */
#define PMU_SR1_SB2F_Msk                  (0x200UL)                 /*!< SB2F (Bitfield-Mask: 0x01)                            */
#define PMU_SR1_SB1F_Pos                  (8UL)                     /*!< SB1F (Bit 8)                                          */
#define PMU_SR1_SB1F_Msk                  (0x100UL)                 /*!< SB1F (Bitfield-Mask: 0x01)                            */
#define PMU_SR1_WUF5_Pos                  (4UL)                     /*!< WUF5 (Bit 4)                                          */
#define PMU_SR1_WUF5_Msk                  (0x10UL)                  /*!< WUF5 (Bitfield-Mask: 0x01)                            */
#define PMU_SR1_WUF4_Pos                  (3UL)                     /*!< WUF4 (Bit 3)                                          */
#define PMU_SR1_WUF4_Msk                  (0x8UL)                   /*!< WUF4 (Bitfield-Mask: 0x01)                            */
#define PMU_SR1_WUF3_Pos                  (2UL)                     /*!< WUF3 (Bit 2)                                          */
#define PMU_SR1_WUF3_Msk                  (0x4UL)                   /*!< WUF3 (Bitfield-Mask: 0x01)                            */
#define PMU_SR1_WUF2_Pos                  (1UL)                     /*!< WUF2 (Bit 1)                                          */
#define PMU_SR1_WUF2_Msk                  (0x2UL)                   /*!< WUF2 (Bitfield-Mask: 0x01)                            */
#define PMU_SR1_WUF1_Pos                  (0UL)                     /*!< WUF1 (Bit 0)                                          */
#define PMU_SR1_WUF1_Msk                  (0x1UL)                   /*!< WUF1 (Bitfield-Mask: 0x01)                            */
/* =========================================================  CSR1  ========================================================== */
#define PMU_CSR1_CSBF_Pos                 (8UL)                     /*!< CSBF (Bit 8)                                          */
#define PMU_CSR1_CSBF_Msk                 (0x100UL)                 /*!< CSBF (Bitfield-Mask: 0x01)                            */
#define PMU_CSR1_CWUF5_Pos                (4UL)                     /*!< CWUF5 (Bit 4)                                         */
#define PMU_CSR1_CWUF5_Msk                (0x10UL)                  /*!< CWUF5 (Bitfield-Mask: 0x01)                           */
#define PMU_CSR1_CWUF4_Pos                (3UL)                     /*!< CWUF4 (Bit 3)                                         */
#define PMU_CSR1_CWUF4_Msk                (0x8UL)                   /*!< CWUF4 (Bitfield-Mask: 0x01)                           */
#define PMU_CSR1_CWUF3_Pos                (2UL)                     /*!< CWUF3 (Bit 2)                                         */
#define PMU_CSR1_CWUF3_Msk                (0x4UL)                   /*!< CWUF3 (Bitfield-Mask: 0x01)                           */
#define PMU_CSR1_CWUF2_Pos                (1UL)                     /*!< CWUF2 (Bit 1)                                         */
#define PMU_CSR1_CWUF2_Msk                (0x2UL)                   /*!< CWUF2 (Bitfield-Mask: 0x01)                           */
#define PMU_CSR1_CWUF1_Pos                (0UL)                     /*!< CWUF1 (Bit 0)                                         */
#define PMU_CSR1_CWUF1_Msk                (0x1UL)                   /*!< CWUF1 (Bitfield-Mask: 0x01)                           */
/* ==========================================================  SR2  ========================================================== */
#define PMU_SR2_SVSOUT1_Pos               (4UL)                     /*!< SVSOUT1 (Bit 4)                                       */
#define PMU_SR2_SVSOUT1_Msk               (0x10UL)                  /*!< SVSOUT1 (Bitfield-Mask: 0x01)                         */
#define PMU_SR2_SVSOUT0_Pos               (3UL)                     /*!< SVSOUT0 (Bit 3)                                       */
#define PMU_SR2_SVSOUT0_Msk               (0x8UL)                   /*!< SVSOUT0 (Bitfield-Mask: 0x01)                         */
#define PMU_SR2_LPF_Pos                   (2UL)                     /*!< LPF (Bit 2)                                           */
#define PMU_SR2_LPF_Msk                   (0x4UL)                   /*!< LPF (Bitfield-Mask: 0x01)                             */
#define PMU_SR2_FLASHRDY_Pos              (0UL)                     /*!< FLASHRDY (Bit 0)                                      */
#define PMU_SR2_FLASHRDY_Msk              (0x1UL)                   /*!< FLASHRDY (Bitfield-Mask: 0x01)                        */
/* =========================================================  CSR4  ========================================================== */
#define PMU_CSR4_IHSTRIM_Pos              (0UL)                     /*!< IHSTRIM (Bit 0)                                       */
#define PMU_CSR4_IHSTRIM_Msk              (0x3fffUL)                /*!< IHSTRIM (Bitfield-Mask: 0x3fff)                       */


/* =========================================================================================================================== */
/* ================                                           IWDG                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  CMD  ========================================================== */
#define IWDG_CMD_CMD_Pos                  (0UL)                     /*!< CMD (Bit 0)                                           */
#define IWDG_CMD_CMD_Msk                  (0xffffUL)                /*!< CMD (Bitfield-Mask: 0xffff)                           */
/* ==========================================================  PSC  ========================================================== */
#define IWDG_PSC_PSC_Pos                  (0UL)                     /*!< PSC (Bit 0)                                           */
#define IWDG_PSC_PSC_Msk                  (0x7UL)                   /*!< PSC (Bitfield-Mask: 0x07)                             */
/* ==========================================================  RLD  ========================================================== */
#define IWDG_RLD_RELOAD_Pos               (0UL)                     /*!< RELOAD (Bit 0)                                        */
#define IWDG_RLD_RELOAD_Msk               (0xfffUL)                 /*!< RELOAD (Bitfield-Mask: 0xfff)                         */
/* ==========================================================  STS  ========================================================== */
#define IWDG_STS_RLDTRGUPD_Pos            (4UL)                     /*!< RLDTRGUPD (Bit 4)                                     */
#define IWDG_STS_RLDTRGUPD_Msk            (0x10UL)                  /*!< RLDTRGUPD (Bitfield-Mask: 0x01)                       */
#define IWDG_STS_ENBUPD_Pos               (3UL)                     /*!< ENBUPD (Bit 3)                                        */
#define IWDG_STS_ENBUPD_Msk               (0x8UL)                   /*!< ENBUPD (Bitfield-Mask: 0x01)                          */
#define IWDG_STS_WINUPD_Pos               (2UL)                     /*!< WINUPD (Bit 2)                                        */
#define IWDG_STS_WINUPD_Msk               (0x4UL)                   /*!< WINUPD (Bitfield-Mask: 0x01)                          */
#define IWDG_STS_RLDUPD_Pos               (1UL)                     /*!< RLDUPD (Bit 1)                                        */
#define IWDG_STS_RLDUPD_Msk               (0x2UL)                   /*!< RLDUPD (Bitfield-Mask: 0x01)                          */
#define IWDG_STS_PSCUPD_Pos               (0UL)                     /*!< PSCUPD (Bit 0)                                        */
#define IWDG_STS_PSCUPD_Msk               (0x1UL)                   /*!< PSCUPD (Bitfield-Mask: 0x01)                          */
/* ==========================================================  WIN  ========================================================== */
#define IWDG_WIN_WIN_Pos                  (0UL)                     /*!< WIN (Bit 0)                                           */
#define IWDG_WIN_WIN_Msk                  (0xfffUL)                 /*!< WIN (Bitfield-Mask: 0xfff)                            */
/* ========================================================  CLKSEL  ========================================================= */
#define IWDG_CLKSEL_CLKSEL_Pos            (0UL)                     /*!< CLKSEL (Bit 0)                                        */
#define IWDG_CLKSEL_CLKSEL_Msk            (0x1UL)                   /*!< CLKSEL (Bitfield-Mask: 0x01)                          */


/* =========================================================================================================================== */
/* ================                                           WWDG                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  CTRL  ========================================================== */
#define WWDG_CTRL_RSTEN_Pos               (7UL)                     /*!< RSTEN (Bit 7)                                         */
#define WWDG_CTRL_RSTEN_Msk               (0x80UL)                  /*!< RSTEN (Bitfield-Mask: 0x01)                           */
#define WWDG_CTRL_WCNT_Pos                (0UL)                     /*!< WCNT (Bit 0)                                          */
#define WWDG_CTRL_WCNT_Msk                (0x7fUL)                  /*!< WCNT (Bitfield-Mask: 0x7f)                            */
/* ==========================================================  CFG  ========================================================== */
#define WWDG_CFG_PSC_Pos                  (11UL)                    /*!< PSC (Bit 11)                                          */
#define WWDG_CFG_PSC_Msk                  (0x3800UL)                /*!< PSC (Bitfield-Mask: 0x07)                             */
#define WWDG_CFG_EWIEN_Pos                (9UL)                     /*!< EWIEN (Bit 9)                                         */
#define WWDG_CFG_EWIEN_Msk                (0x200UL)                 /*!< EWIEN (Bitfield-Mask: 0x01)                           */
#define WWDG_CFG_WIN_Pos                  (0UL)                     /*!< WIN (Bit 0)                                           */
#define WWDG_CFG_WIN_Msk                  (0x7fUL)                  /*!< WIN (Bitfield-Mask: 0x7f)                             */
/* ==========================================================  STS  ========================================================== */
#define WWDG_STS_EWIRAW_Pos               (0UL)                     /*!< EWIRAW (Bit 0)                                        */
#define WWDG_STS_EWIRAW_Msk               (0x1UL)                   /*!< EWIRAW (Bitfield-Mask: 0x01)                          */


/* =========================================================================================================================== */
/* ================                                            DAC                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  CR  =========================================================== */
#define DAC_CR_CEN_Pos                    (14UL)                    /*!< CEN (Bit 14)                                          */
#define DAC_CR_CEN_Msk                    (0x4000UL)                /*!< CEN (Bitfield-Mask: 0x01)                             */
#define DAC_CR_DMAUDRIE_Pos               (13UL)                    /*!< DMAUDRIE (Bit 13)                                     */
#define DAC_CR_DMAUDRIE_Msk               (0x2000UL)                /*!< DMAUDRIE (Bitfield-Mask: 0x01)                        */
#define DAC_CR_DMAEN_Pos                  (12UL)                    /*!< DMAEN (Bit 12)                                        */
#define DAC_CR_DMAEN_Msk                  (0x1000UL)                /*!< DMAEN (Bitfield-Mask: 0x01)                           */
#define DAC_CR_MAMP_Pos                   (8UL)                     /*!< MAMP (Bit 8)                                          */
#define DAC_CR_MAMP_Msk                   (0xf00UL)                 /*!< MAMP (Bitfield-Mask: 0x0f)                            */
#define DAC_CR_WAVE_Pos                   (6UL)                     /*!< WAVE (Bit 6)                                          */
#define DAC_CR_WAVE_Msk                   (0xc0UL)                  /*!< WAVE (Bitfield-Mask: 0x03)                            */
#define DAC_CR_TSEL_Pos                   (2UL)                     /*!< TSEL (Bit 2)                                          */
#define DAC_CR_TSEL_Msk                   (0x3cUL)                  /*!< TSEL (Bitfield-Mask: 0x0f)                            */
#define DAC_CR_TEN_Pos                    (1UL)                     /*!< TEN (Bit 1)                                           */
#define DAC_CR_TEN_Msk                    (0x2UL)                   /*!< TEN (Bitfield-Mask: 0x01)                             */
#define DAC_CR_EN_Pos                     (0UL)                     /*!< EN (Bit 0)                                            */
#define DAC_CR_EN_Msk                     (0x1UL)                   /*!< EN (Bitfield-Mask: 0x01)                              */
/* ========================================================  SWTRGR  ========================================================= */
#define DAC_SWTRGR_SWTRIG_Pos             (0UL)                     /*!< SWTRIG (Bit 0)                                        */
#define DAC_SWTRGR_SWTRIG_Msk             (0x1UL)                   /*!< SWTRIG (Bitfield-Mask: 0x01)                          */
/* ========================================================  DHR12R  ========================================================= */
#define DAC_DHR12R_DACDHRB_Pos            (16UL)                    /*!< DACDHRB (Bit 16)                                      */
#define DAC_DHR12R_DACDHRB_Msk            (0xfff0000UL)             /*!< DACDHRB (Bitfield-Mask: 0xfff)                        */
#define DAC_DHR12R_DACDHR_Pos             (0UL)                     /*!< DACDHR (Bit 0)                                        */
#define DAC_DHR12R_DACDHR_Msk             (0xfffUL)                 /*!< DACDHR (Bitfield-Mask: 0xfff)                         */
/* ========================================================  DHR12L  ========================================================= */
#define DAC_DHR12L_DACDHRB_Pos            (20UL)                    /*!< DACDHRB (Bit 20)                                      */
#define DAC_DHR12L_DACDHRB_Msk            (0xfff00000UL)            /*!< DACDHRB (Bitfield-Mask: 0xfff)                        */
#define DAC_DHR12L_DACDHR_Pos             (4UL)                     /*!< DACDHR (Bit 4)                                        */
#define DAC_DHR12L_DACDHR_Msk             (0xfff0UL)                /*!< DACDHR (Bitfield-Mask: 0xfff)                         */
/* =========================================================  DHR8R  ========================================================= */
#define DAC_DHR8R_DACDHRB_Pos             (8UL)                     /*!< DACDHRB (Bit 8)                                       */
#define DAC_DHR8R_DACDHRB_Msk             (0xff00UL)                /*!< DACDHRB (Bitfield-Mask: 0xff)                         */
#define DAC_DHR8R_DACDHR_Pos              (0UL)                     /*!< DACDHR (Bit 0)                                        */
#define DAC_DHR8R_DACDHR_Msk              (0xffUL)                  /*!< DACDHR (Bitfield-Mask: 0xff)                          */
/* ==========================================================  DOR  ========================================================== */
#define DAC_DOR_DACDORB_Pos               (16UL)                    /*!< DACDORB (Bit 16)                                      */
#define DAC_DOR_DACDORB_Msk               (0xfff0000UL)             /*!< DACDORB (Bitfield-Mask: 0xfff)                        */
#define DAC_DOR_DACDOR_Pos                (0UL)                     /*!< DACDOR (Bit 0)                                        */
#define DAC_DOR_DACDOR_Msk                (0xfffUL)                 /*!< DACDOR (Bitfield-Mask: 0xfff)                         */
/* ==========================================================  SR  =========================================================== */
#define DAC_SR_CALFLAG_Pos                (14UL)                    /*!< CALFLAG (Bit 14)                                      */
#define DAC_SR_CALFLAG_Msk                (0x4000UL)                /*!< CALFLAG (Bitfield-Mask: 0x01)                         */
#define DAC_SR_DMAUDR_Pos                 (13UL)                    /*!< DMAUDR (Bit 13)                                       */
#define DAC_SR_DMAUDR_Msk                 (0x2000UL)                /*!< DMAUDR (Bitfield-Mask: 0x01)                          */
#define DAC_SR_DORSTATUS_Pos              (12UL)                    /*!< DORSTATUS (Bit 12)                                    */
#define DAC_SR_DORSTATUS_Msk              (0x1000UL)                /*!< DORSTATUS (Bitfield-Mask: 0x01)                       */
#define DAC_SR_FIFODEPTH_Pos              (9UL)                     /*!< FIFODEPTH (Bit 9)                                     */
#define DAC_SR_FIFODEPTH_Msk              (0xe00UL)                 /*!< FIFODEPTH (Bitfield-Mask: 0x07)                       */
#define DAC_SR_FIFOOVF_Pos                (8UL)                     /*!< FIFOOVF (Bit 8)                                       */
#define DAC_SR_FIFOOVF_Msk                (0x100UL)                 /*!< FIFOOVF (Bitfield-Mask: 0x01)                         */
#define DAC_SR_FIFOUDF_Pos                (7UL)                     /*!< FIFOUDF (Bit 7)                                       */
#define DAC_SR_FIFOUDF_Msk                (0x80UL)                  /*!< FIFOUDF (Bitfield-Mask: 0x01)                         */
#define DAC_SR_FIFOEMPTY_Pos              (6UL)                     /*!< FIFOEMPTY (Bit 6)                                     */
#define DAC_SR_FIFOEMPTY_Msk              (0x40UL)                  /*!< FIFOEMPTY (Bitfield-Mask: 0x01)                       */
#define DAC_SR_FIFOFULL_Pos               (5UL)                     /*!< FIFOFULL (Bit 5)                                      */
#define DAC_SR_FIFOFULL_Msk               (0x20UL)                  /*!< FIFOFULL (Bitfield-Mask: 0x01)                        */
/* ==========================================================  MCR  ========================================================== */
#define DAC_MCR_SINFORMAT_Pos             (9UL)                     /*!< SINFORMAT (Bit 9)                                     */
#define DAC_MCR_SINFORMAT_Msk             (0x200UL)                 /*!< SINFORMAT (Bitfield-Mask: 0x01)                       */
#define DAC_MCR_DMADOUBLE_Pos             (8UL)                     /*!< DMADOUBLE (Bit 8)                                     */
#define DAC_MCR_DMADOUBLE_Msk             (0x100UL)                 /*!< DMADOUBLE (Bitfield-Mask: 0x01)                       */
#define DAC_MCR_FIFOOVFIE_Pos             (7UL)                     /*!< FIFOOVFIE (Bit 7)                                     */
#define DAC_MCR_FIFOOVFIE_Msk             (0x80UL)                  /*!< FIFOOVFIE (Bitfield-Mask: 0x01)                       */
#define DAC_MCR_FIFOUDFIE_Pos             (6UL)                     /*!< FIFOUDFIE (Bit 6)                                     */
#define DAC_MCR_FIFOUDFIE_Msk             (0x40UL)                  /*!< FIFOUDFIE (Bitfield-Mask: 0x01)                       */
#define DAC_MCR_CHSEL_Pos                 (3UL)                     /*!< CHSEL (Bit 3)                                         */
#define DAC_MCR_CHSEL_Msk                 (0x8UL)                   /*!< CHSEL (Bitfield-Mask: 0x01)                           */
#define DAC_MCR_MODE_Pos                  (0UL)                     /*!< MODE (Bit 0)                                          */
#define DAC_MCR_MODE_Msk                  (0x3UL)                   /*!< MODE (Bitfield-Mask: 0x03)                            */
/* ==========================================================  CCR  ========================================================== */
#define DAC_CCR_OFFSET_Pos                (0UL)                     /*!< OFFSET (Bit 0)                                        */
#define DAC_CCR_OFFSET_Msk                (0x1fUL)                  /*!< OFFSET (Bitfield-Mask: 0x1f)                          */


/* =========================================================================================================================== */
/* ================                                          VREFBUF                                          ================ */
/* =========================================================================================================================== */

/* ==========================================================  CSR  ========================================================== */
#define VREFBUF_CSR_VROCPPD_Pos           (6UL)                     /*!< VROCPPD (Bit 6)                                       */
#define VREFBUF_CSR_VROCPPD_Msk           (0x40UL)                  /*!< VROCPPD (Bitfield-Mask: 0x01)                         */
#define VREFBUF_CSR_VRBYP_Pos             (5UL)                     /*!< VRBYP (Bit 5)                                         */
#define VREFBUF_CSR_VRBYP_Msk             (0x20UL)                  /*!< VRBYP (Bitfield-Mask: 0x01)                           */
#define VREFBUF_CSR_VRS_Pos               (3UL)                     /*!< VRS (Bit 3)                                           */
#define VREFBUF_CSR_VRS_Msk               (0x18UL)                  /*!< VRS (Bitfield-Mask: 0x03)                             */
#define VREFBUF_CSR_VRR_Pos               (2UL)                     /*!< VRR (Bit 2)                                           */
#define VREFBUF_CSR_VRR_Msk               (0x4UL)                   /*!< VRR (Bitfield-Mask: 0x01)                             */
#define VREFBUF_CSR_HIZ_Pos               (1UL)                     /*!< HIZ (Bit 1)                                           */
#define VREFBUF_CSR_HIZ_Msk               (0x2UL)                   /*!< HIZ (Bitfield-Mask: 0x01)                             */
#define VREFBUF_CSR_ENVR_Pos              (0UL)                     /*!< ENVR (Bit 0)                                          */
#define VREFBUF_CSR_ENVR_Msk              (0x1UL)                   /*!< ENVR (Bitfield-Mask: 0x01)                            */
/* ==========================================================  CCR  ========================================================== */
#define VREFBUF_CCR_TRIM_Pos              (0UL)                     /*!< TRIM (Bit 0)                                          */
#define VREFBUF_CCR_TRIM_Msk              (0x3fUL)                  /*!< TRIM (Bitfield-Mask: 0x3f)                            */


/* =========================================================================================================================== */
/* ================                                          SYSCFG                                           ================ */
/* =========================================================================================================================== */

/* ========================================================  MEMRMP  ========================================================= */
#define SYSCFG_MEMRMP_FBMODE_Pos          (8UL)                     /*!< FBMODE (Bit 8)                                        */
#define SYSCFG_MEMRMP_FBMODE_Msk          (0x100UL)                 /*!< FBMODE (Bitfield-Mask: 0x01)                          */
#define SYSCFG_MEMRMP_MEMMODE_Pos         (0UL)                     /*!< MEMMODE (Bit 0)                                       */
#define SYSCFG_MEMRMP_MEMMODE_Msk         (0x3UL)                   /*!< MEMMODE (Bitfield-Mask: 0x03)                         */
/* =========================================================  CFGR1  ========================================================= */
#define SYSCFG_CFGR1_FPUIE_Pos            (0UL)                     /*!< FPUIE (Bit 0)                                         */
#define SYSCFG_CFGR1_FPUIE_Msk            (0x3fUL)                  /*!< FPUIE (Bitfield-Mask: 0x3f)                           */
/* ========================================================  EXTICR1  ======================================================== */
#define SYSCFG_EXTICR1_EXTI3_Pos          (12UL)                    /*!< EXTI3 (Bit 12)                                        */
#define SYSCFG_EXTICR1_EXTI3_Msk          (0xf000UL)                /*!< EXTI3 (Bitfield-Mask: 0x0f)                           */
#define SYSCFG_EXTICR1_EXTI2_Pos          (8UL)                     /*!< EXTI2 (Bit 8)                                         */
#define SYSCFG_EXTICR1_EXTI2_Msk          (0xf00UL)                 /*!< EXTI2 (Bitfield-Mask: 0x0f)                           */
#define SYSCFG_EXTICR1_EXTI1_Pos          (4UL)                     /*!< EXTI1 (Bit 4)                                         */
#define SYSCFG_EXTICR1_EXTI1_Msk          (0xf0UL)                  /*!< EXTI1 (Bitfield-Mask: 0x0f)                           */
#define SYSCFG_EXTICR1_EXTI0_Pos          (0UL)                     /*!< EXTI0 (Bit 0)                                         */
#define SYSCFG_EXTICR1_EXTI0_Msk          (0xfUL)                   /*!< EXTI0 (Bitfield-Mask: 0x0f)                           */
/* ========================================================  EXTICR2  ======================================================== */
#define SYSCFG_EXTICR2_EXTI7_Pos          (12UL)                    /*!< EXTI7 (Bit 12)                                        */
#define SYSCFG_EXTICR2_EXTI7_Msk          (0xf000UL)                /*!< EXTI7 (Bitfield-Mask: 0x0f)                           */
#define SYSCFG_EXTICR2_EXTI6_Pos          (8UL)                     /*!< EXTI6 (Bit 8)                                         */
#define SYSCFG_EXTICR2_EXTI6_Msk          (0xf00UL)                 /*!< EXTI6 (Bitfield-Mask: 0x0f)                           */
#define SYSCFG_EXTICR2_EXTI5_Pos          (4UL)                     /*!< EXTI5 (Bit 4)                                         */
#define SYSCFG_EXTICR2_EXTI5_Msk          (0xf0UL)                  /*!< EXTI5 (Bitfield-Mask: 0x0f)                           */
#define SYSCFG_EXTICR2_EXTI4_Pos          (0UL)                     /*!< EXTI4 (Bit 0)                                         */
#define SYSCFG_EXTICR2_EXTI4_Msk          (0xfUL)                   /*!< EXTI4 (Bitfield-Mask: 0x0f)                           */
/* ========================================================  EXTICR3  ======================================================== */
#define SYSCFG_EXTICR3_EXTI11_Pos         (12UL)                    /*!< EXTI11 (Bit 12)                                       */
#define SYSCFG_EXTICR3_EXTI11_Msk         (0xf000UL)                /*!< EXTI11 (Bitfield-Mask: 0x0f)                          */
#define SYSCFG_EXTICR3_EXTI10_Pos         (8UL)                     /*!< EXTI10 (Bit 8)                                        */
#define SYSCFG_EXTICR3_EXTI10_Msk         (0xf00UL)                 /*!< EXTI10 (Bitfield-Mask: 0x0f)                          */
#define SYSCFG_EXTICR3_EXTI9_Pos          (4UL)                     /*!< EXTI9 (Bit 4)                                         */
#define SYSCFG_EXTICR3_EXTI9_Msk          (0xf0UL)                  /*!< EXTI9 (Bitfield-Mask: 0x0f)                           */
#define SYSCFG_EXTICR3_EXTI8_Pos          (0UL)                     /*!< EXTI8 (Bit 0)                                         */
#define SYSCFG_EXTICR3_EXTI8_Msk          (0xfUL)                   /*!< EXTI8 (Bitfield-Mask: 0x0f)                           */
/* ========================================================  EXTICR4  ======================================================== */
#define SYSCFG_EXTICR4_EXTI15_Pos         (12UL)                    /*!< EXTI15 (Bit 12)                                       */
#define SYSCFG_EXTICR4_EXTI15_Msk         (0xf000UL)                /*!< EXTI15 (Bitfield-Mask: 0x0f)                          */
#define SYSCFG_EXTICR4_EXTI14_Pos         (8UL)                     /*!< EXTI14 (Bit 8)                                        */
#define SYSCFG_EXTICR4_EXTI14_Msk         (0xf00UL)                 /*!< EXTI14 (Bitfield-Mask: 0x0f)                          */
#define SYSCFG_EXTICR4_EXTI13_Pos         (4UL)                     /*!< EXTI13 (Bit 4)                                        */
#define SYSCFG_EXTICR4_EXTI13_Msk         (0xf0UL)                  /*!< EXTI13 (Bitfield-Mask: 0x0f)                          */
#define SYSCFG_EXTICR4_EXTI12_Pos         (0UL)                     /*!< EXTI12 (Bit 0)                                        */
#define SYSCFG_EXTICR4_EXTI12_Msk         (0xfUL)                   /*!< EXTI12 (Bitfield-Mask: 0x0f)                          */
/* =======================================================  INSTCTRL  ======================================================== */
#define SYSCFG_INSTCTRL_CPUWAIT_Pos       (0UL)                     /*!< CPUWAIT (Bit 0)                                       */
#define SYSCFG_INSTCTRL_CPUWAIT_Msk       (0x1UL)                   /*!< CPUWAIT (Bitfield-Mask: 0x01)                         */
/* =======================================================  TRACECTRL  ======================================================= */
#define SYSCFG_TRACECTRL_DAPEN_Pos        (2UL)                     /*!< DAPEN (Bit 2)                                         */
#define SYSCFG_TRACECTRL_DAPEN_Msk        (0x4UL)                   /*!< DAPEN (Bitfield-Mask: 0x01)                           */
#define SYSCFG_TRACECTRL_SOFTSTCLKEN_Pos  (1UL)                     /*!< SOFTSTCLKEN (Bit 1)                                   */
#define SYSCFG_TRACECTRL_SOFTSTCLKEN_Msk  (0x2UL)                   /*!< SOFTSTCLKEN (Bitfield-Mask: 0x01)                     */
#define SYSCFG_TRACECTRL_SOFTTRACEEN_Pos  (0UL)                     /*!< SOFTTRACEEN (Bit 0)                                   */
#define SYSCFG_TRACECTRL_SOFTTRACEEN_Msk  (0x1UL)                   /*!< SOFTTRACEEN (Bitfield-Mask: 0x01)                     */
/* ==================================================  PINOVERTURNINGCTRL0  ================================================== */
#define SYSCFG_PINOVERTURNINGCTRL0_SELPOLARCMP0_Pos (8UL)           /*!< SELPOLARCMP0 (Bit 8)                                  */
#define SYSCFG_PINOVERTURNINGCTRL0_SELPOLARCMP0_Msk (0x100UL)       /*!< SELPOLARCMP0 (Bitfield-Mask: 0x01)                    */
#define SYSCFG_PINOVERTURNINGCTRL0_OVERTURNINGEN_Pos (7UL)          /*!< OVERTURNINGEN (Bit 7)                                 */
#define SYSCFG_PINOVERTURNINGCTRL0_OVERTURNINGEN_Msk (0x80UL)       /*!< OVERTURNINGEN (Bitfield-Mask: 0x01)                   */
#define SYSCFG_PINOVERTURNINGCTRL0_GPIOPINSEL_Pos (3UL)             /*!< GPIOPINSEL (Bit 3)                                    */
#define SYSCFG_PINOVERTURNINGCTRL0_GPIOPINSEL_Msk (0x78UL)          /*!< GPIOPINSEL (Bitfield-Mask: 0x0f)                      */
#define SYSCFG_PINOVERTURNINGCTRL0_GPIOSEL_Pos (0UL)                /*!< GPIOSEL (Bit 0)                                       */
#define SYSCFG_PINOVERTURNINGCTRL0_GPIOSEL_Msk (0x7UL)              /*!< GPIOSEL (Bitfield-Mask: 0x07)                         */
/* ==================================================  PINOVERTURNINGCTRL1  ================================================== */
#define SYSCFG_PINOVERTURNINGCTRL1_SELPOLARCMP1_Pos (8UL)           /*!< SELPOLARCMP1 (Bit 8)                                  */
#define SYSCFG_PINOVERTURNINGCTRL1_SELPOLARCMP1_Msk (0x100UL)       /*!< SELPOLARCMP1 (Bitfield-Mask: 0x01)                    */
#define SYSCFG_PINOVERTURNINGCTRL1_OVERTURNINGEN_Pos (7UL)          /*!< OVERTURNINGEN (Bit 7)                                 */
#define SYSCFG_PINOVERTURNINGCTRL1_OVERTURNINGEN_Msk (0x80UL)       /*!< OVERTURNINGEN (Bitfield-Mask: 0x01)                   */
#define SYSCFG_PINOVERTURNINGCTRL1_GPIOPINSEL_Pos (3UL)             /*!< GPIOPINSEL (Bit 3)                                    */
#define SYSCFG_PINOVERTURNINGCTRL1_GPIOPINSEL_Msk (0x78UL)          /*!< GPIOPINSEL (Bitfield-Mask: 0x0f)                      */
#define SYSCFG_PINOVERTURNINGCTRL1_GPIOSEL_Pos (0UL)                /*!< GPIOSEL (Bit 0)                                       */
#define SYSCFG_PINOVERTURNINGCTRL1_GPIOSEL_Msk (0x7UL)              /*!< GPIOSEL (Bitfield-Mask: 0x07)                         */
/* =========================================================  TCMEB  ========================================================= */
#define SYSCFG_TCMEB_DTCMEB_Pos           (1UL)                     /*!< DTCMEB (Bit 1)                                        */
#define SYSCFG_TCMEB_DTCMEB_Msk           (0x2UL)                   /*!< DTCMEB (Bitfield-Mask: 0x01)                          */
#define SYSCFG_TCMEB_ITCMEB_Pos           (0UL)                     /*!< ITCMEB (Bit 0)                                        */
#define SYSCFG_TCMEB_ITCMEB_Msk           (0x1UL)                   /*!< ITCMEB (Bitfield-Mask: 0x01)                          */
/* ======================================================  CANCNTCTRL  ======================================================= */
#define SYSCFG_CANCNTCTRL_CNTSET0_Pos     (1UL)                     /*!< CNTSET0 (Bit 1)                                       */
#define SYSCFG_CANCNTCTRL_CNTSET0_Msk     (0x2UL)                   /*!< CNTSET0 (Bitfield-Mask: 0x01)                         */
#define SYSCFG_CANCNTCTRL_CNTEN_Pos       (0UL)                     /*!< CNTEN (Bit 0)                                         */
#define SYSCFG_CANCNTCTRL_CNTEN_Msk       (0x1UL)                   /*!< CNTEN (Bitfield-Mask: 0x01)                           */
/* =======================================================  OPENINFO0  ======================================================= */
#define SYSCFG_OPENINFO0_DEVICEID_Pos     (0UL)                     /*!< DEVICEID (Bit 0)                                      */
#define SYSCFG_OPENINFO0_DEVICEID_Msk     (0xffffffffUL)            /*!< DEVICEID (Bitfield-Mask: 0xffffffff)                  */
/* =======================================================  OPENINFO1  ======================================================= */
#define SYSCFG_OPENINFO1_HWREVISION_Pos   (16UL)                    /*!< HWREVISION (Bit 16)                                   */
#define SYSCFG_OPENINFO1_HWREVISION_Msk   (0xffff0000UL)            /*!< HWREVISION (Bitfield-Mask: 0xffff)                    */
#define SYSCFG_OPENINFO1_FWREVISION_Pos   (0UL)                     /*!< FWREVISION (Bit 0)                                    */
#define SYSCFG_OPENINFO1_FWREVISION_Msk   (0xffffUL)                /*!< FWREVISION (Bitfield-Mask: 0xffff)                    */
/* =======================================================  OPENINFO2  ======================================================= */
#define SYSCFG_OPENINFO2_DIEYPOS_Pos      (16UL)                    /*!< DIEYPOS (Bit 16)                                      */
#define SYSCFG_OPENINFO2_DIEYPOS_Msk      (0xffff0000UL)            /*!< DIEYPOS (Bitfield-Mask: 0xffff)                       */
#define SYSCFG_OPENINFO2_DIEXPOS_Pos      (0UL)                     /*!< DIEXPOS (Bit 0)                                       */
#define SYSCFG_OPENINFO2_DIEXPOS_Msk      (0xffffUL)                /*!< DIEXPOS (Bitfield-Mask: 0xffff)                       */
/* =======================================================  OPENINFO3  ======================================================= */
#define SYSCFG_OPENINFO3_LOTWAFERID_Pos   (0UL)                     /*!< LOTWAFERID (Bit 0)                                    */
#define SYSCFG_OPENINFO3_LOTWAFERID_Msk   (0xffffffffUL)            /*!< LOTWAFERID (Bitfield-Mask: 0xffffffff)                */


/* =========================================================================================================================== */
/* ================                                           CMP                                             ================ */
/* =========================================================================================================================== */

/* ==========================================================  CSR  ========================================================== */
#define CMP_CSR_LOCK_Pos                 (31UL)                    /*!< LOCK (Bit 31)                                         */
#define CMP_CSR_LOCK_Msk                 (0x80000000UL)            /*!< LOCK (Bitfield-Mask: 0x01)                            */
#define CMP_CSR_VALUE_Pos                (30UL)                    /*!< VALUE (Bit 30)                                        */
#define CMP_CSR_VALUE_Msk                (0x40000000UL)            /*!< VALUE (Bitfield-Mask: 0x01)                           */
#define CMP_CSR_DAC6BDATAIN_Pos          (21UL)                    /*!< DAC6BDATAIN (Bit 21)                                  */
#define CMP_CSR_DAC6BDATAIN_Msk          (0x7e00000UL)             /*!< DAC6BDATAIN (Bitfield-Mask: 0x3f)                     */
#define CMP_CSR_DAC6BEN_Pos              (20UL)                    /*!< DAC6BEN (Bit 20)                                      */
#define CMP_CSR_DAC6BEN_Msk              (0x100000UL)              /*!< DAC6BEN (Bitfield-Mask: 0x01)                         */
#define CMP_CSR_BLANKSEL_Pos             (17UL)                    /*!< BLANKSEL (Bit 17)                                     */
#define CMP_CSR_BLANKSEL_Msk             (0xe0000UL)               /*!< BLANKSEL (Bitfield-Mask: 0x07)                        */
#define CMP_CSR_BLANKINGEN_Pos           (16UL)                    /*!< BLANKINGEN (Bit 16)                                   */
#define CMP_CSR_BLANKINGEN_Msk           (0x10000UL)               /*!< BLANKINGEN (Bitfield-Mask: 0x01)                      */
#define CMP_CSR_HYST_Pos                 (13UL)                    /*!< HYST (Bit 13)                                         */
#define CMP_CSR_HYST_Msk                 (0xe000UL)                /*!< HYST (Bitfield-Mask: 0x07)                            */
#define CMP_CSR_POL_Pos                  (12UL)                    /*!< POL (Bit 12)                                          */
#define CMP_CSR_POL_Msk                  (0x1000UL)                /*!< POL (Bitfield-Mask: 0x01)                             */
#define CMP_CSR_INPSEL_Pos               (8UL)                     /*!< INPSEL (Bit 8)                                        */
#define CMP_CSR_INPSEL_Msk               (0x700UL)                 /*!< INPSEL (Bitfield-Mask: 0x07)                          */
#define CMP_CSR_INNSEL_Pos               (4UL)                     /*!< INNSEL (Bit 4)                                        */
#define CMP_CSR_INNSEL_Msk               (0x70UL)                  /*!< INNSEL (Bitfield-Mask: 0x07)                          */
#define CMP_CSR_CMPEN_Pos                (0UL)                     /*!< CMPEN (Bit 0)                                         */
#define CMP_CSR_CMPEN_Msk                (0x1UL)                   /*!< CMPEN (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                            OA                                             ================ */
/* =========================================================================================================================== */

/* ==========================================================  CSR  ========================================================== */
#define OA_CSR_LOCK_Pos                  (31UL)                    /*!< LOCK (Bit 31)                                         */
#define OA_CSR_LOCK_Msk                  (0x80000000UL)            /*!< LOCK (Bitfield-Mask: 0x01)                            */
#define OA_CSR_CALOUT_Pos                (30UL)                    /*!< CALOUT (Bit 30)                                       */
#define OA_CSR_CALOUT_Msk                (0x40000000UL)            /*!< CALOUT (Bitfield-Mask: 0x01)                          */
#define OA_CSR_MODESELERR_Pos            (29UL)                    /*!< MODESELERR (Bit 29)                                   */
#define OA_CSR_MODESELERR_Msk            (0x20000000UL)            /*!< MODESELERR (Bitfield-Mask: 0x01)                      */
#define OA_CSR_GPMODEERR_Pos             (28UL)                    /*!< GPMODEERR (Bit 28)                                    */
#define OA_CSR_GPMODEERR_Msk             (0x10000000UL)            /*!< GPMODEERR (Bitfield-Mask: 0x01)                       */
#define OA_CSR_INNSELERR_Pos             (27UL)                    /*!< INNSELERR (Bit 27)                                    */
#define OA_CSR_INNSELERR_Msk             (0x8000000UL)             /*!< INNSELERR (Bitfield-Mask: 0x01)                       */
#define OA_CSR_INPSELERR_Pos             (26UL)                    /*!< INPSELERR (Bit 26)                                    */
#define OA_CSR_INPSELERR_Msk             (0x4000000UL)             /*!< INPSELERR (Bitfield-Mask: 0x01)                       */
#define OA_CSR_OSPSET_Pos                (21UL)                    /*!< OSPSET (Bit 21)                                       */
#define OA_CSR_OSPSET_Msk                (0x3e00000UL)             /*!< OSPSET (Bitfield-Mask: 0x1f)                          */
#define OA_CSR_OSNSET_Pos                (16UL)                    /*!< OSNSET (Bit 16)                                       */
#define OA_CSR_OSNSET_Msk                (0x1f0000UL)              /*!< OSNSET (Bitfield-Mask: 0x1f)                          */
#define OA_CSR_OUTSEL_Pos                (15UL)                    /*!< OUTSEL (Bit 15)                                       */
#define OA_CSR_OUTSEL_Msk                (0x8000UL)                /*!< OUTSEL (Bitfield-Mask: 0x01)                          */
#define OA_CSR_GAIN_Pos                  (12UL)                    /*!< GAIN (Bit 12)                                         */
#define OA_CSR_GAIN_Msk                  (0x7000UL)                /*!< GAIN (Bitfield-Mask: 0x07)                            */
#define OA_CSR_INNSEL_Pos                (10UL)                    /*!< INNSEL (Bit 10)                                       */
#define OA_CSR_INNSEL_Msk                (0xc00UL)                 /*!< INNSEL (Bitfield-Mask: 0x03)                          */
#define OA_CSR_INPSEL_Pos                (8UL)                     /*!< INPSEL (Bit 8)                                        */
#define OA_CSR_INPSEL_Msk                (0x300UL)                 /*!< INPSEL (Bitfield-Mask: 0x03)                          */
#define OA_CSR_MODE_Pos                  (6UL)                     /*!< MODE (Bit 6)                                          */
#define OA_CSR_MODE_Msk                  (0xc0UL)                  /*!< MODE (Bitfield-Mask: 0x03)                            */
#define OA_CSR_CALSEL_Pos                (4UL)                     /*!< CALSEL (Bit 4)                                        */
#define OA_CSR_CALSEL_Msk                (0x30UL)                  /*!< CALSEL (Bitfield-Mask: 0x03)                          */
#define OA_CSR_USERTRIM_Pos              (2UL)                     /*!< USERTRIM (Bit 2)                                      */
#define OA_CSR_USERTRIM_Msk              (0x4UL)                   /*!< USERTRIM (Bitfield-Mask: 0x01)                        */
#define OA_CSR_CALON_Pos                 (1UL)                     /*!< CALON (Bit 1)                                         */
#define OA_CSR_CALON_Msk                 (0x2UL)                   /*!< CALON (Bitfield-Mask: 0x01)                           */
#define OA_CSR_OAEN_Pos                  (0UL)                     /*!< OAEN (Bit 0)                                          */
#define OA_CSR_OAEN_Msk                  (0x1UL)                   /*!< OAEN (Bitfield-Mask: 0x01)                            */


/* =========================================================================================================================== */
/* ================                                           EXTI                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  IMR1  ========================================================== */
#define EXTI_IMR1_IM31_Pos                (31UL)                    /*!< IM31 (Bit 31)                                         */
#define EXTI_IMR1_IM31_Msk                (0x80000000UL)            /*!< IM31 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM30_Pos                (30UL)                    /*!< IM30 (Bit 30)                                         */
#define EXTI_IMR1_IM30_Msk                (0x40000000UL)            /*!< IM30 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM29_Pos                (29UL)                    /*!< IM29 (Bit 29)                                         */
#define EXTI_IMR1_IM29_Msk                (0x20000000UL)            /*!< IM29 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM28_Pos                (28UL)                    /*!< IM28 (Bit 28)                                         */
#define EXTI_IMR1_IM28_Msk                (0x10000000UL)            /*!< IM28 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM27_Pos                (27UL)                    /*!< IM27 (Bit 27)                                         */
#define EXTI_IMR1_IM27_Msk                (0x8000000UL)             /*!< IM27 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM26_Pos                (26UL)                    /*!< IM26 (Bit 26)                                         */
#define EXTI_IMR1_IM26_Msk                (0x4000000UL)             /*!< IM26 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM25_Pos                (25UL)                    /*!< IM25 (Bit 25)                                         */
#define EXTI_IMR1_IM25_Msk                (0x2000000UL)             /*!< IM25 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM24_Pos                (24UL)                    /*!< IM24 (Bit 24)                                         */
#define EXTI_IMR1_IM24_Msk                (0x1000000UL)             /*!< IM24 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM23_Pos                (23UL)                    /*!< IM23 (Bit 23)                                         */
#define EXTI_IMR1_IM23_Msk                (0x800000UL)              /*!< IM23 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM22_Pos                (22UL)                    /*!< IM22 (Bit 22)                                         */
#define EXTI_IMR1_IM22_Msk                (0x400000UL)              /*!< IM22 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM21_Pos                (21UL)                    /*!< IM21 (Bit 21)                                         */
#define EXTI_IMR1_IM21_Msk                (0x200000UL)              /*!< IM21 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM20_Pos                (20UL)                    /*!< IM20 (Bit 20)                                         */
#define EXTI_IMR1_IM20_Msk                (0x100000UL)              /*!< IM20 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM19_Pos                (19UL)                    /*!< IM19 (Bit 19)                                         */
#define EXTI_IMR1_IM19_Msk                (0x80000UL)               /*!< IM19 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM18_Pos                (18UL)                    /*!< IM18 (Bit 18)                                         */
#define EXTI_IMR1_IM18_Msk                (0x40000UL)               /*!< IM18 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM17_Pos                (17UL)                    /*!< IM17 (Bit 17)                                         */
#define EXTI_IMR1_IM17_Msk                (0x20000UL)               /*!< IM17 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM16_Pos                (16UL)                    /*!< IM16 (Bit 16)                                         */
#define EXTI_IMR1_IM16_Msk                (0x10000UL)               /*!< IM16 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM15_Pos                (15UL)                    /*!< IM15 (Bit 15)                                         */
#define EXTI_IMR1_IM15_Msk                (0x8000UL)                /*!< IM15 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM14_Pos                (14UL)                    /*!< IM14 (Bit 14)                                         */
#define EXTI_IMR1_IM14_Msk                (0x4000UL)                /*!< IM14 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM13_Pos                (13UL)                    /*!< IM13 (Bit 13)                                         */
#define EXTI_IMR1_IM13_Msk                (0x2000UL)                /*!< IM13 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM12_Pos                (12UL)                    /*!< IM12 (Bit 12)                                         */
#define EXTI_IMR1_IM12_Msk                (0x1000UL)                /*!< IM12 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM11_Pos                (11UL)                    /*!< IM11 (Bit 11)                                         */
#define EXTI_IMR1_IM11_Msk                (0x800UL)                 /*!< IM11 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM10_Pos                (10UL)                    /*!< IM10 (Bit 10)                                         */
#define EXTI_IMR1_IM10_Msk                (0x400UL)                 /*!< IM10 (Bitfield-Mask: 0x01)                            */
#define EXTI_IMR1_IM9_Pos                 (9UL)                     /*!< IM9 (Bit 9)                                           */
#define EXTI_IMR1_IM9_Msk                 (0x200UL)                 /*!< IM9 (Bitfield-Mask: 0x01)                             */
#define EXTI_IMR1_IM8_Pos                 (8UL)                     /*!< IM8 (Bit 8)                                           */
#define EXTI_IMR1_IM8_Msk                 (0x100UL)                 /*!< IM8 (Bitfield-Mask: 0x01)                             */
#define EXTI_IMR1_IM7_Pos                 (7UL)                     /*!< IM7 (Bit 7)                                           */
#define EXTI_IMR1_IM7_Msk                 (0x80UL)                  /*!< IM7 (Bitfield-Mask: 0x01)                             */
#define EXTI_IMR1_IM6_Pos                 (6UL)                     /*!< IM6 (Bit 6)                                           */
#define EXTI_IMR1_IM6_Msk                 (0x40UL)                  /*!< IM6 (Bitfield-Mask: 0x01)                             */
#define EXTI_IMR1_IM5_Pos                 (5UL)                     /*!< IM5 (Bit 5)                                           */
#define EXTI_IMR1_IM5_Msk                 (0x20UL)                  /*!< IM5 (Bitfield-Mask: 0x01)                             */
#define EXTI_IMR1_IM4_Pos                 (4UL)                     /*!< IM4 (Bit 4)                                           */
#define EXTI_IMR1_IM4_Msk                 (0x10UL)                  /*!< IM4 (Bitfield-Mask: 0x01)                             */
#define EXTI_IMR1_IM3_Pos                 (3UL)                     /*!< IM3 (Bit 3)                                           */
#define EXTI_IMR1_IM3_Msk                 (0x8UL)                   /*!< IM3 (Bitfield-Mask: 0x01)                             */
#define EXTI_IMR1_IM2_Pos                 (2UL)                     /*!< IM2 (Bit 2)                                           */
#define EXTI_IMR1_IM2_Msk                 (0x4UL)                   /*!< IM2 (Bitfield-Mask: 0x01)                             */
#define EXTI_IMR1_IM1_Pos                 (1UL)                     /*!< IM1 (Bit 1)                                           */
#define EXTI_IMR1_IM1_Msk                 (0x2UL)                   /*!< IM1 (Bitfield-Mask: 0x01)                             */
#define EXTI_IMR1_IM0_Pos                 (0UL)                     /*!< IM0 (Bit 0)                                           */
#define EXTI_IMR1_IM0_Msk                 (0x1UL)                   /*!< IM0 (Bitfield-Mask: 0x01)                             */
/* =========================================================  EMR1  ========================================================== */
#define EXTI_EMR1_EM31_Pos                (31UL)                    /*!< EM31 (Bit 31)                                         */
#define EXTI_EMR1_EM31_Msk                (0x80000000UL)            /*!< EM31 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM30_Pos                (30UL)                    /*!< EM30 (Bit 30)                                         */
#define EXTI_EMR1_EM30_Msk                (0x40000000UL)            /*!< EM30 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM29_Pos                (29UL)                    /*!< EM29 (Bit 29)                                         */
#define EXTI_EMR1_EM29_Msk                (0x20000000UL)            /*!< EM29 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM28_Pos                (28UL)                    /*!< EM28 (Bit 28)                                         */
#define EXTI_EMR1_EM28_Msk                (0x10000000UL)            /*!< EM28 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM27_Pos                (27UL)                    /*!< EM27 (Bit 27)                                         */
#define EXTI_EMR1_EM27_Msk                (0x8000000UL)             /*!< EM27 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM26_Pos                (26UL)                    /*!< EM26 (Bit 26)                                         */
#define EXTI_EMR1_EM26_Msk                (0x4000000UL)             /*!< EM26 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM25_Pos                (25UL)                    /*!< EM25 (Bit 25)                                         */
#define EXTI_EMR1_EM25_Msk                (0x2000000UL)             /*!< EM25 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM24_Pos                (24UL)                    /*!< EM24 (Bit 24)                                         */
#define EXTI_EMR1_EM24_Msk                (0x1000000UL)             /*!< EM24 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM23_Pos                (23UL)                    /*!< EM23 (Bit 23)                                         */
#define EXTI_EMR1_EM23_Msk                (0x800000UL)              /*!< EM23 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM22_Pos                (22UL)                    /*!< EM22 (Bit 22)                                         */
#define EXTI_EMR1_EM22_Msk                (0x400000UL)              /*!< EM22 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM21_Pos                (21UL)                    /*!< EM21 (Bit 21)                                         */
#define EXTI_EMR1_EM21_Msk                (0x200000UL)              /*!< EM21 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM20_Pos                (20UL)                    /*!< EM20 (Bit 20)                                         */
#define EXTI_EMR1_EM20_Msk                (0x100000UL)              /*!< EM20 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM19_Pos                (19UL)                    /*!< EM19 (Bit 19)                                         */
#define EXTI_EMR1_EM19_Msk                (0x80000UL)               /*!< EM19 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM18_Pos                (18UL)                    /*!< EM18 (Bit 18)                                         */
#define EXTI_EMR1_EM18_Msk                (0x40000UL)               /*!< EM18 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM17_Pos                (17UL)                    /*!< EM17 (Bit 17)                                         */
#define EXTI_EMR1_EM17_Msk                (0x20000UL)               /*!< EM17 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM16_Pos                (16UL)                    /*!< EM16 (Bit 16)                                         */
#define EXTI_EMR1_EM16_Msk                (0x10000UL)               /*!< EM16 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM15_Pos                (15UL)                    /*!< EM15 (Bit 15)                                         */
#define EXTI_EMR1_EM15_Msk                (0x8000UL)                /*!< EM15 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM14_Pos                (14UL)                    /*!< EM14 (Bit 14)                                         */
#define EXTI_EMR1_EM14_Msk                (0x4000UL)                /*!< EM14 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM13_Pos                (13UL)                    /*!< EM13 (Bit 13)                                         */
#define EXTI_EMR1_EM13_Msk                (0x2000UL)                /*!< EM13 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM12_Pos                (12UL)                    /*!< EM12 (Bit 12)                                         */
#define EXTI_EMR1_EM12_Msk                (0x1000UL)                /*!< EM12 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM11_Pos                (11UL)                    /*!< EM11 (Bit 11)                                         */
#define EXTI_EMR1_EM11_Msk                (0x800UL)                 /*!< EM11 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM10_Pos                (10UL)                    /*!< EM10 (Bit 10)                                         */
#define EXTI_EMR1_EM10_Msk                (0x400UL)                 /*!< EM10 (Bitfield-Mask: 0x01)                            */
#define EXTI_EMR1_EM9_Pos                 (9UL)                     /*!< EM9 (Bit 9)                                           */
#define EXTI_EMR1_EM9_Msk                 (0x200UL)                 /*!< EM9 (Bitfield-Mask: 0x01)                             */
#define EXTI_EMR1_EM8_Pos                 (8UL)                     /*!< EM8 (Bit 8)                                           */
#define EXTI_EMR1_EM8_Msk                 (0x100UL)                 /*!< EM8 (Bitfield-Mask: 0x01)                             */
#define EXTI_EMR1_EM7_Pos                 (7UL)                     /*!< EM7 (Bit 7)                                           */
#define EXTI_EMR1_EM7_Msk                 (0x80UL)                  /*!< EM7 (Bitfield-Mask: 0x01)                             */
#define EXTI_EMR1_EM6_Pos                 (6UL)                     /*!< EM6 (Bit 6)                                           */
#define EXTI_EMR1_EM6_Msk                 (0x40UL)                  /*!< EM6 (Bitfield-Mask: 0x01)                             */
#define EXTI_EMR1_EM5_Pos                 (5UL)                     /*!< EM5 (Bit 5)                                           */
#define EXTI_EMR1_EM5_Msk                 (0x20UL)                  /*!< EM5 (Bitfield-Mask: 0x01)                             */
#define EXTI_EMR1_EM4_Pos                 (4UL)                     /*!< EM4 (Bit 4)                                           */
#define EXTI_EMR1_EM4_Msk                 (0x10UL)                  /*!< EM4 (Bitfield-Mask: 0x01)                             */
#define EXTI_EMR1_EM3_Pos                 (3UL)                     /*!< EM3 (Bit 3)                                           */
#define EXTI_EMR1_EM3_Msk                 (0x8UL)                   /*!< EM3 (Bitfield-Mask: 0x01)                             */
#define EXTI_EMR1_EM2_Pos                 (2UL)                     /*!< EM2 (Bit 2)                                           */
#define EXTI_EMR1_EM2_Msk                 (0x4UL)                   /*!< EM2 (Bitfield-Mask: 0x01)                             */
#define EXTI_EMR1_EM1_Pos                 (1UL)                     /*!< EM1 (Bit 1)                                           */
#define EXTI_EMR1_EM1_Msk                 (0x2UL)                   /*!< EM1 (Bitfield-Mask: 0x01)                             */
#define EXTI_EMR1_EM0_Pos                 (0UL)                     /*!< EM0 (Bit 0)                                           */
#define EXTI_EMR1_EM0_Msk                 (0x1UL)                   /*!< EM0 (Bitfield-Mask: 0x01)                             */
/* =========================================================  RTSR1  ========================================================= */
#define EXTI_RTSR1_RT31_Pos               (31UL)                    /*!< RT31 (Bit 31)                                         */
#define EXTI_RTSR1_RT31_Msk               (0x80000000UL)            /*!< RT31 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT21_Pos               (21UL)                    /*!< RT21 (Bit 21)                                         */
#define EXTI_RTSR1_RT21_Msk               (0x200000UL)              /*!< RT21 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT20_Pos               (20UL)                    /*!< RT20 (Bit 20)                                         */
#define EXTI_RTSR1_RT20_Msk               (0x100000UL)              /*!< RT20 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT19_Pos               (19UL)                    /*!< RT19 (Bit 19)                                         */
#define EXTI_RTSR1_RT19_Msk               (0x80000UL)               /*!< RT19 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT18_Pos               (18UL)                    /*!< RT18 (Bit 18)                                         */
#define EXTI_RTSR1_RT18_Msk               (0x40000UL)               /*!< RT18 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT17_Pos               (17UL)                    /*!< RT17 (Bit 17)                                         */
#define EXTI_RTSR1_RT17_Msk               (0x20000UL)               /*!< RT17 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT16_Pos               (16UL)                    /*!< RT16 (Bit 16)                                         */
#define EXTI_RTSR1_RT16_Msk               (0x10000UL)               /*!< RT16 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT15_Pos               (15UL)                    /*!< RT15 (Bit 15)                                         */
#define EXTI_RTSR1_RT15_Msk               (0x8000UL)                /*!< RT15 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT14_Pos               (14UL)                    /*!< RT14 (Bit 14)                                         */
#define EXTI_RTSR1_RT14_Msk               (0x4000UL)                /*!< RT14 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT13_Pos               (13UL)                    /*!< RT13 (Bit 13)                                         */
#define EXTI_RTSR1_RT13_Msk               (0x2000UL)                /*!< RT13 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT12_Pos               (12UL)                    /*!< RT12 (Bit 12)                                         */
#define EXTI_RTSR1_RT12_Msk               (0x1000UL)                /*!< RT12 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT11_Pos               (11UL)                    /*!< RT11 (Bit 11)                                         */
#define EXTI_RTSR1_RT11_Msk               (0x800UL)                 /*!< RT11 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT10_Pos               (10UL)                    /*!< RT10 (Bit 10)                                         */
#define EXTI_RTSR1_RT10_Msk               (0x400UL)                 /*!< RT10 (Bitfield-Mask: 0x01)                            */
#define EXTI_RTSR1_RT9_Pos                (9UL)                     /*!< RT9 (Bit 9)                                           */
#define EXTI_RTSR1_RT9_Msk                (0x200UL)                 /*!< RT9 (Bitfield-Mask: 0x01)                             */
#define EXTI_RTSR1_RT8_Pos                (8UL)                     /*!< RT8 (Bit 8)                                           */
#define EXTI_RTSR1_RT8_Msk                (0x100UL)                 /*!< RT8 (Bitfield-Mask: 0x01)                             */
#define EXTI_RTSR1_RT7_Pos                (7UL)                     /*!< RT7 (Bit 7)                                           */
#define EXTI_RTSR1_RT7_Msk                (0x80UL)                  /*!< RT7 (Bitfield-Mask: 0x01)                             */
#define EXTI_RTSR1_RT6_Pos                (6UL)                     /*!< RT6 (Bit 6)                                           */
#define EXTI_RTSR1_RT6_Msk                (0x40UL)                  /*!< RT6 (Bitfield-Mask: 0x01)                             */
#define EXTI_RTSR1_RT5_Pos                (5UL)                     /*!< RT5 (Bit 5)                                           */
#define EXTI_RTSR1_RT5_Msk                (0x20UL)                  /*!< RT5 (Bitfield-Mask: 0x01)                             */
#define EXTI_RTSR1_RT4_Pos                (4UL)                     /*!< RT4 (Bit 4)                                           */
#define EXTI_RTSR1_RT4_Msk                (0x10UL)                  /*!< RT4 (Bitfield-Mask: 0x01)                             */
#define EXTI_RTSR1_RT3_Pos                (3UL)                     /*!< RT3 (Bit 3)                                           */
#define EXTI_RTSR1_RT3_Msk                (0x8UL)                   /*!< RT3 (Bitfield-Mask: 0x01)                             */
#define EXTI_RTSR1_RT2_Pos                (2UL)                     /*!< RT2 (Bit 2)                                           */
#define EXTI_RTSR1_RT2_Msk                (0x4UL)                   /*!< RT2 (Bitfield-Mask: 0x01)                             */
#define EXTI_RTSR1_RT1_Pos                (1UL)                     /*!< RT1 (Bit 1)                                           */
#define EXTI_RTSR1_RT1_Msk                (0x2UL)                   /*!< RT1 (Bitfield-Mask: 0x01)                             */
#define EXTI_RTSR1_RT0_Pos                (0UL)                     /*!< RT0 (Bit 0)                                           */
#define EXTI_RTSR1_RT0_Msk                (0x1UL)                   /*!< RT0 (Bitfield-Mask: 0x01)                             */
/* =========================================================  FTSR1  ========================================================= */
#define EXTI_FTSR1_FT31_Pos               (31UL)                    /*!< FT31 (Bit 31)                                         */
#define EXTI_FTSR1_FT31_Msk               (0x80000000UL)            /*!< FT31 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT21_Pos               (21UL)                    /*!< FT21 (Bit 21)                                         */
#define EXTI_FTSR1_FT21_Msk               (0x200000UL)              /*!< FT21 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT20_Pos               (20UL)                    /*!< FT20 (Bit 20)                                         */
#define EXTI_FTSR1_FT20_Msk               (0x100000UL)              /*!< FT20 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT19_Pos               (19UL)                    /*!< FT19 (Bit 19)                                         */
#define EXTI_FTSR1_FT19_Msk               (0x80000UL)               /*!< FT19 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT18_Pos               (18UL)                    /*!< FT18 (Bit 18)                                         */
#define EXTI_FTSR1_FT18_Msk               (0x40000UL)               /*!< FT18 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT17_Pos               (17UL)                    /*!< FT17 (Bit 17)                                         */
#define EXTI_FTSR1_FT17_Msk               (0x20000UL)               /*!< FT17 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT16_Pos               (16UL)                    /*!< FT16 (Bit 16)                                         */
#define EXTI_FTSR1_FT16_Msk               (0x10000UL)               /*!< FT16 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT15_Pos               (15UL)                    /*!< FT15 (Bit 15)                                         */
#define EXTI_FTSR1_FT15_Msk               (0x8000UL)                /*!< FT15 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT14_Pos               (14UL)                    /*!< FT14 (Bit 14)                                         */
#define EXTI_FTSR1_FT14_Msk               (0x4000UL)                /*!< FT14 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT13_Pos               (13UL)                    /*!< FT13 (Bit 13)                                         */
#define EXTI_FTSR1_FT13_Msk               (0x2000UL)                /*!< FT13 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT12_Pos               (12UL)                    /*!< FT12 (Bit 12)                                         */
#define EXTI_FTSR1_FT12_Msk               (0x1000UL)                /*!< FT12 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT11_Pos               (11UL)                    /*!< FT11 (Bit 11)                                         */
#define EXTI_FTSR1_FT11_Msk               (0x800UL)                 /*!< FT11 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT10_Pos               (10UL)                    /*!< FT10 (Bit 10)                                         */
#define EXTI_FTSR1_FT10_Msk               (0x400UL)                 /*!< FT10 (Bitfield-Mask: 0x01)                            */
#define EXTI_FTSR1_FT9_Pos                (9UL)                     /*!< FT9 (Bit 9)                                           */
#define EXTI_FTSR1_FT9_Msk                (0x200UL)                 /*!< FT9 (Bitfield-Mask: 0x01)                             */
#define EXTI_FTSR1_FT8_Pos                (8UL)                     /*!< FT8 (Bit 8)                                           */
#define EXTI_FTSR1_FT8_Msk                (0x100UL)                 /*!< FT8 (Bitfield-Mask: 0x01)                             */
#define EXTI_FTSR1_FT7_Pos                (7UL)                     /*!< FT7 (Bit 7)                                           */
#define EXTI_FTSR1_FT7_Msk                (0x80UL)                  /*!< FT7 (Bitfield-Mask: 0x01)                             */
#define EXTI_FTSR1_FT6_Pos                (6UL)                     /*!< FT6 (Bit 6)                                           */
#define EXTI_FTSR1_FT6_Msk                (0x40UL)                  /*!< FT6 (Bitfield-Mask: 0x01)                             */
#define EXTI_FTSR1_FT5_Pos                (5UL)                     /*!< FT5 (Bit 5)                                           */
#define EXTI_FTSR1_FT5_Msk                (0x20UL)                  /*!< FT5 (Bitfield-Mask: 0x01)                             */
#define EXTI_FTSR1_FT4_Pos                (4UL)                     /*!< FT4 (Bit 4)                                           */
#define EXTI_FTSR1_FT4_Msk                (0x10UL)                  /*!< FT4 (Bitfield-Mask: 0x01)                             */
#define EXTI_FTSR1_FT3_Pos                (3UL)                     /*!< FT3 (Bit 3)                                           */
#define EXTI_FTSR1_FT3_Msk                (0x8UL)                   /*!< FT3 (Bitfield-Mask: 0x01)                             */
#define EXTI_FTSR1_FT2_Pos                (2UL)                     /*!< FT2 (Bit 2)                                           */
#define EXTI_FTSR1_FT2_Msk                (0x4UL)                   /*!< FT2 (Bitfield-Mask: 0x01)                             */
#define EXTI_FTSR1_FT1_Pos                (1UL)                     /*!< FT1 (Bit 1)                                           */
#define EXTI_FTSR1_FT1_Msk                (0x2UL)                   /*!< FT1 (Bitfield-Mask: 0x01)                             */
#define EXTI_FTSR1_FT0_Pos                (0UL)                     /*!< FT0 (Bit 0)                                           */
#define EXTI_FTSR1_FT0_Msk                (0x1UL)                   /*!< FT0 (Bitfield-Mask: 0x01)                             */
/* ========================================================  SWIER1  ========================================================= */
#define EXTI_SWIER1_SWI31_Pos             (31UL)                    /*!< SWI31 (Bit 31)                                        */
#define EXTI_SWIER1_SWI31_Msk             (0x80000000UL)            /*!< SWI31 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI21_Pos             (21UL)                    /*!< SWI21 (Bit 21)                                        */
#define EXTI_SWIER1_SWI21_Msk             (0x200000UL)              /*!< SWI21 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI20_Pos             (20UL)                    /*!< SWI20 (Bit 20)                                        */
#define EXTI_SWIER1_SWI20_Msk             (0x100000UL)              /*!< SWI20 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI19_Pos             (19UL)                    /*!< SWI19 (Bit 19)                                        */
#define EXTI_SWIER1_SWI19_Msk             (0x80000UL)               /*!< SWI19 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI18_Pos             (18UL)                    /*!< SWI18 (Bit 18)                                        */
#define EXTI_SWIER1_SWI18_Msk             (0x40000UL)               /*!< SWI18 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI17_Pos             (17UL)                    /*!< SWI17 (Bit 17)                                        */
#define EXTI_SWIER1_SWI17_Msk             (0x20000UL)               /*!< SWI17 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI16_Pos             (16UL)                    /*!< SWI16 (Bit 16)                                        */
#define EXTI_SWIER1_SWI16_Msk             (0x10000UL)               /*!< SWI16 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI15_Pos             (15UL)                    /*!< SWI15 (Bit 15)                                        */
#define EXTI_SWIER1_SWI15_Msk             (0x8000UL)                /*!< SWI15 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI14_Pos             (14UL)                    /*!< SWI14 (Bit 14)                                        */
#define EXTI_SWIER1_SWI14_Msk             (0x4000UL)                /*!< SWI14 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI13_Pos             (13UL)                    /*!< SWI13 (Bit 13)                                        */
#define EXTI_SWIER1_SWI13_Msk             (0x2000UL)                /*!< SWI13 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI12_Pos             (12UL)                    /*!< SWI12 (Bit 12)                                        */
#define EXTI_SWIER1_SWI12_Msk             (0x1000UL)                /*!< SWI12 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI11_Pos             (11UL)                    /*!< SWI11 (Bit 11)                                        */
#define EXTI_SWIER1_SWI11_Msk             (0x800UL)                 /*!< SWI11 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI10_Pos             (10UL)                    /*!< SWI10 (Bit 10)                                        */
#define EXTI_SWIER1_SWI10_Msk             (0x400UL)                 /*!< SWI10 (Bitfield-Mask: 0x01)                           */
#define EXTI_SWIER1_SWI9_Pos              (9UL)                     /*!< SWI9 (Bit 9)                                          */
#define EXTI_SWIER1_SWI9_Msk              (0x200UL)                 /*!< SWI9 (Bitfield-Mask: 0x01)                            */
#define EXTI_SWIER1_SWI8_Pos              (8UL)                     /*!< SWI8 (Bit 8)                                          */
#define EXTI_SWIER1_SWI8_Msk              (0x100UL)                 /*!< SWI8 (Bitfield-Mask: 0x01)                            */
#define EXTI_SWIER1_SWI7_Pos              (7UL)                     /*!< SWI7 (Bit 7)                                          */
#define EXTI_SWIER1_SWI7_Msk              (0x80UL)                  /*!< SWI7 (Bitfield-Mask: 0x01)                            */
#define EXTI_SWIER1_SWI6_Pos              (6UL)                     /*!< SWI6 (Bit 6)                                          */
#define EXTI_SWIER1_SWI6_Msk              (0x40UL)                  /*!< SWI6 (Bitfield-Mask: 0x01)                            */
#define EXTI_SWIER1_SWI5_Pos              (5UL)                     /*!< SWI5 (Bit 5)                                          */
#define EXTI_SWIER1_SWI5_Msk              (0x20UL)                  /*!< SWI5 (Bitfield-Mask: 0x01)                            */
#define EXTI_SWIER1_SWI4_Pos              (4UL)                     /*!< SWI4 (Bit 4)                                          */
#define EXTI_SWIER1_SWI4_Msk              (0x10UL)                  /*!< SWI4 (Bitfield-Mask: 0x01)                            */
#define EXTI_SWIER1_SWI3_Pos              (3UL)                     /*!< SWI3 (Bit 3)                                          */
#define EXTI_SWIER1_SWI3_Msk              (0x8UL)                   /*!< SWI3 (Bitfield-Mask: 0x01)                            */
#define EXTI_SWIER1_SWI2_Pos              (2UL)                     /*!< SWI2 (Bit 2)                                          */
#define EXTI_SWIER1_SWI2_Msk              (0x4UL)                   /*!< SWI2 (Bitfield-Mask: 0x01)                            */
#define EXTI_SWIER1_SWI1_Pos              (1UL)                     /*!< SWI1 (Bit 1)                                          */
#define EXTI_SWIER1_SWI1_Msk              (0x2UL)                   /*!< SWI1 (Bitfield-Mask: 0x01)                            */
#define EXTI_SWIER1_SWI0_Pos              (0UL)                     /*!< SWI0 (Bit 0)                                          */
#define EXTI_SWIER1_SWI0_Msk              (0x1UL)                   /*!< SWI0 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  PR1  ========================================================== */
#define EXTI_PR1_PIF31_Pos                (31UL)                    /*!< PIF31 (Bit 31)                                        */
#define EXTI_PR1_PIF31_Msk                (0x80000000UL)            /*!< PIF31 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF21_Pos                (21UL)                    /*!< PIF21 (Bit 21)                                        */
#define EXTI_PR1_PIF21_Msk                (0x200000UL)              /*!< PIF21 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF20_Pos                (20UL)                    /*!< PIF20 (Bit 20)                                        */
#define EXTI_PR1_PIF20_Msk                (0x100000UL)              /*!< PIF20 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF19_Pos                (19UL)                    /*!< PIF19 (Bit 19)                                        */
#define EXTI_PR1_PIF19_Msk                (0x80000UL)               /*!< PIF19 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF18_Pos                (18UL)                    /*!< PIF18 (Bit 18)                                        */
#define EXTI_PR1_PIF18_Msk                (0x40000UL)               /*!< PIF18 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF17_Pos                (17UL)                    /*!< PIF17 (Bit 17)                                        */
#define EXTI_PR1_PIF17_Msk                (0x20000UL)               /*!< PIF17 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF16_Pos                (16UL)                    /*!< PIF16 (Bit 16)                                        */
#define EXTI_PR1_PIF16_Msk                (0x10000UL)               /*!< PIF16 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF15_Pos                (15UL)                    /*!< PIF15 (Bit 15)                                        */
#define EXTI_PR1_PIF15_Msk                (0x8000UL)                /*!< PIF15 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF14_Pos                (14UL)                    /*!< PIF14 (Bit 14)                                        */
#define EXTI_PR1_PIF14_Msk                (0x4000UL)                /*!< PIF14 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF13_Pos                (13UL)                    /*!< PIF13 (Bit 13)                                        */
#define EXTI_PR1_PIF13_Msk                (0x2000UL)                /*!< PIF13 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF12_Pos                (12UL)                    /*!< PIF12 (Bit 12)                                        */
#define EXTI_PR1_PIF12_Msk                (0x1000UL)                /*!< PIF12 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF11_Pos                (11UL)                    /*!< PIF11 (Bit 11)                                        */
#define EXTI_PR1_PIF11_Msk                (0x800UL)                 /*!< PIF11 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF10_Pos                (10UL)                    /*!< PIF10 (Bit 10)                                        */
#define EXTI_PR1_PIF10_Msk                (0x400UL)                 /*!< PIF10 (Bitfield-Mask: 0x01)                           */
#define EXTI_PR1_PIF9_Pos                 (9UL)                     /*!< PIF9 (Bit 9)                                          */
#define EXTI_PR1_PIF9_Msk                 (0x200UL)                 /*!< PIF9 (Bitfield-Mask: 0x01)                            */
#define EXTI_PR1_PIF8_Pos                 (8UL)                     /*!< PIF8 (Bit 8)                                          */
#define EXTI_PR1_PIF8_Msk                 (0x100UL)                 /*!< PIF8 (Bitfield-Mask: 0x01)                            */
#define EXTI_PR1_PIF7_Pos                 (7UL)                     /*!< PIF7 (Bit 7)                                          */
#define EXTI_PR1_PIF7_Msk                 (0x80UL)                  /*!< PIF7 (Bitfield-Mask: 0x01)                            */
#define EXTI_PR1_PIF6_Pos                 (6UL)                     /*!< PIF6 (Bit 6)                                          */
#define EXTI_PR1_PIF6_Msk                 (0x40UL)                  /*!< PIF6 (Bitfield-Mask: 0x01)                            */
#define EXTI_PR1_PIF5_Pos                 (5UL)                     /*!< PIF5 (Bit 5)                                          */
#define EXTI_PR1_PIF5_Msk                 (0x20UL)                  /*!< PIF5 (Bitfield-Mask: 0x01)                            */
#define EXTI_PR1_PIF4_Pos                 (4UL)                     /*!< PIF4 (Bit 4)                                          */
#define EXTI_PR1_PIF4_Msk                 (0x10UL)                  /*!< PIF4 (Bitfield-Mask: 0x01)                            */
#define EXTI_PR1_PIF3_Pos                 (3UL)                     /*!< PIF3 (Bit 3)                                          */
#define EXTI_PR1_PIF3_Msk                 (0x8UL)                   /*!< PIF3 (Bitfield-Mask: 0x01)                            */
#define EXTI_PR1_PIF2_Pos                 (2UL)                     /*!< PIF2 (Bit 2)                                          */
#define EXTI_PR1_PIF2_Msk                 (0x4UL)                   /*!< PIF2 (Bitfield-Mask: 0x01)                            */
#define EXTI_PR1_PIF1_Pos                 (1UL)                     /*!< PIF1 (Bit 1)                                          */
#define EXTI_PR1_PIF1_Msk                 (0x2UL)                   /*!< PIF1 (Bitfield-Mask: 0x01)                            */
#define EXTI_PR1_PIF0_Pos                 (0UL)                     /*!< PIF0 (Bit 0)                                          */
#define EXTI_PR1_PIF0_Msk                 (0x1UL)                   /*!< PIF0 (Bitfield-Mask: 0x01)                            */


/* =========================================================================================================================== */
/* ================                                           GPIO                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  MODER  ========================================================= */
#define GPIO_MODER_MODE15_Pos            (30UL)                    /*!< MODE15 (Bit 30)                                       */
#define GPIO_MODER_MODE15_Msk            (0xc0000000UL)            /*!< MODE15 (Bitfield-Mask: 0x03)                          */
#define GPIO_MODER_MODE14_Pos            (28UL)                    /*!< MODE14 (Bit 28)                                       */
#define GPIO_MODER_MODE14_Msk            (0x30000000UL)            /*!< MODE14 (Bitfield-Mask: 0x03)                          */
#define GPIO_MODER_MODE13_Pos            (26UL)                    /*!< MODE13 (Bit 26)                                       */
#define GPIO_MODER_MODE13_Msk            (0xc000000UL)             /*!< MODE13 (Bitfield-Mask: 0x03)                          */
#define GPIO_MODER_MODE12_Pos            (24UL)                    /*!< MODE12 (Bit 24)                                       */
#define GPIO_MODER_MODE12_Msk            (0x3000000UL)             /*!< MODE12 (Bitfield-Mask: 0x03)                          */
#define GPIO_MODER_MODE11_Pos            (22UL)                    /*!< MODE11 (Bit 22)                                       */
#define GPIO_MODER_MODE11_Msk            (0xc00000UL)              /*!< MODE11 (Bitfield-Mask: 0x03)                          */
#define GPIO_MODER_MODE10_Pos            (20UL)                    /*!< MODE10 (Bit 20)                                       */
#define GPIO_MODER_MODE10_Msk            (0x300000UL)              /*!< MODE10 (Bitfield-Mask: 0x03)                          */
#define GPIO_MODER_MODE9_Pos             (18UL)                    /*!< MODE9 (Bit 18)                                        */
#define GPIO_MODER_MODE9_Msk             (0xc0000UL)               /*!< MODE9 (Bitfield-Mask: 0x03)                           */
#define GPIO_MODER_MODE8_Pos             (16UL)                    /*!< MODE8 (Bit 16)                                        */
#define GPIO_MODER_MODE8_Msk             (0x30000UL)               /*!< MODE8 (Bitfield-Mask: 0x03)                           */
#define GPIO_MODER_MODE7_Pos             (14UL)                    /*!< MODE7 (Bit 14)                                        */
#define GPIO_MODER_MODE7_Msk             (0xc000UL)                /*!< MODE7 (Bitfield-Mask: 0x03)                           */
#define GPIO_MODER_MODE6_Pos             (12UL)                    /*!< MODE6 (Bit 12)                                        */
#define GPIO_MODER_MODE6_Msk             (0x3000UL)                /*!< MODE6 (Bitfield-Mask: 0x03)                           */
#define GPIO_MODER_MODE5_Pos             (10UL)                    /*!< MODE5 (Bit 10)                                        */
#define GPIO_MODER_MODE5_Msk             (0xc00UL)                 /*!< MODE5 (Bitfield-Mask: 0x03)                           */
#define GPIO_MODER_MODE4_Pos             (8UL)                     /*!< MODE4 (Bit 8)                                         */
#define GPIO_MODER_MODE4_Msk             (0x300UL)                 /*!< MODE4 (Bitfield-Mask: 0x03)                           */
#define GPIO_MODER_MODE3_Pos             (6UL)                     /*!< MODE3 (Bit 6)                                         */
#define GPIO_MODER_MODE3_Msk             (0xc0UL)                  /*!< MODE3 (Bitfield-Mask: 0x03)                           */
#define GPIO_MODER_MODE2_Pos             (4UL)                     /*!< MODE2 (Bit 4)                                         */
#define GPIO_MODER_MODE2_Msk             (0x30UL)                  /*!< MODE2 (Bitfield-Mask: 0x03)                           */
#define GPIO_MODER_MODE1_Pos             (2UL)                     /*!< MODE1 (Bit 2)                                         */
#define GPIO_MODER_MODE1_Msk             (0xcUL)                   /*!< MODE1 (Bitfield-Mask: 0x03)                           */
#define GPIO_MODER_MODE0_Pos             (0UL)                     /*!< MODE0 (Bit 0)                                         */
#define GPIO_MODER_MODE0_Msk             (0x3UL)                   /*!< MODE0 (Bitfield-Mask: 0x03)                           */
/* ========================================================  OTYPER  ========================================================= */
#define GPIO_OTYPER_OT15_Pos             (15UL)                    /*!< OT15 (Bit 15)                                         */
#define GPIO_OTYPER_OT15_Msk             (0x8000UL)                /*!< OT15 (Bitfield-Mask: 0x01)                            */
#define GPIO_OTYPER_OT14_Pos             (14UL)                    /*!< OT14 (Bit 14)                                         */
#define GPIO_OTYPER_OT14_Msk             (0x4000UL)                /*!< OT14 (Bitfield-Mask: 0x01)                            */
#define GPIO_OTYPER_OT13_Pos             (13UL)                    /*!< OT13 (Bit 13)                                         */
#define GPIO_OTYPER_OT13_Msk             (0x2000UL)                /*!< OT13 (Bitfield-Mask: 0x01)                            */
#define GPIO_OTYPER_OT12_Pos             (12UL)                    /*!< OT12 (Bit 12)                                         */
#define GPIO_OTYPER_OT12_Msk             (0x1000UL)                /*!< OT12 (Bitfield-Mask: 0x01)                            */
#define GPIO_OTYPER_OT11_Pos             (11UL)                    /*!< OT11 (Bit 11)                                         */
#define GPIO_OTYPER_OT11_Msk             (0x800UL)                 /*!< OT11 (Bitfield-Mask: 0x01)                            */
#define GPIO_OTYPER_OT10_Pos             (10UL)                    /*!< OT10 (Bit 10)                                         */
#define GPIO_OTYPER_OT10_Msk             (0x400UL)                 /*!< OT10 (Bitfield-Mask: 0x01)                            */
#define GPIO_OTYPER_OT9_Pos              (9UL)                     /*!< OT9 (Bit 9)                                           */
#define GPIO_OTYPER_OT9_Msk              (0x200UL)                 /*!< OT9 (Bitfield-Mask: 0x01)                             */
#define GPIO_OTYPER_OT8_Pos              (8UL)                     /*!< OT8 (Bit 8)                                           */
#define GPIO_OTYPER_OT8_Msk              (0x100UL)                 /*!< OT8 (Bitfield-Mask: 0x01)                             */
#define GPIO_OTYPER_OT7_Pos              (7UL)                     /*!< OT7 (Bit 7)                                           */
#define GPIO_OTYPER_OT7_Msk              (0x80UL)                  /*!< OT7 (Bitfield-Mask: 0x01)                             */
#define GPIO_OTYPER_OT6_Pos              (6UL)                     /*!< OT6 (Bit 6)                                           */
#define GPIO_OTYPER_OT6_Msk              (0x40UL)                  /*!< OT6 (Bitfield-Mask: 0x01)                             */
#define GPIO_OTYPER_OT5_Pos              (5UL)                     /*!< OT5 (Bit 5)                                           */
#define GPIO_OTYPER_OT5_Msk              (0x20UL)                  /*!< OT5 (Bitfield-Mask: 0x01)                             */
#define GPIO_OTYPER_OT4_Pos              (4UL)                     /*!< OT4 (Bit 4)                                           */
#define GPIO_OTYPER_OT4_Msk              (0x10UL)                  /*!< OT4 (Bitfield-Mask: 0x01)                             */
#define GPIO_OTYPER_OT3_Pos              (3UL)                     /*!< OT3 (Bit 3)                                           */
#define GPIO_OTYPER_OT3_Msk              (0x8UL)                   /*!< OT3 (Bitfield-Mask: 0x01)                             */
#define GPIO_OTYPER_OT2_Pos              (2UL)                     /*!< OT2 (Bit 2)                                           */
#define GPIO_OTYPER_OT2_Msk              (0x4UL)                   /*!< OT2 (Bitfield-Mask: 0x01)                             */
#define GPIO_OTYPER_OT1_Pos              (1UL)                     /*!< OT1 (Bit 1)                                           */
#define GPIO_OTYPER_OT1_Msk              (0x2UL)                   /*!< OT1 (Bitfield-Mask: 0x01)                             */
#define GPIO_OTYPER_OT0_Pos              (0UL)                     /*!< OT0 (Bit 0)                                           */
#define GPIO_OTYPER_OT0_Msk              (0x1UL)                   /*!< OT0 (Bitfield-Mask: 0x01)                             */
/* ========================================================  OSPEEDR  ======================================================== */
#define GPIO_OSPEEDR_OSPEED15_Pos        (30UL)                    /*!< OSPEED15 (Bit 30)                                     */
#define GPIO_OSPEEDR_OSPEED15_Msk        (0xc0000000UL)            /*!< OSPEED15 (Bitfield-Mask: 0x03)                        */
#define GPIO_OSPEEDR_OSPEED14_Pos        (28UL)                    /*!< OSPEED14 (Bit 28)                                     */
#define GPIO_OSPEEDR_OSPEED14_Msk        (0x30000000UL)            /*!< OSPEED14 (Bitfield-Mask: 0x03)                        */
#define GPIO_OSPEEDR_OSPEED13_Pos        (26UL)                    /*!< OSPEED13 (Bit 26)                                     */
#define GPIO_OSPEEDR_OSPEED13_Msk        (0xc000000UL)             /*!< OSPEED13 (Bitfield-Mask: 0x03)                        */
#define GPIO_OSPEEDR_OSPEED12_Pos        (24UL)                    /*!< OSPEED12 (Bit 24)                                     */
#define GPIO_OSPEEDR_OSPEED12_Msk        (0x3000000UL)             /*!< OSPEED12 (Bitfield-Mask: 0x03)                        */
#define GPIO_OSPEEDR_OSPEED11_Pos        (22UL)                    /*!< OSPEED11 (Bit 22)                                     */
#define GPIO_OSPEEDR_OSPEED11_Msk        (0xc00000UL)              /*!< OSPEED11 (Bitfield-Mask: 0x03)                        */
#define GPIO_OSPEEDR_OSPEED10_Pos        (20UL)                    /*!< OSPEED10 (Bit 20)                                     */
#define GPIO_OSPEEDR_OSPEED10_Msk        (0x300000UL)              /*!< OSPEED10 (Bitfield-Mask: 0x03)                        */
#define GPIO_OSPEEDR_OSPEED9_Pos         (18UL)                    /*!< OSPEED9 (Bit 18)                                      */
#define GPIO_OSPEEDR_OSPEED9_Msk         (0xc0000UL)               /*!< OSPEED9 (Bitfield-Mask: 0x03)                         */
#define GPIO_OSPEEDR_OSPEED8_Pos         (16UL)                    /*!< OSPEED8 (Bit 16)                                      */
#define GPIO_OSPEEDR_OSPEED8_Msk         (0x30000UL)               /*!< OSPEED8 (Bitfield-Mask: 0x03)                         */
#define GPIO_OSPEEDR_OSPEED7_Pos         (14UL)                    /*!< OSPEED7 (Bit 14)                                      */
#define GPIO_OSPEEDR_OSPEED7_Msk         (0xc000UL)                /*!< OSPEED7 (Bitfield-Mask: 0x03)                         */
#define GPIO_OSPEEDR_OSPEED6_Pos         (12UL)                    /*!< OSPEED6 (Bit 12)                                      */
#define GPIO_OSPEEDR_OSPEED6_Msk         (0x3000UL)                /*!< OSPEED6 (Bitfield-Mask: 0x03)                         */
#define GPIO_OSPEEDR_OSPEED5_Pos         (10UL)                    /*!< OSPEED5 (Bit 10)                                      */
#define GPIO_OSPEEDR_OSPEED5_Msk         (0xc00UL)                 /*!< OSPEED5 (Bitfield-Mask: 0x03)                         */
#define GPIO_OSPEEDR_OSPEED4_Pos         (8UL)                     /*!< OSPEED4 (Bit 8)                                       */
#define GPIO_OSPEEDR_OSPEED4_Msk         (0x300UL)                 /*!< OSPEED4 (Bitfield-Mask: 0x03)                         */
#define GPIO_OSPEEDR_OSPEED3_Pos         (6UL)                     /*!< OSPEED3 (Bit 6)                                       */
#define GPIO_OSPEEDR_OSPEED3_Msk         (0xc0UL)                  /*!< OSPEED3 (Bitfield-Mask: 0x03)                         */
#define GPIO_OSPEEDR_OSPEED2_Pos         (4UL)                     /*!< OSPEED2 (Bit 4)                                       */
#define GPIO_OSPEEDR_OSPEED2_Msk         (0x30UL)                  /*!< OSPEED2 (Bitfield-Mask: 0x03)                         */
#define GPIO_OSPEEDR_OSPEED1_Pos         (2UL)                     /*!< OSPEED1 (Bit 2)                                       */
#define GPIO_OSPEEDR_OSPEED1_Msk         (0xcUL)                   /*!< OSPEED1 (Bitfield-Mask: 0x03)                         */
#define GPIO_OSPEEDR_OSPEED0_Pos         (0UL)                     /*!< OSPEED0 (Bit 0)                                       */
#define GPIO_OSPEEDR_OSPEED0_Msk         (0x3UL)                   /*!< OSPEED0 (Bitfield-Mask: 0x03)                         */
/* =========================================================  PUPDR  ========================================================= */
#define GPIO_PUPDR_PUPD15_Pos            (30UL)                    /*!< PUPD15 (Bit 30)                                       */
#define GPIO_PUPDR_PUPD15_Msk            (0xc0000000UL)            /*!< PUPD15 (Bitfield-Mask: 0x03)                          */
#define GPIO_PUPDR_PUPD14_Pos            (28UL)                    /*!< PUPD14 (Bit 28)                                       */
#define GPIO_PUPDR_PUPD14_Msk            (0x30000000UL)            /*!< PUPD14 (Bitfield-Mask: 0x03)                          */
#define GPIO_PUPDR_PUPD13_Pos            (26UL)                    /*!< PUPD13 (Bit 26)                                       */
#define GPIO_PUPDR_PUPD13_Msk            (0xc000000UL)             /*!< PUPD13 (Bitfield-Mask: 0x03)                          */
#define GPIO_PUPDR_PUPD12_Pos            (24UL)                    /*!< PUPD12 (Bit 24)                                       */
#define GPIO_PUPDR_PUPD12_Msk            (0x3000000UL)             /*!< PUPD12 (Bitfield-Mask: 0x03)                          */
#define GPIO_PUPDR_PUPD11_Pos            (22UL)                    /*!< PUPD11 (Bit 22)                                       */
#define GPIO_PUPDR_PUPD11_Msk            (0xc00000UL)              /*!< PUPD11 (Bitfield-Mask: 0x03)                          */
#define GPIO_PUPDR_PUPD10_Pos            (20UL)                    /*!< PUPD10 (Bit 20)                                       */
#define GPIO_PUPDR_PUPD10_Msk            (0x300000UL)              /*!< PUPD10 (Bitfield-Mask: 0x03)                          */
#define GPIO_PUPDR_PUPD9_Pos             (18UL)                    /*!< PUPD9 (Bit 18)                                        */
#define GPIO_PUPDR_PUPD9_Msk             (0xc0000UL)               /*!< PUPD9 (Bitfield-Mask: 0x03)                           */
#define GPIO_PUPDR_PUPD8_Pos             (16UL)                    /*!< PUPD8 (Bit 16)                                        */
#define GPIO_PUPDR_PUPD8_Msk             (0x30000UL)               /*!< PUPD8 (Bitfield-Mask: 0x03)                           */
#define GPIO_PUPDR_PUPD7_Pos             (14UL)                    /*!< PUPD7 (Bit 14)                                        */
#define GPIO_PUPDR_PUPD7_Msk             (0xc000UL)                /*!< PUPD7 (Bitfield-Mask: 0x03)                           */
#define GPIO_PUPDR_PUPD6_Pos             (12UL)                    /*!< PUPD6 (Bit 12)                                        */
#define GPIO_PUPDR_PUPD6_Msk             (0x3000UL)                /*!< PUPD6 (Bitfield-Mask: 0x03)                           */
#define GPIO_PUPDR_PUPD5_Pos             (10UL)                    /*!< PUPD5 (Bit 10)                                        */
#define GPIO_PUPDR_PUPD5_Msk             (0xc00UL)                 /*!< PUPD5 (Bitfield-Mask: 0x03)                           */
#define GPIO_PUPDR_PUPD4_Pos             (8UL)                     /*!< PUPD4 (Bit 8)                                         */
#define GPIO_PUPDR_PUPD4_Msk             (0x300UL)                 /*!< PUPD4 (Bitfield-Mask: 0x03)                           */
#define GPIO_PUPDR_PUPD3_Pos             (6UL)                     /*!< PUPD3 (Bit 6)                                         */
#define GPIO_PUPDR_PUPD3_Msk             (0xc0UL)                  /*!< PUPD3 (Bitfield-Mask: 0x03)                           */
#define GPIO_PUPDR_PUPD2_Pos             (4UL)                     /*!< PUPD2 (Bit 4)                                         */
#define GPIO_PUPDR_PUPD2_Msk             (0x30UL)                  /*!< PUPD2 (Bitfield-Mask: 0x03)                           */
#define GPIO_PUPDR_PUPD1_Pos             (2UL)                     /*!< PUPD1 (Bit 2)                                         */
#define GPIO_PUPDR_PUPD1_Msk             (0xcUL)                   /*!< PUPD1 (Bitfield-Mask: 0x03)                           */
#define GPIO_PUPDR_PUPD0_Pos             (0UL)                     /*!< PUPD0 (Bit 0)                                         */
#define GPIO_PUPDR_PUPD0_Msk             (0x3UL)                   /*!< PUPD0 (Bitfield-Mask: 0x03)                           */
/* ==========================================================  DRR  ========================================================== */
#define GPIO_DRR_DR15_Pos                (15UL)                    /*!< DR15 (Bit 15)                                         */
#define GPIO_DRR_DR15_Msk                (0x8000UL)                /*!< DR15 (Bitfield-Mask: 0x01)                            */
#define GPIO_DRR_DR14_Pos                (14UL)                    /*!< DR14 (Bit 14)                                         */
#define GPIO_DRR_DR14_Msk                (0x4000UL)                /*!< DR14 (Bitfield-Mask: 0x01)                            */
#define GPIO_DRR_DR13_Pos                (13UL)                    /*!< DR13 (Bit 13)                                         */
#define GPIO_DRR_DR13_Msk                (0x2000UL)                /*!< DR13 (Bitfield-Mask: 0x01)                            */
#define GPIO_DRR_DR12_Pos                (12UL)                    /*!< DR12 (Bit 12)                                         */
#define GPIO_DRR_DR12_Msk                (0x1000UL)                /*!< DR12 (Bitfield-Mask: 0x01)                            */
#define GPIO_DRR_DR11_Pos                (11UL)                    /*!< DR11 (Bit 11)                                         */
#define GPIO_DRR_DR11_Msk                (0x800UL)                 /*!< DR11 (Bitfield-Mask: 0x01)                            */
#define GPIO_DRR_DR10_Pos                (10UL)                    /*!< DR10 (Bit 10)                                         */
#define GPIO_DRR_DR10_Msk                (0x400UL)                 /*!< DR10 (Bitfield-Mask: 0x01)                            */
#define GPIO_DRR_DR9_Pos                 (9UL)                     /*!< DR9 (Bit 9)                                           */
#define GPIO_DRR_DR9_Msk                 (0x200UL)                 /*!< DR9 (Bitfield-Mask: 0x01)                             */
#define GPIO_DRR_DR8_Pos                 (8UL)                     /*!< DR8 (Bit 8)                                           */
#define GPIO_DRR_DR8_Msk                 (0x100UL)                 /*!< DR8 (Bitfield-Mask: 0x01)                             */
#define GPIO_DRR_DR7_Pos                 (7UL)                     /*!< DR7 (Bit 7)                                           */
#define GPIO_DRR_DR7_Msk                 (0x80UL)                  /*!< DR7 (Bitfield-Mask: 0x01)                             */
#define GPIO_DRR_DR6_Pos                 (6UL)                     /*!< DR6 (Bit 6)                                           */
#define GPIO_DRR_DR6_Msk                 (0x40UL)                  /*!< DR6 (Bitfield-Mask: 0x01)                             */
#define GPIO_DRR_DR5_Pos                 (5UL)                     /*!< DR5 (Bit 5)                                           */
#define GPIO_DRR_DR5_Msk                 (0x20UL)                  /*!< DR5 (Bitfield-Mask: 0x01)                             */
#define GPIO_DRR_DR4_Pos                 (4UL)                     /*!< DR4 (Bit 4)                                           */
#define GPIO_DRR_DR4_Msk                 (0x10UL)                  /*!< DR4 (Bitfield-Mask: 0x01)                             */
#define GPIO_DRR_DR3_Pos                 (3UL)                     /*!< DR3 (Bit 3)                                           */
#define GPIO_DRR_DR3_Msk                 (0x8UL)                   /*!< DR3 (Bitfield-Mask: 0x01)                             */
#define GPIO_DRR_DR2_Pos                 (2UL)                     /*!< DR2 (Bit 2)                                           */
#define GPIO_DRR_DR2_Msk                 (0x4UL)                   /*!< DR2 (Bitfield-Mask: 0x01)                             */
#define GPIO_DRR_DR1_Pos                 (1UL)                     /*!< DR1 (Bit 1)                                           */
#define GPIO_DRR_DR1_Msk                 (0x2UL)                   /*!< DR1 (Bitfield-Mask: 0x01)                             */
#define GPIO_DRR_DR0_Pos                 (0UL)                     /*!< DR0 (Bit 0)                                           */
#define GPIO_DRR_DR0_Msk                 (0x1UL)                   /*!< DR0 (Bitfield-Mask: 0x01)                             */
/* ==========================================================  IDR  ========================================================== */
#define GPIO_IDR_IDR15_Pos               (15UL)                    /*!< IDR15 (Bit 15)                                        */
#define GPIO_IDR_IDR15_Msk               (0x8000UL)                /*!< IDR15 (Bitfield-Mask: 0x01)                           */
#define GPIO_IDR_IDR14_Pos               (14UL)                    /*!< IDR14 (Bit 14)                                        */
#define GPIO_IDR_IDR14_Msk               (0x4000UL)                /*!< IDR14 (Bitfield-Mask: 0x01)                           */
#define GPIO_IDR_IDR13_Pos               (13UL)                    /*!< IDR13 (Bit 13)                                        */
#define GPIO_IDR_IDR13_Msk               (0x2000UL)                /*!< IDR13 (Bitfield-Mask: 0x01)                           */
#define GPIO_IDR_IDR12_Pos               (12UL)                    /*!< IDR12 (Bit 12)                                        */
#define GPIO_IDR_IDR12_Msk               (0x1000UL)                /*!< IDR12 (Bitfield-Mask: 0x01)                           */
#define GPIO_IDR_IDR11_Pos               (11UL)                    /*!< IDR11 (Bit 11)                                        */
#define GPIO_IDR_IDR11_Msk               (0x800UL)                 /*!< IDR11 (Bitfield-Mask: 0x01)                           */
#define GPIO_IDR_IDR10_Pos               (10UL)                    /*!< IDR10 (Bit 10)                                        */
#define GPIO_IDR_IDR10_Msk               (0x400UL)                 /*!< IDR10 (Bitfield-Mask: 0x01)                           */
#define GPIO_IDR_IDR9_Pos                (9UL)                     /*!< IDR9 (Bit 9)                                          */
#define GPIO_IDR_IDR9_Msk                (0x200UL)                 /*!< IDR9 (Bitfield-Mask: 0x01)                            */
#define GPIO_IDR_IDR8_Pos                (8UL)                     /*!< IDR8 (Bit 8)                                          */
#define GPIO_IDR_IDR8_Msk                (0x100UL)                 /*!< IDR8 (Bitfield-Mask: 0x01)                            */
#define GPIO_IDR_IDR7_Pos                (7UL)                     /*!< IDR7 (Bit 7)                                          */
#define GPIO_IDR_IDR7_Msk                (0x80UL)                  /*!< IDR7 (Bitfield-Mask: 0x01)                            */
#define GPIO_IDR_IDR6_Pos                (6UL)                     /*!< IDR6 (Bit 6)                                          */
#define GPIO_IDR_IDR6_Msk                (0x40UL)                  /*!< IDR6 (Bitfield-Mask: 0x01)                            */
#define GPIO_IDR_IDR5_Pos                (5UL)                     /*!< IDR5 (Bit 5)                                          */
#define GPIO_IDR_IDR5_Msk                (0x20UL)                  /*!< IDR5 (Bitfield-Mask: 0x01)                            */
#define GPIO_IDR_IDR4_Pos                (4UL)                     /*!< IDR4 (Bit 4)                                          */
#define GPIO_IDR_IDR4_Msk                (0x10UL)                  /*!< IDR4 (Bitfield-Mask: 0x01)                            */
#define GPIO_IDR_IDR3_Pos                (3UL)                     /*!< IDR3 (Bit 3)                                          */
#define GPIO_IDR_IDR3_Msk                (0x8UL)                   /*!< IDR3 (Bitfield-Mask: 0x01)                            */
#define GPIO_IDR_IDR2_Pos                (2UL)                     /*!< IDR2 (Bit 2)                                          */
#define GPIO_IDR_IDR2_Msk                (0x4UL)                   /*!< IDR2 (Bitfield-Mask: 0x01)                            */
#define GPIO_IDR_IDR1_Pos                (1UL)                     /*!< IDR1 (Bit 1)                                          */
#define GPIO_IDR_IDR1_Msk                (0x2UL)                   /*!< IDR1 (Bitfield-Mask: 0x01)                            */
#define GPIO_IDR_IDR0_Pos                (0UL)                     /*!< IDR0 (Bit 0)                                          */
#define GPIO_IDR_IDR0_Msk                (0x1UL)                   /*!< IDR0 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  ODR  ========================================================== */
#define GPIO_ODR_ODR15_Pos               (15UL)                    /*!< ODR15 (Bit 15)                                        */
#define GPIO_ODR_ODR15_Msk               (0x8000UL)                /*!< ODR15 (Bitfield-Mask: 0x01)                           */
#define GPIO_ODR_ODR14_Pos               (14UL)                    /*!< ODR14 (Bit 14)                                        */
#define GPIO_ODR_ODR14_Msk               (0x4000UL)                /*!< ODR14 (Bitfield-Mask: 0x01)                           */
#define GPIO_ODR_ODR13_Pos               (13UL)                    /*!< ODR13 (Bit 13)                                        */
#define GPIO_ODR_ODR13_Msk               (0x2000UL)                /*!< ODR13 (Bitfield-Mask: 0x01)                           */
#define GPIO_ODR_ODR12_Pos               (12UL)                    /*!< ODR12 (Bit 12)                                        */
#define GPIO_ODR_ODR12_Msk               (0x1000UL)                /*!< ODR12 (Bitfield-Mask: 0x01)                           */
#define GPIO_ODR_ODR11_Pos               (11UL)                    /*!< ODR11 (Bit 11)                                        */
#define GPIO_ODR_ODR11_Msk               (0x800UL)                 /*!< ODR11 (Bitfield-Mask: 0x01)                           */
#define GPIO_ODR_ODR10_Pos               (10UL)                    /*!< ODR10 (Bit 10)                                        */
#define GPIO_ODR_ODR10_Msk               (0x400UL)                 /*!< ODR10 (Bitfield-Mask: 0x01)                           */
#define GPIO_ODR_ODR9_Pos                (9UL)                     /*!< ODR9 (Bit 9)                                          */
#define GPIO_ODR_ODR9_Msk                (0x200UL)                 /*!< ODR9 (Bitfield-Mask: 0x01)                            */
#define GPIO_ODR_ODR8_Pos                (8UL)                     /*!< ODR8 (Bit 8)                                          */
#define GPIO_ODR_ODR8_Msk                (0x100UL)                 /*!< ODR8 (Bitfield-Mask: 0x01)                            */
#define GPIO_ODR_ODR7_Pos                (7UL)                     /*!< ODR7 (Bit 7)                                          */
#define GPIO_ODR_ODR7_Msk                (0x80UL)                  /*!< ODR7 (Bitfield-Mask: 0x01)                            */
#define GPIO_ODR_ODR6_Pos                (6UL)                     /*!< ODR6 (Bit 6)                                          */
#define GPIO_ODR_ODR6_Msk                (0x40UL)                  /*!< ODR6 (Bitfield-Mask: 0x01)                            */
#define GPIO_ODR_ODR5_Pos                (5UL)                     /*!< ODR5 (Bit 5)                                          */
#define GPIO_ODR_ODR5_Msk                (0x20UL)                  /*!< ODR5 (Bitfield-Mask: 0x01)                            */
#define GPIO_ODR_ODR4_Pos                (4UL)                     /*!< ODR4 (Bit 4)                                          */
#define GPIO_ODR_ODR4_Msk                (0x10UL)                  /*!< ODR4 (Bitfield-Mask: 0x01)                            */
#define GPIO_ODR_ODR3_Pos                (3UL)                     /*!< ODR3 (Bit 3)                                          */
#define GPIO_ODR_ODR3_Msk                (0x8UL)                   /*!< ODR3 (Bitfield-Mask: 0x01)                            */
#define GPIO_ODR_ODR2_Pos                (2UL)                     /*!< ODR2 (Bit 2)                                          */
#define GPIO_ODR_ODR2_Msk                (0x4UL)                   /*!< ODR2 (Bitfield-Mask: 0x01)                            */
#define GPIO_ODR_ODR1_Pos                (1UL)                     /*!< ODR1 (Bit 1)                                          */
#define GPIO_ODR_ODR1_Msk                (0x2UL)                   /*!< ODR1 (Bitfield-Mask: 0x01)                            */
#define GPIO_ODR_ODR0_Pos                (0UL)                     /*!< ODR0 (Bit 0)                                          */
#define GPIO_ODR_ODR0_Msk                (0x1UL)                   /*!< ODR0 (Bitfield-Mask: 0x01)                            */
/* =========================================================  BSRR  ========================================================== */
#define GPIO_BSRR_BR15_Pos               (31UL)                    /*!< BR15 (Bit 31)                                         */
#define GPIO_BSRR_BR15_Msk               (0x80000000UL)            /*!< BR15 (Bitfield-Mask: 0x01)                            */
#define GPIO_BSRR_BR14_Pos               (30UL)                    /*!< BR14 (Bit 30)                                         */
#define GPIO_BSRR_BR14_Msk               (0x40000000UL)            /*!< BR14 (Bitfield-Mask: 0x01)                            */
#define GPIO_BSRR_BR13_Pos               (29UL)                    /*!< BR13 (Bit 29)                                         */
#define GPIO_BSRR_BR13_Msk               (0x20000000UL)            /*!< BR13 (Bitfield-Mask: 0x01)                            */
#define GPIO_BSRR_BR12_Pos               (28UL)                    /*!< BR12 (Bit 28)                                         */
#define GPIO_BSRR_BR12_Msk               (0x10000000UL)            /*!< BR12 (Bitfield-Mask: 0x01)                            */
#define GPIO_BSRR_BR11_Pos               (27UL)                    /*!< BR11 (Bit 27)                                         */
#define GPIO_BSRR_BR11_Msk               (0x8000000UL)             /*!< BR11 (Bitfield-Mask: 0x01)                            */
#define GPIO_BSRR_BR10_Pos               (26UL)                    /*!< BR10 (Bit 26)                                         */
#define GPIO_BSRR_BR10_Msk               (0x4000000UL)             /*!< BR10 (Bitfield-Mask: 0x01)                            */
#define GPIO_BSRR_BR9_Pos                (25UL)                    /*!< BR9 (Bit 25)                                          */
#define GPIO_BSRR_BR9_Msk                (0x2000000UL)             /*!< BR9 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BR8_Pos                (24UL)                    /*!< BR8 (Bit 24)                                          */
#define GPIO_BSRR_BR8_Msk                (0x1000000UL)             /*!< BR8 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BR7_Pos                (23UL)                    /*!< BR7 (Bit 23)                                          */
#define GPIO_BSRR_BR7_Msk                (0x800000UL)              /*!< BR7 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BR6_Pos                (22UL)                    /*!< BR6 (Bit 22)                                          */
#define GPIO_BSRR_BR6_Msk                (0x400000UL)              /*!< BR6 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BR5_Pos                (21UL)                    /*!< BR5 (Bit 21)                                          */
#define GPIO_BSRR_BR5_Msk                (0x200000UL)              /*!< BR5 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BR4_Pos                (20UL)                    /*!< BR4 (Bit 20)                                          */
#define GPIO_BSRR_BR4_Msk                (0x100000UL)              /*!< BR4 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BR3_Pos                (19UL)                    /*!< BR3 (Bit 19)                                          */
#define GPIO_BSRR_BR3_Msk                (0x80000UL)               /*!< BR3 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BR2_Pos                (18UL)                    /*!< BR2 (Bit 18)                                          */
#define GPIO_BSRR_BR2_Msk                (0x40000UL)               /*!< BR2 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BR1_Pos                (17UL)                    /*!< BR1 (Bit 17)                                          */
#define GPIO_BSRR_BR1_Msk                (0x20000UL)               /*!< BR1 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BR0_Pos                (16UL)                    /*!< BR0 (Bit 16)                                          */
#define GPIO_BSRR_BR0_Msk                (0x10000UL)               /*!< BR0 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BS15_Pos               (15UL)                    /*!< BS15 (Bit 15)                                         */
#define GPIO_BSRR_BS15_Msk               (0x8000UL)                /*!< BS15 (Bitfield-Mask: 0x01)                            */
#define GPIO_BSRR_BS14_Pos               (14UL)                    /*!< BS14 (Bit 14)                                         */
#define GPIO_BSRR_BS14_Msk               (0x4000UL)                /*!< BS14 (Bitfield-Mask: 0x01)                            */
#define GPIO_BSRR_BS13_Pos               (13UL)                    /*!< BS13 (Bit 13)                                         */
#define GPIO_BSRR_BS13_Msk               (0x2000UL)                /*!< BS13 (Bitfield-Mask: 0x01)                            */
#define GPIO_BSRR_BS12_Pos               (12UL)                    /*!< BS12 (Bit 12)                                         */
#define GPIO_BSRR_BS12_Msk               (0x1000UL)                /*!< BS12 (Bitfield-Mask: 0x01)                            */
#define GPIO_BSRR_BS11_Pos               (11UL)                    /*!< BS11 (Bit 11)                                         */
#define GPIO_BSRR_BS11_Msk               (0x800UL)                 /*!< BS11 (Bitfield-Mask: 0x01)                            */
#define GPIO_BSRR_BS10_Pos               (10UL)                    /*!< BS10 (Bit 10)                                         */
#define GPIO_BSRR_BS10_Msk               (0x400UL)                 /*!< BS10 (Bitfield-Mask: 0x01)                            */
#define GPIO_BSRR_BS9_Pos                (9UL)                     /*!< BS9 (Bit 9)                                           */
#define GPIO_BSRR_BS9_Msk                (0x200UL)                 /*!< BS9 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BS8_Pos                (8UL)                     /*!< BS8 (Bit 8)                                           */
#define GPIO_BSRR_BS8_Msk                (0x100UL)                 /*!< BS8 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BS7_Pos                (7UL)                     /*!< BS7 (Bit 7)                                           */
#define GPIO_BSRR_BS7_Msk                (0x80UL)                  /*!< BS7 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BS6_Pos                (6UL)                     /*!< BS6 (Bit 6)                                           */
#define GPIO_BSRR_BS6_Msk                (0x40UL)                  /*!< BS6 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BS5_Pos                (5UL)                     /*!< BS5 (Bit 5)                                           */
#define GPIO_BSRR_BS5_Msk                (0x20UL)                  /*!< BS5 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BS4_Pos                (4UL)                     /*!< BS4 (Bit 4)                                           */
#define GPIO_BSRR_BS4_Msk                (0x10UL)                  /*!< BS4 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BS3_Pos                (3UL)                     /*!< BS3 (Bit 3)                                           */
#define GPIO_BSRR_BS3_Msk                (0x8UL)                   /*!< BS3 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BS2_Pos                (2UL)                     /*!< BS2 (Bit 2)                                           */
#define GPIO_BSRR_BS2_Msk                (0x4UL)                   /*!< BS2 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BS1_Pos                (1UL)                     /*!< BS1 (Bit 1)                                           */
#define GPIO_BSRR_BS1_Msk                (0x2UL)                   /*!< BS1 (Bitfield-Mask: 0x01)                             */
#define GPIO_BSRR_BS0_Pos                (0UL)                     /*!< BS0 (Bit 0)                                           */
#define GPIO_BSRR_BS0_Msk                (0x1UL)                   /*!< BS0 (Bitfield-Mask: 0x01)                             */
/* =========================================================  LCKR  ========================================================== */
#define GPIO_LCKR_LCKK_Pos               (16UL)                    /*!< LCKK (Bit 16)                                         */
#define GPIO_LCKR_LCKK_Msk               (0x10000UL)               /*!< LCKK (Bitfield-Mask: 0x01)                            */
#define GPIO_LCKR_LCK15_Pos              (15UL)                    /*!< LCK15 (Bit 15)                                        */
#define GPIO_LCKR_LCK15_Msk              (0x8000UL)                /*!< LCK15 (Bitfield-Mask: 0x01)                           */
#define GPIO_LCKR_LCK14_Pos              (14UL)                    /*!< LCK14 (Bit 14)                                        */
#define GPIO_LCKR_LCK14_Msk              (0x4000UL)                /*!< LCK14 (Bitfield-Mask: 0x01)                           */
#define GPIO_LCKR_LCK13_Pos              (13UL)                    /*!< LCK13 (Bit 13)                                        */
#define GPIO_LCKR_LCK13_Msk              (0x2000UL)                /*!< LCK13 (Bitfield-Mask: 0x01)                           */
#define GPIO_LCKR_LCK12_Pos              (12UL)                    /*!< LCK12 (Bit 12)                                        */
#define GPIO_LCKR_LCK12_Msk              (0x1000UL)                /*!< LCK12 (Bitfield-Mask: 0x01)                           */
#define GPIO_LCKR_LCK11_Pos              (11UL)                    /*!< LCK11 (Bit 11)                                        */
#define GPIO_LCKR_LCK11_Msk              (0x800UL)                 /*!< LCK11 (Bitfield-Mask: 0x01)                           */
#define GPIO_LCKR_LCK10_Pos              (10UL)                    /*!< LCK10 (Bit 10)                                        */
#define GPIO_LCKR_LCK10_Msk              (0x400UL)                 /*!< LCK10 (Bitfield-Mask: 0x01)                           */
#define GPIO_LCKR_LCK9_Pos               (9UL)                     /*!< LCK9 (Bit 9)                                          */
#define GPIO_LCKR_LCK9_Msk               (0x200UL)                 /*!< LCK9 (Bitfield-Mask: 0x01)                            */
#define GPIO_LCKR_LCK8_Pos               (8UL)                     /*!< LCK8 (Bit 8)                                          */
#define GPIO_LCKR_LCK8_Msk               (0x100UL)                 /*!< LCK8 (Bitfield-Mask: 0x01)                            */
#define GPIO_LCKR_LCK7_Pos               (7UL)                     /*!< LCK7 (Bit 7)                                          */
#define GPIO_LCKR_LCK7_Msk               (0x80UL)                  /*!< LCK7 (Bitfield-Mask: 0x01)                            */
#define GPIO_LCKR_LCK6_Pos               (6UL)                     /*!< LCK6 (Bit 6)                                          */
#define GPIO_LCKR_LCK6_Msk               (0x40UL)                  /*!< LCK6 (Bitfield-Mask: 0x01)                            */
#define GPIO_LCKR_LCK5_Pos               (5UL)                     /*!< LCK5 (Bit 5)                                          */
#define GPIO_LCKR_LCK5_Msk               (0x20UL)                  /*!< LCK5 (Bitfield-Mask: 0x01)                            */
#define GPIO_LCKR_LCK4_Pos               (4UL)                     /*!< LCK4 (Bit 4)                                          */
#define GPIO_LCKR_LCK4_Msk               (0x10UL)                  /*!< LCK4 (Bitfield-Mask: 0x01)                            */
#define GPIO_LCKR_LCK3_Pos               (3UL)                     /*!< LCK3 (Bit 3)                                          */
#define GPIO_LCKR_LCK3_Msk               (0x8UL)                   /*!< LCK3 (Bitfield-Mask: 0x01)                            */
#define GPIO_LCKR_LCK2_Pos               (2UL)                     /*!< LCK2 (Bit 2)                                          */
#define GPIO_LCKR_LCK2_Msk               (0x4UL)                   /*!< LCK2 (Bitfield-Mask: 0x01)                            */
#define GPIO_LCKR_LCK1_Pos               (1UL)                     /*!< LCK1 (Bit 1)                                          */
#define GPIO_LCKR_LCK1_Msk               (0x2UL)                   /*!< LCK1 (Bitfield-Mask: 0x01)                            */
#define GPIO_LCKR_LCK0_Pos               (0UL)                     /*!< LCK0 (Bit 0)                                          */
#define GPIO_LCKR_LCK0_Msk               (0x1UL)                   /*!< LCK0 (Bitfield-Mask: 0x01)                            */
/* =========================================================  AFRL  ========================================================== */
#define GPIO_AFRL_AF7_Pos                (28UL)                    /*!< AF7 (Bit 28)                                          */
#define GPIO_AFRL_AF7_Msk                (0xf0000000UL)            /*!< AF7 (Bitfield-Mask: 0x0f)                             */
#define GPIO_AFRL_AF6_Pos                (24UL)                    /*!< AF6 (Bit 24)                                          */
#define GPIO_AFRL_AF6_Msk                (0xf000000UL)             /*!< AF6 (Bitfield-Mask: 0x0f)                             */
#define GPIO_AFRL_AF5_Pos                (20UL)                    /*!< AF5 (Bit 20)                                          */
#define GPIO_AFRL_AF5_Msk                (0xf00000UL)              /*!< AF5 (Bitfield-Mask: 0x0f)                             */
#define GPIO_AFRL_AF4_Pos                (16UL)                    /*!< AF4 (Bit 16)                                          */
#define GPIO_AFRL_AF4_Msk                (0xf0000UL)               /*!< AF4 (Bitfield-Mask: 0x0f)                             */
#define GPIO_AFRL_AF3_Pos                (12UL)                    /*!< AF3 (Bit 12)                                          */
#define GPIO_AFRL_AF3_Msk                (0xf000UL)                /*!< AF3 (Bitfield-Mask: 0x0f)                             */
#define GPIO_AFRL_AF2_Pos                (8UL)                     /*!< AF2 (Bit 8)                                           */
#define GPIO_AFRL_AF2_Msk                (0xf00UL)                 /*!< AF2 (Bitfield-Mask: 0x0f)                             */
#define GPIO_AFRL_AF1_Pos                (4UL)                     /*!< AF1 (Bit 4)                                           */
#define GPIO_AFRL_AF1_Msk                (0xf0UL)                  /*!< AF1 (Bitfield-Mask: 0x0f)                             */
#define GPIO_AFRL_AF0_Pos                (0UL)                     /*!< AF0 (Bit 0)                                           */
#define GPIO_AFRL_AF0_Msk                (0xfUL)                   /*!< AF0 (Bitfield-Mask: 0x0f)                             */
/* =========================================================  AFRH  ========================================================== */
#define GPIO_AFRH_AF15_Pos               (28UL)                    /*!< AF15 (Bit 28)                                         */
#define GPIO_AFRH_AF15_Msk               (0xf0000000UL)            /*!< AF15 (Bitfield-Mask: 0x0f)                            */
#define GPIO_AFRH_AF14_Pos               (24UL)                    /*!< AF14 (Bit 24)                                         */
#define GPIO_AFRH_AF14_Msk               (0xf000000UL)             /*!< AF14 (Bitfield-Mask: 0x0f)                            */
#define GPIO_AFRH_AF13_Pos               (20UL)                    /*!< AF13 (Bit 20)                                         */
#define GPIO_AFRH_AF13_Msk               (0xf00000UL)              /*!< AF13 (Bitfield-Mask: 0x0f)                            */
#define GPIO_AFRH_AF12_Pos               (16UL)                    /*!< AF12 (Bit 16)                                         */
#define GPIO_AFRH_AF12_Msk               (0xf0000UL)               /*!< AF12 (Bitfield-Mask: 0x0f)                            */
#define GPIO_AFRH_AF11_Pos               (12UL)                    /*!< AF11 (Bit 12)                                         */
#define GPIO_AFRH_AF11_Msk               (0xf000UL)                /*!< AF11 (Bitfield-Mask: 0x0f)                            */
#define GPIO_AFRH_AF10_Pos               (8UL)                     /*!< AF10 (Bit 8)                                          */
#define GPIO_AFRH_AF10_Msk               (0xf00UL)                 /*!< AF10 (Bitfield-Mask: 0x0f)                            */
#define GPIO_AFRH_AF9_Pos                (4UL)                     /*!< AF9 (Bit 4)                                           */
#define GPIO_AFRH_AF9_Msk                (0xf0UL)                  /*!< AF9 (Bitfield-Mask: 0x0f)                             */
#define GPIO_AFRH_AF8_Pos                (0UL)                     /*!< AF8 (Bit 0)                                           */
#define GPIO_AFRH_AF8_Msk                (0xfUL)                   /*!< AF8 (Bitfield-Mask: 0x0f)                             */
/* ==========================================================  BRR  ========================================================== */
#define GPIO_BRR_BR15_Pos                (15UL)                    /*!< BR15 (Bit 15)                                         */
#define GPIO_BRR_BR15_Msk                (0x8000UL)                /*!< BR15 (Bitfield-Mask: 0x01)                            */
#define GPIO_BRR_BR14_Pos                (14UL)                    /*!< BR14 (Bit 14)                                         */
#define GPIO_BRR_BR14_Msk                (0x4000UL)                /*!< BR14 (Bitfield-Mask: 0x01)                            */
#define GPIO_BRR_BR13_Pos                (13UL)                    /*!< BR13 (Bit 13)                                         */
#define GPIO_BRR_BR13_Msk                (0x2000UL)                /*!< BR13 (Bitfield-Mask: 0x01)                            */
#define GPIO_BRR_BR12_Pos                (12UL)                    /*!< BR12 (Bit 12)                                         */
#define GPIO_BRR_BR12_Msk                (0x1000UL)                /*!< BR12 (Bitfield-Mask: 0x01)                            */
#define GPIO_BRR_BR11_Pos                (11UL)                    /*!< BR11 (Bit 11)                                         */
#define GPIO_BRR_BR11_Msk                (0x800UL)                 /*!< BR11 (Bitfield-Mask: 0x01)                            */
#define GPIO_BRR_BR10_Pos                (10UL)                    /*!< BR10 (Bit 10)                                         */
#define GPIO_BRR_BR10_Msk                (0x400UL)                 /*!< BR10 (Bitfield-Mask: 0x01)                            */
#define GPIO_BRR_BR9_Pos                 (9UL)                     /*!< BR9 (Bit 9)                                           */
#define GPIO_BRR_BR9_Msk                 (0x200UL)                 /*!< BR9 (Bitfield-Mask: 0x01)                             */
#define GPIO_BRR_BR8_Pos                 (8UL)                     /*!< BR8 (Bit 8)                                           */
#define GPIO_BRR_BR8_Msk                 (0x100UL)                 /*!< BR8 (Bitfield-Mask: 0x01)                             */
#define GPIO_BRR_BR7_Pos                 (7UL)                     /*!< BR7 (Bit 7)                                           */
#define GPIO_BRR_BR7_Msk                 (0x80UL)                  /*!< BR7 (Bitfield-Mask: 0x01)                             */
#define GPIO_BRR_BR6_Pos                 (6UL)                     /*!< BR6 (Bit 6)                                           */
#define GPIO_BRR_BR6_Msk                 (0x40UL)                  /*!< BR6 (Bitfield-Mask: 0x01)                             */
#define GPIO_BRR_BR5_Pos                 (5UL)                     /*!< BR5 (Bit 5)                                           */
#define GPIO_BRR_BR5_Msk                 (0x20UL)                  /*!< BR5 (Bitfield-Mask: 0x01)                             */
#define GPIO_BRR_BR4_Pos                 (4UL)                     /*!< BR4 (Bit 4)                                           */
#define GPIO_BRR_BR4_Msk                 (0x10UL)                  /*!< BR4 (Bitfield-Mask: 0x01)                             */
#define GPIO_BRR_BR3_Pos                 (3UL)                     /*!< BR3 (Bit 3)                                           */
#define GPIO_BRR_BR3_Msk                 (0x8UL)                   /*!< BR3 (Bitfield-Mask: 0x01)                             */
#define GPIO_BRR_BR2_Pos                 (2UL)                     /*!< BR2 (Bit 2)                                           */
#define GPIO_BRR_BR2_Msk                 (0x4UL)                   /*!< BR2 (Bitfield-Mask: 0x01)                             */
#define GPIO_BRR_BR1_Pos                 (1UL)                     /*!< BR1 (Bit 1)                                           */
#define GPIO_BRR_BR1_Msk                 (0x2UL)                   /*!< BR1 (Bitfield-Mask: 0x01)                             */
#define GPIO_BRR_BR0_Pos                 (0UL)                     /*!< BR0 (Bit 0)                                           */
#define GPIO_BRR_BR0_Msk                 (0x1UL)                   /*!< BR0 (Bitfield-Mask: 0x01)                             */
/* ==========================================================  DFR  ========================================================== */
#define GPIO_DFR_DF15_Pos                (15UL)                    /*!< DF15 (Bit 15)                                         */
#define GPIO_DFR_DF15_Msk                (0x8000UL)                /*!< DF15 (Bitfield-Mask: 0x01)                            */
#define GPIO_DFR_DF14_Pos                (14UL)                    /*!< DF14 (Bit 14)                                         */
#define GPIO_DFR_DF14_Msk                (0x4000UL)                /*!< DF14 (Bitfield-Mask: 0x01)                            */
#define GPIO_DFR_DF13_Pos                (13UL)                    /*!< DF13 (Bit 13)                                         */
#define GPIO_DFR_DF13_Msk                (0x2000UL)                /*!< DF13 (Bitfield-Mask: 0x01)                            */
#define GPIO_DFR_DF12_Pos                (12UL)                    /*!< DF12 (Bit 12)                                         */
#define GPIO_DFR_DF12_Msk                (0x1000UL)                /*!< DF12 (Bitfield-Mask: 0x01)                            */
#define GPIO_DFR_DF11_Pos                (11UL)                    /*!< DF11 (Bit 11)                                         */
#define GPIO_DFR_DF11_Msk                (0x800UL)                 /*!< DF11 (Bitfield-Mask: 0x01)                            */
#define GPIO_DFR_DF10_Pos                (10UL)                    /*!< DF10 (Bit 10)                                         */
#define GPIO_DFR_DF10_Msk                (0x400UL)                 /*!< DF10 (Bitfield-Mask: 0x01)                            */
#define GPIO_DFR_DF9_Pos                 (9UL)                     /*!< DF9 (Bit 9)                                           */
#define GPIO_DFR_DF9_Msk                 (0x200UL)                 /*!< DF9 (Bitfield-Mask: 0x01)                             */
#define GPIO_DFR_DF8_Pos                 (8UL)                     /*!< DF8 (Bit 8)                                           */
#define GPIO_DFR_DF8_Msk                 (0x100UL)                 /*!< DF8 (Bitfield-Mask: 0x01)                             */
#define GPIO_DFR_DF7_Pos                 (7UL)                     /*!< DF7 (Bit 7)                                           */
#define GPIO_DFR_DF7_Msk                 (0x80UL)                  /*!< DF7 (Bitfield-Mask: 0x01)                             */
#define GPIO_DFR_DF6_Pos                 (6UL)                     /*!< DF6 (Bit 6)                                           */
#define GPIO_DFR_DF6_Msk                 (0x40UL)                  /*!< DF6 (Bitfield-Mask: 0x01)                             */
#define GPIO_DFR_DF5_Pos                 (5UL)                     /*!< DF5 (Bit 5)                                           */
#define GPIO_DFR_DF5_Msk                 (0x20UL)                  /*!< DF5 (Bitfield-Mask: 0x01)                             */
#define GPIO_DFR_DF4_Pos                 (4UL)                     /*!< DF4 (Bit 4)                                           */
#define GPIO_DFR_DF4_Msk                 (0x10UL)                  /*!< DF4 (Bitfield-Mask: 0x01)                             */
#define GPIO_DFR_DF3_Pos                 (3UL)                     /*!< DF3 (Bit 3)                                           */
#define GPIO_DFR_DF3_Msk                 (0x8UL)                   /*!< DF3 (Bitfield-Mask: 0x01)                             */
#define GPIO_DFR_DF2_Pos                 (2UL)                     /*!< DF2 (Bit 2)                                           */
#define GPIO_DFR_DF2_Msk                 (0x4UL)                   /*!< DF2 (Bitfield-Mask: 0x01)                             */
#define GPIO_DFR_DF1_Pos                 (1UL)                     /*!< DF1 (Bit 1)                                           */
#define GPIO_DFR_DF1_Msk                 (0x2UL)                   /*!< DF1 (Bitfield-Mask: 0x01)                             */
#define GPIO_DFR_DF0_Pos                 (0UL)                     /*!< DF0 (Bit 0)                                           */
#define GPIO_DFR_DF0_Msk                 (0x1UL)                   /*!< DF0 (Bitfield-Mask: 0x01)                             */
/* ==========================================================  ASR  ========================================================== */
#define GPIO_ASR_AS15_Pos                (15UL)                    /*!< AS15 (Bit 15)                                         */
#define GPIO_ASR_AS15_Msk                (0x8000UL)                /*!< AS15 (Bitfield-Mask: 0x01)                            */
#define GPIO_ASR_AS14_Pos                (14UL)                    /*!< AS14 (Bit 14)                                         */
#define GPIO_ASR_AS14_Msk                (0x4000UL)                /*!< AS14 (Bitfield-Mask: 0x01)                            */
#define GPIO_ASR_AS13_Pos                (13UL)                    /*!< AS13 (Bit 13)                                         */
#define GPIO_ASR_AS13_Msk                (0x2000UL)                /*!< AS13 (Bitfield-Mask: 0x01)                            */
#define GPIO_ASR_AS12_Pos                (12UL)                    /*!< AS12 (Bit 12)                                         */
#define GPIO_ASR_AS12_Msk                (0x1000UL)                /*!< AS12 (Bitfield-Mask: 0x01)                            */
#define GPIO_ASR_AS11_Pos                (11UL)                    /*!< AS11 (Bit 11)                                         */
#define GPIO_ASR_AS11_Msk                (0x800UL)                 /*!< AS11 (Bitfield-Mask: 0x01)                            */
#define GPIO_ASR_AS10_Pos                (10UL)                    /*!< AS10 (Bit 10)                                         */
#define GPIO_ASR_AS10_Msk                (0x400UL)                 /*!< AS10 (Bitfield-Mask: 0x01)                            */
#define GPIO_ASR_AS9_Pos                 (9UL)                     /*!< AS9 (Bit 9)                                           */
#define GPIO_ASR_AS9_Msk                 (0x200UL)                 /*!< AS9 (Bitfield-Mask: 0x01)                             */
#define GPIO_ASR_AS8_Pos                 (8UL)                     /*!< AS8 (Bit 8)                                           */
#define GPIO_ASR_AS8_Msk                 (0x100UL)                 /*!< AS8 (Bitfield-Mask: 0x01)                             */
#define GPIO_ASR_AS7_Pos                 (7UL)                     /*!< AS7 (Bit 7)                                           */
#define GPIO_ASR_AS7_Msk                 (0x80UL)                  /*!< AS7 (Bitfield-Mask: 0x01)                             */
#define GPIO_ASR_AS6_Pos                 (6UL)                     /*!< AS6 (Bit 6)                                           */
#define GPIO_ASR_AS6_Msk                 (0x40UL)                  /*!< AS6 (Bitfield-Mask: 0x01)                             */
#define GPIO_ASR_AS5_Pos                 (5UL)                     /*!< AS5 (Bit 5)                                           */
#define GPIO_ASR_AS5_Msk                 (0x20UL)                  /*!< AS5 (Bitfield-Mask: 0x01)                             */
#define GPIO_ASR_AS4_Pos                 (4UL)                     /*!< AS4 (Bit 4)                                           */
#define GPIO_ASR_AS4_Msk                 (0x10UL)                  /*!< AS4 (Bitfield-Mask: 0x01)                             */
#define GPIO_ASR_AS3_Pos                 (3UL)                     /*!< AS3 (Bit 3)                                           */
#define GPIO_ASR_AS3_Msk                 (0x8UL)                   /*!< AS3 (Bitfield-Mask: 0x01)                             */
#define GPIO_ASR_AS2_Pos                 (2UL)                     /*!< AS2 (Bit 2)                                           */
#define GPIO_ASR_AS2_Msk                 (0x4UL)                   /*!< AS2 (Bitfield-Mask: 0x01)                             */
#define GPIO_ASR_AS1_Pos                 (1UL)                     /*!< AS1 (Bit 1)                                           */
#define GPIO_ASR_AS1_Msk                 (0x2UL)                   /*!< AS1 (Bitfield-Mask: 0x01)                             */
#define GPIO_ASR_AS0_Pos                 (0UL)                     /*!< AS0 (Bit 0)                                           */
#define GPIO_ASR_AS0_Msk                 (0x1UL)                   /*!< AS0 (Bitfield-Mask: 0x01)                             */
/* ==========================================================  CSR  ========================================================== */
#define GPIO_CSR_CS15_Pos                (15UL)                    /*!< CS15 (Bit 15)                                         */
#define GPIO_CSR_CS15_Msk                (0x8000UL)                /*!< CS15 (Bitfield-Mask: 0x01)                            */
#define GPIO_CSR_CS14_Pos                (14UL)                    /*!< CS14 (Bit 14)                                         */
#define GPIO_CSR_CS14_Msk                (0x4000UL)                /*!< CS14 (Bitfield-Mask: 0x01)                            */
#define GPIO_CSR_CS13_Pos                (13UL)                    /*!< CS13 (Bit 13)                                         */
#define GPIO_CSR_CS13_Msk                (0x2000UL)                /*!< CS13 (Bitfield-Mask: 0x01)                            */
#define GPIO_CSR_CS12_Pos                (12UL)                    /*!< CS12 (Bit 12)                                         */
#define GPIO_CSR_CS12_Msk                (0x1000UL)                /*!< CS12 (Bitfield-Mask: 0x01)                            */
#define GPIO_CSR_CS11_Pos                (11UL)                    /*!< CS11 (Bit 11)                                         */
#define GPIO_CSR_CS11_Msk                (0x800UL)                 /*!< CS11 (Bitfield-Mask: 0x01)                            */
#define GPIO_CSR_CS10_Pos                (10UL)                    /*!< CS10 (Bit 10)                                         */
#define GPIO_CSR_CS10_Msk                (0x400UL)                 /*!< CS10 (Bitfield-Mask: 0x01)                            */
#define GPIO_CSR_CS9_Pos                 (9UL)                     /*!< CS9 (Bit 9)                                           */
#define GPIO_CSR_CS9_Msk                 (0x200UL)                 /*!< CS9 (Bitfield-Mask: 0x01)                             */
#define GPIO_CSR_CS8_Pos                 (8UL)                     /*!< CS8 (Bit 8)                                           */
#define GPIO_CSR_CS8_Msk                 (0x100UL)                 /*!< CS8 (Bitfield-Mask: 0x01)                             */
#define GPIO_CSR_CS7_Pos                 (7UL)                     /*!< CS7 (Bit 7)                                           */
#define GPIO_CSR_CS7_Msk                 (0x80UL)                  /*!< CS7 (Bitfield-Mask: 0x01)                             */
#define GPIO_CSR_CS6_Pos                 (6UL)                     /*!< CS6 (Bit 6)                                           */
#define GPIO_CSR_CS6_Msk                 (0x40UL)                  /*!< CS6 (Bitfield-Mask: 0x01)                             */
#define GPIO_CSR_CS5_Pos                 (5UL)                     /*!< CS5 (Bit 5)                                           */
#define GPIO_CSR_CS5_Msk                 (0x20UL)                  /*!< CS5 (Bitfield-Mask: 0x01)                             */
#define GPIO_CSR_CS4_Pos                 (4UL)                     /*!< CS4 (Bit 4)                                           */
#define GPIO_CSR_CS4_Msk                 (0x10UL)                  /*!< CS4 (Bitfield-Mask: 0x01)                             */
#define GPIO_CSR_CS3_Pos                 (3UL)                     /*!< CS3 (Bit 3)                                           */
#define GPIO_CSR_CS3_Msk                 (0x8UL)                   /*!< CS3 (Bitfield-Mask: 0x01)                             */
#define GPIO_CSR_CS2_Pos                 (2UL)                     /*!< CS2 (Bit 2)                                           */
#define GPIO_CSR_CS2_Msk                 (0x4UL)                   /*!< CS2 (Bitfield-Mask: 0x01)                             */
#define GPIO_CSR_CS1_Pos                 (1UL)                     /*!< CS1 (Bit 1)                                           */
#define GPIO_CSR_CS1_Msk                 (0x2UL)                   /*!< CS1 (Bitfield-Mask: 0x01)                             */
#define GPIO_CSR_CS0_Pos                 (0UL)                     /*!< CS0 (Bit 0)                                           */
#define GPIO_CSR_CS0_Msk                 (0x1UL)                   /*!< CS0 (Bitfield-Mask: 0x01)                             */


/* =========================================================================================================================== */
/* ================                                            AES                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  CR  =========================================================== */
#define AES_CR_ENMASK_Pos                 (24UL)                    /*!< ENMASK (Bit 24)                                       */
#define AES_CR_ENMASK_Msk                 (0x1000000UL)             /*!< ENMASK (Bitfield-Mask: 0x01)                          */
#define AES_CR_NPBLB_Pos                  (20UL)                    /*!< NPBLB (Bit 20)                                        */
#define AES_CR_NPBLB_Msk                  (0xf00000UL)              /*!< NPBLB (Bitfield-Mask: 0x0f)                           */
#define AES_CR_KEYSIZE_Pos                (18UL)                    /*!< KEYSIZE (Bit 18)                                      */
#define AES_CR_KEYSIZE_Msk                (0xc0000UL)               /*!< KEYSIZE (Bitfield-Mask: 0x03)                         */
#define AES_CR_CCFC_Pos                   (15UL)                    /*!< CCFC (Bit 15)                                         */
#define AES_CR_CCFC_Msk                   (0x8000UL)                /*!< CCFC (Bitfield-Mask: 0x01)                            */
#define AES_CR_ODATSWAP_Pos               (14UL)                    /*!< ODATSWAP (Bit 14)                                     */
#define AES_CR_ODATSWAP_Msk               (0x4000UL)                /*!< ODATSWAP (Bitfield-Mask: 0x01)                        */
#define AES_CR_IDATSWAP_Pos               (13UL)                    /*!< IDATSWAP (Bit 13)                                     */
#define AES_CR_IDATSWAP_Msk               (0x2000UL)                /*!< IDATSWAP (Bitfield-Mask: 0x01)                        */
#define AES_CR_DMAOUTEN_Pos               (12UL)                    /*!< DMAOUTEN (Bit 12)                                     */
#define AES_CR_DMAOUTEN_Msk               (0x1000UL)                /*!< DMAOUTEN (Bitfield-Mask: 0x01)                        */
#define AES_CR_DMAINEN_Pos                (11UL)                    /*!< DMAINEN (Bit 11)                                      */
#define AES_CR_DMAINEN_Msk                (0x800UL)                 /*!< DMAINEN (Bitfield-Mask: 0x01)                         */
#define AES_CR_ERRIE_Pos                  (10UL)                    /*!< ERRIE (Bit 10)                                        */
#define AES_CR_ERRIE_Msk                  (0x400UL)                 /*!< ERRIE (Bitfield-Mask: 0x01)                           */
#define AES_CR_CCFIE_Pos                  (9UL)                     /*!< CCFIE (Bit 9)                                         */
#define AES_CR_CCFIE_Msk                  (0x200UL)                 /*!< CCFIE (Bitfield-Mask: 0x01)                           */
#define AES_CR_ERRC_Pos                   (8UL)                     /*!< ERRC (Bit 8)                                          */
#define AES_CR_ERRC_Msk                   (0x100UL)                 /*!< ERRC (Bitfield-Mask: 0x01)                            */
#define AES_CR_CHMOD_Pos                  (5UL)                     /*!< CHMOD (Bit 5)                                         */
#define AES_CR_CHMOD_Msk                  (0xe0UL)                  /*!< CHMOD (Bitfield-Mask: 0x07)                           */
#define AES_CR_MODE_Pos                   (3UL)                     /*!< MODE (Bit 3)                                          */
#define AES_CR_MODE_Msk                   (0x8UL)                   /*!< MODE (Bitfield-Mask: 0x01)                            */
#define AES_CR_DATATYPE_Pos               (1UL)                     /*!< DATATYPE (Bit 1)                                      */
#define AES_CR_DATATYPE_Msk               (0x6UL)                   /*!< DATATYPE (Bitfield-Mask: 0x03)                        */
#define AES_CR_EN_Pos                     (0UL)                     /*!< EN (Bit 0)                                            */
#define AES_CR_EN_Msk                     (0x1UL)                   /*!< EN (Bitfield-Mask: 0x01)                              */
/* ==========================================================  SR  =========================================================== */
#define AES_SR_BUSY_Pos                   (3UL)                     /*!< BUSY (Bit 3)                                          */
#define AES_SR_BUSY_Msk                   (0x8UL)                   /*!< BUSY (Bitfield-Mask: 0x01)                            */
#define AES_SR_WRERR_Pos                  (2UL)                     /*!< WRERR (Bit 2)                                         */
#define AES_SR_WRERR_Msk                  (0x4UL)                   /*!< WRERR (Bitfield-Mask: 0x01)                           */
#define AES_SR_RDERR_Pos                  (1UL)                     /*!< RDERR (Bit 1)                                         */
#define AES_SR_RDERR_Msk                  (0x2UL)                   /*!< RDERR (Bitfield-Mask: 0x01)                           */
#define AES_SR_CCF_Pos                    (0UL)                     /*!< CCF (Bit 0)                                           */
#define AES_SR_CCF_Msk                    (0x1UL)                   /*!< CCF (Bitfield-Mask: 0x01)                             */
/* =========================================================  DINR  ========================================================== */
#define AES_DINR_DIN_Pos                  (0UL)                     /*!< DIN (Bit 0)                                           */
#define AES_DINR_DIN_Msk                  (0xffffffffUL)            /*!< DIN (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  DOUT  ========================================================== */
#define AES_DOUT_DOUT_Pos                 (0UL)                     /*!< DOUT (Bit 0)                                          */
#define AES_DOUT_DOUT_Msk                 (0xffffffffUL)            /*!< DOUT (Bitfield-Mask: 0xffffffff)                      */
/* =========================================================  KEY0  ========================================================== */
#define AES_KEY0_KEY0_Pos                 (0UL)                     /*!< KEY0 (Bit 0)                                          */
#define AES_KEY0_KEY0_Msk                 (0xffffffffUL)            /*!< KEY0 (Bitfield-Mask: 0xffffffff)                      */
/* =========================================================  KEY1  ========================================================== */
#define AES_KEY1_KEY1_Pos                 (0UL)                     /*!< KEY1 (Bit 0)                                          */
#define AES_KEY1_KEY1_Msk                 (0xffffffffUL)            /*!< KEY1 (Bitfield-Mask: 0xffffffff)                      */
/* =========================================================  KEY2  ========================================================== */
#define AES_KEY2_KEY2_Pos                 (0UL)                     /*!< KEY2 (Bit 0)                                          */
#define AES_KEY2_KEY2_Msk                 (0xffffffffUL)            /*!< KEY2 (Bitfield-Mask: 0xffffffff)                      */
/* =========================================================  KEY3  ========================================================== */
#define AES_KEY3_KEY3_Pos                 (0UL)                     /*!< KEY3 (Bit 0)                                          */
#define AES_KEY3_KEY3_Msk                 (0xffffffffUL)            /*!< KEY3 (Bitfield-Mask: 0xffffffff)                      */
/* =========================================================  IVR0  ========================================================== */
#define AES_IVR0_IV0_Pos                  (0UL)                     /*!< IV0 (Bit 0)                                           */
#define AES_IVR0_IV0_Msk                  (0xffffffffUL)            /*!< IV0 (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  IVR1  ========================================================== */
#define AES_IVR1_IV1_Pos                  (0UL)                     /*!< IV1 (Bit 0)                                           */
#define AES_IVR1_IV1_Msk                  (0xffffffffUL)            /*!< IV1 (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  IVR2  ========================================================== */
#define AES_IVR2_IV2_Pos                  (0UL)                     /*!< IV2 (Bit 0)                                           */
#define AES_IVR2_IV2_Msk                  (0xffffffffUL)            /*!< IV2 (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  IVR3  ========================================================== */
#define AES_IVR3_IV3_Pos                  (0UL)                     /*!< IV3 (Bit 0)                                           */
#define AES_IVR3_IV3_Msk                  (0xffffffffUL)            /*!< IV3 (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  KEY4  ========================================================== */
#define AES_KEY4_KEY4_Pos                 (0UL)                     /*!< KEY4 (Bit 0)                                          */
#define AES_KEY4_KEY4_Msk                 (0xffffffffUL)            /*!< KEY4 (Bitfield-Mask: 0xffffffff)                      */
/* =========================================================  KEY5  ========================================================== */
#define AES_KEY5_KEY5_Pos                 (0UL)                     /*!< KEY5 (Bit 0)                                          */
#define AES_KEY5_KEY5_Msk                 (0xffffffffUL)            /*!< KEY5 (Bitfield-Mask: 0xffffffff)                      */
/* =========================================================  KEY6  ========================================================== */
#define AES_KEY6_KEY6_Pos                 (0UL)                     /*!< KEY6 (Bit 0)                                          */
#define AES_KEY6_KEY6_Msk                 (0xffffffffUL)            /*!< KEY6 (Bitfield-Mask: 0xffffffff)                      */
/* =========================================================  KEY7  ========================================================== */
#define AES_KEY7_KEY7_Pos                 (0UL)                     /*!< KEY7 (Bit 0)                                          */
#define AES_KEY7_KEY7_Msk                 (0xffffffffUL)            /*!< KEY7 (Bitfield-Mask: 0xffffffff)                      */


/* =========================================================================================================================== */
/* ================                                           HASH                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  CR0  ========================================================== */
#define HASH_CR0_ALGSEL_Pos               (5UL)                     /*!< ALGSEL (Bit 5)                                        */
#define HASH_CR0_ALGSEL_Msk               (0x60UL)                  /*!< ALGSEL (Bitfield-Mask: 0x03)                          */
#define HASH_CR0_BURST_Pos                (4UL)                     /*!< BURST (Bit 4)                                         */
#define HASH_CR0_BURST_Msk                (0x10UL)                  /*!< BURST (Bitfield-Mask: 0x01)                           */
#define HASH_CR0_DATATYPESEL_Pos          (2UL)                     /*!< DATATYPESEL (Bit 2)                                   */
#define HASH_CR0_DATATYPESEL_Msk          (0xcUL)                   /*!< DATATYPESEL (Bitfield-Mask: 0x03)                     */
#define HASH_CR0_DMAEN_Pos                (1UL)                     /*!< DMAEN (Bit 1)                                         */
#define HASH_CR0_DMAEN_Msk                (0x2UL)                   /*!< DMAEN (Bitfield-Mask: 0x01)                           */
#define HASH_CR0_INIT_Pos                 (0UL)                     /*!< INIT (Bit 0)                                          */
#define HASH_CR0_INIT_Msk                 (0x1UL)                   /*!< INIT (Bitfield-Mask: 0x01)                            */
/* ==========================================================  DIN  ========================================================== */
#define HASH_DIN_DIN_Pos                  (0UL)                     /*!< DIN (Bit 0)                                           */
#define HASH_DIN_DIN_Msk                  (0xffffffffUL)            /*!< DIN (Bitfield-Mask: 0xffffffff)                       */
/* ==========================================================  STR  ========================================================== */
#define HASH_STR_DIGCAL_Pos               (15UL)                    /*!< DIGCAL (Bit 15)                                       */
#define HASH_STR_DIGCAL_Msk               (0x8000UL)                /*!< DIGCAL (Bitfield-Mask: 0x01)                          */
#define HASH_STR_BITNUMLW_Pos             (0UL)                     /*!< BITNUMLW (Bit 0)                                      */
#define HASH_STR_BITNUMLW_Msk             (0x1fUL)                  /*!< BITNUMLW (Bitfield-Mask: 0x1f)                        */
/* ==========================================================  H0  =========================================================== */
#define HASH_H0_DR0_Pos                   (0UL)                     /*!< DR0 (Bit 0)                                           */
#define HASH_H0_DR0_Msk                   (0xffffffffUL)            /*!< DR0 (Bitfield-Mask: 0xffffffff)                       */
/* ==========================================================  H1  =========================================================== */
#define HASH_H1_DR1_Pos                   (0UL)                     /*!< DR1 (Bit 0)                                           */
#define HASH_H1_DR1_Msk                   (0xffffffffUL)            /*!< DR1 (Bitfield-Mask: 0xffffffff)                       */
/* ==========================================================  H2  =========================================================== */
#define HASH_H2_DR2_Pos                   (0UL)                     /*!< DR2 (Bit 0)                                           */
#define HASH_H2_DR2_Msk                   (0xffffffffUL)            /*!< DR2 (Bitfield-Mask: 0xffffffff)                       */
/* ==========================================================  H3  =========================================================== */
#define HASH_H3_DR3_Pos                   (0UL)                     /*!< DR3 (Bit 0)                                           */
#define HASH_H3_DR3_Msk                   (0xffffffffUL)            /*!< DR3 (Bitfield-Mask: 0xffffffff)                       */
/* ==========================================================  H4  =========================================================== */
#define HASH_H4_DR4_Pos                   (0UL)                     /*!< DR4 (Bit 0)                                           */
#define HASH_H4_DR4_Msk                   (0xffffffffUL)            /*!< DR4 (Bitfield-Mask: 0xffffffff)                       */
/* ==========================================================  H5  =========================================================== */
#define HASH_H5_DR5_Pos                   (0UL)                     /*!< DR5 (Bit 0)                                           */
#define HASH_H5_DR5_Msk                   (0xffffffffUL)            /*!< DR5 (Bitfield-Mask: 0xffffffff)                       */
/* ==========================================================  H6  =========================================================== */
#define HASH_H6_DR6_Pos                   (0UL)                     /*!< DR6 (Bit 0)                                           */
#define HASH_H6_DR6_Msk                   (0xffffffffUL)            /*!< DR6 (Bitfield-Mask: 0xffffffff)                       */
/* ==========================================================  H7  =========================================================== */
#define HASH_H7_DR7_Pos                   (0UL)                     /*!< DR7 (Bit 0)                                           */
#define HASH_H7_DR7_Msk                   (0xffffffffUL)            /*!< DR7 (Bitfield-Mask: 0xffffffff)                       */
/* ==========================================================  IMR  ========================================================== */
#define HASH_IMR_DIGCALIE_Pos             (1UL)                     /*!< DIGCALIE (Bit 1)                                      */
#define HASH_IMR_DIGCALIE_Msk             (0x2UL)                   /*!< DIGCALIE (Bitfield-Mask: 0x01)                        */
#define HASH_IMR_DATAINIE_Pos             (0UL)                     /*!< DATAINIE (Bit 0)                                      */
#define HASH_IMR_DATAINIE_Msk             (0x1UL)                   /*!< DATAINIE (Bitfield-Mask: 0x01)                        */
/* ==========================================================  SR  =========================================================== */
#define HASH_SR_WORDNUM_Pos               (5UL)                     /*!< WORDNUM (Bit 5)                                       */
#define HASH_SR_WORDNUM_Msk               (0x1e0UL)                 /*!< WORDNUM (Bitfield-Mask: 0x0f)                         */
#define HASH_SR_DINNE_Pos                 (4UL)                     /*!< DINNE (Bit 4)                                         */
#define HASH_SR_DINNE_Msk                 (0x10UL)                  /*!< DINNE (Bitfield-Mask: 0x01)                           */
#define HASH_SR_BUSY_Pos                  (3UL)                     /*!< BUSY (Bit 3)                                          */
#define HASH_SR_BUSY_Msk                  (0x8UL)                   /*!< BUSY (Bitfield-Mask: 0x01)                            */
#define HASH_SR_DIGCALSTAT_Pos            (1UL)                     /*!< DIGCALSTAT (Bit 1)                                    */
#define HASH_SR_DIGCALSTAT_Msk            (0x2UL)                   /*!< DIGCALSTAT (Bitfield-Mask: 0x01)                      */
#define HASH_SR_DATAINSTAT_Pos            (0UL)                     /*!< DATAINSTAT (Bit 0)                                    */
#define HASH_SR_DATAINSTAT_Msk            (0x1UL)                   /*!< DATAINSTAT (Bitfield-Mask: 0x01)                      */
/* ==========================================================  CR1  ========================================================== */
#define HASH_CR1_DMAPADEN_Pos             (31UL)                    /*!< DMAPADEN (Bit 31)                                     */
#define HASH_CR1_DMAPADEN_Msk             (0x80000000UL)            /*!< DMAPADEN (Bitfield-Mask: 0x01)                        */
#define HASH_CR1_DMADINLEN_Pos            (0UL)                     /*!< DMADINLEN (Bit 0)                                     */
#define HASH_CR1_DMADINLEN_Msk            (0x7fffffffUL)            /*!< DMADINLEN (Bitfield-Mask: 0x7fffffff)                 */


/* =========================================================================================================================== */
/* ================                                            ADC                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  ISR  ========================================================== */
#define ADC_ISR_AWDHFG_Pos                (31UL)                    /*!< AWDHFG (Bit 31)                                       */
#define ADC_ISR_AWDHFG_Msk                (0x80000000UL)            /*!< AWDHFG (Bitfield-Mask: 0x01)                          */
#define ADC_ISR_AWDLFG_Pos                (30UL)                    /*!< AWDLFG (Bit 30)                                       */
#define ADC_ISR_AWDLFG_Msk                (0x40000000UL)            /*!< AWDLFG (Bitfield-Mask: 0x01)                          */
#define ADC_ISR_AWD_Pos                   (5UL)                     /*!< AWD (Bit 5)                                           */
#define ADC_ISR_AWD_Msk                   (0x20UL)                  /*!< AWD (Bitfield-Mask: 0x01)                             */
#define ADC_ISR_OVR_Pos                   (4UL)                     /*!< OVR (Bit 4)                                           */
#define ADC_ISR_OVR_Msk                   (0x10UL)                  /*!< OVR (Bitfield-Mask: 0x01)                             */
#define ADC_ISR_EOS_Pos                   (3UL)                     /*!< EOS (Bit 3)                                           */
#define ADC_ISR_EOS_Msk                   (0x8UL)                   /*!< EOS (Bitfield-Mask: 0x01)                             */
#define ADC_ISR_EOC_Pos                   (2UL)                     /*!< EOC (Bit 2)                                           */
#define ADC_ISR_EOC_Msk                   (0x4UL)                   /*!< EOC (Bitfield-Mask: 0x01)                             */
#define ADC_ISR_EOSMP_Pos                 (1UL)                     /*!< EOSMP (Bit 1)                                         */
#define ADC_ISR_EOSMP_Msk                 (0x2UL)                   /*!< EOSMP (Bitfield-Mask: 0x01)                           */
#define ADC_ISR_ADRDY_Pos                 (0UL)                     /*!< ADRDY (Bit 0)                                         */
#define ADC_ISR_ADRDY_Msk                 (0x1UL)                   /*!< ADRDY (Bitfield-Mask: 0x01)                           */
/* ==========================================================  IER  ========================================================== */
#define ADC_IER_AWDIE_Pos                 (5UL)                     /*!< AWDIE (Bit 5)                                         */
#define ADC_IER_AWDIE_Msk                 (0x20UL)                  /*!< AWDIE (Bitfield-Mask: 0x01)                           */
#define ADC_IER_OVRIE_Pos                 (4UL)                     /*!< OVRIE (Bit 4)                                         */
#define ADC_IER_OVRIE_Msk                 (0x10UL)                  /*!< OVRIE (Bitfield-Mask: 0x01)                           */
#define ADC_IER_EOSIE_Pos                 (3UL)                     /*!< EOSIE (Bit 3)                                         */
#define ADC_IER_EOSIE_Msk                 (0x8UL)                   /*!< EOSIE (Bitfield-Mask: 0x01)                           */
#define ADC_IER_EOCIE_Pos                 (2UL)                     /*!< EOCIE (Bit 2)                                         */
#define ADC_IER_EOCIE_Msk                 (0x4UL)                   /*!< EOCIE (Bitfield-Mask: 0x01)                           */
#define ADC_IER_EOSMPIE_Pos               (1UL)                     /*!< EOSMPIE (Bit 1)                                       */
#define ADC_IER_EOSMPIE_Msk               (0x2UL)                   /*!< EOSMPIE (Bitfield-Mask: 0x01)                         */
#define ADC_IER_ADRDYIE_Pos               (0UL)                     /*!< ADRDYIE (Bit 0)                                       */
#define ADC_IER_ADRDYIE_Msk               (0x1UL)                   /*!< ADRDYIE (Bitfield-Mask: 0x01)                         */
/* ==========================================================  CR  =========================================================== */
#define ADC_CR_OSADCALI_Pos               (31UL)                    /*!< OSADCALI (Bit 31)                                     */
#define ADC_CR_OSADCALI_Msk               (0x80000000UL)            /*!< OSADCALI (Bitfield-Mask: 0x01)                        */
#define ADC_CR_GAINADCALI_Pos             (30UL)                    /*!< GAINADCALI (Bit 30)                                   */
#define ADC_CR_GAINADCALI_Msk             (0x40000000UL)            /*!< GAINADCALI (Bitfield-Mask: 0x01)                      */
#define ADC_CR_ADCALIDIF_Pos              (29UL)                    /*!< ADCALIDIF (Bit 29)                                    */
#define ADC_CR_ADCALIDIF_Msk              (0x20000000UL)            /*!< ADCALIDIF (Bitfield-Mask: 0x01)                       */
#define ADC_CR_BOOSTEN_Pos                (8UL)                     /*!< BOOSTEN (Bit 8)                                       */
#define ADC_CR_BOOSTEN_Msk                (0x100UL)                 /*!< BOOSTEN (Bitfield-Mask: 0x01)                         */
#define ADC_CR_ADSTOP_Pos                 (3UL)                     /*!< ADSTOP (Bit 3)                                        */
#define ADC_CR_ADSTOP_Msk                 (0x8UL)                   /*!< ADSTOP (Bitfield-Mask: 0x01)                          */
#define ADC_CR_ADSTART_Pos                (2UL)                     /*!< ADSTART (Bit 2)                                       */
#define ADC_CR_ADSTART_Msk                (0x4UL)                   /*!< ADSTART (Bitfield-Mask: 0x01)                         */
#define ADC_CR_ADDIS_Pos                  (1UL)                     /*!< ADDIS (Bit 1)                                         */
#define ADC_CR_ADDIS_Msk                  (0x2UL)                   /*!< ADDIS (Bitfield-Mask: 0x01)                           */
#define ADC_CR_ADCEN_Pos                  (0UL)                     /*!< ADCEN (Bit 0)                                         */
#define ADC_CR_ADCEN_Msk                  (0x1UL)                   /*!< ADCEN (Bitfield-Mask: 0x01)                           */
/* =========================================================  CFGR  ========================================================== */
#define ADC_CFGR_DISCNUM_Pos              (18UL)                    /*!< DISCNUM (Bit 18)                                      */
#define ADC_CFGR_DISCNUM_Msk              (0x1c0000UL)              /*!< DISCNUM (Bitfield-Mask: 0x07)                         */
#define ADC_CFGR_DISCEN_Pos               (17UL)                    /*!< DISCEN (Bit 17)                                       */
#define ADC_CFGR_DISCEN_Msk               (0x20000UL)               /*!< DISCEN (Bitfield-Mask: 0x01)                          */
#define ADC_CFGR_ALIGN_Pos                (16UL)                    /*!< ALIGN (Bit 16)                                        */
#define ADC_CFGR_ALIGN_Msk                (0x10000UL)               /*!< ALIGN (Bitfield-Mask: 0x01)                           */
#define ADC_CFGR_AUTOOFF_Pos              (15UL)                    /*!< AUTOOFF (Bit 15)                                      */
#define ADC_CFGR_AUTOOFF_Msk              (0x8000UL)                /*!< AUTOOFF (Bitfield-Mask: 0x01)                         */
#define ADC_CFGR_AUTODLY_Pos              (14UL)                    /*!< AUTODLY (Bit 14)                                      */
#define ADC_CFGR_AUTODLY_Msk              (0x4000UL)                /*!< AUTODLY (Bitfield-Mask: 0x01)                         */
#define ADC_CFGR_CONT_Pos                 (13UL)                    /*!< CONT (Bit 13)                                         */
#define ADC_CFGR_CONT_Msk                 (0x2000UL)                /*!< CONT (Bitfield-Mask: 0x01)                            */
#define ADC_CFGR_OVRMOD_Pos               (12UL)                    /*!< OVRMOD (Bit 12)                                       */
#define ADC_CFGR_OVRMOD_Msk               (0x1000UL)                /*!< OVRMOD (Bitfield-Mask: 0x01)                          */
#define ADC_CFGR_EXTEN_Pos                (10UL)                    /*!< EXTEN (Bit 10)                                        */
#define ADC_CFGR_EXTEN_Msk                (0xc00UL)                 /*!< EXTEN (Bitfield-Mask: 0x03)                           */
#define ADC_CFGR_EXTSEL_Pos               (5UL)                     /*!< EXTSEL (Bit 5)                                        */
#define ADC_CFGR_EXTSEL_Msk               (0x3e0UL)                 /*!< EXTSEL (Bitfield-Mask: 0x1f)                          */
#define ADC_CFGR_RES_Pos                  (3UL)                     /*!< RES (Bit 3)                                           */
#define ADC_CFGR_RES_Msk                  (0x18UL)                  /*!< RES (Bitfield-Mask: 0x03)                             */
#define ADC_CFGR_DMAEN_Pos                (0UL)                     /*!< DMAEN (Bit 0)                                         */
#define ADC_CFGR_DMAEN_Msk                (0x1UL)                   /*!< DMAEN (Bitfield-Mask: 0x01)                           */
/* =========================================================  CFGR2  ========================================================= */
#define ADC_CFGR2_SMPPLUS_Pos             (18UL)                    /*!< SMPPLUS (Bit 18)                                      */
#define ADC_CFGR2_SMPPLUS_Msk             (0x40000UL)               /*!< SMPPLUS (Bitfield-Mask: 0x01)                         */
#define ADC_CFGR2_OVSMPTEN_Pos            (9UL)                     /*!< OVSMPTEN (Bit 9)                                      */
#define ADC_CFGR2_OVSMPTEN_Msk            (0x200UL)                 /*!< OVSMPTEN (Bitfield-Mask: 0x01)                        */
#define ADC_CFGR2_OVSS_Pos                (5UL)                     /*!< OVSS (Bit 5)                                          */
#define ADC_CFGR2_OVSS_Msk                (0x1e0UL)                 /*!< OVSS (Bitfield-Mask: 0x0f)                            */
#define ADC_CFGR2_OVSR_Pos                (1UL)                     /*!< OVSR (Bit 1)                                          */
#define ADC_CFGR2_OVSR_Msk                (0xeUL)                   /*!< OVSR (Bitfield-Mask: 0x07)                            */
#define ADC_CFGR2_OVSMPEN_Pos             (0UL)                     /*!< OVSMPEN (Bit 0)                                       */
#define ADC_CFGR2_OVSMPEN_Msk             (0x1UL)                   /*!< OVSMPEN (Bitfield-Mask: 0x01)                         */
/* =========================================================  SMPR1  ========================================================= */
#define ADC_SMPR1_SMP9_Pos                (27UL)                    /*!< SMP9 (Bit 27)                                         */
#define ADC_SMPR1_SMP9_Msk                (0x38000000UL)            /*!< SMP9 (Bitfield-Mask: 0x07)                            */
#define ADC_SMPR1_SMP8_Pos                (24UL)                    /*!< SMP8 (Bit 24)                                         */
#define ADC_SMPR1_SMP8_Msk                (0x7000000UL)             /*!< SMP8 (Bitfield-Mask: 0x07)                            */
#define ADC_SMPR1_SMP7_Pos                (21UL)                    /*!< SMP7 (Bit 21)                                         */
#define ADC_SMPR1_SMP7_Msk                (0xe00000UL)              /*!< SMP7 (Bitfield-Mask: 0x07)                            */
#define ADC_SMPR1_SMP6_Pos                (18UL)                    /*!< SMP6 (Bit 18)                                         */
#define ADC_SMPR1_SMP6_Msk                (0x1c0000UL)              /*!< SMP6 (Bitfield-Mask: 0x07)                            */
#define ADC_SMPR1_SMP5_Pos                (15UL)                    /*!< SMP5 (Bit 15)                                         */
#define ADC_SMPR1_SMP5_Msk                (0x38000UL)               /*!< SMP5 (Bitfield-Mask: 0x07)                            */
#define ADC_SMPR1_SMP4_Pos                (12UL)                    /*!< SMP4 (Bit 12)                                         */
#define ADC_SMPR1_SMP4_Msk                (0x7000UL)                /*!< SMP4 (Bitfield-Mask: 0x07)                            */
#define ADC_SMPR1_SMP3_Pos                (9UL)                     /*!< SMP3 (Bit 9)                                          */
#define ADC_SMPR1_SMP3_Msk                (0xe00UL)                 /*!< SMP3 (Bitfield-Mask: 0x07)                            */
#define ADC_SMPR1_SMP2_Pos                (6UL)                     /*!< SMP2 (Bit 6)                                          */
#define ADC_SMPR1_SMP2_Msk                (0x1c0UL)                 /*!< SMP2 (Bitfield-Mask: 0x07)                            */
#define ADC_SMPR1_SMP1_Pos                (3UL)                     /*!< SMP1 (Bit 3)                                          */
#define ADC_SMPR1_SMP1_Msk                (0x38UL)                  /*!< SMP1 (Bitfield-Mask: 0x07)                            */
#define ADC_SMPR1_SMP0_Pos                (0UL)                     /*!< SMP0 (Bit 0)                                          */
#define ADC_SMPR1_SMP0_Msk                (0x7UL)                   /*!< SMP0 (Bitfield-Mask: 0x07)                            */
/* =========================================================  SMPR2  ========================================================= */
#define ADC_SMPR2_SMP19_Pos               (27UL)                    /*!< SMP19 (Bit 27)                                        */
#define ADC_SMPR2_SMP19_Msk               (0x38000000UL)            /*!< SMP19 (Bitfield-Mask: 0x07)                           */
#define ADC_SMPR2_SMP18_Pos               (24UL)                    /*!< SMP18 (Bit 24)                                        */
#define ADC_SMPR2_SMP18_Msk               (0x7000000UL)             /*!< SMP18 (Bitfield-Mask: 0x07)                           */
#define ADC_SMPR2_SMP17_Pos               (21UL)                    /*!< SMP17 (Bit 21)                                        */
#define ADC_SMPR2_SMP17_Msk               (0xe00000UL)              /*!< SMP17 (Bitfield-Mask: 0x07)                           */
#define ADC_SMPR2_SMP16_Pos               (18UL)                    /*!< SMP16 (Bit 18)                                        */
#define ADC_SMPR2_SMP16_Msk               (0x1c0000UL)              /*!< SMP16 (Bitfield-Mask: 0x07)                           */
#define ADC_SMPR2_SMP15_Pos               (15UL)                    /*!< SMP15 (Bit 15)                                        */
#define ADC_SMPR2_SMP15_Msk               (0x38000UL)               /*!< SMP15 (Bitfield-Mask: 0x07)                           */
#define ADC_SMPR2_SMP14_Pos               (12UL)                    /*!< SMP14 (Bit 12)                                        */
#define ADC_SMPR2_SMP14_Msk               (0x7000UL)                /*!< SMP14 (Bitfield-Mask: 0x07)                           */
#define ADC_SMPR2_SMP13_Pos               (9UL)                     /*!< SMP13 (Bit 9)                                         */
#define ADC_SMPR2_SMP13_Msk               (0xe00UL)                 /*!< SMP13 (Bitfield-Mask: 0x07)                           */
#define ADC_SMPR2_SMP12_Pos               (6UL)                     /*!< SMP12 (Bit 6)                                         */
#define ADC_SMPR2_SMP12_Msk               (0x1c0UL)                 /*!< SMP12 (Bitfield-Mask: 0x07)                           */
#define ADC_SMPR2_SMP11_Pos               (3UL)                     /*!< SMP11 (Bit 3)                                         */
#define ADC_SMPR2_SMP11_Msk               (0x38UL)                  /*!< SMP11 (Bitfield-Mask: 0x07)                           */
#define ADC_SMPR2_SMP10_Pos               (0UL)                     /*!< SMP10 (Bit 0)                                         */
#define ADC_SMPR2_SMP10_Msk               (0x7UL)                   /*!< SMP10 (Bitfield-Mask: 0x07)                           */
/* =========================================================  AWDCR  ========================================================= */
#define ADC_AWDCR_AWDCH_Pos               (0UL)                     /*!< AWDCH (Bit 0)                                         */
#define ADC_AWDCR_AWDCH_Msk               (0xfffffUL)               /*!< AWDCH (Bitfield-Mask: 0xfffff)                        */
/* =========================================================  AWDTR  ========================================================= */
#define ADC_AWDTR_AWDDMAEN_Pos            (27UL)                    /*!< AWDDMAEN (Bit 27)                                     */
#define ADC_AWDTR_AWDDMAEN_Msk            (0x8000000UL)             /*!< AWDDMAEN (Bitfield-Mask: 0x01)                        */
#define ADC_AWDTR_AWDFILT_Pos             (24UL)                    /*!< AWDFILT (Bit 24)                                      */
#define ADC_AWDTR_AWDFILT_Msk             (0x7000000UL)             /*!< AWDFILT (Bitfield-Mask: 0x07)                         */
#define ADC_AWDTR_HTH_Pos                 (12UL)                    /*!< HTH (Bit 12)                                          */
#define ADC_AWDTR_HTH_Msk                 (0xfff000UL)              /*!< HTH (Bitfield-Mask: 0xfff)                            */
#define ADC_AWDTR_LTH_Pos                 (0UL)                     /*!< LTH (Bit 0)                                           */
#define ADC_AWDTR_LTH_Msk                 (0xfffUL)                 /*!< LTH (Bitfield-Mask: 0xfff)                            */
/* =========================================================  SQR1  ========================================================== */
#define ADC_SQR1_SQ3_Pos                  (24UL)                    /*!< SQ3 (Bit 24)                                          */
#define ADC_SQR1_SQ3_Msk                  (0x1f000000UL)            /*!< SQ3 (Bitfield-Mask: 0x1f)                             */
#define ADC_SQR1_SQ2_Pos                  (18UL)                    /*!< SQ2 (Bit 18)                                          */
#define ADC_SQR1_SQ2_Msk                  (0x7c0000UL)              /*!< SQ2 (Bitfield-Mask: 0x1f)                             */
#define ADC_SQR1_SQ1_Pos                  (12UL)                    /*!< SQ1 (Bit 12)                                          */
#define ADC_SQR1_SQ1_Msk                  (0x1f000UL)               /*!< SQ1 (Bitfield-Mask: 0x1f)                             */
#define ADC_SQR1_SQ0_Pos                  (6UL)                     /*!< SQ0 (Bit 6)                                           */
#define ADC_SQR1_SQ0_Msk                  (0x7c0UL)                 /*!< SQ0 (Bitfield-Mask: 0x1f)                             */
#define ADC_SQR1_CHLENGTH_Pos             (0UL)                     /*!< CHLENGTH (Bit 0)                                      */
#define ADC_SQR1_CHLENGTH_Msk             (0xfUL)                   /*!< CHLENGTH (Bitfield-Mask: 0x0f)                        */
/* =========================================================  SQR2  ========================================================== */
#define ADC_SQR2_SQ8_Pos                  (24UL)                    /*!< SQ8 (Bit 24)                                          */
#define ADC_SQR2_SQ8_Msk                  (0x1f000000UL)            /*!< SQ8 (Bitfield-Mask: 0x1f)                             */
#define ADC_SQR2_SQ7_Pos                  (18UL)                    /*!< SQ7 (Bit 18)                                          */
#define ADC_SQR2_SQ7_Msk                  (0x7c0000UL)              /*!< SQ7 (Bitfield-Mask: 0x1f)                             */
#define ADC_SQR2_SQ6_Pos                  (12UL)                    /*!< SQ6 (Bit 12)                                          */
#define ADC_SQR2_SQ6_Msk                  (0x1f000UL)               /*!< SQ6 (Bitfield-Mask: 0x1f)                             */
#define ADC_SQR2_SQ5_Pos                  (6UL)                     /*!< SQ5 (Bit 6)                                           */
#define ADC_SQR2_SQ5_Msk                  (0x7c0UL)                 /*!< SQ5 (Bitfield-Mask: 0x1f)                             */
#define ADC_SQR2_SQ4_Pos                  (0UL)                     /*!< SQ4 (Bit 0)                                           */
#define ADC_SQR2_SQ4_Msk                  (0x1fUL)                  /*!< SQ4 (Bitfield-Mask: 0x1f)                             */
/* =========================================================  SQR3  ========================================================== */
#define ADC_SQR3_SQ13_Pos                 (24UL)                    /*!< SQ13 (Bit 24)                                         */
#define ADC_SQR3_SQ13_Msk                 (0x1f000000UL)            /*!< SQ13 (Bitfield-Mask: 0x1f)                            */
#define ADC_SQR3_SQ12_Pos                 (18UL)                    /*!< SQ12 (Bit 18)                                         */
#define ADC_SQR3_SQ12_Msk                 (0x7c0000UL)              /*!< SQ12 (Bitfield-Mask: 0x1f)                            */
#define ADC_SQR3_SQ11_Pos                 (12UL)                    /*!< SQ11 (Bit 12)                                         */
#define ADC_SQR3_SQ11_Msk                 (0x1f000UL)               /*!< SQ11 (Bitfield-Mask: 0x1f)                            */
#define ADC_SQR3_SQ10_Pos                 (6UL)                     /*!< SQ10 (Bit 6)                                          */
#define ADC_SQR3_SQ10_Msk                 (0x7c0UL)                 /*!< SQ10 (Bitfield-Mask: 0x1f)                            */
#define ADC_SQR3_SQ9_Pos                  (0UL)                     /*!< SQ9 (Bit 0)                                           */
#define ADC_SQR3_SQ9_Msk                  (0x1fUL)                  /*!< SQ9 (Bitfield-Mask: 0x1f)                             */
/* =========================================================  SQR4  ========================================================== */
#define ADC_SQR4_SQ15_Pos                 (6UL)                     /*!< SQ15 (Bit 6)                                          */
#define ADC_SQR4_SQ15_Msk                 (0x7c0UL)                 /*!< SQ15 (Bitfield-Mask: 0x1f)                            */
#define ADC_SQR4_SQ14_Pos                 (0UL)                     /*!< SQ14 (Bit 0)                                          */
#define ADC_SQR4_SQ14_Msk                 (0x1fUL)                  /*!< SQ14 (Bitfield-Mask: 0x1f)                            */
/* ==========================================================  DR  =========================================================== */
#define ADC_DR_CONVDATA_Pos               (0UL)                     /*!< CONVDATA (Bit 0)                                      */
#define ADC_DR_CONVDATA_Msk               (0xffffUL)                /*!< CONVDATA (Bitfield-Mask: 0xffff)                      */
/* ==========================================================  DR0  ========================================================== */
#define ADC_DR0_CONVDATA0_Pos             (0UL)                     /*!< CONVDATA0 (Bit 0)                                     */
#define ADC_DR0_CONVDATA0_Msk             (0xffffUL)                /*!< CONVDATA0 (Bitfield-Mask: 0xffff)                     */
/* ==========================================================  DR1  ========================================================== */
#define ADC_DR1_CONVDATA1_Pos             (0UL)                     /*!< CONVDATA1 (Bit 0)                                     */
#define ADC_DR1_CONVDATA1_Msk             (0xffffUL)                /*!< CONVDATA1 (Bitfield-Mask: 0xffff)                     */
/* ==========================================================  DR2  ========================================================== */
#define ADC_DR2_CONVDATA2_Pos             (0UL)                     /*!< CONVDATA2 (Bit 0)                                     */
#define ADC_DR2_CONVDATA2_Msk             (0xffffUL)                /*!< CONVDATA2 (Bitfield-Mask: 0xffff)                     */
/* ==========================================================  DR3  ========================================================== */
#define ADC_DR3_CONVDATA3_Pos             (0UL)                     /*!< CONVDATA3 (Bit 0)                                     */
#define ADC_DR3_CONVDATA3_Msk             (0xffffUL)                /*!< CONVDATA3 (Bitfield-Mask: 0xffff)                     */
/* ==========================================================  DR4  ========================================================== */
#define ADC_DR4_CONVDATA4_Pos             (0UL)                     /*!< CONVDATA4 (Bit 0)                                     */
#define ADC_DR4_CONVDATA4_Msk             (0xffffUL)                /*!< CONVDATA4 (Bitfield-Mask: 0xffff)                     */
/* ==========================================================  DR5  ========================================================== */
#define ADC_DR5_CONVDATA5_Pos             (0UL)                     /*!< CONVDATA5 (Bit 0)                                     */
#define ADC_DR5_CONVDATA5_Msk             (0xffffUL)                /*!< CONVDATA5 (Bitfield-Mask: 0xffff)                     */
/* ==========================================================  DR6  ========================================================== */
#define ADC_DR6_CONVDATA6_Pos             (0UL)                     /*!< CONVDATA6 (Bit 0)                                     */
#define ADC_DR6_CONVDATA6_Msk             (0xffffUL)                /*!< CONVDATA6 (Bitfield-Mask: 0xffff)                     */
/* ==========================================================  DR7  ========================================================== */
#define ADC_DR7_CONVDATA7_Pos             (0UL)                     /*!< CONVDATA7 (Bit 0)                                     */
#define ADC_DR7_CONVDATA7_Msk             (0xffffUL)                /*!< CONVDATA7 (Bitfield-Mask: 0xffff)                     */
/* ==========================================================  DR8  ========================================================== */
#define ADC_DR8_CONVDATA8_Pos             (0UL)                     /*!< CONVDATA8 (Bit 0)                                     */
#define ADC_DR8_CONVDATA8_Msk             (0xffffUL)                /*!< CONVDATA8 (Bitfield-Mask: 0xffff)                     */
/* ==========================================================  DR9  ========================================================== */
#define ADC_DR9_CONVDATA9_Pos             (0UL)                     /*!< CONVDATA9 (Bit 0)                                     */
#define ADC_DR9_CONVDATA9_Msk             (0xffffUL)                /*!< CONVDATA9 (Bitfield-Mask: 0xffff)                     */
/* =========================================================  DR10  ========================================================== */
#define ADC_DR10_CONVDATA10_Pos           (0UL)                     /*!< CONVDATA10 (Bit 0)                                    */
#define ADC_DR10_CONVDATA10_Msk           (0xffffUL)                /*!< CONVDATA10 (Bitfield-Mask: 0xffff)                    */
/* =========================================================  DR11  ========================================================== */
#define ADC_DR11_CONVDATA11_Pos           (0UL)                     /*!< CONVDATA11 (Bit 0)                                    */
#define ADC_DR11_CONVDATA11_Msk           (0xffffUL)                /*!< CONVDATA11 (Bitfield-Mask: 0xffff)                    */
/* =========================================================  DR12  ========================================================== */
#define ADC_DR12_CONVDATA12_Pos           (0UL)                     /*!< CONVDATA12 (Bit 0)                                    */
#define ADC_DR12_CONVDATA12_Msk           (0xffffUL)                /*!< CONVDATA12 (Bitfield-Mask: 0xffff)                    */
/* =========================================================  DR13  ========================================================== */
#define ADC_DR13_CONVDATA13_Pos           (0UL)                     /*!< CONVDATA13 (Bit 0)                                    */
#define ADC_DR13_CONVDATA13_Msk           (0xffffUL)                /*!< CONVDATA13 (Bitfield-Mask: 0xffff)                    */
/* =========================================================  DR14  ========================================================== */
#define ADC_DR14_CONVDATA14_Pos           (0UL)                     /*!< CONVDATA14 (Bit 0)                                    */
#define ADC_DR14_CONVDATA14_Msk           (0xffffUL)                /*!< CONVDATA14 (Bitfield-Mask: 0xffff)                    */
/* =========================================================  DR15  ========================================================== */
#define ADC_DR15_CONVDATA15_Pos           (0UL)                     /*!< CONVDATA15 (Bit 0)                                    */
#define ADC_DR15_CONVDATA15_Msk           (0xffffUL)                /*!< CONVDATA15 (Bitfield-Mask: 0xffff)                    */
/* =========================================================  DR16  ========================================================== */
#define ADC_DR16_CONVDATA16_Pos           (0UL)                     /*!< CONVDATA16 (Bit 0)                                    */
#define ADC_DR16_CONVDATA16_Msk           (0xffffUL)                /*!< CONVDATA16 (Bitfield-Mask: 0xffff)                    */
/* =========================================================  DR17  ========================================================== */
#define ADC_DR17_CONVDATA17_Pos           (0UL)                     /*!< CONVDATA17 (Bit 0)                                    */
#define ADC_DR17_CONVDATA17_Msk           (0xffffUL)                /*!< CONVDATA17 (Bitfield-Mask: 0xffff)                    */
/* =========================================================  DR18  ========================================================== */
#define ADC_DR18_CONVDATA18_Pos           (0UL)                     /*!< CONVDATA18 (Bit 0)                                    */
#define ADC_DR18_CONVDATA18_Msk           (0xffffUL)                /*!< CONVDATA18 (Bitfield-Mask: 0xffff)                    */
/* =========================================================  DR19  ========================================================== */
#define ADC_DR19_CONVDATA19_Pos           (0UL)                     /*!< CONVDATA19 (Bit 0)                                    */
#define ADC_DR19_CONVDATA19_Msk           (0xffffUL)                /*!< CONVDATA19 (Bitfield-Mask: 0xffff)                    */
/* =========================================================  OFR1  ========================================================== */
#define ADC_OFR1_OFFSET1EN_Pos            (31UL)                    /*!< OFFSET1EN (Bit 31)                                    */
#define ADC_OFR1_OFFSET1EN_Msk            (0x80000000UL)            /*!< OFFSET1EN (Bitfield-Mask: 0x01)                       */
#define ADC_OFR1_OFFSET1CH_Pos            (26UL)                    /*!< OFFSET1CH (Bit 26)                                    */
#define ADC_OFR1_OFFSET1CH_Msk            (0x7c000000UL)            /*!< OFFSET1CH (Bitfield-Mask: 0x1f)                       */
#define ADC_OFR1_SATEN_Pos                (25UL)                    /*!< SATEN (Bit 25)                                        */
#define ADC_OFR1_SATEN_Msk                (0x2000000UL)             /*!< SATEN (Bitfield-Mask: 0x01)                           */
#define ADC_OFR1_OFFSETPOS_Pos            (24UL)                    /*!< OFFSETPOS (Bit 24)                                    */
#define ADC_OFR1_OFFSETPOS_Msk            (0x1000000UL)             /*!< OFFSETPOS (Bitfield-Mask: 0x01)                       */
#define ADC_OFR1_OFFSET1_Pos              (0UL)                     /*!< OFFSET1 (Bit 0)                                       */
#define ADC_OFR1_OFFSET1_Msk              (0xfffUL)                 /*!< OFFSET1 (Bitfield-Mask: 0xfff)                        */
/* =========================================================  OFR2  ========================================================== */
#define ADC_OFR2_OFFSET2EN_Pos            (31UL)                    /*!< OFFSET2EN (Bit 31)                                    */
#define ADC_OFR2_OFFSET2EN_Msk            (0x80000000UL)            /*!< OFFSET2EN (Bitfield-Mask: 0x01)                       */
#define ADC_OFR2_OFFSET2CH_Pos            (26UL)                    /*!< OFFSET2CH (Bit 26)                                    */
#define ADC_OFR2_OFFSET2CH_Msk            (0x7c000000UL)            /*!< OFFSET2CH (Bitfield-Mask: 0x1f)                       */
#define ADC_OFR2_OFFSET2_Pos              (0UL)                     /*!< OFFSET2 (Bit 0)                                       */
#define ADC_OFR2_OFFSET2_Msk              (0xfffUL)                 /*!< OFFSET2 (Bitfield-Mask: 0xfff)                        */
/* =========================================================  OFR3  ========================================================== */
#define ADC_OFR3_OFFSET3EN_Pos            (31UL)                    /*!< OFFSET3EN (Bit 31)                                    */
#define ADC_OFR3_OFFSET3EN_Msk            (0x80000000UL)            /*!< OFFSET3EN (Bitfield-Mask: 0x01)                       */
#define ADC_OFR3_OFFSET3CH_Pos            (26UL)                    /*!< OFFSET3CH (Bit 26)                                    */
#define ADC_OFR3_OFFSET3CH_Msk            (0x7c000000UL)            /*!< OFFSET3CH (Bitfield-Mask: 0x1f)                       */
#define ADC_OFR3_OFFSET3_Pos              (0UL)                     /*!< OFFSET3 (Bit 0)                                       */
#define ADC_OFR3_OFFSET3_Msk              (0xfffUL)                 /*!< OFFSET3 (Bitfield-Mask: 0xfff)                        */
/* =========================================================  OFR4  ========================================================== */
#define ADC_OFR4_OFFSET4EN_Pos            (31UL)                    /*!< OFFSET4EN (Bit 31)                                    */
#define ADC_OFR4_OFFSET4EN_Msk            (0x80000000UL)            /*!< OFFSET4EN (Bitfield-Mask: 0x01)                       */
#define ADC_OFR4_OFFSET4CH_Pos            (26UL)                    /*!< OFFSET4CH (Bit 26)                                    */
#define ADC_OFR4_OFFSET4CH_Msk            (0x7c000000UL)            /*!< OFFSET4CH (Bitfield-Mask: 0x1f)                       */
#define ADC_OFR4_OFFSET4_Pos              (0UL)                     /*!< OFFSET4 (Bit 0)                                       */
#define ADC_OFR4_OFFSET4_Msk              (0xfffUL)                 /*!< OFFSET4 (Bitfield-Mask: 0xfff)                        */
/* ========================================================  DIFSEL  ========================================================= */
#define ADC_DIFSEL_DIFSEL_Pos             (0UL)                     /*!< DIFSEL (Bit 0)                                        */
#define ADC_DIFSEL_DIFSEL_Msk             (0xfffffUL)               /*!< DIFSEL (Bitfield-Mask: 0xfffff)                       */
/* ========================================================  CALFACT  ======================================================== */
#define ADC_CALFACT_GAINTRIMS_Pos         (21UL)                    /*!< GAINTRIMS (Bit 21)                                    */
#define ADC_CALFACT_GAINTRIMS_Msk         (0x3e00000UL)             /*!< GAINTRIMS (Bitfield-Mask: 0x1f)                       */
#define ADC_CALFACT_GAINTRIMD_Pos         (16UL)                    /*!< GAINTRIMD (Bit 16)                                    */
#define ADC_CALFACT_GAINTRIMD_Msk         (0x1f0000UL)              /*!< GAINTRIMD (Bitfield-Mask: 0x1f)                       */
#define ADC_CALFACT_OSTRIMS_Pos           (5UL)                     /*!< OSTRIMS (Bit 5)                                       */
#define ADC_CALFACT_OSTRIMS_Msk           (0x3e0UL)                 /*!< OSTRIMS (Bitfield-Mask: 0x1f)                         */
#define ADC_CALFACT_OSTRIMD_Pos           (0UL)                     /*!< OSTRIMD (Bit 0)                                       */
#define ADC_CALFACT_OSTRIMD_Msk           (0x1fUL)                  /*!< OSTRIMD (Bitfield-Mask: 0x1f)                         */
/* =========================================================  GCOMP  ========================================================= */
#define ADC_GCOMP_GAINEN_Pos              (16UL)                    /*!< GAINEN (Bit 16)                                       */
#define ADC_GCOMP_GAINEN_Msk              (0x10000UL)               /*!< GAINEN (Bitfield-Mask: 0x01)                          */
#define ADC_GCOMP_GAINCOEF_Pos            (0UL)                     /*!< GAINCOEF (Bit 0)                                      */
#define ADC_GCOMP_GAINCOEF_Msk            (0x3fffUL)                /*!< GAINCOEF (Bitfield-Mask: 0x3fff)                      */
/* ==========================================================  CCR  ========================================================== */
#define ADC_CCR_HSMODE_Pos                (11UL)                    /*!< HSMODE (Bit 11)                                       */
#define ADC_CCR_HSMODE_Msk                (0x800UL)                 /*!< HSMODE (Bitfield-Mask: 0x01)                          */
#define ADC_CCR_VREFSEL_Pos               (10UL)                    /*!< VREFSEL (Bit 10)                                      */
#define ADC_CCR_VREFSEL_Msk               (0x400UL)                 /*!< VREFSEL (Bitfield-Mask: 0x01)                         */
#define ADC_CCR_HALFVDDEN_Pos             (9UL)                     /*!< HALFVDDEN (Bit 9)                                     */
#define ADC_CCR_HALFVDDEN_Msk             (0x200UL)                 /*!< HALFVDDEN (Bitfield-Mask: 0x01)                       */
#define ADC_CCR_VSENSEEN_Pos              (8UL)                     /*!< VSENSEEN (Bit 8)                                      */
#define ADC_CCR_VSENSEEN_Msk              (0x100UL)                 /*!< VSENSEEN (Bitfield-Mask: 0x01)                        */
#define ADC_CCR_VBATEN_Pos                (7UL)                     /*!< VBATEN (Bit 7)                                        */
#define ADC_CCR_VBATEN_Msk                (0x80UL)                  /*!< VBATEN (Bitfield-Mask: 0x01)                          */
#define ADC_CCR_PRESC_Pos                 (2UL)                     /*!< PRESC (Bit 2)                                         */
#define ADC_CCR_PRESC_Msk                 (0x3cUL)                  /*!< PRESC (Bitfield-Mask: 0x0f)                           */
#define ADC_CCR_CKMODE_Pos                (0UL)                     /*!< CKMODE (Bit 0)                                        */
#define ADC_CCR_CKMODE_Msk                (0x3UL)                   /*!< CKMODE (Bitfield-Mask: 0x03)                          */
/* ==========================================================  TSR  ========================================================== */
#define ADC_TSR_TS125C_Pos                (16UL)                    /*!< TS125C (Bit 16)                                       */
#define ADC_TSR_TS125C_Msk                (0xfff0000UL)             /*!< TS125C (Bitfield-Mask: 0xfff)                         */
#define ADC_TSR_TS25C_Pos                 (0UL)                     /*!< TS25C (Bit 0)                                         */
#define ADC_TSR_TS25C_Msk                 (0xfffUL)                 /*!< TS25C (Bitfield-Mask: 0xfff)                          */


/* =========================================================================================================================== */
/* ================                                            RCC                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  CR  =========================================================== */
#define RCC_CR_PLLRDY_Pos                 (25UL)                    /*!< PLLRDY (Bit 25)                                       */
#define RCC_CR_PLLRDY_Msk                 (0x2000000UL)             /*!< PLLRDY (Bitfield-Mask: 0x01)                          */
#define RCC_CR_PLLON_Pos                  (24UL)                    /*!< PLLON (Bit 24)                                        */
#define RCC_CR_PLLON_Msk                  (0x1000000UL)             /*!< PLLON (Bitfield-Mask: 0x01)                           */
#define RCC_CR_CSSON_Pos                  (19UL)                    /*!< CSSON (Bit 19)                                        */
#define RCC_CR_CSSON_Msk                  (0x80000UL)               /*!< CSSON (Bitfield-Mask: 0x01)                           */
#define RCC_CR_EHSBYP_Pos                 (18UL)                    /*!< EHSBYP (Bit 18)                                       */
#define RCC_CR_EHSBYP_Msk                 (0x40000UL)               /*!< EHSBYP (Bitfield-Mask: 0x01)                          */
#define RCC_CR_EHSRDY_Pos                 (17UL)                    /*!< EHSRDY (Bit 17)                                       */
#define RCC_CR_EHSRDY_Msk                 (0x20000UL)               /*!< EHSRDY (Bitfield-Mask: 0x01)                          */
#define RCC_CR_EHSON_Pos                  (16UL)                    /*!< EHSON (Bit 16)                                        */
#define RCC_CR_EHSON_Msk                  (0x10000UL)               /*!< EHSON (Bitfield-Mask: 0x01)                           */
#define RCC_CR_EHSECLKON_Pos              (15UL)                    /*!< EHSECLKON (Bit 15)                                    */
#define RCC_CR_EHSECLKON_Msk              (0x8000UL)                /*!< EHSECLKON (Bitfield-Mask: 0x01)                       */
#define RCC_CR_IHSRDY_Pos                 (10UL)                    /*!< IHSRDY (Bit 10)                                       */
#define RCC_CR_IHSRDY_Msk                 (0x400UL)                 /*!< IHSRDY (Bitfield-Mask: 0x01)                          */
#define RCC_CR_IHSON_Pos                  (8UL)                     /*!< IHSON (Bit 8)                                         */
#define RCC_CR_IHSON_Msk                  (0x100UL)                 /*!< IHSON (Bitfield-Mask: 0x01)                           */
/* ==========================================================  CR1  ========================================================== */
#define RCC_CR1_EHSTESTEN_Pos             (16UL)                    /*!< EHSTESTEN (Bit 16)                                    */
#define RCC_CR1_EHSTESTEN_Msk             (0x10000UL)               /*!< EHSTESTEN (Bitfield-Mask: 0x01)                       */
#define RCC_CR1_EHSCTRL_Pos               (8UL)                     /*!< EHSCTRL (Bit 8)                                       */
#define RCC_CR1_EHSCTRL_Msk               (0xff00UL)                /*!< EHSCTRL (Bitfield-Mask: 0xff)                         */
#define RCC_CR1_EHSFREQSEL_Pos            (0UL)                     /*!< EHSFREQSEL (Bit 0)                                    */
#define RCC_CR1_EHSFREQSEL_Msk            (0xffUL)                  /*!< EHSFREQSEL (Bitfield-Mask: 0xff)                      */
/* =========================================================  CFGR  ========================================================== */
#define RCC_CFGR_MCOEN_Pos                (27UL)                    /*!< MCOEN (Bit 27)                                        */
#define RCC_CFGR_MCOEN_Msk                (0x8000000UL)             /*!< MCOEN (Bitfield-Mask: 0x01)                           */
#define RCC_CFGR_MCOSEL_Pos               (24UL)                    /*!< MCOSEL (Bit 24)                                       */
#define RCC_CFGR_MCOSEL_Msk               (0x7000000UL)             /*!< MCOSEL (Bitfield-Mask: 0x07)                          */
#define RCC_CFGR_MCOPRE_Pos               (16UL)                    /*!< MCOPRE (Bit 16)                                       */
#define RCC_CFGR_MCOPRE_Msk               (0xff0000UL)              /*!< MCOPRE (Bitfield-Mask: 0xff)                          */
#define RCC_CFGR_PPRE2_Pos                (11UL)                    /*!< PPRE2 (Bit 11)                                        */
#define RCC_CFGR_PPRE2_Msk                (0x3800UL)                /*!< PPRE2 (Bitfield-Mask: 0x07)                           */
#define RCC_CFGR_PPRE1_Pos                (8UL)                     /*!< PPRE1 (Bit 8)                                         */
#define RCC_CFGR_PPRE1_Msk                (0x700UL)                 /*!< PPRE1 (Bitfield-Mask: 0x07)                           */
#define RCC_CFGR_HPRE_Pos                 (4UL)                     /*!< HPRE (Bit 4)                                          */
#define RCC_CFGR_HPRE_Msk                 (0xf0UL)                  /*!< HPRE (Bitfield-Mask: 0x0f)                            */
#define RCC_CFGR_SWS_Pos                  (2UL)                     /*!< SWS (Bit 2)                                           */
#define RCC_CFGR_SWS_Msk                  (0xcUL)                   /*!< SWS (Bitfield-Mask: 0x03)                             */
#define RCC_CFGR_SW_Pos                   (0UL)                     /*!< SW (Bit 0)                                            */
#define RCC_CFGR_SW_Msk                   (0x3UL)                   /*!< SW (Bitfield-Mask: 0x03)                              */
/* =======================================================  PLLCFGR1  ======================================================== */
#define RCC_PLLCFGR1_PLLFREFLEAD_Pos      (29UL)                    /*!< PLLFREFLEAD (Bit 29)                                  */
#define RCC_PLLCFGR1_PLLFREFLEAD_Msk      (0x20000000UL)            /*!< PLLFREFLEAD (Bitfield-Mask: 0x01)                     */
#define RCC_PLLCFGR1_PLLDIV48M_Pos        (27UL)                    /*!< PLLDIV48M (Bit 27)                                    */
#define RCC_PLLCFGR1_PLLDIV48M_Msk        (0x18000000UL)            /*!< PLLDIV48M (Bitfield-Mask: 0x03)                       */
#define RCC_PLLCFGR1_PLLDIV48MPD_Pos      (26UL)                    /*!< PLLDIV48MPD (Bit 26)                                  */
#define RCC_PLLCFGR1_PLLDIV48MPD_Msk      (0x4000000UL)             /*!< PLLDIV48MPD (Bitfield-Mask: 0x01)                     */
#define RCC_PLLCFGR1_PLLODIV_Pos          (13UL)                    /*!< PLLODIV (Bit 13)                                      */
#define RCC_PLLCFGR1_PLLODIV_Msk          (0x6000UL)                /*!< PLLODIV (Bitfield-Mask: 0x03)                         */
#define RCC_PLLCFGR1_PLLFBDIV_Pos         (5UL)                     /*!< PLLFBDIV (Bit 5)                                      */
#define RCC_PLLCFGR1_PLLFBDIV_Msk         (0x1fe0UL)                /*!< PLLFBDIV (Bitfield-Mask: 0xff)                        */
#define RCC_PLLCFGR1_PLLINDIV_Pos         (3UL)                     /*!< PLLINDIV (Bit 3)                                      */
#define RCC_PLLCFGR1_PLLINDIV_Msk         (0x18UL)                  /*!< PLLINDIV (Bitfield-Mask: 0x03)                        */
#define RCC_PLLCFGR1_PLLMANUALRSTN_Pos    (2UL)                     /*!< PLLMANUALRSTN (Bit 2)                                 */
#define RCC_PLLCFGR1_PLLMANUALRSTN_Msk    (0x4UL)                   /*!< PLLMANUALRSTN (Bitfield-Mask: 0x01)                   */
#define RCC_PLLCFGR1_PLLSRC_Pos           (0UL)                     /*!< PLLSRC (Bit 0)                                        */
#define RCC_PLLCFGR1_PLLSRC_Msk           (0x3UL)                   /*!< PLLSRC (Bitfield-Mask: 0x03)                          */
/* =======================================================  PLLCFGR2  ======================================================== */
#define RCC_PLLCFGR2_PLLRDIVFRAC_Pos      (29UL)                    /*!< PLLRDIVFRAC (Bit 29)                                  */
#define RCC_PLLCFGR2_PLLRDIVFRAC_Msk      (0x60000000UL)            /*!< PLLRDIVFRAC (Bitfield-Mask: 0x03)                     */
#define RCC_PLLCFGR2_PLLRDIVINT_Pos       (25UL)                    /*!< PLLRDIVINT (Bit 25)                                   */
#define RCC_PLLCFGR2_PLLRDIVINT_Msk       (0x1e000000UL)            /*!< PLLRDIVINT (Bitfield-Mask: 0x0f)                      */
#define RCC_PLLCFGR2_PLLRDIVCTRL_Pos      (17UL)                    /*!< PLLRDIVCTRL (Bit 17)                                  */
#define RCC_PLLCFGR2_PLLRDIVCTRL_Msk      (0x1fe0000UL)             /*!< PLLRDIVCTRL (Bitfield-Mask: 0xff)                     */
#define RCC_PLLCFGR2_PLLRDIVPD_Pos        (16UL)                    /*!< PLLRDIVPD (Bit 16)                                    */
#define RCC_PLLCFGR2_PLLRDIVPD_Msk        (0x10000UL)               /*!< PLLRDIVPD (Bitfield-Mask: 0x01)                       */
#define RCC_PLLCFGR2_PLLCTRL1_Pos         (8UL)                     /*!< PLLCTRL1 (Bit 8)                                      */
#define RCC_PLLCFGR2_PLLCTRL1_Msk         (0xff00UL)                /*!< PLLCTRL1 (Bitfield-Mask: 0xff)                        */
#define RCC_PLLCFGR2_PLLCTRL0_Pos         (0UL)                     /*!< PLLCTRL0 (Bit 0)                                      */
#define RCC_PLLCFGR2_PLLCTRL0_Msk         (0xffUL)                  /*!< PLLCTRL0 (Bitfield-Mask: 0xff)                        */
/* ==========================================================  CR2  ========================================================== */
#define RCC_CR2_EHSCSSTARGETCLKCNTEND_Pos (16UL)                    /*!< EHSCSSTARGETCLKCNTEND (Bit 16)                        */
#define RCC_CR2_EHSCSSTARGETCLKCNTEND_Msk (0xfff0000UL)             /*!< EHSCSSTARGETCLKCNTEND (Bitfield-Mask: 0xfff)          */
#define RCC_CR2_EHSCSSLOCALCLKCNTEND_Pos  (0UL)                     /*!< EHSCSSLOCALCLKCNTEND (Bit 0)                          */
#define RCC_CR2_EHSCSSLOCALCLKCNTEND_Msk  (0xfffUL)                 /*!< EHSCSSLOCALCLKCNTEND (Bitfield-Mask: 0xfff)           */
/* =========================================================  CIER  ========================================================== */
#define RCC_CIER_ELSCSSIE_Pos             (6UL)                     /*!< ELSCSSIE (Bit 6)                                      */
#define RCC_CIER_ELSCSSIE_Msk             (0x40UL)                  /*!< ELSCSSIE (Bitfield-Mask: 0x01)                        */
#define RCC_CIER_PLLRDYIE_Pos             (4UL)                     /*!< PLLRDYIE (Bit 4)                                      */
#define RCC_CIER_PLLRDYIE_Msk             (0x10UL)                  /*!< PLLRDYIE (Bitfield-Mask: 0x01)                        */
#define RCC_CIER_EHSRDYIE_Pos             (3UL)                     /*!< EHSRDYIE (Bit 3)                                      */
#define RCC_CIER_EHSRDYIE_Msk             (0x8UL)                   /*!< EHSRDYIE (Bitfield-Mask: 0x01)                        */
#define RCC_CIER_IHSRDYIE_Pos             (2UL)                     /*!< IHSRDYIE (Bit 2)                                      */
#define RCC_CIER_IHSRDYIE_Msk             (0x4UL)                   /*!< IHSRDYIE (Bitfield-Mask: 0x01)                        */
#define RCC_CIER_ELSRDYIE_Pos             (1UL)                     /*!< ELSRDYIE (Bit 1)                                      */
#define RCC_CIER_ELSRDYIE_Msk             (0x2UL)                   /*!< ELSRDYIE (Bitfield-Mask: 0x01)                        */
#define RCC_CIER_ILSRDYIE_Pos             (0UL)                     /*!< ILSRDYIE (Bit 0)                                      */
#define RCC_CIER_ILSRDYIE_Msk             (0x1UL)                   /*!< ILSRDYIE (Bitfield-Mask: 0x01)                        */
/* =========================================================  CIFR  ========================================================== */
#define RCC_CIFR_ELSCSSF_Pos              (6UL)                     /*!< ELSCSSF (Bit 6)                                       */
#define RCC_CIFR_ELSCSSF_Msk              (0x40UL)                  /*!< ELSCSSF (Bitfield-Mask: 0x01)                         */
#define RCC_CIFR_CSSF_Pos                 (5UL)                     /*!< CSSF (Bit 5)                                          */
#define RCC_CIFR_CSSF_Msk                 (0x20UL)                  /*!< CSSF (Bitfield-Mask: 0x01)                            */
#define RCC_CIFR_PLLRDYF_Pos              (4UL)                     /*!< PLLRDYF (Bit 4)                                       */
#define RCC_CIFR_PLLRDYF_Msk              (0x10UL)                  /*!< PLLRDYF (Bitfield-Mask: 0x01)                         */
#define RCC_CIFR_EHSRDYF_Pos              (3UL)                     /*!< EHSRDYF (Bit 3)                                       */
#define RCC_CIFR_EHSRDYF_Msk              (0x8UL)                   /*!< EHSRDYF (Bitfield-Mask: 0x01)                         */
#define RCC_CIFR_IHSRDYF_Pos              (2UL)                     /*!< IHSRDYF (Bit 2)                                       */
#define RCC_CIFR_IHSRDYF_Msk              (0x4UL)                   /*!< IHSRDYF (Bitfield-Mask: 0x01)                         */
#define RCC_CIFR_ELSRDYF_Pos              (1UL)                     /*!< ELSRDYF (Bit 1)                                       */
#define RCC_CIFR_ELSRDYF_Msk              (0x2UL)                   /*!< ELSRDYF (Bitfield-Mask: 0x01)                         */
#define RCC_CIFR_ILSRDYF_Pos              (0UL)                     /*!< ILSRDYF (Bit 0)                                       */
#define RCC_CIFR_ILSRDYF_Msk              (0x1UL)                   /*!< ILSRDYF (Bitfield-Mask: 0x01)                         */
/* =========================================================  CICR  ========================================================== */
#define RCC_CICR_ELSCSSC_Pos              (6UL)                     /*!< ELSCSSC (Bit 6)                                       */
#define RCC_CICR_ELSCSSC_Msk              (0x40UL)                  /*!< ELSCSSC (Bitfield-Mask: 0x01)                         */
#define RCC_CICR_CSSC_Pos                 (5UL)                     /*!< CSSC (Bit 5)                                          */
#define RCC_CICR_CSSC_Msk                 (0x20UL)                  /*!< CSSC (Bitfield-Mask: 0x01)                            */
#define RCC_CICR_PLLRDYC_Pos              (4UL)                     /*!< PLLRDYC (Bit 4)                                       */
#define RCC_CICR_PLLRDYC_Msk              (0x10UL)                  /*!< PLLRDYC (Bitfield-Mask: 0x01)                         */
#define RCC_CICR_EHSRDYC_Pos              (3UL)                     /*!< EHSRDYC (Bit 3)                                       */
#define RCC_CICR_EHSRDYC_Msk              (0x8UL)                   /*!< EHSRDYC (Bitfield-Mask: 0x01)                         */
#define RCC_CICR_IHSRDYC_Pos              (2UL)                     /*!< IHSRDYC (Bit 2)                                       */
#define RCC_CICR_IHSRDYC_Msk              (0x4UL)                   /*!< IHSRDYC (Bitfield-Mask: 0x01)                         */
#define RCC_CICR_ELSRDYC_Pos              (1UL)                     /*!< ELSRDYC (Bit 1)                                       */
#define RCC_CICR_ELSRDYC_Msk              (0x2UL)                   /*!< ELSRDYC (Bitfield-Mask: 0x01)                         */
#define RCC_CICR_ILSRDYC_Pos              (0UL)                     /*!< ILSRDYC (Bit 0)                                       */
#define RCC_CICR_ILSRDYC_Msk              (0x1UL)                   /*!< ILSRDYC (Bitfield-Mask: 0x01)                         */
/* =======================================================  AHB1RSTR  ======================================================== */
#define RCC_AHB1RSTR_GPIOFRST_Pos         (5UL)                     /*!< GPIOFRST (Bit 5)                                      */
#define RCC_AHB1RSTR_GPIOFRST_Msk         (0x20UL)                  /*!< GPIOFRST (Bitfield-Mask: 0x01)                        */
#define RCC_AHB1RSTR_GPIOERST_Pos         (4UL)                     /*!< GPIOERST (Bit 4)                                      */
#define RCC_AHB1RSTR_GPIOERST_Msk         (0x10UL)                  /*!< GPIOERST (Bitfield-Mask: 0x01)                        */
#define RCC_AHB1RSTR_GPIODRST_Pos         (3UL)                     /*!< GPIODRST (Bit 3)                                      */
#define RCC_AHB1RSTR_GPIODRST_Msk         (0x8UL)                   /*!< GPIODRST (Bitfield-Mask: 0x01)                        */
#define RCC_AHB1RSTR_GPIOCRST_Pos         (2UL)                     /*!< GPIOCRST (Bit 2)                                      */
#define RCC_AHB1RSTR_GPIOCRST_Msk         (0x4UL)                   /*!< GPIOCRST (Bitfield-Mask: 0x01)                        */
#define RCC_AHB1RSTR_GPIOBRST_Pos         (1UL)                     /*!< GPIOBRST (Bit 1)                                      */
#define RCC_AHB1RSTR_GPIOBRST_Msk         (0x2UL)                   /*!< GPIOBRST (Bitfield-Mask: 0x01)                        */
#define RCC_AHB1RSTR_GPIOARST_Pos         (0UL)                     /*!< GPIOARST (Bit 0)                                      */
#define RCC_AHB1RSTR_GPIOARST_Msk         (0x1UL)                   /*!< GPIOARST (Bitfield-Mask: 0x01)                        */
/* =======================================================  AHB2RSTR  ======================================================== */
#define RCC_AHB2RSTR_ADCRST_Pos           (10UL)                    /*!< ADCRST (Bit 10)                                       */
#define RCC_AHB2RSTR_ADCRST_Msk           (0x400UL)                 /*!< ADCRST (Bitfield-Mask: 0x01)                          */
#define RCC_AHB2RSTR_HASHRST_Pos          (4UL)                     /*!< HASHRST (Bit 4)                                       */
#define RCC_AHB2RSTR_HASHRST_Msk          (0x10UL)                  /*!< HASHRST (Bitfield-Mask: 0x01)                         */
#define RCC_AHB2RSTR_AESRST_Pos           (3UL)                     /*!< AESRST (Bit 3)                                        */
#define RCC_AHB2RSTR_AESRST_Msk           (0x8UL)                   /*!< AESRST (Bitfield-Mask: 0x01)                          */
#define RCC_AHB2RSTR_CRCRST_Pos           (2UL)                     /*!< CRCRST (Bit 2)                                        */
#define RCC_AHB2RSTR_CRCRST_Msk           (0x4UL)                   /*!< CRCRST (Bitfield-Mask: 0x01)                          */
#define RCC_AHB2RSTR_DMA1RST_Pos          (1UL)                     /*!< DMA1RST (Bit 1)                                       */
#define RCC_AHB2RSTR_DMA1RST_Msk          (0x2UL)                   /*!< DMA1RST (Bitfield-Mask: 0x01)                         */
#define RCC_AHB2RSTR_DMA0RST_Pos          (0UL)                     /*!< DMA0RST (Bit 0)                                       */
#define RCC_AHB2RSTR_DMA0RST_Msk          (0x1UL)                   /*!< DMA0RST (Bitfield-Mask: 0x01)                         */
/* =======================================================  AHB2RSTR1  ======================================================= */
#define RCC_AHB2RSTR1_FLASHRST_Pos        (1UL)                     /*!< FLASHRST (Bit 1)                                      */
#define RCC_AHB2RSTR1_FLASHRST_Msk        (0x2UL)                   /*!< FLASHRST (Bitfield-Mask: 0x01)                        */
/* =======================================================  APB1RSTR  ======================================================== */
#define RCC_APB1RSTR_PMURST_Pos           (16UL)                    /*!< PMURST (Bit 16)                                       */
#define RCC_APB1RSTR_PMURST_Msk           (0x10000UL)               /*!< PMURST (Bitfield-Mask: 0x01)                          */
#define RCC_APB1RSTR_USART6RST_Pos        (15UL)                    /*!< USART6RST (Bit 15)                                    */
#define RCC_APB1RSTR_USART6RST_Msk        (0x8000UL)                /*!< USART6RST (Bitfield-Mask: 0x01)                       */
#define RCC_APB1RSTR_SPI1RST_Pos          (14UL)                    /*!< SPI1RST (Bit 14)                                      */
#define RCC_APB1RSTR_SPI1RST_Msk          (0x4000UL)                /*!< SPI1RST (Bitfield-Mask: 0x01)                         */
#define RCC_APB1RSTR_SPI0RST_Pos          (13UL)                    /*!< SPI0RST (Bit 13)                                      */
#define RCC_APB1RSTR_SPI0RST_Msk          (0x2000UL)                /*!< SPI0RST (Bitfield-Mask: 0x01)                         */
#define RCC_APB1RSTR_DACRST_Pos           (12UL)                    /*!< DACRST (Bit 12)                                       */
#define RCC_APB1RSTR_DACRST_Msk           (0x1000UL)                /*!< DACRST (Bitfield-Mask: 0x01)                          */
#define RCC_APB1RSTR_WWDGRST_Pos          (11UL)                    /*!< WWDGRST (Bit 11)                                      */
#define RCC_APB1RSTR_WWDGRST_Msk          (0x800UL)                 /*!< WWDGRST (Bitfield-Mask: 0x01)                         */
#define RCC_APB1RSTR_USART5RST_Pos        (10UL)                    /*!< USART5RST (Bit 10)                                    */
#define RCC_APB1RSTR_USART5RST_Msk        (0x400UL)                 /*!< USART5RST (Bitfield-Mask: 0x01)                       */
#define RCC_APB1RSTR_USART4RST_Pos        (9UL)                     /*!< USART4RST (Bit 9)                                     */
#define RCC_APB1RSTR_USART4RST_Msk        (0x200UL)                 /*!< USART4RST (Bitfield-Mask: 0x01)                       */
#define RCC_APB1RSTR_I2C1RST_Pos          (8UL)                     /*!< I2C1RST (Bit 8)                                       */
#define RCC_APB1RSTR_I2C1RST_Msk          (0x100UL)                 /*!< I2C1RST (Bitfield-Mask: 0x01)                         */
#define RCC_APB1RSTR_I2C0RST_Pos          (7UL)                     /*!< I2C0RST (Bit 7)                                       */
#define RCC_APB1RSTR_I2C0RST_Msk          (0x80UL)                  /*!< I2C0RST (Bitfield-Mask: 0x01)                         */
#define RCC_APB1RSTR_RTCAPBRST_Pos        (6UL)                     /*!< RTCAPBRST (Bit 6)                                     */
#define RCC_APB1RSTR_RTCAPBRST_Msk        (0x40UL)                  /*!< RTCAPBRST (Bitfield-Mask: 0x01)                       */
#define RCC_APB1RSTR_GPTMR5RST_Pos        (5UL)                     /*!< GPTMR5RST (Bit 5)                                     */
#define RCC_APB1RSTR_GPTMR5RST_Msk        (0x20UL)                  /*!< GPTMR5RST (Bitfield-Mask: 0x01)                       */
#define RCC_APB1RSTR_GPTMR4RST_Pos        (4UL)                     /*!< GPTMR4RST (Bit 4)                                     */
#define RCC_APB1RSTR_GPTMR4RST_Msk        (0x10UL)                  /*!< GPTMR4RST (Bitfield-Mask: 0x01)                       */
#define RCC_APB1RSTR_GPTMR3RST_Pos        (3UL)                     /*!< GPTMR3RST (Bit 3)                                     */
#define RCC_APB1RSTR_GPTMR3RST_Msk        (0x8UL)                   /*!< GPTMR3RST (Bitfield-Mask: 0x01)                       */
#define RCC_APB1RSTR_GPTMR2RST_Pos        (2UL)                     /*!< GPTMR2RST (Bit 2)                                     */
#define RCC_APB1RSTR_GPTMR2RST_Msk        (0x4UL)                   /*!< GPTMR2RST (Bitfield-Mask: 0x01)                       */
#define RCC_APB1RSTR_GPTMR1RST_Pos        (1UL)                     /*!< GPTMR1RST (Bit 1)                                     */
#define RCC_APB1RSTR_GPTMR1RST_Msk        (0x2UL)                   /*!< GPTMR1RST (Bitfield-Mask: 0x01)                       */
#define RCC_APB1RSTR_GPTMR0RST_Pos        (0UL)                     /*!< GPTMR0RST (Bit 0)                                     */
#define RCC_APB1RSTR_GPTMR0RST_Msk        (0x1UL)                   /*!< GPTMR0RST (Bitfield-Mask: 0x01)                       */
/* =======================================================  APB2RSTR  ======================================================== */
#define RCC_APB2RSTR_TRNGRST_Pos          (16UL)                    /*!< TRNGRST (Bit 16)                                      */
#define RCC_APB2RSTR_TRNGRST_Msk          (0x10000UL)               /*!< TRNGRST (Bitfield-Mask: 0x01)                         */
#define RCC_APB2RSTR_OA1RST_Pos           (15UL)                    /*!< OA1RST (Bit 15)                                       */
#define RCC_APB2RSTR_OA1RST_Msk           (0x8000UL)                /*!< OA1RST (Bitfield-Mask: 0x01)                          */
#define RCC_APB2RSTR_OA0RST_Pos           (14UL)                    /*!< OA0RST (Bit 14)                                       */
#define RCC_APB2RSTR_OA0RST_Msk           (0x4000UL)                /*!< OA0RST (Bitfield-Mask: 0x01)                          */
#define RCC_APB2RSTR_CMP1RST_Pos          (13UL)                    /*!< CMP1RST (Bit 13)                                      */
#define RCC_APB2RSTR_CMP1RST_Msk          (0x2000UL)                /*!< CMP1RST (Bitfield-Mask: 0x01)                         */
#define RCC_APB2RSTR_CMP0RST_Pos          (12UL)                    /*!< CMP0RST (Bit 12)                                      */
#define RCC_APB2RSTR_CMP0RST_Msk          (0x1000UL)                /*!< CMP0RST (Bitfield-Mask: 0x01)                         */
#define RCC_APB2RSTR_VREFBUFRST_Pos       (11UL)                    /*!< VREFBUFRST (Bit 11)                                   */
#define RCC_APB2RSTR_VREFBUFRST_Msk       (0x800UL)                 /*!< VREFBUFRST (Bitfield-Mask: 0x01)                      */
#define RCC_APB2RSTR_SPI2RST_Pos          (10UL)                    /*!< SPI2RST (Bit 10)                                      */
#define RCC_APB2RSTR_SPI2RST_Msk          (0x400UL)                 /*!< SPI2RST (Bitfield-Mask: 0x01)                         */
#define RCC_APB2RSTR_CANRST_Pos           (9UL)                     /*!< CANRST (Bit 9)                                        */
#define RCC_APB2RSTR_CANRST_Msk           (0x200UL)                 /*!< CANRST (Bitfield-Mask: 0x01)                          */
#define RCC_APB2RSTR_ADVTMR2RST_Pos       (8UL)                     /*!< ADVTMR2RST (Bit 8)                                    */
#define RCC_APB2RSTR_ADVTMR2RST_Msk       (0x100UL)                 /*!< ADVTMR2RST (Bitfield-Mask: 0x01)                      */
#define RCC_APB2RSTR_ADVTMR1RST_Pos       (7UL)                     /*!< ADVTMR1RST (Bit 7)                                    */
#define RCC_APB2RSTR_ADVTMR1RST_Msk       (0x80UL)                  /*!< ADVTMR1RST (Bitfield-Mask: 0x01)                      */
#define RCC_APB2RSTR_ADVTMR0RST_Pos       (6UL)                     /*!< ADVTMR0RST (Bit 6)                                    */
#define RCC_APB2RSTR_ADVTMR0RST_Msk       (0x40UL)                  /*!< ADVTMR0RST (Bitfield-Mask: 0x01)                      */
#define RCC_APB2RSTR_SYSCFGRST_Pos        (5UL)                     /*!< SYSCFGRST (Bit 5)                                     */
#define RCC_APB2RSTR_SYSCFGRST_Msk        (0x20UL)                  /*!< SYSCFGRST (Bitfield-Mask: 0x01)                       */
#define RCC_APB2RSTR_USART3RST_Pos        (4UL)                     /*!< USART3RST (Bit 4)                                     */
#define RCC_APB2RSTR_USART3RST_Msk        (0x10UL)                  /*!< USART3RST (Bitfield-Mask: 0x01)                       */
#define RCC_APB2RSTR_USART2RST_Pos        (3UL)                     /*!< USART2RST (Bit 3)                                     */
#define RCC_APB2RSTR_USART2RST_Msk        (0x8UL)                   /*!< USART2RST (Bitfield-Mask: 0x01)                       */
#define RCC_APB2RSTR_USART1RST_Pos        (2UL)                     /*!< USART1RST (Bit 2)                                     */
#define RCC_APB2RSTR_USART1RST_Msk        (0x4UL)                   /*!< USART1RST (Bitfield-Mask: 0x01)                       */
#define RCC_APB2RSTR_USART0RST_Pos        (1UL)                     /*!< USART0RST (Bit 1)                                     */
#define RCC_APB2RSTR_USART0RST_Msk        (0x2UL)                   /*!< USART0RST (Bitfield-Mask: 0x01)                       */
#define RCC_APB2RSTR_TPCRST_Pos           (0UL)                     /*!< TPCRST (Bit 0)                                        */
#define RCC_APB2RSTR_TPCRST_Msk           (0x1UL)                   /*!< TPCRST (Bitfield-Mask: 0x01)                          */
/* ========================================================  AHB1ENR  ======================================================== */
#define RCC_AHB1ENR_GPIOFEN_Pos           (5UL)                     /*!< GPIOFEN (Bit 5)                                       */
#define RCC_AHB1ENR_GPIOFEN_Msk           (0x20UL)                  /*!< GPIOFEN (Bitfield-Mask: 0x01)                         */
#define RCC_AHB1ENR_GPIOEEN_Pos           (4UL)                     /*!< GPIOEEN (Bit 4)                                       */
#define RCC_AHB1ENR_GPIOEEN_Msk           (0x10UL)                  /*!< GPIOEEN (Bitfield-Mask: 0x01)                         */
#define RCC_AHB1ENR_GPIODEN_Pos           (3UL)                     /*!< GPIODEN (Bit 3)                                       */
#define RCC_AHB1ENR_GPIODEN_Msk           (0x8UL)                   /*!< GPIODEN (Bitfield-Mask: 0x01)                         */
#define RCC_AHB1ENR_GPIOCEN_Pos           (2UL)                     /*!< GPIOCEN (Bit 2)                                       */
#define RCC_AHB1ENR_GPIOCEN_Msk           (0x4UL)                   /*!< GPIOCEN (Bitfield-Mask: 0x01)                         */
#define RCC_AHB1ENR_GPIOBEN_Pos           (1UL)                     /*!< GPIOBEN (Bit 1)                                       */
#define RCC_AHB1ENR_GPIOBEN_Msk           (0x2UL)                   /*!< GPIOBEN (Bitfield-Mask: 0x01)                         */
#define RCC_AHB1ENR_GPIOAEN_Pos           (0UL)                     /*!< GPIOAEN (Bit 0)                                       */
#define RCC_AHB1ENR_GPIOAEN_Msk           (0x1UL)                   /*!< GPIOAEN (Bitfield-Mask: 0x01)                         */
/* ========================================================  AHB2ENR  ======================================================== */
#define RCC_AHB2ENR_ADCEN_Pos             (5UL)                     /*!< ADCEN (Bit 5)                                         */
#define RCC_AHB2ENR_ADCEN_Msk             (0x20UL)                  /*!< ADCEN (Bitfield-Mask: 0x01)                           */
#define RCC_AHB2ENR_HASHEN_Pos            (4UL)                     /*!< HASHEN (Bit 4)                                        */
#define RCC_AHB2ENR_HASHEN_Msk            (0x10UL)                  /*!< HASHEN (Bitfield-Mask: 0x01)                          */
#define RCC_AHB2ENR_AESEN_Pos             (3UL)                     /*!< AESEN (Bit 3)                                         */
#define RCC_AHB2ENR_AESEN_Msk             (0x8UL)                   /*!< AESEN (Bitfield-Mask: 0x01)                           */
#define RCC_AHB2ENR_CRCEN_Pos             (2UL)                     /*!< CRCEN (Bit 2)                                         */
#define RCC_AHB2ENR_CRCEN_Msk             (0x4UL)                   /*!< CRCEN (Bitfield-Mask: 0x01)                           */
#define RCC_AHB2ENR_DMA1EN_Pos            (1UL)                     /*!< DMA1EN (Bit 1)                                        */
#define RCC_AHB2ENR_DMA1EN_Msk            (0x2UL)                   /*!< DMA1EN (Bitfield-Mask: 0x01)                          */
#define RCC_AHB2ENR_DMA0EN_Pos            (0UL)                     /*!< DMA0EN (Bit 0)                                        */
#define RCC_AHB2ENR_DMA0EN_Msk            (0x1UL)                   /*!< DMA0EN (Bitfield-Mask: 0x01)                          */
/* =======================================================  AHB2ENR1  ======================================================== */
#define RCC_AHB2ENR1_FLASHEN_Pos          (1UL)                     /*!< FLASHEN (Bit 1)                                       */
#define RCC_AHB2ENR1_FLASHEN_Msk          (0x2UL)                   /*!< FLASHEN (Bitfield-Mask: 0x01)                         */
/* ========================================================  APB1ENR  ======================================================== */
#define RCC_APB1ENR_PMUEN_Pos             (16UL)                    /*!< PMUEN (Bit 16)                                        */
#define RCC_APB1ENR_PMUEN_Msk             (0x10000UL)               /*!< PMUEN (Bitfield-Mask: 0x01)                           */
#define RCC_APB1ENR_USART6EN_Pos          (15UL)                    /*!< USART6EN (Bit 15)                                     */
#define RCC_APB1ENR_USART6EN_Msk          (0x8000UL)                /*!< USART6EN (Bitfield-Mask: 0x01)                        */
#define RCC_APB1ENR_SPI1EN_Pos            (14UL)                    /*!< SPI1EN (Bit 14)                                       */
#define RCC_APB1ENR_SPI1EN_Msk            (0x4000UL)                /*!< SPI1EN (Bitfield-Mask: 0x01)                          */
#define RCC_APB1ENR_SPI0EN_Pos            (13UL)                    /*!< SPI0EN (Bit 13)                                       */
#define RCC_APB1ENR_SPI0EN_Msk            (0x2000UL)                /*!< SPI0EN (Bitfield-Mask: 0x01)                          */
#define RCC_APB1ENR_DACEN_Pos             (12UL)                    /*!< DACEN (Bit 12)                                        */
#define RCC_APB1ENR_DACEN_Msk             (0x1000UL)                /*!< DACEN (Bitfield-Mask: 0x01)                           */
#define RCC_APB1ENR_WWDGEN_Pos            (11UL)                    /*!< WWDGEN (Bit 11)                                       */
#define RCC_APB1ENR_WWDGEN_Msk            (0x800UL)                 /*!< WWDGEN (Bitfield-Mask: 0x01)                          */
#define RCC_APB1ENR_USART5EN_Pos          (10UL)                    /*!< USART5EN (Bit 10)                                     */
#define RCC_APB1ENR_USART5EN_Msk          (0x400UL)                 /*!< USART5EN (Bitfield-Mask: 0x01)                        */
#define RCC_APB1ENR_USART4EN_Pos          (9UL)                     /*!< USART4EN (Bit 9)                                      */
#define RCC_APB1ENR_USART4EN_Msk          (0x200UL)                 /*!< USART4EN (Bitfield-Mask: 0x01)                        */
#define RCC_APB1ENR_I2C1EN_Pos            (8UL)                     /*!< I2C1EN (Bit 8)                                        */
#define RCC_APB1ENR_I2C1EN_Msk            (0x100UL)                 /*!< I2C1EN (Bitfield-Mask: 0x01)                          */
#define RCC_APB1ENR_I2C0EN_Pos            (7UL)                     /*!< I2C0EN (Bit 7)                                        */
#define RCC_APB1ENR_I2C0EN_Msk            (0x80UL)                  /*!< I2C0EN (Bitfield-Mask: 0x01)                          */
#define RCC_APB1ENR_RTCAPBEN_Pos          (6UL)                     /*!< RTCAPBEN (Bit 6)                                      */
#define RCC_APB1ENR_RTCAPBEN_Msk          (0x40UL)                  /*!< RTCAPBEN (Bitfield-Mask: 0x01)                        */
#define RCC_APB1ENR_GPTMR5EN_Pos          (5UL)                     /*!< GPTMR5EN (Bit 5)                                      */
#define RCC_APB1ENR_GPTMR5EN_Msk          (0x20UL)                  /*!< GPTMR5EN (Bitfield-Mask: 0x01)                        */
#define RCC_APB1ENR_GPTMR4EN_Pos          (4UL)                     /*!< GPTMR4EN (Bit 4)                                      */
#define RCC_APB1ENR_GPTMR4EN_Msk          (0x10UL)                  /*!< GPTMR4EN (Bitfield-Mask: 0x01)                        */
#define RCC_APB1ENR_GPTMR3EN_Pos          (3UL)                     /*!< GPTMR3EN (Bit 3)                                      */
#define RCC_APB1ENR_GPTMR3EN_Msk          (0x8UL)                   /*!< GPTMR3EN (Bitfield-Mask: 0x01)                        */
#define RCC_APB1ENR_GPTMR2EN_Pos          (2UL)                     /*!< GPTMR2EN (Bit 2)                                      */
#define RCC_APB1ENR_GPTMR2EN_Msk          (0x4UL)                   /*!< GPTMR2EN (Bitfield-Mask: 0x01)                        */
#define RCC_APB1ENR_GPTMR1EN_Pos          (1UL)                     /*!< GPTMR1EN (Bit 1)                                      */
#define RCC_APB1ENR_GPTMR1EN_Msk          (0x2UL)                   /*!< GPTMR1EN (Bitfield-Mask: 0x01)                        */
#define RCC_APB1ENR_GPTMR0EN_Pos          (0UL)                     /*!< GPTMR0EN (Bit 0)                                      */
#define RCC_APB1ENR_GPTMR0EN_Msk          (0x1UL)                   /*!< GPTMR0EN (Bitfield-Mask: 0x01)                        */
/* ========================================================  APB2ENR  ======================================================== */
#define RCC_APB2ENR_TRNGEN_Pos            (16UL)                    /*!< TRNGEN (Bit 16)                                       */
#define RCC_APB2ENR_TRNGEN_Msk            (0x10000UL)               /*!< TRNGEN (Bitfield-Mask: 0x01)                          */
#define RCC_APB2ENR_OA1EN_Pos             (15UL)                    /*!< OA1EN (Bit 15)                                        */
#define RCC_APB2ENR_OA1EN_Msk             (0x8000UL)                /*!< OA1EN (Bitfield-Mask: 0x01)                           */
#define RCC_APB2ENR_OA0EN_Pos             (14UL)                    /*!< OA0EN (Bit 14)                                        */
#define RCC_APB2ENR_OA0EN_Msk             (0x4000UL)                /*!< OA0EN (Bitfield-Mask: 0x01)                           */
#define RCC_APB2ENR_CMP1EN_Pos            (13UL)                    /*!< CMP1EN (Bit 13)                                       */
#define RCC_APB2ENR_CMP1EN_Msk            (0x2000UL)                /*!< CMP1EN (Bitfield-Mask: 0x01)                          */
#define RCC_APB2ENR_CMP0EN_Pos            (12UL)                    /*!< CMP0EN (Bit 12)                                       */
#define RCC_APB2ENR_CMP0EN_Msk            (0x1000UL)                /*!< CMP0EN (Bitfield-Mask: 0x01)                          */
#define RCC_APB2ENR_VREFBUFEN_Pos         (11UL)                    /*!< VREFBUFEN (Bit 11)                                    */
#define RCC_APB2ENR_VREFBUFEN_Msk         (0x800UL)                 /*!< VREFBUFEN (Bitfield-Mask: 0x01)                       */
#define RCC_APB2ENR_SPI2EN_Pos            (10UL)                    /*!< SPI2EN (Bit 10)                                       */
#define RCC_APB2ENR_SPI2EN_Msk            (0x400UL)                 /*!< SPI2EN (Bitfield-Mask: 0x01)                          */
#define RCC_APB2ENR_CANEN_Pos             (9UL)                     /*!< CANEN (Bit 9)                                         */
#define RCC_APB2ENR_CANEN_Msk             (0x200UL)                 /*!< CANEN (Bitfield-Mask: 0x01)                           */
#define RCC_APB2ENR_ADVTMR2EN_Pos         (8UL)                     /*!< ADVTMR2EN (Bit 8)                                     */
#define RCC_APB2ENR_ADVTMR2EN_Msk         (0x100UL)                 /*!< ADVTMR2EN (Bitfield-Mask: 0x01)                       */
#define RCC_APB2ENR_ADVTMR1EN_Pos         (7UL)                     /*!< ADVTMR1EN (Bit 7)                                     */
#define RCC_APB2ENR_ADVTMR1EN_Msk         (0x80UL)                  /*!< ADVTMR1EN (Bitfield-Mask: 0x01)                       */
#define RCC_APB2ENR_ADVTMR0EN_Pos         (6UL)                     /*!< ADVTMR0EN (Bit 6)                                     */
#define RCC_APB2ENR_ADVTMR0EN_Msk         (0x40UL)                  /*!< ADVTMR0EN (Bitfield-Mask: 0x01)                       */
#define RCC_APB2ENR_SYSCFGEN_Pos          (5UL)                     /*!< SYSCFGEN (Bit 5)                                      */
#define RCC_APB2ENR_SYSCFGEN_Msk          (0x20UL)                  /*!< SYSCFGEN (Bitfield-Mask: 0x01)                        */
#define RCC_APB2ENR_USART3EN_Pos          (4UL)                     /*!< USART3EN (Bit 4)                                      */
#define RCC_APB2ENR_USART3EN_Msk          (0x10UL)                  /*!< USART3EN (Bitfield-Mask: 0x01)                        */
#define RCC_APB2ENR_USART2EN_Pos          (3UL)                     /*!< USART2EN (Bit 3)                                      */
#define RCC_APB2ENR_USART2EN_Msk          (0x8UL)                   /*!< USART2EN (Bitfield-Mask: 0x01)                        */
#define RCC_APB2ENR_USART1EN_Pos          (2UL)                     /*!< USART1EN (Bit 2)                                      */
#define RCC_APB2ENR_USART1EN_Msk          (0x4UL)                   /*!< USART1EN (Bitfield-Mask: 0x01)                        */
#define RCC_APB2ENR_USART0EN_Pos          (1UL)                     /*!< USART0EN (Bit 1)                                      */
#define RCC_APB2ENR_USART0EN_Msk          (0x2UL)                   /*!< USART0EN (Bitfield-Mask: 0x01)                        */
#define RCC_APB2ENR_TPCEN_Pos             (0UL)                     /*!< TPCEN (Bit 0)                                         */
#define RCC_APB2ENR_TPCEN_Msk             (0x1UL)                   /*!< TPCEN (Bitfield-Mask: 0x01)                           */
/* =======================================================  PLLCFGR3  ======================================================== */
#define RCC_PLLCFGR3_PLLPFDCPCTRL_Pos     (26UL)                    /*!< PLLPFDCPCTRL (Bit 26)                                 */
#define RCC_PLLCFGR3_PLLPFDCPCTRL_Msk     (0x7c000000UL)            /*!< PLLPFDCPCTRL (Bitfield-Mask: 0x1f)                    */
#define RCC_PLLCFGR3_PLLLPF3RDBYPASS_Pos  (25UL)                    /*!< PLLLPF3RDBYPASS (Bit 25)                              */
#define RCC_PLLCFGR3_PLLLPF3RDBYPASS_Msk  (0x2000000UL)             /*!< PLLLPF3RDBYPASS (Bitfield-Mask: 0x01)                 */
#define RCC_PLLCFGR3_PLLLPFR3_Pos         (20UL)                    /*!< PLLLPFR3 (Bit 20)                                     */
#define RCC_PLLCFGR3_PLLLPFR3_Msk         (0x1f00000UL)             /*!< PLLLPFR3 (Bitfield-Mask: 0x1f)                        */
#define RCC_PLLCFGR3_PLLLPFR2_Pos         (15UL)                    /*!< PLLLPFR2 (Bit 15)                                     */
#define RCC_PLLCFGR3_PLLLPFR2_Msk         (0xf8000UL)               /*!< PLLLPFR2 (Bitfield-Mask: 0x1f)                        */
#define RCC_PLLCFGR3_PLLLPFC3_Pos         (10UL)                    /*!< PLLLPFC3 (Bit 10)                                     */
#define RCC_PLLCFGR3_PLLLPFC3_Msk         (0x7c00UL)                /*!< PLLLPFC3 (Bitfield-Mask: 0x1f)                        */
#define RCC_PLLCFGR3_PLLLPFC2_Pos         (5UL)                     /*!< PLLLPFC2 (Bit 5)                                      */
#define RCC_PLLCFGR3_PLLLPFC2_Msk         (0x3e0UL)                 /*!< PLLLPFC2 (Bitfield-Mask: 0x1f)                        */
#define RCC_PLLCFGR3_PLLLPFC1_Pos         (0UL)                     /*!< PLLLPFC1 (Bit 0)                                      */
#define RCC_PLLCFGR3_PLLLPFC1_Msk         (0x1fUL)                  /*!< PLLLPFC1 (Bitfield-Mask: 0x1f)                        */
/* =======================================================  PLLCFGR4  ======================================================== */
#define RCC_PLLCFGR4_PLLVCOCTRL_Pos       (12UL)                    /*!< PLLVCOCTRL (Bit 12)                                   */
#define RCC_PLLCFGR4_PLLVCOCTRL_Msk       (0x1f000UL)               /*!< PLLVCOCTRL (Bitfield-Mask: 0x1f)                      */
#define RCC_PLLCFGR4_PLLCLKTSTOL_Pos      (11UL)                    /*!< PLLCLKTSTOL (Bit 11)                                  */
#define RCC_PLLCFGR4_PLLCLKTSTOL_Msk      (0x800UL)                 /*!< PLLCLKTSTOL (Bitfield-Mask: 0x01)                     */
#define RCC_PLLCFGR4_PLLCLKTSTCTRL_Pos    (9UL)                     /*!< PLLCLKTSTCTRL (Bit 9)                                 */
#define RCC_PLLCFGR4_PLLCLKTSTCTRL_Msk    (0x600UL)                 /*!< PLLCLKTSTCTRL (Bitfield-Mask: 0x03)                   */
#define RCC_PLLCFGR4_PLLLOCKEDCTRL_Pos    (5UL)                     /*!< PLLLOCKEDCTRL (Bit 5)                                 */
#define RCC_PLLCFGR4_PLLLOCKEDCTRL_Msk    (0x1e0UL)                 /*!< PLLLOCKEDCTRL (Bitfield-Mask: 0x0f)                   */
#define RCC_PLLCFGR4_PLLTESTMUX_Pos       (1UL)                     /*!< PLLTESTMUX (Bit 1)                                    */
#define RCC_PLLCFGR4_PLLTESTMUX_Msk       (0x1eUL)                  /*!< PLLTESTMUX (Bitfield-Mask: 0x0f)                      */
#define RCC_PLLCFGR4_PLLTESTEN_Pos        (0UL)                     /*!< PLLTESTEN (Bit 0)                                     */
#define RCC_PLLCFGR4_PLLTESTEN_Msk        (0x1UL)                   /*!< PLLTESTEN (Bitfield-Mask: 0x01)                       */
/* =========================================================  CCIPR  ========================================================= */
#define RCC_CCIPR_PMUSEL_Pos              (20UL)                    /*!< PMUSEL (Bit 20)                                       */
#define RCC_CCIPR_PMUSEL_Msk              (0x300000UL)              /*!< PMUSEL (Bitfield-Mask: 0x03)                          */
#define RCC_CCIPR_TPCSEL_Pos              (18UL)                    /*!< TPCSEL (Bit 18)                                       */
#define RCC_CCIPR_TPCSEL_Msk              (0xc0000UL)               /*!< TPCSEL (Bitfield-Mask: 0x03)                          */
#define RCC_CCIPR_ADCSEL_Pos              (16UL)                    /*!< ADCSEL (Bit 16)                                       */
#define RCC_CCIPR_ADCSEL_Msk              (0x30000UL)               /*!< ADCSEL (Bitfield-Mask: 0x03)                          */
#define RCC_CCIPR_CANSEL_Pos              (14UL)                    /*!< CANSEL (Bit 14)                                       */
#define RCC_CCIPR_CANSEL_Msk              (0xc000UL)                /*!< CANSEL (Bitfield-Mask: 0x03)                          */
#define RCC_CCIPR_USART6SEL_Pos           (12UL)                    /*!< USART6SEL (Bit 12)                                    */
#define RCC_CCIPR_USART6SEL_Msk           (0x3000UL)                /*!< USART6SEL (Bitfield-Mask: 0x03)                       */
#define RCC_CCIPR_USART3SEL_Pos           (10UL)                    /*!< USART3SEL (Bit 10)                                    */
#define RCC_CCIPR_USART3SEL_Msk           (0xc00UL)                 /*!< USART3SEL (Bitfield-Mask: 0x03)                       */
#define RCC_CCIPR_USART2SEL_Pos           (8UL)                     /*!< USART2SEL (Bit 8)                                     */
#define RCC_CCIPR_USART2SEL_Msk           (0x300UL)                 /*!< USART2SEL (Bitfield-Mask: 0x03)                       */
#define RCC_CCIPR_USART1SEL_Pos           (6UL)                     /*!< USART1SEL (Bit 6)                                     */
#define RCC_CCIPR_USART1SEL_Msk           (0xc0UL)                  /*!< USART1SEL (Bitfield-Mask: 0x03)                       */
#define RCC_CCIPR_USART0SEL_Pos           (4UL)                     /*!< USART0SEL (Bit 4)                                     */
#define RCC_CCIPR_USART0SEL_Msk           (0x30UL)                  /*!< USART0SEL (Bitfield-Mask: 0x03)                       */
#define RCC_CCIPR_USART5SEL_Pos           (2UL)                     /*!< USART5SEL (Bit 2)                                     */
#define RCC_CCIPR_USART5SEL_Msk           (0xcUL)                   /*!< USART5SEL (Bitfield-Mask: 0x03)                       */
#define RCC_CCIPR_USART4SEL_Pos           (0UL)                     /*!< USART4SEL (Bit 0)                                     */
#define RCC_CCIPR_USART4SEL_Msk           (0x3UL)                   /*!< USART4SEL (Bitfield-Mask: 0x03)                       */
/* ==========================================================  CSR  ========================================================== */
#define RCC_CSR_LPWRRSTF_Pos              (31UL)                    /*!< LPWRRSTF (Bit 31)                                     */
#define RCC_CSR_LPWRRSTF_Msk              (0x80000000UL)            /*!< LPWRRSTF (Bitfield-Mask: 0x01)                        */
#define RCC_CSR_WWDGRSTF_Pos              (30UL)                    /*!< WWDGRSTF (Bit 30)                                     */
#define RCC_CSR_WWDGRSTF_Msk              (0x40000000UL)            /*!< WWDGRSTF (Bitfield-Mask: 0x01)                        */
#define RCC_CSR_IWDGRSTF_Pos              (29UL)                    /*!< IWDGRSTF (Bit 29)                                     */
#define RCC_CSR_IWDGRSTF_Msk              (0x20000000UL)            /*!< IWDGRSTF (Bitfield-Mask: 0x01)                        */
#define RCC_CSR_SFTRSTF_Pos               (28UL)                    /*!< SFTRSTF (Bit 28)                                      */
#define RCC_CSR_SFTRSTF_Msk               (0x10000000UL)            /*!< SFTRSTF (Bitfield-Mask: 0x01)                         */
#define RCC_CSR_BORRSTF_Pos               (27UL)                    /*!< BORRSTF (Bit 27)                                      */
#define RCC_CSR_BORRSTF_Msk               (0x8000000UL)             /*!< BORRSTF (Bitfield-Mask: 0x01)                         */
#define RCC_CSR_PINRSTF_Pos               (26UL)                    /*!< PINRSTF (Bit 26)                                      */
#define RCC_CSR_PINRSTF_Msk               (0x4000000UL)             /*!< PINRSTF (Bitfield-Mask: 0x01)                         */
#define RCC_CSR_OBLRSTF_Pos               (25UL)                    /*!< OBLRSTF (Bit 25)                                      */
#define RCC_CSR_OBLRSTF_Msk               (0x2000000UL)             /*!< OBLRSTF (Bitfield-Mask: 0x01)                         */
#define RCC_CSR_RMVF_Pos                  (23UL)                    /*!< RMVF (Bit 23)                                         */
#define RCC_CSR_RMVF_Msk                  (0x800000UL)              /*!< RMVF (Bitfield-Mask: 0x01)                            */
#define RCC_CSR_LSCOSEL_Pos               (1UL)                     /*!< LSCOSEL (Bit 1)                                       */
#define RCC_CSR_LSCOSEL_Msk               (0x2UL)                   /*!< LSCOSEL (Bitfield-Mask: 0x01)                         */
#define RCC_CSR_LSCOEN_Pos                (0UL)                     /*!< LSCOEN (Bit 0)                                        */
#define RCC_CSR_LSCOEN_Msk                (0x1UL)                   /*!< LSCOEN (Bitfield-Mask: 0x01)                          */
/* =========================================================  CFG2R  ========================================================= */
#define RCC_CFG2R_TPCDIV_Pos              (20UL)                    /*!< TPCDIV (Bit 20)                                       */
#define RCC_CFG2R_TPCDIV_Msk              (0x1f00000UL)             /*!< TPCDIV (Bitfield-Mask: 0x1f)                          */
#define RCC_CFG2R_ADCDIV_Pos              (16UL)                    /*!< ADCDIV (Bit 16)                                       */
#define RCC_CFG2R_ADCDIV_Msk              (0xf0000UL)               /*!< ADCDIV (Bitfield-Mask: 0x0f)                          */
/* =========================================================  CFG3R  ========================================================= */
#define RCC_CFG3R_CANTIMERDIV_Pos         (9UL)                     /*!< CANTIMERDIV (Bit 9)                                   */
#define RCC_CFG3R_CANTIMERDIV_Msk         (0xe00UL)                 /*!< CANTIMERDIV (Bitfield-Mask: 0x07)                     */
#define RCC_CFG3R_TRACEDIV_Pos            (0UL)                     /*!< TRACEDIV (Bit 0)                                      */
#define RCC_CFG3R_TRACEDIV_Msk            (0x1ffUL)                 /*!< TRACEDIV (Bitfield-Mask: 0x1ff)                       */
/* =========================================================  BDCR  ========================================================== */
#define RCC_BDCR_RSTRDY_Pos               (20UL)                    /*!< RSTRDY (Bit 20)                                       */
#define RCC_BDCR_RSTRDY_Msk               (0x100000UL)              /*!< RSTRDY (Bitfield-Mask: 0x01)                          */
#define RCC_BDCR_BDRST_Pos                (19UL)                    /*!< BDRST (Bit 19)                                        */
#define RCC_BDCR_BDRST_Msk                (0x80000UL)               /*!< BDRST (Bitfield-Mask: 0x01)                           */
#define RCC_BDCR_RTCEN_Pos                (18UL)                    /*!< RTCEN (Bit 18)                                        */
#define RCC_BDCR_RTCEN_Msk                (0x40000UL)               /*!< RTCEN (Bitfield-Mask: 0x01)                           */
#define RCC_BDCR_ILSRDY_Pos               (17UL)                    /*!< ILSRDY (Bit 17)                                       */
#define RCC_BDCR_ILSRDY_Msk               (0x20000UL)               /*!< ILSRDY (Bitfield-Mask: 0x01)                          */
#define RCC_BDCR_ILSON_Pos                (16UL)                    /*!< ILSON (Bit 16)                                        */
#define RCC_BDCR_ILSON_Msk                (0x10000UL)               /*!< ILSON (Bitfield-Mask: 0x01)                           */
#define RCC_BDCR_RTCSEL_Pos               (14UL)                    /*!< RTCSEL (Bit 14)                                       */
#define RCC_BDCR_RTCSEL_Msk               (0xc000UL)                /*!< RTCSEL (Bitfield-Mask: 0x03)                          */
#define RCC_BDCR_ELSCSSD_Pos              (13UL)                    /*!< ELSCSSD (Bit 13)                                      */
#define RCC_BDCR_ELSCSSD_Msk              (0x2000UL)                /*!< ELSCSSD (Bitfield-Mask: 0x01)                         */
#define RCC_BDCR_ELSCSSON_Pos             (12UL)                    /*!< ELSCSSON (Bit 12)                                     */
#define RCC_BDCR_ELSCSSON_Msk             (0x1000UL)                /*!< ELSCSSON (Bitfield-Mask: 0x01)                        */
#define RCC_BDCR_ELSCTRL_Pos              (4UL)                     /*!< ELSCTRL (Bit 4)                                       */
#define RCC_BDCR_ELSCTRL_Msk              (0xff0UL)                 /*!< ELSCTRL (Bitfield-Mask: 0xff)                         */
#define RCC_BDCR_ELSBYP_Pos               (3UL)                     /*!< ELSBYP (Bit 3)                                        */
#define RCC_BDCR_ELSBYP_Msk               (0x8UL)                   /*!< ELSBYP (Bitfield-Mask: 0x01)                          */
#define RCC_BDCR_ELSFASTREADYEN_Pos       (2UL)                     /*!< ELSFASTREADYEN (Bit 2)                                */
#define RCC_BDCR_ELSFASTREADYEN_Msk       (0x4UL)                   /*!< ELSFASTREADYEN (Bitfield-Mask: 0x01)                  */
#define RCC_BDCR_ELSRDY_Pos               (1UL)                     /*!< ELSRDY (Bit 1)                                        */
#define RCC_BDCR_ELSRDY_Msk               (0x2UL)                   /*!< ELSRDY (Bitfield-Mask: 0x01)                          */
#define RCC_BDCR_ELSON_Pos                (0UL)                     /*!< ELSON (Bit 0)                                         */
#define RCC_BDCR_ELSON_Msk                (0x1UL)                   /*!< ELSON (Bitfield-Mask: 0x01)                           */
/* =========================================================  BDCR2  ========================================================= */
#define RCC_BDCR2_ILSTRIM_Pos             (0UL)                     /*!< ILSTRIM (Bit 0)                                       */
#define RCC_BDCR2_ILSTRIM_Msk             (0xfffUL)                 /*!< ILSTRIM (Bitfield-Mask: 0xfff)                        */
/* =========================================================  BDCR3  ========================================================= */
#define RCC_BDCR3_ILSRESERVED_Pos         (21UL)                    /*!< ILSRESERVED (Bit 21)                                  */
#define RCC_BDCR3_ILSRESERVED_Msk         (0x1fe00000UL)            /*!< ILSRESERVED (Bitfield-Mask: 0xff)                     */
#define RCC_BDCR3_ILSTESTMUX_Pos          (17UL)                    /*!< ILSTESTMUX (Bit 17)                                   */
#define RCC_BDCR3_ILSTESTMUX_Msk          (0x1e0000UL)              /*!< ILSTESTMUX (Bitfield-Mask: 0x0f)                      */
#define RCC_BDCR3_ILSTESTEN_Pos           (16UL)                    /*!< ILSTESTEN (Bit 16)                                    */
#define RCC_BDCR3_ILSTESTEN_Msk           (0x10000UL)               /*!< ILSTESTEN (Bitfield-Mask: 0x01)                       */
/* =========================================================  BDCR4  ========================================================= */
#define RCC_BDCR4_ELSCSSTARGETCLKCNTEND_Pos (8UL)                   /*!< ELSCSSTARGETCLKCNTEND (Bit 8)                         */
#define RCC_BDCR4_ELSCSSTARGETCLKCNTEND_Msk (0xff00UL)              /*!< ELSCSSTARGETCLKCNTEND (Bitfield-Mask: 0xff)           */
#define RCC_BDCR4_ELSCSSLOCALCLKCNTEND_Pos (0UL)                    /*!< ELSCSSLOCALCLKCNTEND (Bit 0)                          */
#define RCC_BDCR4_ELSCSSLOCALCLKCNTEND_Msk (0xffUL)                 /*!< ELSCSSLOCALCLKCNTEND (Bitfield-Mask: 0xff)            */
/* =========================================================  BDCR5  ========================================================= */
#define RCC_BDCR5_ELSDLYEN_Pos            (16UL)                    /*!< ELSDLYEN (Bit 16)                                     */
#define RCC_BDCR5_ELSDLYEN_Msk            (0x10000UL)               /*!< ELSDLYEN (Bitfield-Mask: 0x01)                        */
#define RCC_BDCR5_ELSIBSTEPDLY_Pos        (8UL)                     /*!< ELSIBSTEPDLY (Bit 8)                                  */
#define RCC_BDCR5_ELSIBSTEPDLY_Msk        (0xff00UL)                /*!< ELSIBSTEPDLY (Bitfield-Mask: 0xff)                    */
#define RCC_BDCR5_ELSPREIBDLY_Pos         (0UL)                     /*!< ELSPREIBDLY (Bit 0)                                   */
#define RCC_BDCR5_ELSPREIBDLY_Msk         (0xffUL)                  /*!< ELSPREIBDLY (Bitfield-Mask: 0xff)                     */
/* =========================================================  BDCR6  ========================================================= */
#define RCC_BDCR6_ELSSTIB_Pos             (3UL)                     /*!< ELSSTIB (Bit 3)                                       */
#define RCC_BDCR6_ELSSTIB_Msk             (0x78UL)                  /*!< ELSSTIB (Bitfield-Mask: 0x0f)                         */
#define RCC_BDCR6_ELSSTIBSWEN_Pos         (2UL)                     /*!< ELSSTIBSWEN (Bit 2)                                   */
#define RCC_BDCR6_ELSSTIBSWEN_Msk         (0x4UL)                   /*!< ELSSTIBSWEN (Bitfield-Mask: 0x01)                     */
#define RCC_BDCR6_ELSSTIBPD_Pos           (1UL)                     /*!< ELSSTIBPD (Bit 1)                                     */
#define RCC_BDCR6_ELSSTIBPD_Msk           (0x2UL)                   /*!< ELSSTIBPD (Bitfield-Mask: 0x01)                       */
#define RCC_BDCR6_ELSTESTEN_Pos           (0UL)                     /*!< ELSTESTEN (Bit 0)                                     */
#define RCC_BDCR6_ELSTESTEN_Msk           (0x1UL)                   /*!< ELSTESTEN (Bitfield-Mask: 0x01)                       */
/* =========================================================  BDCR7  ========================================================= */
#define RCC_BDCR7_SWITCHD0EN_Pos          (0UL)                     /*!< SWITCHD0EN (Bit 0)                                    */
#define RCC_BDCR7_SWITCHD0EN_Msk          (0x1UL)                   /*!< SWITCHD0EN (Bitfield-Mask: 0x01)                      */


/* =========================================================================================================================== */
/* ================                                           DMA                                             ================ */
/* =========================================================================================================================== */

/* ========================================================  INTSTS0  ======================================================== */
#define DMA_INTSTS0_CH3FULLTRANSFERINT_Pos (27UL)                  /*!< CH3FULLTRANSFERINT (Bit 27)                           */
#define DMA_INTSTS0_CH3FULLTRANSFERINT_Msk (0x8000000UL)           /*!< CH3FULLTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS0_CH3HALFTRANSFERINT_Pos (26UL)                  /*!< CH3HALFTRANSFERINT (Bit 26)                           */
#define DMA_INTSTS0_CH3HALFTRANSFERINT_Msk (0x4000000UL)           /*!< CH3HALFTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS0_CH3TRANSFERERRINT_Pos (25UL)                   /*!< CH3TRANSFERERRINT (Bit 25)                            */
#define DMA_INTSTS0_CH3TRANSFERERRINT_Msk (0x2000000UL)            /*!< CH3TRANSFERERRINT (Bitfield-Mask: 0x01)               */
#define DMA_INTSTS0_CH3DIRECTMODEERRINT_Pos (24UL)                 /*!< CH3DIRECTMODEERRINT (Bit 24)                          */
#define DMA_INTSTS0_CH3DIRECTMODEERRINT_Msk (0x1000000UL)          /*!< CH3DIRECTMODEERRINT (Bitfield-Mask: 0x01)             */
#define DMA_INTSTS0_CH3FIFOERRINT_Pos    (22UL)                    /*!< CH3FIFOERRINT (Bit 22)                                */
#define DMA_INTSTS0_CH3FIFOERRINT_Msk    (0x400000UL)              /*!< CH3FIFOERRINT (Bitfield-Mask: 0x01)                   */
#define DMA_INTSTS0_CH2FULLTRANSFERINT_Pos (21UL)                  /*!< CH2FULLTRANSFERINT (Bit 21)                           */
#define DMA_INTSTS0_CH2FULLTRANSFERINT_Msk (0x200000UL)            /*!< CH2FULLTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS0_CH2HALFTRANSFERINT_Pos (20UL)                  /*!< CH2HALFTRANSFERINT (Bit 20)                           */
#define DMA_INTSTS0_CH2HALFTRANSFERINT_Msk (0x100000UL)            /*!< CH2HALFTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS0_CH2TRANSFERERRINT_Pos (19UL)                   /*!< CH2TRANSFERERRINT (Bit 19)                            */
#define DMA_INTSTS0_CH2TRANSFERERRINT_Msk (0x80000UL)              /*!< CH2TRANSFERERRINT (Bitfield-Mask: 0x01)               */
#define DMA_INTSTS0_CH2DIRECTMODEERRINT_Pos (18UL)                 /*!< CH2DIRECTMODEERRINT (Bit 18)                          */
#define DMA_INTSTS0_CH2DIRECTMODEERRINT_Msk (0x40000UL)            /*!< CH2DIRECTMODEERRINT (Bitfield-Mask: 0x01)             */
#define DMA_INTSTS0_CH2FIFOERRINT_Pos    (16UL)                    /*!< CH2FIFOERRINT (Bit 16)                                */
#define DMA_INTSTS0_CH2FIFOERRINT_Msk    (0x10000UL)               /*!< CH2FIFOERRINT (Bitfield-Mask: 0x01)                   */
#define DMA_INTSTS0_CH1FULLTRANSFERINT_Pos (11UL)                  /*!< CH1FULLTRANSFERINT (Bit 11)                           */
#define DMA_INTSTS0_CH1FULLTRANSFERINT_Msk (0x800UL)               /*!< CH1FULLTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS0_CH1HALFTRANSFERINT_Pos (10UL)                  /*!< CH1HALFTRANSFERINT (Bit 10)                           */
#define DMA_INTSTS0_CH1HALFTRANSFERINT_Msk (0x400UL)               /*!< CH1HALFTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS0_CH1TRANSFERERRINT_Pos (9UL)                    /*!< CH1TRANSFERERRINT (Bit 9)                             */
#define DMA_INTSTS0_CH1TRANSFERERRINT_Msk (0x200UL)                /*!< CH1TRANSFERERRINT (Bitfield-Mask: 0x01)               */
#define DMA_INTSTS0_CH1DIRECTMODEERRINT_Pos (8UL)                  /*!< CH1DIRECTMODEERRINT (Bit 8)                           */
#define DMA_INTSTS0_CH1DIRECTMODEERRINT_Msk (0x100UL)              /*!< CH1DIRECTMODEERRINT (Bitfield-Mask: 0x01)             */
#define DMA_INTSTS0_CH1FIFOERRINT_Pos    (6UL)                     /*!< CH1FIFOERRINT (Bit 6)                                 */
#define DMA_INTSTS0_CH1FIFOERRINT_Msk    (0x40UL)                  /*!< CH1FIFOERRINT (Bitfield-Mask: 0x01)                   */
#define DMA_INTSTS0_CH0FULLTRANSFERINT_Pos (5UL)                   /*!< CH0FULLTRANSFERINT (Bit 5)                            */
#define DMA_INTSTS0_CH0FULLTRANSFERINT_Msk (0x20UL)                /*!< CH0FULLTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS0_CH0HALFTRANSFERINT_Pos (4UL)                   /*!< CH0HALFTRANSFERINT (Bit 4)                            */
#define DMA_INTSTS0_CH0HALFTRANSFERINT_Msk (0x10UL)                /*!< CH0HALFTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS0_CH0TRANSFERERRINT_Pos (3UL)                    /*!< CH0TRANSFERERRINT (Bit 3)                             */
#define DMA_INTSTS0_CH0TRANSFERERRINT_Msk (0x8UL)                  /*!< CH0TRANSFERERRINT (Bitfield-Mask: 0x01)               */
#define DMA_INTSTS0_CH0DIRECTMODEERRINT_Pos (2UL)                  /*!< CH0DIRECTMODEERRINT (Bit 2)                           */
#define DMA_INTSTS0_CH0DIRECTMODEERRINT_Msk (0x4UL)                /*!< CH0DIRECTMODEERRINT (Bitfield-Mask: 0x01)             */
#define DMA_INTSTS0_CH0FIFOERRINT_Pos    (0UL)                     /*!< CH0FIFOERRINT (Bit 0)                                 */
#define DMA_INTSTS0_CH0FIFOERRINT_Msk    (0x1UL)                   /*!< CH0FIFOERRINT (Bitfield-Mask: 0x01)                   */
/* ========================================================  INTSTS1  ======================================================== */
#define DMA_INTSTS1_CH7FULLTRANSFERINT_Pos (27UL)                  /*!< CH7FULLTRANSFERINT (Bit 27)                           */
#define DMA_INTSTS1_CH7FULLTRANSFERINT_Msk (0x8000000UL)           /*!< CH7FULLTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS1_CH7HALFTRANSFERINT_Pos (26UL)                  /*!< CH7HALFTRANSFERINT (Bit 26)                           */
#define DMA_INTSTS1_CH7HALFTRANSFERINT_Msk (0x4000000UL)           /*!< CH7HALFTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS1_CH7TRANSFERERRINT_Pos (25UL)                   /*!< CH7TRANSFERERRINT (Bit 25)                            */
#define DMA_INTSTS1_CH7TRANSFERERRINT_Msk (0x2000000UL)            /*!< CH7TRANSFERERRINT (Bitfield-Mask: 0x01)               */
#define DMA_INTSTS1_CH7DIRECTMODEERRINT_Pos (24UL)                 /*!< CH7DIRECTMODEERRINT (Bit 24)                          */
#define DMA_INTSTS1_CH7DIRECTMODEERRINT_Msk (0x1000000UL)          /*!< CH7DIRECTMODEERRINT (Bitfield-Mask: 0x01)             */
#define DMA_INTSTS1_CH7FIFOERRINT_Pos    (22UL)                    /*!< CH7FIFOERRINT (Bit 22)                                */
#define DMA_INTSTS1_CH7FIFOERRINT_Msk    (0x400000UL)              /*!< CH7FIFOERRINT (Bitfield-Mask: 0x01)                   */
#define DMA_INTSTS1_CH6FULLTRANSFERINT_Pos (21UL)                  /*!< CH6FULLTRANSFERINT (Bit 21)                           */
#define DMA_INTSTS1_CH6FULLTRANSFERINT_Msk (0x200000UL)            /*!< CH6FULLTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS1_CH6HALFTRANSFERINT_Pos (20UL)                  /*!< CH6HALFTRANSFERINT (Bit 20)                           */
#define DMA_INTSTS1_CH6HALFTRANSFERINT_Msk (0x100000UL)            /*!< CH6HALFTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS1_CH6TRANSFERERRINT_Pos (19UL)                   /*!< CH6TRANSFERERRINT (Bit 19)                            */
#define DMA_INTSTS1_CH6TRANSFERERRINT_Msk (0x80000UL)              /*!< CH6TRANSFERERRINT (Bitfield-Mask: 0x01)               */
#define DMA_INTSTS1_CH6DIRECTMODEERRINT_Pos (18UL)                 /*!< CH6DIRECTMODEERRINT (Bit 18)                          */
#define DMA_INTSTS1_CH6DIRECTMODEERRINT_Msk (0x40000UL)            /*!< CH6DIRECTMODEERRINT (Bitfield-Mask: 0x01)             */
#define DMA_INTSTS1_CH6FIFOERRINT_Pos    (16UL)                    /*!< CH6FIFOERRINT (Bit 16)                                */
#define DMA_INTSTS1_CH6FIFOERRINT_Msk    (0x10000UL)               /*!< CH6FIFOERRINT (Bitfield-Mask: 0x01)                   */
#define DMA_INTSTS1_CH5FULLTRANSFERINT_Pos (11UL)                  /*!< CH5FULLTRANSFERINT (Bit 11)                           */
#define DMA_INTSTS1_CH5FULLTRANSFERINT_Msk (0x800UL)               /*!< CH5FULLTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS1_CH5HALFTRANSFERINT_Pos (10UL)                  /*!< CH5HALFTRANSFERINT (Bit 10)                           */
#define DMA_INTSTS1_CH5HALFTRANSFERINT_Msk (0x400UL)               /*!< CH5HALFTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS1_CH5TRANSFERERRINT_Pos (9UL)                    /*!< CH5TRANSFERERRINT (Bit 9)                             */
#define DMA_INTSTS1_CH5TRANSFERERRINT_Msk (0x200UL)                /*!< CH5TRANSFERERRINT (Bitfield-Mask: 0x01)               */
#define DMA_INTSTS1_CH5DIRECTMODEERRINT_Pos (8UL)                  /*!< CH5DIRECTMODEERRINT (Bit 8)                           */
#define DMA_INTSTS1_CH5DIRECTMODEERRINT_Msk (0x100UL)              /*!< CH5DIRECTMODEERRINT (Bitfield-Mask: 0x01)             */
#define DMA_INTSTS1_CH5FIFOERRINT_Pos    (6UL)                     /*!< CH5FIFOERRINT (Bit 6)                                 */
#define DMA_INTSTS1_CH5FIFOERRINT_Msk    (0x40UL)                  /*!< CH5FIFOERRINT (Bitfield-Mask: 0x01)                   */
#define DMA_INTSTS1_CH4FULLTRANSFERINT_Pos (5UL)                   /*!< CH4FULLTRANSFERINT (Bit 5)                            */
#define DMA_INTSTS1_CH4FULLTRANSFERINT_Msk (0x20UL)                /*!< CH4FULLTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS1_CH4HALFTRANSFERINT_Pos (4UL)                   /*!< CH4HALFTRANSFERINT (Bit 4)                            */
#define DMA_INTSTS1_CH4HALFTRANSFERINT_Msk (0x10UL)                /*!< CH4HALFTRANSFERINT (Bitfield-Mask: 0x01)              */
#define DMA_INTSTS1_CH4TRANSFERERRINT_Pos (3UL)                    /*!< CH4TRANSFERERRINT (Bit 3)                             */
#define DMA_INTSTS1_CH4TRANSFERERRINT_Msk (0x8UL)                  /*!< CH4TRANSFERERRINT (Bitfield-Mask: 0x01)               */
#define DMA_INTSTS1_CH4DIRECTMODEERRINT_Pos (2UL)                  /*!< CH4DIRECTMODEERRINT (Bit 2)                           */
#define DMA_INTSTS1_CH4DIRECTMODEERRINT_Msk (0x4UL)                /*!< CH4DIRECTMODEERRINT (Bitfield-Mask: 0x01)             */
#define DMA_INTSTS1_CH4FIFOERRINT_Pos    (0UL)                     /*!< CH4FIFOERRINT (Bit 0)                                 */
#define DMA_INTSTS1_CH4FIFOERRINT_Msk    (0x1UL)                   /*!< CH4FIFOERRINT (Bitfield-Mask: 0x01)                   */
/* ========================================================  INTCLR0  ======================================================== */
#define DMA_INTCLR0_CH3FULLTRANSFERINTCLR_Pos (27UL)               /*!< CH3FULLTRANSFERINTCLR (Bit 27)                        */
#define DMA_INTCLR0_CH3FULLTRANSFERINTCLR_Msk (0x8000000UL)        /*!< CH3FULLTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR0_CH3HALFTRANSFERINTCLR_Pos (26UL)               /*!< CH3HALFTRANSFERINTCLR (Bit 26)                        */
#define DMA_INTCLR0_CH3HALFTRANSFERINTCLR_Msk (0x4000000UL)        /*!< CH3HALFTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR0_CH3TRANSFERERRINTCLR_Pos (25UL)                /*!< CH3TRANSFERERRINTCLR (Bit 25)                         */
#define DMA_INTCLR0_CH3TRANSFERERRINTCLR_Msk (0x2000000UL)         /*!< CH3TRANSFERERRINTCLR (Bitfield-Mask: 0x01)            */
#define DMA_INTCLR0_CH3DIRECTMODEERRINTCLR_Pos (24UL)              /*!< CH3DIRECTMODEERRINTCLR (Bit 24)                       */
#define DMA_INTCLR0_CH3DIRECTMODEERRINTCLR_Msk (0x1000000UL)       /*!< CH3DIRECTMODEERRINTCLR (Bitfield-Mask: 0x01)          */
#define DMA_INTCLR0_CH3FIFOERRINTCLR_Pos (22UL)                    /*!< CH3FIFOERRINTCLR (Bit 22)                             */
#define DMA_INTCLR0_CH3FIFOERRINTCLR_Msk (0x400000UL)              /*!< CH3FIFOERRINTCLR (Bitfield-Mask: 0x01)                */
#define DMA_INTCLR0_CH2FULLTRANSFERINTCLR_Pos (21UL)               /*!< CH2FULLTRANSFERINTCLR (Bit 21)                        */
#define DMA_INTCLR0_CH2FULLTRANSFERINTCLR_Msk (0x200000UL)         /*!< CH2FULLTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR0_CH2HALFTRANSFERINTCLR_Pos (20UL)               /*!< CH2HALFTRANSFERINTCLR (Bit 20)                        */
#define DMA_INTCLR0_CH2HALFTRANSFERINTCLR_Msk (0x100000UL)         /*!< CH2HALFTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR0_CH2TRANSFERERRINTCLR_Pos (19UL)                /*!< CH2TRANSFERERRINTCLR (Bit 19)                         */
#define DMA_INTCLR0_CH2TRANSFERERRINTCLR_Msk (0x80000UL)           /*!< CH2TRANSFERERRINTCLR (Bitfield-Mask: 0x01)            */
#define DMA_INTCLR0_CH2DIRECTMODEERRINTCLR_Pos (18UL)              /*!< CH2DIRECTMODEERRINTCLR (Bit 18)                       */
#define DMA_INTCLR0_CH2DIRECTMODEERRINTCLR_Msk (0x40000UL)         /*!< CH2DIRECTMODEERRINTCLR (Bitfield-Mask: 0x01)          */
#define DMA_INTCLR0_CH2FIFOERRINTCLR_Pos (16UL)                    /*!< CH2FIFOERRINTCLR (Bit 16)                             */
#define DMA_INTCLR0_CH2FIFOERRINTCLR_Msk (0x10000UL)               /*!< CH2FIFOERRINTCLR (Bitfield-Mask: 0x01)                */
#define DMA_INTCLR0_CH1FULLTRANSFERINTCLR_Pos (11UL)               /*!< CH1FULLTRANSFERINTCLR (Bit 11)                        */
#define DMA_INTCLR0_CH1FULLTRANSFERINTCLR_Msk (0x800UL)            /*!< CH1FULLTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR0_CH1HALFTRANSFERINTCLR_Pos (10UL)               /*!< CH1HALFTRANSFERINTCLR (Bit 10)                        */
#define DMA_INTCLR0_CH1HALFTRANSFERINTCLR_Msk (0x400UL)            /*!< CH1HALFTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR0_CH1TRANSFERERRINTCLR_Pos (9UL)                 /*!< CH1TRANSFERERRINTCLR (Bit 9)                          */
#define DMA_INTCLR0_CH1TRANSFERERRINTCLR_Msk (0x200UL)             /*!< CH1TRANSFERERRINTCLR (Bitfield-Mask: 0x01)            */
#define DMA_INTCLR0_CH1DIRECTMODEERRINTCLR_Pos (8UL)               /*!< CH1DIRECTMODEERRINTCLR (Bit 8)                        */
#define DMA_INTCLR0_CH1DIRECTMODEERRINTCLR_Msk (0x100UL)           /*!< CH1DIRECTMODEERRINTCLR (Bitfield-Mask: 0x01)          */
#define DMA_INTCLR0_CH1FIFOERRINTCLR_Pos (6UL)                     /*!< CH1FIFOERRINTCLR (Bit 6)                              */
#define DMA_INTCLR0_CH1FIFOERRINTCLR_Msk (0x40UL)                  /*!< CH1FIFOERRINTCLR (Bitfield-Mask: 0x01)                */
#define DMA_INTCLR0_CH0FULLTRANSFERINTCLR_Pos (5UL)                /*!< CH0FULLTRANSFERINTCLR (Bit 5)                         */
#define DMA_INTCLR0_CH0FULLTRANSFERINTCLR_Msk (0x20UL)             /*!< CH0FULLTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR0_CH0HALFTRANSFERINTCLR_Pos (4UL)                /*!< CH0HALFTRANSFERINTCLR (Bit 4)                         */
#define DMA_INTCLR0_CH0HALFTRANSFERINTCLR_Msk (0x10UL)             /*!< CH0HALFTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR0_CH0TRANSFERERRINTCLR_Pos (3UL)                 /*!< CH0TRANSFERERRINTCLR (Bit 3)                          */
#define DMA_INTCLR0_CH0TRANSFERERRINTCLR_Msk (0x8UL)               /*!< CH0TRANSFERERRINTCLR (Bitfield-Mask: 0x01)            */
#define DMA_INTCLR0_CH0DIRECTMODEERRINTCLR_Pos (2UL)               /*!< CH0DIRECTMODEERRINTCLR (Bit 2)                        */
#define DMA_INTCLR0_CH0DIRECTMODEERRINTCLR_Msk (0x4UL)             /*!< CH0DIRECTMODEERRINTCLR (Bitfield-Mask: 0x01)          */
#define DMA_INTCLR0_CH0FIFOERRINTCLR_Pos (0UL)                     /*!< CH0FIFOERRINTCLR (Bit 0)                              */
#define DMA_INTCLR0_CH0FIFOERRINTCLR_Msk (0x1UL)                   /*!< CH0FIFOERRINTCLR (Bitfield-Mask: 0x01)                */
/* ======================================================  INTCLR1  ======================================================= */
#define DMA_INTCLR1_CH7FULLTRANSFERINTCLR_Pos (27UL)            /*!< CH7FULLTRANSFERINTCLR (Bit 27)                        */
#define DMA_INTCLR1_CH7FULLTRANSFERINTCLR_Msk (0x8000000UL)     /*!< CH7FULLTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR1_CH7HALFTRANSFERINTCLR_Pos (26UL)            /*!< CH7HALFTRANSFERINTCLR (Bit 26)                        */
#define DMA_INTCLR1_CH7HALFTRANSFERINTCLR_Msk (0x4000000UL)     /*!< CH7HALFTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR1_CH7TRANSFERERRINTCLR_Pos (25UL)             /*!< CH7TRANSFERERRINTCLR (Bit 25)                         */
#define DMA_INTCLR1_CH7TRANSFERERRINTCLR_Msk (0x2000000UL)      /*!< CH7TRANSFERERRINTCLR (Bitfield-Mask: 0x01)            */
#define DMA_INTCLR1_CH7DIRECTMODEERRINTCLR_Pos (24UL)           /*!< CH7DIRECTMODEERRINTCLR (Bit 24)                       */
#define DMA_INTCLR1_CH7DIRECTMODEERRINTCLR_Msk (0x1000000UL)    /*!< CH7DIRECTMODEERRINTCLR (Bitfield-Mask: 0x01)          */
#define DMA_INTCLR1_CH7FIFOERRINTCLR_Pos (22UL)                 /*!< CH7FIFOERRINTCLR (Bit 22)                             */
#define DMA_INTCLR1_CH7FIFOERRINTCLR_Msk (0x400000UL)           /*!< CH7FIFOERRINTCLR (Bitfield-Mask: 0x01)                */
#define DMA_INTCLR1_CH6FULLTRANSFERINTCLR_Pos (21UL)            /*!< CH6FULLTRANSFERINTCLR (Bit 21)                        */
#define DMA_INTCLR1_CH6FULLTRANSFERINTCLR_Msk (0x200000UL)      /*!< CH6FULLTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR1_CH6HALFTRANSFERINTCLR_Pos (20UL)            /*!< CH6HALFTRANSFERINTCLR (Bit 20)                        */
#define DMA_INTCLR1_CH6HALFTRANSFERINTCLR_Msk (0x100000UL)      /*!< CH6HALFTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR1_CH6TRANSFERERRINTCLR_Pos (19UL)             /*!< CH6TRANSFERERRINTCLR (Bit 19)                         */
#define DMA_INTCLR1_CH6TRANSFERERRINTCLR_Msk (0x80000UL)        /*!< CH6TRANSFERERRINTCLR (Bitfield-Mask: 0x01)            */
#define DMA_INTCLR1_CH6DIRECTMODEERRINTCLR_Pos (18UL)           /*!< CH6DIRECTMODEERRINTCLR (Bit 18)                       */
#define DMA_INTCLR1_CH6DIRECTMODEERRINTCLR_Msk (0x40000UL)      /*!< CH6DIRECTMODEERRINTCLR (Bitfield-Mask: 0x01)          */
#define DMA_INTCLR1_CH6FIFOERRINTCLR_Pos (16UL)                 /*!< CH6FIFOERRINTCLR (Bit 16)                             */
#define DMA_INTCLR1_CH6FIFOERRINTCLR_Msk (0x10000UL)            /*!< CH6FIFOERRINTCLR (Bitfield-Mask: 0x01)                */
#define DMA_INTCLR1_CH5FULLTRANSFERINTCLR_Pos (11UL)            /*!< CH5FULLTRANSFERINTCLR (Bit 11)                        */
#define DMA_INTCLR1_CH5FULLTRANSFERINTCLR_Msk (0x800UL)         /*!< CH5FULLTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR1_CH5HALFTRANSFERINTCLR_Pos (10UL)            /*!< CH5HALFTRANSFERINTCLR (Bit 10)                        */
#define DMA_INTCLR1_CH5HALFTRANSFERINTCLR_Msk (0x400UL)         /*!< CH5HALFTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR1_CH5TRANSFERERRINTCLR_Pos (9UL)              /*!< CH5TRANSFERERRINTCLR (Bit 9)                          */
#define DMA_INTCLR1_CH5TRANSFERERRINTCLR_Msk (0x200UL)          /*!< CH5TRANSFERERRINTCLR (Bitfield-Mask: 0x01)            */
#define DMA_INTCLR1_CH5DIRECTMODEERRINTCLR_Pos (8UL)            /*!< CH5DIRECTMODEERRINTCLR (Bit 8)                        */
#define DMA_INTCLR1_CH5DIRECTMODEERRINTCLR_Msk (0x100UL)        /*!< CH5DIRECTMODEERRINTCLR (Bitfield-Mask: 0x01)          */
#define DMA_INTCLR1_CH5FIFOERRINTCLR_Pos (6UL)                  /*!< CH5FIFOERRINTCLR (Bit 6)                              */
#define DMA_INTCLR1_CH5FIFOERRINTCLR_Msk (0x40UL)               /*!< CH5FIFOERRINTCLR (Bitfield-Mask: 0x01)                */
#define DMA_INTCLR1_CH4FULLTRANSFERINTCLR_Pos (5UL)             /*!< CH4FULLTRANSFERINTCLR (Bit 5)                         */
#define DMA_INTCLR1_CH4FULLTRANSFERINTCLR_Msk (0x20UL)          /*!< CH4FULLTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR1_CH4HALFTRANSFERINTCLR_Pos (4UL)             /*!< CH4HALFTRANSFERINTCLR (Bit 4)                         */
#define DMA_INTCLR1_CH4HALFTRANSFERINTCLR_Msk (0x10UL)          /*!< CH4HALFTRANSFERINTCLR (Bitfield-Mask: 0x01)           */
#define DMA_INTCLR1_CH4TRANSFERERRINTCLR_Pos (3UL)              /*!< CH4TRANSFERERRINTCLR (Bit 3)                          */
#define DMA_INTCLR1_CH4TRANSFERERRINTCLR_Msk (0x8UL)            /*!< CH4TRANSFERERRINTCLR (Bitfield-Mask: 0x01)            */
#define DMA_INTCLR1_CH4DIRECTMODEERRINTCLR_Pos (2UL)            /*!< CH4DIRECTMODEERRINTCLR (Bit 2)                        */
#define DMA_INTCLR1_CH4DIRECTMODEERRINTCLR_Msk (0x4UL)          /*!< CH4DIRECTMODEERRINTCLR (Bitfield-Mask: 0x01)          */
#define DMA_INTCLR1_CH4FIFOERRINTCLR_Pos (0UL)                  /*!< CH4FIFOERRINTCLR (Bit 0)                              */
#define DMA_INTCLR1_CH4FIFOERRINTCLR_Msk (0x1UL)                /*!< CH4FIFOERRINTCLR (Bitfield-Mask: 0x01)                */


/* =========================================================================================================================== */
/* ================                                         DMA_CH                                           ================ */
/* =========================================================================================================================== */

/* ==========================================================  CFG  ========================================================== */
#define DMA_CH_CFG_PERISRCSEL_Pos       (25UL)                    /*!< PERISRCSEL (Bit 25)                                   */
#define DMA_CH_CFG_PERISRCSEL_Msk       (0xe000000UL)             /*!< PERISRCSEL (Bitfield-Mask: 0x07)                      */
#define DMA_CH_CFG_MBURST_Pos           (23UL)                    /*!< MBURST (Bit 23)                                       */
#define DMA_CH_CFG_MBURST_Msk           (0x1800000UL)             /*!< MBURST (Bitfield-Mask: 0x03)                          */
#define DMA_CH_CFG_PBURST_Pos           (21UL)                    /*!< PBURST (Bit 21)                                       */
#define DMA_CH_CFG_PBURST_Msk           (0x600000UL)              /*!< PBURST (Bitfield-Mask: 0x03)                          */
#define DMA_CH_CFG_CURRENTMEM_Pos       (19UL)                    /*!< CURRENTMEM (Bit 19)                                   */
#define DMA_CH_CFG_CURRENTMEM_Msk       (0x80000UL)               /*!< CURRENTMEM (Bitfield-Mask: 0x01)                      */
#define DMA_CH_CFG_MEMSWITCHMODE_Pos    (18UL)                    /*!< MEMSWITCHMODE (Bit 18)                                */
#define DMA_CH_CFG_MEMSWITCHMODE_Msk    (0x40000UL)               /*!< MEMSWITCHMODE (Bitfield-Mask: 0x01)                   */
#define DMA_CH_CFG_PRIORITYLEVEL_Pos    (16UL)                    /*!< PRIORITYLEVEL (Bit 16)                                */
#define DMA_CH_CFG_PRIORITYLEVEL_Msk    (0x30000UL)               /*!< PRIORITYLEVEL (Bitfield-Mask: 0x03)                   */
#define DMA_CH_CFG_PERIINCOFFSETSIZE_Pos (15UL)                   /*!< PERIINCOFFSETSIZE (Bit 15)                            */
#define DMA_CH_CFG_PERIINCOFFSETSIZE_Msk (0x8000UL)               /*!< PERIINCOFFSETSIZE (Bitfield-Mask: 0x01)               */
#define DMA_CH_CFG_MEMDATASIZE_Pos      (13UL)                    /*!< MEMDATASIZE (Bit 13)                                  */
#define DMA_CH_CFG_MEMDATASIZE_Msk      (0x6000UL)                /*!< MEMDATASIZE (Bitfield-Mask: 0x03)                     */
#define DMA_CH_CFG_PERIDATASIZE_Pos     (11UL)                    /*!< PERIDATASIZE (Bit 11)                                 */
#define DMA_CH_CFG_PERIDATASIZE_Msk     (0x1800UL)                /*!< PERIDATASIZE (Bitfield-Mask: 0x03)                    */
#define DMA_CH_CFG_MEMINCEN_Pos         (10UL)                    /*!< MEMINCEN (Bit 10)                                     */
#define DMA_CH_CFG_MEMINCEN_Msk         (0x400UL)                 /*!< MEMINCEN (Bitfield-Mask: 0x01)                        */
#define DMA_CH_CFG_PERIINCEN_Pos        (9UL)                     /*!< PERIINCEN (Bit 9)                                     */
#define DMA_CH_CFG_PERIINCEN_Msk        (0x200UL)                 /*!< PERIINCEN (Bitfield-Mask: 0x01)                       */
#define DMA_CH_CFG_CIRCULARMODE_Pos     (8UL)                     /*!< CIRCULARMODE (Bit 8)                                  */
#define DMA_CH_CFG_CIRCULARMODE_Msk     (0x100UL)                 /*!< CIRCULARMODE (Bitfield-Mask: 0x01)                    */
#define DMA_CH_CFG_TRANSFERDIRECTION_Pos (6UL)                    /*!< TRANSFERDIRECTION (Bit 6)                             */
#define DMA_CH_CFG_TRANSFERDIRECTION_Msk (0xc0UL)                 /*!< TRANSFERDIRECTION (Bitfield-Mask: 0x03)               */
#define DMA_CH_CFG_TRANSFERCONTROLLERSEL_Pos (5UL)                /*!< TRANSFERCONTROLLERSEL (Bit 5)                         */
#define DMA_CH_CFG_TRANSFERCONTROLLERSEL_Msk (0x20UL)             /*!< TRANSFERCONTROLLERSEL (Bitfield-Mask: 0x01)           */
#define DMA_CH_CFG_FULLTRANSFERINTEN_Pos (4UL)                    /*!< FULLTRANSFERINTEN (Bit 4)                             */
#define DMA_CH_CFG_FULLTRANSFERINTEN_Msk (0x10UL)                 /*!< FULLTRANSFERINTEN (Bitfield-Mask: 0x01)               */
#define DMA_CH_CFG_HALFTRANSFERINTEN_Pos (3UL)                    /*!< HALFTRANSFERINTEN (Bit 3)                             */
#define DMA_CH_CFG_HALFTRANSFERINTEN_Msk (0x8UL)                  /*!< HALFTRANSFERINTEN (Bitfield-Mask: 0x01)               */
#define DMA_CH_CFG_TRANSFERERRINTEN_Pos (2UL)                     /*!< TRANSFERERRINTEN (Bit 2)                              */
#define DMA_CH_CFG_TRANSFERERRINTEN_Msk (0x4UL)                   /*!< TRANSFERERRINTEN (Bitfield-Mask: 0x01)                */
#define DMA_CH_CFG_DIRECTMODEERRINTEN_Pos (1UL)                   /*!< DIRECTMODEERRINTEN (Bit 1)                            */
#define DMA_CH_CFG_DIRECTMODEERRINTEN_Msk (0x2UL)                 /*!< DIRECTMODEERRINTEN (Bitfield-Mask: 0x01)              */
#define DMA_CH_CFG_EN_Pos               (0UL)                     /*!< EN (Bit 0)                                            */
#define DMA_CH_CFG_EN_Msk               (0x1UL)                   /*!< EN (Bitfield-Mask: 0x01)                              */
/* ========================================================  DATANUM  ======================================================== */
#define DMA_CH_DATANUM_DATANUM_Pos      (0UL)                     /*!< DATANUM (Bit 0)                                       */
#define DMA_CH_DATANUM_DATANUM_Msk      (0xffffUL)                /*!< DATANUM (Bitfield-Mask: 0xffff)                       */
/* =======================================================  PERIADDR  ======================================================== */
#define DMA_CH_PERIADDR_PERIADDR_Pos    (0UL)                     /*!< PERIADDR (Bit 0)                                      */
#define DMA_CH_PERIADDR_PERIADDR_Msk    (0xffffffffUL)            /*!< PERIADDR (Bitfield-Mask: 0xffffffff)                  */
/* =======================================================  MEM0ADDR  ======================================================== */
#define DMA_CH_MEM0ADDR_MEM0ADDR_Pos    (0UL)                     /*!< MEM0ADDR (Bit 0)                                      */
#define DMA_CH_MEM0ADDR_MEM0ADDR_Msk    (0xffffffffUL)            /*!< MEM0ADDR (Bitfield-Mask: 0xffffffff)                  */
/* =======================================================  MEM1ADDR  ======================================================== */
#define DMA_CH_MEM1ADDR_MEM1ADDR_Pos    (0UL)                     /*!< MEM1ADDR (Bit 0)                                      */
#define DMA_CH_MEM1ADDR_MEM1ADDR_Msk    (0xffffffffUL)            /*!< MEM1ADDR (Bitfield-Mask: 0xffffffff)                  */
/* =======================================================  FIFOCTRL  ======================================================== */
#define DMA_CH_FIFOCTRL_FIFOERRINTEN_Pos (7UL)                    /*!< FIFOERRINTEN (Bit 7)                                  */
#define DMA_CH_FIFOCTRL_FIFOERRINTEN_Msk (0x80UL)                 /*!< FIFOERRINTEN (Bitfield-Mask: 0x01)                    */
#define DMA_CH_FIFOCTRL_FIFODEPTHSTS_Pos (3UL)                    /*!< FIFODEPTHSTS (Bit 3)                                  */
#define DMA_CH_FIFOCTRL_FIFODEPTHSTS_Msk (0x38UL)                 /*!< FIFODEPTHSTS (Bitfield-Mask: 0x07)                    */
#define DMA_CH_FIFOCTRL_DIRECTMODEDISABLE_Pos (2UL)               /*!< DIRECTMODEDISABLE (Bit 2)                             */
#define DMA_CH_FIFOCTRL_DIRECTMODEDISABLE_Msk (0x4UL)             /*!< DIRECTMODEDISABLE (Bitfield-Mask: 0x01)               */
#define DMA_CH_FIFOCTRL_FIFOTH_Pos      (0UL)                     /*!< FIFOTH (Bit 0)                                        */
#define DMA_CH_FIFOCTRL_FIFOTH_Msk      (0x3UL)                   /*!< FIFOTH (Bitfield-Mask: 0x03)                          */


/* =========================================================================================================================== */
/* ================                                            CRC                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  DR  =========================================================== */
#define CRC_DR_DR_Pos                     (0UL)                     /*!< DR (Bit 0)                                            */
#define CRC_DR_DR_Msk                     (0xffffffffUL)            /*!< DR (Bitfield-Mask: 0xffffffff)                        */
/* ==========================================================  IDR  ========================================================== */
#define CRC_IDR_IDR_Pos                   (0UL)                     /*!< IDR (Bit 0)                                           */
#define CRC_IDR_IDR_Msk                   (0xffUL)                  /*!< IDR (Bitfield-Mask: 0xff)                             */
/* ==========================================================  CR  =========================================================== */
#define CRC_CR_XOROUT_Pos                 (18UL)                    /*!< XOROUT (Bit 18)                                       */
#define CRC_CR_XOROUT_Msk                 (0x40000UL)               /*!< XOROUT (Bitfield-Mask: 0x01)                          */
#define CRC_CR_DATASIZEMODE_Pos           (14UL)                    /*!< DATASIZEMODE (Bit 14)                                 */
#define CRC_CR_DATASIZEMODE_Msk           (0x4000UL)                /*!< DATASIZEMODE (Bitfield-Mask: 0x01)                    */
#define CRC_CR_DATASIZE_Pos               (12UL)                    /*!< DATASIZE (Bit 12)                                     */
#define CRC_CR_DATASIZE_Msk               (0x3000UL)                /*!< DATASIZE (Bitfield-Mask: 0x03)                        */
#define CRC_CR_REVOUT_Pos                 (7UL)                     /*!< REVOUT (Bit 7)                                        */
#define CRC_CR_REVOUT_Msk                 (0x80UL)                  /*!< REVOUT (Bitfield-Mask: 0x01)                          */
#define CRC_CR_REVIN_Pos                  (5UL)                     /*!< REVIN (Bit 5)                                         */
#define CRC_CR_REVIN_Msk                  (0x60UL)                  /*!< REVIN (Bitfield-Mask: 0x03)                           */
#define CRC_CR_POLYSIZE_Pos               (3UL)                     /*!< POLYSIZE (Bit 3)                                      */
#define CRC_CR_POLYSIZE_Msk               (0x18UL)                  /*!< POLYSIZE (Bitfield-Mask: 0x03)                        */
#define CRC_CR_RST_Pos                    (0UL)                     /*!< RST (Bit 0)                                           */
#define CRC_CR_RST_Msk                    (0x1UL)                   /*!< RST (Bitfield-Mask: 0x01)                             */
/* =========================================================  INIT  ========================================================== */
#define CRC_INIT_POLYINIT_Pos             (0UL)                     /*!< POLYINIT (Bit 0)                                      */
#define CRC_INIT_POLYINIT_Msk             (0xffffffffUL)            /*!< POLYINIT (Bitfield-Mask: 0xffffffff)                  */
/* =========================================================  POLY  ========================================================== */
#define CRC_POLY_POLY_Pos                 (0UL)                     /*!< POLY (Bit 0)                                          */
#define CRC_POLY_POLY_Msk                 (0xffffffffUL)            /*!< POLY (Bitfield-Mask: 0xffffffff)                      */


/* =========================================================================================================================== */
/* ================                                            FMC                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  ACR  ========================================================== */
#define FMC_ACR_LVCTL_Pos                 (25UL)                    /*!< LVCTL (Bit 25)                                        */
#define FMC_ACR_LVCTL_Msk                 (0x2000000UL)             /*!< LVCTL (Bitfield-Mask: 0x01)                           */
#define FMC_ACR_WCLKMODE_Pos              (24UL)                    /*!< WCLKMODE (Bit 24)                                     */
#define FMC_ACR_WCLKMODE_Msk              (0x1000000UL)             /*!< WCLKMODE (Bitfield-Mask: 0x01)                        */
#define FMC_ACR_WMODE_Pos                 (16UL)                    /*!< WMODE (Bit 16)                                        */
#define FMC_ACR_WMODE_Msk                 (0x30000UL)               /*!< WMODE (Bitfield-Mask: 0x03)                           */
#define FMC_ACR_RCLKMODE_Pos              (15UL)                    /*!< RCLKMODE (Bit 15)                                     */
#define FMC_ACR_RCLKMODE_Msk              (0x8000UL)                /*!< RCLKMODE (Bitfield-Mask: 0x01)                        */
#define FMC_ACR_SLPPD_Pos                 (14UL)                    /*!< SLPPD (Bit 14)                                        */
#define FMC_ACR_SLPPD_Msk                 (0x4000UL)                /*!< SLPPD (Bitfield-Mask: 0x01)                           */
#define FMC_ACR_RUNPD_Pos                 (13UL)                    /*!< RUNPD (Bit 13)                                        */
#define FMC_ACR_RUNPD_Msk                 (0x2000UL)                /*!< RUNPD (Bitfield-Mask: 0x01)                           */
#define FMC_ACR_PRFTEN_Pos                (8UL)                     /*!< PRFTEN (Bit 8)                                        */
#define FMC_ACR_PRFTEN_Msk                (0x100UL)                 /*!< PRFTEN (Bitfield-Mask: 0x01)                          */
#define FMC_ACR_RMODE_Pos                 (0UL)                     /*!< RMODE (Bit 0)                                         */
#define FMC_ACR_RMODE_Msk                 (0x1fUL)                  /*!< RMODE (Bitfield-Mask: 0x1f)                           */
/* ========================================================  PDKEYR  ========================================================= */
#define FMC_PDKEYR_PDKEY_Pos              (0UL)                     /*!< PDKEY (Bit 0)                                         */
#define FMC_PDKEYR_PDKEY_Msk              (0xffffffffUL)            /*!< PDKEY (Bitfield-Mask: 0xffffffff)                     */
/* =========================================================  KEYR  ========================================================== */
#define FMC_KEYR_KEY_Pos                  (0UL)                     /*!< KEY (Bit 0)                                           */
#define FMC_KEYR_KEY_Msk                  (0xffffffffUL)            /*!< KEY (Bitfield-Mask: 0xffffffff)                       */
/* ========================================================  OPTKEYR  ======================================================== */
#define FMC_OPTKEYR_OPTKEY_Pos            (0UL)                     /*!< OPTKEY (Bit 0)                                        */
#define FMC_OPTKEYR_OPTKEY_Msk            (0xffffffffUL)            /*!< OPTKEY (Bitfield-Mask: 0xffffffff)                    */
/* ==========================================================  SR  =========================================================== */
#define FMC_SR_PGINT_Pos                  (17UL)                    /*!< PGINT (Bit 17)                                        */
#define FMC_SR_PGINT_Msk                  (0x20000UL)               /*!< PGINT (Bitfield-Mask: 0x01)                           */
#define FMC_SR_BUSY_Pos                   (16UL)                    /*!< BUSY (Bit 16)                                         */
#define FMC_SR_BUSY_Msk                   (0x10000UL)               /*!< BUSY (Bitfield-Mask: 0x01)                            */
#define FMC_SR_OPTVERR_Pos                (15UL)                    /*!< OPTVERR (Bit 15)                                      */
#define FMC_SR_OPTVERR_Msk                (0x8000UL)                /*!< OPTVERR (Bitfield-Mask: 0x01)                         */
#define FMC_SR_RDERR_Pos                  (14UL)                    /*!< RDERR (Bit 14)                                        */
#define FMC_SR_RDERR_Msk                  (0x4000UL)                /*!< RDERR (Bitfield-Mask: 0x01)                           */
#define FMC_SR_FASTERR_Pos                (9UL)                     /*!< FASTERR (Bit 9)                                       */
#define FMC_SR_FASTERR_Msk                (0x200UL)                 /*!< FASTERR (Bitfield-Mask: 0x01)                         */
#define FMC_SR_MISSERR_Pos                (8UL)                     /*!< MISSERR (Bit 8)                                       */
#define FMC_SR_MISSERR_Msk                (0x100UL)                 /*!< MISSERR (Bitfield-Mask: 0x01)                         */
#define FMC_SR_PGSERR_Pos                 (7UL)                     /*!< PGSERR (Bit 7)                                        */
#define FMC_SR_PGSERR_Msk                 (0x80UL)                  /*!< PGSERR (Bitfield-Mask: 0x01)                          */
#define FMC_SR_SIZERR_Pos                 (6UL)                     /*!< SIZERR (Bit 6)                                        */
#define FMC_SR_SIZERR_Msk                 (0x40UL)                  /*!< SIZERR (Bitfield-Mask: 0x01)                          */
#define FMC_SR_PGAERR_Pos                 (5UL)                     /*!< PGAERR (Bit 5)                                        */
#define FMC_SR_PGAERR_Msk                 (0x20UL)                  /*!< PGAERR (Bitfield-Mask: 0x01)                          */
#define FMC_SR_WRPERR_Pos                 (4UL)                     /*!< WRPERR (Bit 4)                                        */
#define FMC_SR_WRPERR_Msk                 (0x10UL)                  /*!< WRPERR (Bitfield-Mask: 0x01)                          */
#define FMC_SR_PROGERR_Pos                (3UL)                     /*!< PROGERR (Bit 3)                                       */
#define FMC_SR_PROGERR_Msk                (0x8UL)                   /*!< PROGERR (Bitfield-Mask: 0x01)                         */
#define FMC_SR_OPERR_Pos                  (1UL)                     /*!< OPERR (Bit 1)                                         */
#define FMC_SR_OPERR_Msk                  (0x2UL)                   /*!< OPERR (Bitfield-Mask: 0x01)                           */
#define FMC_SR_EOP_Pos                    (0UL)                     /*!< EOP (Bit 0)                                           */
#define FMC_SR_EOP_Msk                    (0x1UL)                   /*!< EOP (Bitfield-Mask: 0x01)                             */
/* ==========================================================  CR  =========================================================== */
#define FMC_CR_LOCK_Pos                   (31UL)                    /*!< LOCK (Bit 31)                                         */
#define FMC_CR_LOCK_Msk                   (0x80000000UL)            /*!< LOCK (Bitfield-Mask: 0x01)                            */
#define FMC_CR_OPTLOCK_Pos                (30UL)                    /*!< OPTLOCK (Bit 30)                                      */
#define FMC_CR_OPTLOCK_Msk                (0x40000000UL)            /*!< OPTLOCK (Bitfield-Mask: 0x01)                         */
#define FMC_CR_PGIE_Pos                   (29UL)                    /*!< PGIE (Bit 29)                                         */
#define FMC_CR_PGIE_Msk                   (0x20000000UL)            /*!< PGIE (Bitfield-Mask: 0x01)                            */
#define FMC_CR_DMAEN_Pos                  (28UL)                    /*!< DMAEN (Bit 28)                                        */
#define FMC_CR_DMAEN_Msk                  (0x10000000UL)            /*!< DMAEN (Bitfield-Mask: 0x01)                           */
#define FMC_CR_OBLLAUNCH_Pos              (27UL)                    /*!< OBLLAUNCH (Bit 27)                                    */
#define FMC_CR_OBLLAUNCH_Msk              (0x8000000UL)             /*!< OBLLAUNCH (Bitfield-Mask: 0x01)                       */
#define FMC_CR_RDERRIE_Pos                (26UL)                    /*!< RDERRIE (Bit 26)                                      */
#define FMC_CR_RDERRIE_Msk                (0x4000000UL)             /*!< RDERRIE (Bitfield-Mask: 0x01)                         */
#define FMC_CR_ERRIE_Pos                  (25UL)                    /*!< ERRIE (Bit 25)                                        */
#define FMC_CR_ERRIE_Msk                  (0x2000000UL)             /*!< ERRIE (Bitfield-Mask: 0x01)                           */
#define FMC_CR_EOPIE_Pos                  (24UL)                    /*!< EOPIE (Bit 24)                                        */
#define FMC_CR_EOPIE_Msk                  (0x1000000UL)             /*!< EOPIE (Bitfield-Mask: 0x01)                           */
#define FMC_CR_FSTPG_Pos                  (18UL)                    /*!< FSTPG (Bit 18)                                        */
#define FMC_CR_FSTPG_Msk                  (0x40000UL)               /*!< FSTPG (Bitfield-Mask: 0x01)                           */
#define FMC_CR_OPTSTRT_Pos                (17UL)                    /*!< OPTSTRT (Bit 17)                                      */
#define FMC_CR_OPTSTRT_Msk                (0x20000UL)               /*!< OPTSTRT (Bitfield-Mask: 0x01)                         */
#define FMC_CR_STRT_Pos                   (16UL)                    /*!< STRT (Bit 16)                                         */
#define FMC_CR_STRT_Msk                   (0x10000UL)               /*!< STRT (Bitfield-Mask: 0x01)                            */
#define FMC_CR_MER1_Pos                   (15UL)                    /*!< MER1 (Bit 15)                                         */
#define FMC_CR_MER1_Msk                   (0x8000UL)                /*!< MER1 (Bitfield-Mask: 0x01)                            */
#define FMC_CR_NVR_Pos                    (14UL)                    /*!< NVR (Bit 14)                                          */
#define FMC_CR_NVR_Msk                    (0x4000UL)                /*!< NVR (Bitfield-Mask: 0x01)                             */
#define FMC_CR_BKER_Pos                   (11UL)                    /*!< BKER (Bit 11)                                         */
#define FMC_CR_BKER_Msk                   (0x800UL)                 /*!< BKER (Bitfield-Mask: 0x01)                            */
#define FMC_CR_SNB_Pos                    (3UL)                     /*!< SNB (Bit 3)                                           */
#define FMC_CR_SNB_Msk                    (0x7f8UL)                 /*!< SNB (Bitfield-Mask: 0xff)                             */
#define FMC_CR_MER0_Pos                   (2UL)                     /*!< MER0 (Bit 2)                                          */
#define FMC_CR_MER0_Msk                   (0x4UL)                   /*!< MER0 (Bitfield-Mask: 0x01)                            */
#define FMC_CR_SER_Pos                    (1UL)                     /*!< SER (Bit 1)                                           */
#define FMC_CR_SER_Msk                    (0x2UL)                   /*!< SER (Bitfield-Mask: 0x01)                             */
#define FMC_CR_PG_Pos                     (0UL)                     /*!< PG (Bit 0)                                            */
#define FMC_CR_PG_Msk                     (0x1UL)                   /*!< PG (Bitfield-Mask: 0x01)                              */
/* =========================================================  PESR  ========================================================== */
#define FMC_PESR_FERFLAG_Pos              (0UL)                     /*!< FERFLAG (Bit 0)                                       */
#define FMC_PESR_FERFLAG_Msk              (0x1UL)                   /*!< FERFLAG (Bitfield-Mask: 0x01)                         */
/* =========================================================  OPTR  ========================================================== */
#define FMC_OPTR_IHSGATEDIS_Pos           (31UL)                    /*!< IHSGATEDIS (Bit 31)                                   */
#define FMC_OPTR_IHSGATEDIS_Msk           (0x80000000UL)            /*!< IHSGATEDIS (Bitfield-Mask: 0x01)                      */
#define FMC_OPTR_NRSTMODE_Pos             (28UL)                    /*!< NRSTMODE (Bit 28)                                     */
#define FMC_OPTR_NRSTMODE_Msk             (0x30000000UL)            /*!< NRSTMODE (Bitfield-Mask: 0x03)                        */
#define FMC_OPTR_NBOOT0_Pos               (27UL)                    /*!< NBOOT0 (Bit 27)                                       */
#define FMC_OPTR_NBOOT0_Msk               (0x8000000UL)             /*!< NBOOT0 (Bitfield-Mask: 0x01)                          */
#define FMC_OPTR_NSWBOOT0_Pos             (26UL)                    /*!< NSWBOOT0 (Bit 26)                                     */
#define FMC_OPTR_NSWBOOT0_Msk             (0x4000000UL)             /*!< NSWBOOT0 (Bitfield-Mask: 0x01)                        */
#define FMC_OPTR_NBOOT1_Pos               (23UL)                    /*!< NBOOT1 (Bit 23)                                       */
#define FMC_OPTR_NBOOT1_Msk               (0x800000UL)              /*!< NBOOT1 (Bitfield-Mask: 0x01)                          */
#define FMC_OPTR_DBANK_Pos                (22UL)                    /*!< DBANK (Bit 22)                                        */
#define FMC_OPTR_DBANK_Msk                (0x400000UL)              /*!< DBANK (Bitfield-Mask: 0x01)                           */
#define FMC_OPTR_SWAPBANK_Pos             (20UL)                    /*!< SWAPBANK (Bit 20)                                     */
#define FMC_OPTR_SWAPBANK_Msk             (0x100000UL)              /*!< SWAPBANK (Bitfield-Mask: 0x01)                        */
#define FMC_OPTR_WWDGSW_Pos               (19UL)                    /*!< WWDGSW (Bit 19)                                       */
#define FMC_OPTR_WWDGSW_Msk               (0x80000UL)               /*!< WWDGSW (Bitfield-Mask: 0x01)                          */
#define FMC_OPTR_IWDGSTDBY_Pos            (18UL)                    /*!< IWDGSTDBY (Bit 18)                                    */
#define FMC_OPTR_IWDGSTDBY_Msk            (0x40000UL)               /*!< IWDGSTDBY (Bitfield-Mask: 0x01)                       */
#define FMC_OPTR_IWDGSTOP_Pos             (17UL)                    /*!< IWDGSTOP (Bit 17)                                     */
#define FMC_OPTR_IWDGSTOP_Msk             (0x20000UL)               /*!< IWDGSTOP (Bitfield-Mask: 0x01)                        */
#define FMC_OPTR_IWDGSW_Pos               (16UL)                    /*!< IWDGSW (Bit 16)                                       */
#define FMC_OPTR_IWDGSW_Msk               (0x10000UL)               /*!< IWDGSW (Bitfield-Mask: 0x01)                          */
#define FMC_OPTR_NRSTLVL_Pos              (15UL)                    /*!< NRSTLVL (Bit 15)                                      */
#define FMC_OPTR_NRSTLVL_Msk              (0x8000UL)                /*!< NRSTLVL (Bitfield-Mask: 0x01)                         */
#define FMC_OPTR_NRSTSHDW_Pos             (14UL)                    /*!< NRSTSHDW (Bit 14)                                     */
#define FMC_OPTR_NRSTSHDW_Msk             (0x4000UL)                /*!< NRSTSHDW (Bitfield-Mask: 0x01)                        */
#define FMC_OPTR_NRSTSTDBY_Pos            (13UL)                    /*!< NRSTSTDBY (Bit 13)                                    */
#define FMC_OPTR_NRSTSTDBY_Msk            (0x2000UL)                /*!< NRSTSTDBY (Bitfield-Mask: 0x01)                       */
#define FMC_OPTR_NRSTSTOP_Pos             (12UL)                    /*!< NRSTSTOP (Bit 12)                                     */
#define FMC_OPTR_NRSTSTOP_Msk             (0x1000UL)                /*!< NRSTSTOP (Bitfield-Mask: 0x01)                        */
#define FMC_OPTR_BORLEV_Pos               (8UL)                     /*!< BORLEV (Bit 8)                                        */
#define FMC_OPTR_BORLEV_Msk               (0x700UL)                 /*!< BORLEV (Bitfield-Mask: 0x07)                          */
#define FMC_OPTR_RDP_Pos                  (0UL)                     /*!< RDP (Bit 0)                                           */
#define FMC_OPTR_RDP_Msk                  (0xffUL)                  /*!< RDP (Bitfield-Mask: 0xff)                             */
/* =======================================================  PCROP1SR  ======================================================== */
#define FMC_PCROP1SR_PCROP1STRT_Pos       (0UL)                     /*!< PCROP1STRT (Bit 0)                                    */
#define FMC_PCROP1SR_PCROP1STRT_Msk       (0x1ffffUL)               /*!< PCROP1STRT (Bitfield-Mask: 0x1ffff)                   */
/* =======================================================  PCROP1ER  ======================================================== */
#define FMC_PCROP1ER_PCROPRDP_Pos         (31UL)                    /*!< PCROPRDP (Bit 31)                                     */
#define FMC_PCROP1ER_PCROPRDP_Msk         (0x80000000UL)            /*!< PCROPRDP (Bitfield-Mask: 0x01)                        */
#define FMC_PCROP1ER_PCROP1END_Pos        (0UL)                     /*!< PCROP1END (Bit 0)                                     */
#define FMC_PCROP1ER_PCROP1END_Msk        (0x1ffffUL)               /*!< PCROP1END (Bitfield-Mask: 0x1ffff)                    */
/* ========================================================  WRP1AR  ========================================================= */
#define FMC_WRP1AR_WRP1AEND_Pos           (16UL)                    /*!< WRP1AEND (Bit 16)                                     */
#define FMC_WRP1AR_WRP1AEND_Msk           (0xff0000UL)              /*!< WRP1AEND (Bitfield-Mask: 0xff)                        */
#define FMC_WRP1AR_WRP1ASTRT_Pos          (0UL)                     /*!< WRP1ASTRT (Bit 0)                                     */
#define FMC_WRP1AR_WRP1ASTRT_Msk          (0xffUL)                  /*!< WRP1ASTRT (Bitfield-Mask: 0xff)                       */
/* ========================================================  WRP1BR  ========================================================= */
#define FMC_WRP1BR_WRP1BEND_Pos           (16UL)                    /*!< WRP1BEND (Bit 16)                                     */
#define FMC_WRP1BR_WRP1BEND_Msk           (0xff0000UL)              /*!< WRP1BEND (Bitfield-Mask: 0xff)                        */
#define FMC_WRP1BR_WRP1BSTRT_Pos          (0UL)                     /*!< WRP1BSTRT (Bit 0)                                     */
#define FMC_WRP1BR_WRP1BSTRT_Msk          (0xffUL)                  /*!< WRP1BSTRT (Bitfield-Mask: 0xff)                       */
/* =======================================================  PCROP2SR  ======================================================== */
#define FMC_PCROP2SR_PCROP2STRT_Pos       (0UL)                     /*!< PCROP2STRT (Bit 0)                                    */
#define FMC_PCROP2SR_PCROP2STRT_Msk       (0x1ffffUL)               /*!< PCROP2STRT (Bitfield-Mask: 0x1ffff)                   */
/* =======================================================  PCROP2ER  ======================================================== */
#define FMC_PCROP2ER_PCROP2END_Pos        (0UL)                     /*!< PCROP2END (Bit 0)                                     */
#define FMC_PCROP2ER_PCROP2END_Msk        (0x1ffffUL)               /*!< PCROP2END (Bitfield-Mask: 0x1ffff)                    */
/* ========================================================  WRP2AR  ========================================================= */
#define FMC_WRP2AR_WRP2AEND_Pos           (16UL)                    /*!< WRP2AEND (Bit 16)                                     */
#define FMC_WRP2AR_WRP2AEND_Msk           (0xff0000UL)              /*!< WRP2AEND (Bitfield-Mask: 0xff)                        */
#define FMC_WRP2AR_WRP2ASTRT_Pos          (0UL)                     /*!< WRP2ASTRT (Bit 0)                                     */
#define FMC_WRP2AR_WRP2ASTRT_Msk          (0xffUL)                  /*!< WRP2ASTRT (Bitfield-Mask: 0xff)                       */
/* ========================================================  WRP2BR  ========================================================= */
#define FMC_WRP2BR_WRP2BEND_Pos           (16UL)                    /*!< WRP2BEND (Bit 16)                                     */
#define FMC_WRP2BR_WRP2BEND_Msk           (0xff0000UL)              /*!< WRP2BEND (Bitfield-Mask: 0xff)                        */
#define FMC_WRP2BR_WRP2BSTRT_Pos          (0UL)                     /*!< WRP2BSTRT (Bit 0)                                     */
#define FMC_WRP2BR_WRP2BSTRT_Msk          (0xffUL)                  /*!< WRP2BSTRT (Bitfield-Mask: 0xff)                       */
/* =========================================================  BOOTR  ========================================================= */
#define FMC_BOOTR_BOOTLOCK_Pos            (16UL)                    /*!< BOOTLOCK (Bit 16)                                     */
#define FMC_BOOTR_BOOTLOCK_Msk            (0x10000UL)               /*!< BOOTLOCK (Bitfield-Mask: 0x01)                        */


/* =========================================================================================================================== */
/* ================                                            CAN                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  CFG  ========================================================== */
#define CAN_CFG_TSPOS_Pos                 (25UL)                    /*!< TSPOS (Bit 25)                                        */
#define CAN_CFG_TSPOS_Msk                 (0x2000000UL)             /*!< TSPOS (Bitfield-Mask: 0x01)                           */
#define CAN_CFG_TSEN_Pos                  (24UL)                    /*!< TSEN (Bit 24)                                         */
#define CAN_CFG_TSEN_Msk                  (0x1000000UL)             /*!< TSEN (Bitfield-Mask: 0x01)                            */
#define CAN_CFG_ROP_Pos                   (17UL)                    /*!< ROP (Bit 17)                                          */
#define CAN_CFG_ROP_Msk                   (0x20000UL)               /*!< ROP (Bitfield-Mask: 0x01)                             */
#define CAN_CFG_CES_Pos                   (16UL)                    /*!< CES (Bit 16)                                          */
#define CAN_CFG_CES_Msk                   (0x10000UL)               /*!< CES (Bitfield-Mask: 0x01)                             */
#define CAN_CFG_VER1_Pos                  (8UL)                     /*!< VER1 (Bit 8)                                          */
#define CAN_CFG_VER1_Msk                  (0xff00UL)                /*!< VER1 (Bitfield-Mask: 0xff)                            */
#define CAN_CFG_VER0_Pos                  (0UL)                     /*!< VER0 (Bit 0)                                          */
#define CAN_CFG_VER0_Msk                  (0xffUL)                  /*!< VER0 (Bitfield-Mask: 0xff)                            */
/* ========================================================  BITTIME  ======================================================== */
#define CAN_BITTIME_ACSJW_Pos             (24UL)                    /*!< ACSJW (Bit 24)                                        */
#define CAN_BITTIME_ACSJW_Msk             (0x7f000000UL)            /*!< ACSJW (Bitfield-Mask: 0x7f)                           */
#define CAN_BITTIME_ACSEG2_Pos            (16UL)                    /*!< ACSEG2 (Bit 16)                                       */
#define CAN_BITTIME_ACSEG2_Msk            (0x7f0000UL)              /*!< ACSEG2 (Bitfield-Mask: 0x7f)                          */
#define CAN_BITTIME_ACSEG1_Pos            (0UL)                     /*!< ACSEG1 (Bit 0)                                        */
#define CAN_BITTIME_ACSEG1_Msk            (0x1ffUL)                 /*!< ACSEG1 (Bitfield-Mask: 0x1ff)                         */
/* ========================================================  CLKCTRL  ======================================================== */
#define CAN_CLKCTRL_RETLIM_Pos            (28UL)                    /*!< RETLIM (Bit 28)                                       */
#define CAN_CLKCTRL_RETLIM_Msk            (0x70000000UL)            /*!< RETLIM (Bitfield-Mask: 0x07)                          */
#define CAN_CLKCTRL_REALIM_Pos            (24UL)                    /*!< REALIM (Bit 24)                                       */
#define CAN_CLKCTRL_REALIM_Msk            (0x7000000UL)             /*!< REALIM (Bitfield-Mask: 0x07)                          */
#define CAN_CLKCTRL_PRESC_Pos             (0UL)                     /*!< PRESC (Bit 0)                                         */
#define CAN_CLKCTRL_PRESC_Msk             (0x1fUL)                  /*!< PRESC (Bitfield-Mask: 0x1f)                           */
/* =========================================================  INTF  ========================================================== */
#define CAN_INTF_EWARN_Pos                (31UL)                    /*!< EWARN (Bit 31)                                        */
#define CAN_INTF_EWARN_Msk                (0x80000000UL)            /*!< EWARN (Bitfield-Mask: 0x01)                           */
#define CAN_INTF_EPASS_Pos                (30UL)                    /*!< EPASS (Bit 30)                                        */
#define CAN_INTF_EPASS_Msk                (0x40000000UL)            /*!< EPASS (Bitfield-Mask: 0x01)                           */
#define CAN_INTF_EPIF_Pos                 (10UL)                    /*!< EPIF (Bit 10)                                         */
#define CAN_INTF_EPIF_Msk                 (0x400UL)                 /*!< EPIF (Bitfield-Mask: 0x01)                            */
#define CAN_INTF_ALIF_Pos                 (9UL)                     /*!< ALIF (Bit 9)                                          */
#define CAN_INTF_ALIF_Msk                 (0x200UL)                 /*!< ALIF (Bitfield-Mask: 0x01)                            */
#define CAN_INTF_BEIF_Pos                 (8UL)                     /*!< BEIF (Bit 8)                                          */
#define CAN_INTF_BEIF_Msk                 (0x100UL)                 /*!< BEIF (Bitfield-Mask: 0x01)                            */
#define CAN_INTF_RIF_Pos                  (7UL)                     /*!< RIF (Bit 7)                                           */
#define CAN_INTF_RIF_Msk                  (0x80UL)                  /*!< RIF (Bitfield-Mask: 0x01)                             */
#define CAN_INTF_ROIF_Pos                 (6UL)                     /*!< ROIF (Bit 6)                                          */
#define CAN_INTF_ROIF_Msk                 (0x40UL)                  /*!< ROIF (Bitfield-Mask: 0x01)                            */
#define CAN_INTF_RFIF_Pos                 (5UL)                     /*!< RFIF (Bit 5)                                          */
#define CAN_INTF_RFIF_Msk                 (0x20UL)                  /*!< RFIF (Bitfield-Mask: 0x01)                            */
#define CAN_INTF_RAFIF_Pos                (4UL)                     /*!< RAFIF (Bit 4)                                         */
#define CAN_INTF_RAFIF_Msk                (0x10UL)                  /*!< RAFIF (Bitfield-Mask: 0x01)                           */
#define CAN_INTF_TPIF_Pos                 (3UL)                     /*!< TPIF (Bit 3)                                          */
#define CAN_INTF_TPIF_Msk                 (0x8UL)                   /*!< TPIF (Bitfield-Mask: 0x01)                            */
#define CAN_INTF_TSIF_Pos                 (2UL)                     /*!< TSIF (Bit 2)                                          */
#define CAN_INTF_TSIF_Msk                 (0x4UL)                   /*!< TSIF (Bitfield-Mask: 0x01)                            */
#define CAN_INTF_EIF_Pos                  (1UL)                     /*!< EIF (Bit 1)                                           */
#define CAN_INTF_EIF_Msk                  (0x2UL)                   /*!< EIF (Bitfield-Mask: 0x01)                             */
#define CAN_INTF_AIF_Pos                  (0UL)                     /*!< AIF (Bit 0)                                           */
#define CAN_INTF_AIF_Msk                  (0x1UL)                   /*!< AIF (Bitfield-Mask: 0x01)                             */
/* =========================================================  INTE  ========================================================== */
#define CAN_INTE_EPIE_Pos                 (10UL)                    /*!< EPIE (Bit 10)                                         */
#define CAN_INTE_EPIE_Msk                 (0x400UL)                 /*!< EPIE (Bitfield-Mask: 0x01)                            */
#define CAN_INTE_ALIE_Pos                 (9UL)                     /*!< ALIE (Bit 9)                                          */
#define CAN_INTE_ALIE_Msk                 (0x200UL)                 /*!< ALIE (Bitfield-Mask: 0x01)                            */
#define CAN_INTE_BEIE_Pos                 (8UL)                     /*!< BEIE (Bit 8)                                          */
#define CAN_INTE_BEIE_Msk                 (0x100UL)                 /*!< BEIE (Bitfield-Mask: 0x01)                            */
#define CAN_INTE_RIE_Pos                  (7UL)                     /*!< RIE (Bit 7)                                           */
#define CAN_INTE_RIE_Msk                  (0x80UL)                  /*!< RIE (Bitfield-Mask: 0x01)                             */
#define CAN_INTE_ROIE_Pos                 (6UL)                     /*!< ROIE (Bit 6)                                          */
#define CAN_INTE_ROIE_Msk                 (0x40UL)                  /*!< ROIE (Bitfield-Mask: 0x01)                            */
#define CAN_INTE_RFIE_Pos                 (5UL)                     /*!< RFIE (Bit 5)                                          */
#define CAN_INTE_RFIE_Msk                 (0x20UL)                  /*!< RFIE (Bitfield-Mask: 0x01)                            */
#define CAN_INTE_RAFIE_Pos                (4UL)                     /*!< RAFIE (Bit 4)                                         */
#define CAN_INTE_RAFIE_Msk                (0x10UL)                  /*!< RAFIE (Bitfield-Mask: 0x01)                           */
#define CAN_INTE_TPIE_Pos                 (3UL)                     /*!< TPIE (Bit 3)                                          */
#define CAN_INTE_TPIE_Msk                 (0x8UL)                   /*!< TPIE (Bitfield-Mask: 0x01)                            */
#define CAN_INTE_TSIE_Pos                 (2UL)                     /*!< TSIE (Bit 2)                                          */
#define CAN_INTE_TSIE_Msk                 (0x4UL)                   /*!< TSIE (Bitfield-Mask: 0x01)                            */
#define CAN_INTE_EIE_Pos                  (1UL)                     /*!< EIE (Bit 1)                                           */
#define CAN_INTE_EIE_Msk                  (0x2UL)                   /*!< EIE (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSTAT  ========================================================= */
#define CAN_TSTAT_TSTAT2_Pos              (24UL)                    /*!< TSTAT2 (Bit 24)                                       */
#define CAN_TSTAT_TSTAT2_Msk              (0x7000000UL)             /*!< TSTAT2 (Bitfield-Mask: 0x07)                          */
#define CAN_TSTAT_HANDLE2_Pos             (16UL)                    /*!< HANDLE2 (Bit 16)                                      */
#define CAN_TSTAT_HANDLE2_Msk             (0xff0000UL)              /*!< HANDLE2 (Bitfield-Mask: 0xff)                         */
#define CAN_TSTAT_TSTAT1_Pos              (8UL)                     /*!< TSTAT1 (Bit 8)                                        */
#define CAN_TSTAT_TSTAT1_Msk              (0x700UL)                 /*!< TSTAT1 (Bitfield-Mask: 0x07)                          */
#define CAN_TSTAT_HANDLE1_Pos             (0UL)                     /*!< HANDLE1 (Bit 0)                                       */
#define CAN_TSTAT_HANDLE1_Msk             (0xffUL)                  /*!< HANDLE1 (Bitfield-Mask: 0xff)                         */
/* =========================================================  TSCSR  ========================================================= */
#define CAN_TSCSR_TTS_Pos                 (0UL)                     /*!< TTS (Bit 0)                                           */
#define CAN_TSCSR_TTS_Msk                 (0xffffUL)                /*!< TTS (Bitfield-Mask: 0xffff)                           */
/* ==========================================================  CMD  ========================================================== */
#define CAN_CMD_SACK_Pos                  (31UL)                    /*!< SACK (Bit 31)                                         */
#define CAN_CMD_SACK_Msk                  (0x80000000UL)            /*!< SACK (Bitfield-Mask: 0x01)                            */
#define CAN_CMD_ROM_Pos                   (30UL)                    /*!< ROM (Bit 30)                                          */
#define CAN_CMD_ROM_Msk                   (0x40000000UL)            /*!< ROM (Bitfield-Mask: 0x01)                             */
#define CAN_CMD_ROV_Pos                   (29UL)                    /*!< ROV (Bit 29)                                          */
#define CAN_CMD_ROV_Msk                   (0x20000000UL)            /*!< ROV (Bitfield-Mask: 0x01)                             */
#define CAN_CMD_RREL_Pos                  (28UL)                    /*!< RREL (Bit 28)                                         */
#define CAN_CMD_RREL_Msk                  (0x10000000UL)            /*!< RREL (Bitfield-Mask: 0x01)                            */
#define CAN_CMD_RBALL_Pos                 (27UL)                    /*!< RBALL (Bit 27)                                        */
#define CAN_CMD_RBALL_Msk                 (0x8000000UL)             /*!< RBALL (Bitfield-Mask: 0x01)                           */
#define CAN_CMD_RSTAT_Pos                 (24UL)                    /*!< RSTAT (Bit 24)                                        */
#define CAN_CMD_RSTAT_Msk                 (0x3000000UL)             /*!< RSTAT (Bitfield-Mask: 0x03)                           */
#define CAN_CMD_TSNEXT_Pos                (22UL)                    /*!< TSNEXT (Bit 22)                                       */
#define CAN_CMD_TSNEXT_Msk                (0x400000UL)              /*!< TSNEXT (Bitfield-Mask: 0x01)                          */
#define CAN_CMD_TSMODE_Pos                (21UL)                    /*!< TSMODE (Bit 21)                                       */
#define CAN_CMD_TSMODE_Msk                (0x200000UL)              /*!< TSMODE (Bitfield-Mask: 0x01)                          */
#define CAN_CMD_TSFF_Pos                  (18UL)                    /*!< TSFF (Bit 18)                                         */
#define CAN_CMD_TSFF_Msk                  (0x40000UL)               /*!< TSFF (Bitfield-Mask: 0x01)                            */
#define CAN_CMD_TSSTAT_Pos                (16UL)                    /*!< TSSTAT (Bit 16)                                       */
#define CAN_CMD_TSSTAT_Msk                (0x30000UL)               /*!< TSSTAT (Bitfield-Mask: 0x03)                          */
#define CAN_CMD_TBSEL_Pos                 (15UL)                    /*!< TBSEL (Bit 15)                                        */
#define CAN_CMD_TBSEL_Msk                 (0x8000UL)                /*!< TBSEL (Bitfield-Mask: 0x01)                           */
#define CAN_CMD_LOM_Pos                   (14UL)                    /*!< LOM (Bit 14)                                          */
#define CAN_CMD_LOM_Msk                   (0x4000UL)                /*!< LOM (Bitfield-Mask: 0x01)                             */
#define CAN_CMD_STBY_Pos                  (13UL)                    /*!< STBY (Bit 13)                                         */
#define CAN_CMD_STBY_Msk                  (0x2000UL)                /*!< STBY (Bitfield-Mask: 0x01)                            */
#define CAN_CMD_TPE_Pos                   (12UL)                    /*!< TPE (Bit 12)                                          */
#define CAN_CMD_TPE_Msk                   (0x1000UL)                /*!< TPE (Bitfield-Mask: 0x01)                             */
#define CAN_CMD_TPA_Pos                   (11UL)                    /*!< TPA (Bit 11)                                          */
#define CAN_CMD_TPA_Msk                   (0x800UL)                 /*!< TPA (Bitfield-Mask: 0x01)                             */
#define CAN_CMD_TSONE_Pos                 (10UL)                    /*!< TSONE (Bit 10)                                        */
#define CAN_CMD_TSONE_Msk                 (0x400UL)                 /*!< TSONE (Bitfield-Mask: 0x01)                           */
#define CAN_CMD_TSALL_Pos                 (9UL)                     /*!< TSALL (Bit 9)                                         */
#define CAN_CMD_TSALL_Msk                 (0x200UL)                 /*!< TSALL (Bitfield-Mask: 0x01)                           */
#define CAN_CMD_TSA_Pos                   (8UL)                     /*!< TSA (Bit 8)                                           */
#define CAN_CMD_TSA_Msk                   (0x100UL)                 /*!< TSA (Bitfield-Mask: 0x01)                             */
#define CAN_CMD_RESET_Pos                 (7UL)                     /*!< RESET (Bit 7)                                         */
#define CAN_CMD_RESET_Msk                 (0x80UL)                  /*!< RESET (Bitfield-Mask: 0x01)                           */
#define CAN_CMD_LBME_Pos                  (6UL)                     /*!< LBME (Bit 6)                                          */
#define CAN_CMD_LBME_Msk                  (0x40UL)                  /*!< LBME (Bitfield-Mask: 0x01)                            */
#define CAN_CMD_LBMI_Pos                  (5UL)                     /*!< LBMI (Bit 5)                                          */
#define CAN_CMD_LBMI_Msk                  (0x20UL)                  /*!< LBMI (Bitfield-Mask: 0x01)                            */
#define CAN_CMD_BUSOFF_Pos                (0UL)                     /*!< BUSOFF (Bit 0)                                        */
#define CAN_CMD_BUSOFF_Msk                (0x1UL)                   /*!< BUSOFF (Bitfield-Mask: 0x01)                          */
/* =======================================================  ERRSTATS  ======================================================== */
#define CAN_ERRSTATS_TECNT_Pos            (24UL)                    /*!< TECNT (Bit 24)                                        */
#define CAN_ERRSTATS_TECNT_Msk            (0xff000000UL)            /*!< TECNT (Bitfield-Mask: 0xff)                           */
#define CAN_ERRSTATS_RECNT_Pos            (16UL)                    /*!< RECNT (Bit 16)                                        */
#define CAN_ERRSTATS_RECNT_Msk            (0xff0000UL)              /*!< RECNT (Bitfield-Mask: 0xff)                           */
#define CAN_ERRSTATS_KOER_Pos             (13UL)                    /*!< KOER (Bit 13)                                         */
#define CAN_ERRSTATS_KOER_Msk             (0xe000UL)                /*!< KOER (Bitfield-Mask: 0x07)                            */
#define CAN_ERRSTATS_ALC_Pos              (8UL)                     /*!< ALC (Bit 8)                                           */
#define CAN_ERRSTATS_ALC_Msk              (0x1f00UL)                /*!< ALC (Bitfield-Mask: 0x1f)                             */
#define CAN_ERRSTATS_AFWL_Pos             (4UL)                     /*!< AFWL (Bit 4)                                          */
#define CAN_ERRSTATS_AFWL_Msk             (0xf0UL)                  /*!< AFWL (Bitfield-Mask: 0x0f)                            */
#define CAN_ERRSTATS_EWL_Pos              (0UL)                     /*!< EWL (Bit 0)                                           */
#define CAN_ERRSTATS_EWL_Msk              (0xfUL)                   /*!< EWL (Bitfield-Mask: 0x0f)                             */
/* ==========================================================  ACF  ========================================================== */
#define CAN_ACF_AE3_Pos                   (19UL)                    /*!< AE3 (Bit 19)                                          */
#define CAN_ACF_AE3_Msk                   (0x80000UL)               /*!< AE3 (Bitfield-Mask: 0x01)                             */
#define CAN_ACF_AE2_Pos                   (18UL)                    /*!< AE2 (Bit 18)                                          */
#define CAN_ACF_AE2_Msk                   (0x40000UL)               /*!< AE2 (Bitfield-Mask: 0x01)                             */
#define CAN_ACF_AE1_Pos                   (17UL)                    /*!< AE1 (Bit 17)                                          */
#define CAN_ACF_AE1_Msk                   (0x20000UL)               /*!< AE1 (Bitfield-Mask: 0x01)                             */
#define CAN_ACF_AE0_Pos                   (16UL)                    /*!< AE0 (Bit 16)                                          */
#define CAN_ACF_AE0_Msk                   (0x10000UL)               /*!< AE0 (Bitfield-Mask: 0x01)                             */
#define CAN_ACF_ACFADR_Pos                (0UL)                     /*!< ACFADR (Bit 0)                                        */
#define CAN_ACF_ACFADR_Msk                (0x3UL)                   /*!< ACFADR (Bitfield-Mask: 0x03)                          */
/* ======================================================  ACFIDENTREG  ====================================================== */
#define CAN_ACFIDENTREG_ACFID_Pos         (0UL)                     /*!< ACFID (Bit 0)                                         */
#define CAN_ACFIDENTREG_ACFID_Msk         (0x1fffffffUL)            /*!< ACFID (Bitfield-Mask: 0x1fffffff)                     */
/* =======================================================  ACFFORMAT  ======================================================= */
#define CAN_ACFFORMAT_ACFLBF_Pos          (28UL)                    /*!< ACFLBF (Bit 28)                                       */
#define CAN_ACFFORMAT_ACFLBF_Msk          (0x10000000UL)            /*!< ACFLBF (Bitfield-Mask: 0x01)                          */
#define CAN_ACFFORMAT_ACFESI_Pos          (27UL)                    /*!< ACFESI (Bit 27)                                       */
#define CAN_ACFFORMAT_ACFESI_Msk          (0x8000000UL)             /*!< ACFESI (Bitfield-Mask: 0x01)                          */
#define CAN_ACFFORMAT_ACFSEC_Pos          (21UL)                    /*!< ACFSEC (Bit 21)                                       */
#define CAN_ACFFORMAT_ACFSEC_Msk          (0x200000UL)              /*!< ACFSEC (Bitfield-Mask: 0x01)                          */
#define CAN_ACFFORMAT_ACFRMF_Pos          (20UL)                    /*!< ACFRMF (Bit 20)                                       */
#define CAN_ACFFORMAT_ACFRMF_Msk          (0x100000UL)              /*!< ACFRMF (Bitfield-Mask: 0x01)                          */
#define CAN_ACFFORMAT_ACFIDE_Pos          (16UL)                    /*!< ACFIDE (Bit 16)                                       */
#define CAN_ACFFORMAT_ACFIDE_Msk          (0x10000UL)               /*!< ACFIDE (Bitfield-Mask: 0x01)                          */
#define CAN_ACFFORMAT_ACFDLC_Pos          (0UL)                     /*!< ACFDLC (Bit 0)                                        */
#define CAN_ACFFORMAT_ACFDLC_Msk          (0xfUL)                   /*!< ACFDLC (Bitfield-Mask: 0x0f)                          */
/* ======================================================  ACMIDENTREG  ====================================================== */
#define CAN_ACMIDENTREG_ACMID_Pos         (0UL)                     /*!< ACMID (Bit 0)                                         */
#define CAN_ACMIDENTREG_ACMID_Msk         (0x1fffffffUL)            /*!< ACMID (Bitfield-Mask: 0x1fffffff)                     */
/* =======================================================  ACMFORMAT  ======================================================= */
#define CAN_ACMFORMAT_ACMLBF_Pos          (28UL)                    /*!< ACMLBF (Bit 28)                                       */
#define CAN_ACMFORMAT_ACMLBF_Msk          (0x10000000UL)            /*!< ACMLBF (Bitfield-Mask: 0x01)                          */
#define CAN_ACMFORMAT_ACMESI_Pos          (27UL)                    /*!< ACMESI (Bit 27)                                       */
#define CAN_ACMFORMAT_ACMESI_Msk          (0x8000000UL)             /*!< ACMESI (Bitfield-Mask: 0x01)                          */
#define CAN_ACMFORMAT_ACMSEC_Pos          (21UL)                    /*!< ACMSEC (Bit 21)                                       */
#define CAN_ACMFORMAT_ACMSEC_Msk          (0x200000UL)              /*!< ACMSEC (Bitfield-Mask: 0x01)                          */
#define CAN_ACMFORMAT_ACMRMF_Pos          (20UL)                    /*!< ACMRMF (Bit 20)                                       */
#define CAN_ACMFORMAT_ACMRMF_Msk          (0x100000UL)              /*!< ACMRMF (Bitfield-Mask: 0x01)                          */
#define CAN_ACMFORMAT_ACMIDE_Pos          (16UL)                    /*!< ACMIDE (Bit 16)                                       */
#define CAN_ACMFORMAT_ACMIDE_Msk          (0x10000UL)               /*!< ACMIDE (Bitfield-Mask: 0x01)                          */
#define CAN_ACMFORMAT_ACMDLC_Pos          (0UL)                     /*!< ACMDLC (Bit 0)                                        */
#define CAN_ACMFORMAT_ACMDLC_Msk          (0xfUL)                   /*!< ACMDLC (Bitfield-Mask: 0x0f)                          */
/* =========================================================  RBID  ========================================================== */
#define CAN_RBID_RBID_Pos                 (0UL)                     /*!< RBID (Bit 0)                                          */
#define CAN_RBID_RBID_Msk                 (0x1fffffffUL)            /*!< RBID (Bitfield-Mask: 0x1fffffff)                      */
/* =======================================================  RBFORMAT  ======================================================== */
#define CAN_RBFORMAT_RBLBF_Pos            (28UL)                    /*!< RBLBF (Bit 28)                                        */
#define CAN_RBFORMAT_RBLBF_Msk            (0x10000000UL)            /*!< RBLBF (Bitfield-Mask: 0x01)                           */
#define CAN_RBFORMAT_RBESI_Pos            (27UL)                    /*!< RBESI (Bit 27)                                        */
#define CAN_RBFORMAT_RBESI_Msk            (0x8000000UL)             /*!< RBESI (Bitfield-Mask: 0x01)                           */
#define CAN_RBFORMAT_RKOER_Pos            (24UL)                    /*!< RKOER (Bit 24)                                        */
#define CAN_RBFORMAT_RKOER_Msk            (0x7000000UL)             /*!< RKOER (Bitfield-Mask: 0x07)                           */
#define CAN_RBFORMAT_RBSEC_Pos            (21UL)                    /*!< RBSEC (Bit 21)                                        */
#define CAN_RBFORMAT_RBSEC_Msk            (0x200000UL)              /*!< RBSEC (Bitfield-Mask: 0x01)                           */
#define CAN_RBFORMAT_RMF_Pos              (20UL)                    /*!< RMF (Bit 20)                                          */
#define CAN_RBFORMAT_RMF_Msk              (0x100000UL)              /*!< RMF (Bitfield-Mask: 0x01)                             */
#define CAN_RBFORMAT_RBIDE_Pos            (16UL)                    /*!< RBIDE (Bit 16)                                        */
#define CAN_RBFORMAT_RBIDE_Msk            (0x10000UL)               /*!< RBIDE (Bitfield-Mask: 0x01)                           */
#define CAN_RBFORMAT_DLC_Pos              (0UL)                     /*!< DLC (Bit 0)                                           */
#define CAN_RBFORMAT_DLC_Msk              (0xfUL)                   /*!< DLC (Bitfield-Mask: 0x0f)                             */
/* ========================================================  RBTSREG  ======================================================== */
#define CAN_RBTSREG_RBRTS_Pos             (0UL)                     /*!< RBRTS (Bit 0)                                         */
#define CAN_RBTSREG_RBRTS_Msk             (0xffffUL)                /*!< RBRTS (Bitfield-Mask: 0xffff)                         */
/* ======================================================  RBDATAREG0  ======================================================= */
#define CAN_RBDATAREG0_RBPAYLOADDATA0_Pos (0UL)                     /*!< RBPAYLOADDATA0 (Bit 0)                                */
#define CAN_RBDATAREG0_RBPAYLOADDATA0_Msk (0xffffffffUL)            /*!< RBPAYLOADDATA0 (Bitfield-Mask: 0xffffffff)            */
/* ======================================================  RBDATAREG1  ======================================================= */
#define CAN_RBDATAREG1_RBPAYLOADDATA1_Pos (0UL)                     /*!< RBPAYLOADDATA1 (Bit 0)                                */
#define CAN_RBDATAREG1_RBPAYLOADDATA1_Msk (0xffffffffUL)            /*!< RBPAYLOADDATA1 (Bitfield-Mask: 0xffffffff)            */
/* =========================================================  TBID  ========================================================== */
#define CAN_TBID_TBTTSEN_Pos              (31UL)                    /*!< TBTTSEN (Bit 31)                                      */
#define CAN_TBID_TBTTSEN_Msk              (0x80000000UL)            /*!< TBTTSEN (Bitfield-Mask: 0x01)                         */
#define CAN_TBID_TBID_Pos                 (0UL)                     /*!< TBID (Bit 0)                                          */
#define CAN_TBID_TBID_Msk                 (0x1fffffffUL)            /*!< TBID (Bitfield-Mask: 0x1fffffff)                      */
/* =======================================================  TBFORMAT  ======================================================== */
#define CAN_TBFORMAT_TBSEC_Pos            (21UL)                    /*!< TBSEC (Bit 21)                                        */
#define CAN_TBFORMAT_TBSEC_Msk            (0x200000UL)              /*!< TBSEC (Bitfield-Mask: 0x01)                           */
#define CAN_TBFORMAT_TBRMF_Pos            (20UL)                    /*!< TBRMF (Bit 20)                                        */
#define CAN_TBFORMAT_TBRMF_Msk            (0x100000UL)              /*!< TBRMF (Bitfield-Mask: 0x01)                           */
#define CAN_TBFORMAT_TBIDE_Pos            (16UL)                    /*!< TBIDE (Bit 16)                                        */
#define CAN_TBFORMAT_TBIDE_Msk            (0x10000UL)               /*!< TBIDE (Bitfield-Mask: 0x01)                           */
#define CAN_TBFORMAT_TBDLC_Pos            (0UL)                     /*!< TBDLC (Bit 0)                                         */
#define CAN_TBFORMAT_TBDLC_Msk            (0xfUL)                   /*!< TBDLC (Bitfield-Mask: 0x0f)                           */
/* ======================================================  TBDATAREG0  ======================================================= */
#define CAN_TBDATAREG0_PAYLOAD0_Pos       (0UL)                     /*!< PAYLOAD0 (Bit 0)                                      */
#define CAN_TBDATAREG0_PAYLOAD0_Msk       (0xffffffffUL)            /*!< PAYLOAD0 (Bitfield-Mask: 0xffffffff)                  */
/* ======================================================  TBDATAREG1  ======================================================= */
#define CAN_TBDATAREG1_PAYLOAD1_Pos       (0UL)                     /*!< PAYLOAD1 (Bit 0)                                      */
#define CAN_TBDATAREG1_PAYLOAD1_Msk       (0xffffffffUL)            /*!< PAYLOAD1 (Bitfield-Mask: 0xffffffff)                  */


/* =========================================================================================================================== */
/* ================                                           QSPI                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  CR  =========================================================== */
#define QSPI_CR_SCKSCALER_Pos             (24UL)                    /*!< SCKSCALER (Bit 24)                                    */
#define QSPI_CR_SCKSCALER_Msk             (0x3f000000UL)            /*!< SCKSCALER (Bitfield-Mask: 0x3f)                       */
#define QSPI_CR_CSRHT_Pos                 (16UL)                    /*!< CSRHT (Bit 16)                                        */
#define QSPI_CR_CSRHT_Msk                 (0x70000UL)               /*!< CSRHT (Bitfield-Mask: 0x07)                           */
#define QSPI_CR_FMSIZE_Pos                (8UL)                     /*!< FMSIZE (Bit 8)                                        */
#define QSPI_CR_FMSIZE_Msk                (0x1f00UL)                /*!< FMSIZE (Bitfield-Mask: 0x1f)                          */
#define QSPI_CR_XIPMODE_Pos               (5UL)                     /*!< XIPMODE (Bit 5)                                       */
#define QSPI_CR_XIPMODE_Msk               (0x20UL)                  /*!< XIPMODE (Bitfield-Mask: 0x01)                         */
#define QSPI_CR_SCKMODE_Pos               (4UL)                     /*!< SCKMODE (Bit 4)                                       */
#define QSPI_CR_SCKMODE_Msk               (0x10UL)                  /*!< SCKMODE (Bitfield-Mask: 0x01)                         */
#define QSPI_CR_OPMODE_Pos                (0UL)                     /*!< OPMODE (Bit 0)                                        */
#define QSPI_CR_OPMODE_Msk                (0x3UL)                   /*!< OPMODE (Bitfield-Mask: 0x03)                          */
/* ==========================================================  SR  =========================================================== */
#define QSPI_SR_FIFODEPTH_Pos             (24UL)                    /*!< FIFODEPTH (Bit 24)                                    */
#define QSPI_SR_FIFODEPTH_Msk             (0xf000000UL)             /*!< FIFODEPTH (Bitfield-Mask: 0x0f)                       */
#define QSPI_SR_FIFOLEVEL_Pos             (12UL)                    /*!< FIFOLEVEL (Bit 12)                                    */
#define QSPI_SR_FIFOLEVEL_Msk             (0xf000UL)                /*!< FIFOLEVEL (Bitfield-Mask: 0x0f)                       */
#define QSPI_SR_FIFOFULL_Pos              (9UL)                     /*!< FIFOFULL (Bit 9)                                      */
#define QSPI_SR_FIFOFULL_Msk              (0x200UL)                 /*!< FIFOFULL (Bitfield-Mask: 0x01)                        */
#define QSPI_SR_FIFOEMPTY_Pos             (8UL)                     /*!< FIFOEMPTY (Bit 8)                                     */
#define QSPI_SR_FIFOEMPTY_Msk             (0x100UL)                 /*!< FIFOEMPTY (Bitfield-Mask: 0x01)                       */
#define QSPI_SR_XIPSTATUS_Pos             (6UL)                     /*!< XIPSTATUS (Bit 6)                                     */
#define QSPI_SR_XIPSTATUS_Msk             (0x40UL)                  /*!< XIPSTATUS (Bitfield-Mask: 0x01)                       */
#define QSPI_SR_BUSY_Pos                  (5UL)                     /*!< BUSY (Bit 5)                                          */
#define QSPI_SR_BUSY_Msk                  (0x20UL)                  /*!< BUSY (Bitfield-Mask: 0x01)                            */
#define QSPI_SR_TCF_Pos                   (4UL)                     /*!< TCF (Bit 4)                                           */
#define QSPI_SR_TCF_Msk                   (0x10UL)                  /*!< TCF (Bitfield-Mask: 0x01)                             */
#define QSPI_SR_OPCRCF_Pos                (2UL)                     /*!< OPCRCF (Bit 2)                                        */
#define QSPI_SR_OPCRCF_Msk                (0x4UL)                   /*!< OPCRCF (Bitfield-Mask: 0x01)                          */
#define QSPI_SR_CUR_OP_Pos                (0UL)                     /*!< CUR_OP (Bit 0)                                        */
#define QSPI_SR_CUR_OP_Msk                (0x3UL)                   /*!< CUR_OP (Bitfield-Mask: 0x03)                          */
/* =========================================================  RMCR  ========================================================== */
#define QSPI_RMCR_DDRMODE_Pos             (31UL)                    /*!< DDRMODE (Bit 31)                                      */
#define QSPI_RMCR_DDRMODE_Msk             (0x80000000UL)            /*!< DDRMODE (Bitfield-Mask: 0x01)                         */
#define QSPI_RMCR_NOWRAP_Pos              (30UL)                    /*!< NOWRAP (Bit 30)                                       */
#define QSPI_RMCR_NOWRAP_Msk              (0x40000000UL)            /*!< NOWRAP (Bitfield-Mask: 0x01)                          */
#define QSPI_RMCR_WRAPMODE_Pos            (29UL)                    /*!< WRAPMODE (Bit 29)                                     */
#define QSPI_RMCR_WRAPMODE_Msk            (0x20000000UL)            /*!< WRAPMODE (Bitfield-Mask: 0x01)                        */
#define QSPI_RMCR_NUMDC_Pos               (24UL)                    /*!< NUMDC (Bit 24)                                        */
#define QSPI_RMCR_NUMDC_Msk               (0x1f000000UL)            /*!< NUMDC (Bitfield-Mask: 0x1f)                           */
#define QSPI_RMCR_RXDLY_Pos               (22UL)                    /*!< RXDLY (Bit 22)                                        */
#define QSPI_RMCR_RXDLY_Msk               (0xc00000UL)              /*!< RXDLY (Bitfield-Mask: 0x03)                           */
#define QSPI_RMCR_DSIZE_Pos               (20UL)                    /*!< DSIZE (Bit 20)                                        */
#define QSPI_RMCR_DSIZE_Msk               (0x300000UL)              /*!< DSIZE (Bitfield-Mask: 0x03)                           */
#define QSPI_RMCR_DMODE_Pos               (18UL)                    /*!< DMODE (Bit 18)                                        */
#define QSPI_RMCR_DMODE_Msk               (0xc0000UL)               /*!< DMODE (Bitfield-Mask: 0x03)                           */
#define QSPI_RMCR_ABSIZE_Pos              (16UL)                    /*!< ABSIZE (Bit 16)                                       */
#define QSPI_RMCR_ABSIZE_Msk              (0x30000UL)               /*!< ABSIZE (Bitfield-Mask: 0x03)                          */
#define QSPI_RMCR_ABMODE_Pos              (14UL)                    /*!< ABMODE (Bit 14)                                       */
#define QSPI_RMCR_ABMODE_Msk              (0xc000UL)                /*!< ABMODE (Bitfield-Mask: 0x03)                          */
#define QSPI_RMCR_ADSIZE_Pos              (12UL)                    /*!< ADSIZE (Bit 12)                                       */
#define QSPI_RMCR_ADSIZE_Msk              (0x3000UL)                /*!< ADSIZE (Bitfield-Mask: 0x03)                          */
#define QSPI_RMCR_ADMODE_Pos              (10UL)                    /*!< ADMODE (Bit 10)                                       */
#define QSPI_RMCR_ADMODE_Msk              (0xc00UL)                 /*!< ADMODE (Bitfield-Mask: 0x03)                          */
#define QSPI_RMCR_IMODE_Pos               (8UL)                     /*!< IMODE (Bit 8)                                         */
#define QSPI_RMCR_IMODE_Msk               (0x300UL)                 /*!< IMODE (Bitfield-Mask: 0x03)                           */
#define QSPI_RMCR_INSTRUCTION_Pos         (0UL)                     /*!< INSTRUCTION (Bit 0)                                   */
#define QSPI_RMCR_INSTRUCTION_Msk         (0xffUL)                  /*!< INSTRUCTION (Bitfield-Mask: 0xff)                     */
/* =========================================================  OMCR  ========================================================== */
#define QSPI_OMCR_DDRMODE_Pos             (31UL)                    /*!< DDRMODE (Bit 31)                                      */
#define QSPI_OMCR_DDRMODE_Msk             (0x80000000UL)            /*!< DDRMODE (Bitfield-Mask: 0x01)                         */
#define QSPI_OMCR_IDMODE_Pos              (30UL)                    /*!< IDMODE (Bit 30)                                       */
#define QSPI_OMCR_IDMODE_Msk              (0x40000000UL)            /*!< IDMODE (Bitfield-Mask: 0x01)                          */
#define QSPI_OMCR_XIPIMMENTER_Pos         (29UL)                    /*!< XIPIMMENTER (Bit 29)                                  */
#define QSPI_OMCR_XIPIMMENTER_Msk         (0x20000000UL)            /*!< XIPIMMENTER (Bitfield-Mask: 0x01)                     */
#define QSPI_OMCR_NUMDC_Pos               (24UL)                    /*!< NUMDC (Bit 24)                                        */
#define QSPI_OMCR_NUMDC_Msk               (0x1f000000UL)            /*!< NUMDC (Bitfield-Mask: 0x1f)                           */
#define QSPI_OMCR_RXDLY_Pos               (22UL)                    /*!< RXDLY (Bit 22)                                        */
#define QSPI_OMCR_RXDLY_Msk               (0xc00000UL)              /*!< RXDLY (Bitfield-Mask: 0x03)                           */
#define QSPI_OMCR_DSIZE_Pos               (20UL)                    /*!< DSIZE (Bit 20)                                        */
#define QSPI_OMCR_DSIZE_Msk               (0x300000UL)              /*!< DSIZE (Bitfield-Mask: 0x03)                           */
#define QSPI_OMCR_DMODE_Pos               (18UL)                    /*!< DMODE (Bit 18)                                        */
#define QSPI_OMCR_DMODE_Msk               (0xc0000UL)               /*!< DMODE (Bitfield-Mask: 0x03)                           */
#define QSPI_OMCR_ABSIZE_Pos              (16UL)                    /*!< ABSIZE (Bit 16)                                       */
#define QSPI_OMCR_ABSIZE_Msk              (0x30000UL)               /*!< ABSIZE (Bitfield-Mask: 0x03)                          */
#define QSPI_OMCR_ABMODE_Pos              (14UL)                    /*!< ABMODE (Bit 14)                                       */
#define QSPI_OMCR_ABMODE_Msk              (0xc000UL)                /*!< ABMODE (Bitfield-Mask: 0x03)                          */
#define QSPI_OMCR_ADSIZE_Pos              (12UL)                    /*!< ADSIZE (Bit 12)                                       */
#define QSPI_OMCR_ADSIZE_Msk              (0x3000UL)                /*!< ADSIZE (Bitfield-Mask: 0x03)                          */
#define QSPI_OMCR_ADMODE_Pos              (10UL)                    /*!< ADMODE (Bit 10)                                       */
#define QSPI_OMCR_ADMODE_Msk              (0xc00UL)                 /*!< ADMODE (Bitfield-Mask: 0x03)                          */
#define QSPI_OMCR_IMODE_Pos               (8UL)                     /*!< IMODE (Bit 8)                                         */
#define QSPI_OMCR_IMODE_Msk               (0x300UL)                 /*!< IMODE (Bitfield-Mask: 0x03)                           */
#define QSPI_OMCR_INSTRUCTION_Pos         (0UL)                     /*!< INSTRUCTION (Bit 0)                                   */
#define QSPI_OMCR_INSTRUCTION_Msk         (0xffUL)                  /*!< INSTRUCTION (Bitfield-Mask: 0xff)                     */
/* =========================================================  RABR  ========================================================== */
#define QSPI_RABR_ALT_Pos                 (0UL)                     /*!< ALT (Bit 0)                                           */
#define QSPI_RABR_ALT_Msk                 (0xffffffffUL)            /*!< ALT (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  OABR  ========================================================== */
#define QSPI_OABR_ALT_Pos                 (0UL)                     /*!< ALT (Bit 0)                                           */
#define QSPI_OABR_ALT_Msk                 (0xffffffffUL)            /*!< ALT (Bitfield-Mask: 0xffffffff)                       */
/* =========================================================  IMAR  ========================================================== */
#define QSPI_IMAR_IMADDR_Pos              (0UL)                     /*!< IMADDR (Bit 0)                                        */
#define QSPI_IMAR_IMADDR_Msk              (0xffffffffUL)            /*!< IMADDR (Bitfield-Mask: 0xffffffff)                    */
/* ==========================================================  FDR  ========================================================== */
#define QSPI_FDR_FIFODATA_Pos             (0UL)                     /*!< FIFODATA (Bit 0)                                      */
#define QSPI_FDR_FIFODATA_Msk             (0xffffffffUL)            /*!< FIFODATA (Bitfield-Mask: 0xffffffff)                  */
/* ==========================================================  DLR  ========================================================== */
#define QSPI_DLR_DL_Pos                   (0UL)                     /*!< DL (Bit 0)                                            */
#define QSPI_DLR_DL_Msk                   (0xfffffUL)               /*!< DL (Bitfield-Mask: 0xfffff)                           */
/* =========================================================  WCNT  ========================================================== */
#define QSPI_WCNT_WCNT_Pos                (0UL)                     /*!< WCNT (Bit 0)                                          */
#define QSPI_WCNT_WCNT_Msk                (0x3fffffffUL)            /*!< WCNT (Bitfield-Mask: 0x3fffffff)                      */


/* =========================================================================================================================== */
/* ================                                           TRNG                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  RNGIMR  ========================================================= */
#define TRNG_RNGIMR_VNERRINTMASK_Pos      (3UL)                     /*!< VNERRINTMASK (Bit 3)                                  */
#define TRNG_RNGIMR_VNERRINTMASK_Msk      (0x8UL)                   /*!< VNERRINTMASK (Bitfield-Mask: 0x01)                    */
#define TRNG_RNGIMR_CRNGTERRINTMASK_Pos   (2UL)                     /*!< CRNGTERRINTMASK (Bit 2)                               */
#define TRNG_RNGIMR_CRNGTERRINTMASK_Msk   (0x4UL)                   /*!< CRNGTERRINTMASK (Bitfield-Mask: 0x01)                 */
#define TRNG_RNGIMR_AUTOCORRERRINTMASK_Pos (1UL)                    /*!< AUTOCORRERRINTMASK (Bit 1)                            */
#define TRNG_RNGIMR_AUTOCORRERRINTMASK_Msk (0x2UL)                  /*!< AUTOCORRERRINTMASK (Bitfield-Mask: 0x01)              */
#define TRNG_RNGIMR_EHRVALIDINTMASK_Pos   (0UL)                     /*!< EHRVALIDINTMASK (Bit 0)                               */
#define TRNG_RNGIMR_EHRVALIDINTMASK_Msk   (0x1UL)                   /*!< EHRVALIDINTMASK (Bitfield-Mask: 0x01)                 */
/* ========================================================  RNGISR  ========================================================= */
#define TRNG_RNGISR_VNERR_Pos             (3UL)                     /*!< VNERR (Bit 3)                                         */
#define TRNG_RNGISR_VNERR_Msk             (0x8UL)                   /*!< VNERR (Bitfield-Mask: 0x01)                           */
#define TRNG_RNGISR_CRNGTERR_Pos          (2UL)                     /*!< CRNGTERR (Bit 2)                                      */
#define TRNG_RNGISR_CRNGTERR_Msk          (0x4UL)                   /*!< CRNGTERR (Bitfield-Mask: 0x01)                        */
#define TRNG_RNGISR_AUTOCORRERR_Pos       (1UL)                     /*!< AUTOCORRERR (Bit 1)                                   */
#define TRNG_RNGISR_AUTOCORRERR_Msk       (0x2UL)                   /*!< AUTOCORRERR (Bitfield-Mask: 0x01)                     */
#define TRNG_RNGISR_EHRVALID_Pos          (0UL)                     /*!< EHRVALID (Bit 0)                                      */
#define TRNG_RNGISR_EHRVALID_Msk          (0x1UL)                   /*!< EHRVALID (Bitfield-Mask: 0x01)                        */
/* ========================================================  RNGICR  ========================================================= */
#define TRNG_RNGICR_VNERR_Pos             (3UL)                     /*!< VNERR (Bit 3)                                         */
#define TRNG_RNGICR_VNERR_Msk             (0x8UL)                   /*!< VNERR (Bitfield-Mask: 0x01)                           */
#define TRNG_RNGICR_CRNGTERR_Pos          (2UL)                     /*!< CRNGTERR (Bit 2)                                      */
#define TRNG_RNGICR_CRNGTERR_Msk          (0x4UL)                   /*!< CRNGTERR (Bitfield-Mask: 0x01)                        */
#define TRNG_RNGICR_AUTOCORRERR_Pos       (1UL)                     /*!< AUTOCORRERR (Bit 1)                                   */
#define TRNG_RNGICR_AUTOCORRERR_Msk       (0x2UL)                   /*!< AUTOCORRERR (Bitfield-Mask: 0x01)                     */
#define TRNG_RNGICR_EHRVALID_Pos          (0UL)                     /*!< EHRVALID (Bit 0)                                      */
#define TRNG_RNGICR_EHRVALID_Msk          (0x1UL)                   /*!< EHRVALID (Bitfield-Mask: 0x01)                        */
/* ======================================================  TRNGCONFIG  ======================================================= */
#define TRNG_TRNGCONFIG_RNDSRCSEL_Pos     (0UL)                     /*!< RNDSRCSEL (Bit 0)                                     */
#define TRNG_TRNGCONFIG_RNDSRCSEL_Msk     (0x3UL)                   /*!< RNDSRCSEL (Bitfield-Mask: 0x03)                       */
/* =======================================================  TRNGVALID  ======================================================= */
#define TRNG_TRNGVALID_EHRVALID_Pos       (0UL)                     /*!< EHRVALID (Bit 0)                                      */
#define TRNG_TRNGVALID_EHRVALID_Msk       (0x1UL)                   /*!< EHRVALID (Bitfield-Mask: 0x01)                        */
/* =======================================================  EHRDATA0  ======================================================== */
#define TRNG_EHRDATA0_EHRDATA_Pos         (0UL)                     /*!< EHRDATA (Bit 0)                                       */
#define TRNG_EHRDATA0_EHRDATA_Msk         (0xffffffffUL)            /*!< EHRDATA (Bitfield-Mask: 0xffffffff)                   */
/* =======================================================  EHRDATA1  ======================================================== */
#define TRNG_EHRDATA1_EHRDATA_Pos         (0UL)                     /*!< EHRDATA (Bit 0)                                       */
#define TRNG_EHRDATA1_EHRDATA_Msk         (0xffffffffUL)            /*!< EHRDATA (Bitfield-Mask: 0xffffffff)                   */
/* =======================================================  EHRDATA2  ======================================================== */
#define TRNG_EHRDATA2_EHRDATA_Pos         (0UL)                     /*!< EHRDATA (Bit 0)                                       */
#define TRNG_EHRDATA2_EHRDATA_Msk         (0xffffffffUL)            /*!< EHRDATA (Bitfield-Mask: 0xffffffff)                   */
/* =======================================================  EHRDATA3  ======================================================== */
#define TRNG_EHRDATA3_EHRDATA_Pos         (0UL)                     /*!< EHRDATA (Bit 0)                                       */
#define TRNG_EHRDATA3_EHRDATA_Msk         (0xffffffffUL)            /*!< EHRDATA (Bitfield-Mask: 0xffffffff)                   */
/* =======================================================  EHRDATA4  ======================================================== */
#define TRNG_EHRDATA4_EHRDATA_Pos         (0UL)                     /*!< EHRDATA (Bit 0)                                       */
#define TRNG_EHRDATA4_EHRDATA_Msk         (0xffffffffUL)            /*!< EHRDATA (Bitfield-Mask: 0xffffffff)                   */
/* =======================================================  EHRDATA5  ======================================================== */
#define TRNG_EHRDATA5_EHRDATA_Pos         (0UL)                     /*!< EHRDATA (Bit 0)                                       */
#define TRNG_EHRDATA5_EHRDATA_Msk         (0xffffffffUL)            /*!< EHRDATA (Bitfield-Mask: 0xffffffff)                   */
/* ====================================================  RNDSOURCEENABLE  ==================================================== */
#define TRNG_RNDSOURCEENABLE_RNDSRCEN_Pos (0UL)                     /*!< RNDSRCEN (Bit 0)                                      */
#define TRNG_RNDSOURCEENABLE_RNDSRCEN_Msk (0x1UL)                   /*!< RNDSRCEN (Bitfield-Mask: 0x01)                        */
/* ======================================================  SAMPLECNT1  ======================================================= */
#define TRNG_SAMPLECNT1_SAMPLECNTR1_Pos   (0UL)                     /*!< SAMPLECNTR1 (Bit 0)                                   */
#define TRNG_SAMPLECNT1_SAMPLECNTR1_Msk   (0xffffffffUL)            /*!< SAMPLECNTR1 (Bitfield-Mask: 0xffffffff)               */
/* ===================================================  AUTOCORRSTATISTIC  =================================================== */
#define TRNG_AUTOCORRSTATISTIC_AUTOCORRFAILS_Pos (14UL)             /*!< AUTOCORRFAILS (Bit 14)                                */
#define TRNG_AUTOCORRSTATISTIC_AUTOCORRFAILS_Msk (0x3fc000UL)       /*!< AUTOCORRFAILS (Bitfield-Mask: 0xff)                   */
#define TRNG_AUTOCORRSTATISTIC_AUTOCORRTRYS_Pos (0UL)               /*!< AUTOCORRTRYS (Bit 0)                                  */
#define TRNG_AUTOCORRSTATISTIC_AUTOCORRTRYS_Msk (0x3fffUL)          /*!< AUTOCORRTRYS (Bitfield-Mask: 0x3fff)                  */
/* ===================================================  TRNGDEBUGCONTROL  ==================================================== */
#define TRNG_TRNGDEBUGCONTROL_AUTOCORRELATEBYPASS_Pos (3UL)         /*!< AUTOCORRELATEBYPASS (Bit 3)                           */
#define TRNG_TRNGDEBUGCONTROL_AUTOCORRELATEBYPASS_Msk (0x8UL)       /*!< AUTOCORRELATEBYPASS (Bitfield-Mask: 0x01)             */
#define TRNG_TRNGDEBUGCONTROL_TRNGCRNGTBYPASS_Pos (2UL)             /*!< TRNGCRNGTBYPASS (Bit 2)                               */
#define TRNG_TRNGDEBUGCONTROL_TRNGCRNGTBYPASS_Msk (0x4UL)           /*!< TRNGCRNGTBYPASS (Bitfield-Mask: 0x01)                 */
#define TRNG_TRNGDEBUGCONTROL_VNCBYPASS_Pos (1UL)                   /*!< VNCBYPASS (Bit 1)                                     */
#define TRNG_TRNGDEBUGCONTROL_VNCBYPASS_Msk (0x2UL)                 /*!< VNCBYPASS (Bitfield-Mask: 0x01)                       */
/* ======================================================  TRNGSWRESET  ====================================================== */
#define TRNG_TRNGSWRESET_RNGSWRESET_Pos   (0UL)                     /*!< RNGSWRESET (Bit 0)                                    */
#define TRNG_TRNGSWRESET_RNGSWRESET_Msk   (0x1UL)                   /*!< RNGSWRESET (Bitfield-Mask: 0x01)                      */
/* ====================================================  RNGDEBUGENINPUT  ==================================================== */
#define TRNG_RNGDEBUGENINPUT_RNGDEBUGEN_Pos (0UL)                   /*!< RNGDEBUGEN (Bit 0)                                    */
#define TRNG_RNGDEBUGENINPUT_RNGDEBUGEN_Msk (0x1UL)                 /*!< RNGDEBUGEN (Bitfield-Mask: 0x01)                      */
/* ========================================================  RNGBUSY  ======================================================== */
#define TRNG_RNGBUSY_RNGBUSY_Pos          (0UL)                     /*!< RNGBUSY (Bit 0)                                       */
#define TRNG_RNGBUSY_RNGBUSY_Msk          (0x1UL)                   /*!< RNGBUSY (Bitfield-Mask: 0x01)                         */
/* ====================================================  RSTBITSCOUNTER  ===================================================== */
#define TRNG_RSTBITSCOUNTER_RSTBITSCOUNTER_Pos (0UL)                /*!< RSTBITSCOUNTER (Bit 0)                                */
#define TRNG_RSTBITSCOUNTER_RSTBITSCOUNTER_Msk (0x1UL)              /*!< RSTBITSCOUNTER (Bitfield-Mask: 0x01)                  */
/* ======================================================  RNGVERSION  ======================================================= */
#define TRNG_RNGVERSION_RNGUSE5SBOXES_Pos (7UL)                     /*!< RNGUSE5SBOXES (Bit 7)                                 */
#define TRNG_RNGVERSION_RNGUSE5SBOXES_Msk (0x80UL)                  /*!< RNGUSE5SBOXES (Bitfield-Mask: 0x01)                   */
#define TRNG_RNGVERSION_RESEEDINGEXISTS_Pos (6UL)                   /*!< RESEEDINGEXISTS (Bit 6)                               */
#define TRNG_RNGVERSION_RESEEDINGEXISTS_Msk (0x40UL)                /*!< RESEEDINGEXISTS (Bitfield-Mask: 0x01)                 */
#define TRNG_RNGVERSION_KATEXISTS_Pos     (5UL)                     /*!< KATEXISTS (Bit 5)                                     */
#define TRNG_RNGVERSION_KATEXISTS_Msk     (0x20UL)                  /*!< KATEXISTS (Bitfield-Mask: 0x01)                       */
#define TRNG_RNGVERSION_PRNGEXISTS_Pos    (4UL)                     /*!< PRNGEXISTS (Bit 4)                                    */
#define TRNG_RNGVERSION_PRNGEXISTS_Msk    (0x10UL)                  /*!< PRNGEXISTS (Bitfield-Mask: 0x01)                      */
#define TRNG_RNGVERSION_TRNGTESTSBYPASSEN_Pos (3UL)                 /*!< TRNGTESTSBYPASSEN (Bit 3)                             */
#define TRNG_RNGVERSION_TRNGTESTSBYPASSEN_Msk (0x8UL)               /*!< TRNGTESTSBYPASSEN (Bitfield-Mask: 0x01)               */
#define TRNG_RNGVERSION_AUTOCORREXISTS_Pos (2UL)                    /*!< AUTOCORREXISTS (Bit 2)                                */
#define TRNG_RNGVERSION_AUTOCORREXISTS_Msk (0x4UL)                  /*!< AUTOCORREXISTS (Bitfield-Mask: 0x01)                  */
#define TRNG_RNGVERSION_CRNGTEXISTS_Pos   (1UL)                     /*!< CRNGTEXISTS (Bit 1)                                   */
#define TRNG_RNGVERSION_CRNGTEXISTS_Msk   (0x2UL)                   /*!< CRNGTEXISTS (Bitfield-Mask: 0x01)                     */
#define TRNG_RNGVERSION_EHRWIDTH192_Pos   (0UL)                     /*!< EHRWIDTH192 (Bit 0)                                   */
#define TRNG_RNGVERSION_EHRWIDTH192_Msk   (0x1UL)                   /*!< EHRWIDTH192 (Bitfield-Mask: 0x01)                     */
/* =====================================================  RNGBISTCNTR0  ====================================================== */
#define TRNG_RNGBISTCNTR0_ROSCCNTRVAL_Pos (0UL)                     /*!< ROSCCNTRVAL (Bit 0)                                   */
#define TRNG_RNGBISTCNTR0_ROSCCNTRVAL_Msk (0x3fffffUL)              /*!< ROSCCNTRVAL (Bitfield-Mask: 0x3fffff)                 */
/* =====================================================  RNGBISTCNTR1  ====================================================== */
#define TRNG_RNGBISTCNTR1_ROSCCNTRVAL_Pos (0UL)                     /*!< ROSCCNTRVAL (Bit 0)                                   */
#define TRNG_RNGBISTCNTR1_ROSCCNTRVAL_Msk (0x3fffffUL)              /*!< ROSCCNTRVAL (Bitfield-Mask: 0x3fffff)                 */
/* =====================================================  RNGBISTCNTR2  ====================================================== */
#define TRNG_RNGBISTCNTR2_ROSCCNTRVAL_Pos (0UL)                     /*!< ROSCCNTRVAL (Bit 0)                                   */
#define TRNG_RNGBISTCNTR2_ROSCCNTRVAL_Msk (0x3fffffUL)              /*!< ROSCCNTRVAL (Bitfield-Mask: 0x3fffff)                 */

/** @} */ /* End of group PosMask_peripherals */




#ifdef __cplusplus
}
#endif

#endif /* TPS325M0x_H */

/** @} */ /* End of group TPS325M0x */

/** @} */ /* End of group  */
